#include <qimageblitz_includes.h>

#include <smoke.h>
#include <qimageblitz_smoke.h>

namespace __smokeqimageblitz {

static void *cast(void *xptr, Smoke::Index from, Smoke::Index to) {
  switch(from) {
    case 1:   //Blitz
      switch(to) {
        case 1: return (void*)(Blitz*)xptr;
        default: return xptr;
      }
    case 2:   //QBool
      switch(to) {
        case 2: return (void*)(QBool*)xptr;
        default: return xptr;
      }
    case 3:   //QColor
      switch(to) {
        case 3: return (void*)(QColor*)xptr;
        default: return xptr;
      }
    case 5:   //QImage
      switch(to) {
        case 5: return (void*)(QImage*)xptr;
        default: return xptr;
      }
    case 6:   //QIncompatibleFlag
      switch(to) {
        case 6: return (void*)(QIncompatibleFlag*)xptr;
        default: return xptr;
      }
    case 7:   //QRegExp
      switch(to) {
        case 7: return (void*)(QRegExp*)xptr;
        default: return xptr;
      }
    case 8:   //QSize
      switch(to) {
        case 8: return (void*)(QSize*)xptr;
        default: return xptr;
      }
    default: return xptr;
  }
}

// Group of Indexes (0 separated) used as super class lists.
// Classes with super classes have an index into this array.
static Smoke::Index inheritanceList[] = {
    0,	// 0: (no super class)
};

// These are the xenum functions for manipulating enum pointers
void xenum_Blitz(Smoke::EnumOperation, Smoke::Index, void*&, long&);
void xenum_QGlobalSpace(Smoke::EnumOperation, Smoke::Index, void*&, long&);

// Those are the xcall functions defined in each x_*.cpp file, for dispatching method calls
void xcall_Blitz(Smoke::Index, void*, Smoke::Stack);
void xcall_QGlobalSpace(Smoke::Index, void*, Smoke::Stack);

// List of all classes
// Name, external, index into inheritanceList, method dispatcher, enum dispatcher, class flags, size
static Smoke::Class classes[] = {
    { 0L, false, 0, 0, 0, 0, 0 },	// 0 (no class)
    { "Blitz", false, 0, xcall_Blitz, xenum_Blitz, Smoke::cf_constructor|Smoke::cf_deepcopy, sizeof(Blitz) },	//1
    { "QBool", true, 0, 0, 0, 0, 0 },	//2
    { "QColor", true, 0, 0, 0, 0, 0 },	//3
    { "QGlobalSpace", false, 0, xcall_QGlobalSpace, xenum_QGlobalSpace, Smoke::cf_namespace, 0 },	//4
    { "QImage", true, 0, 0, 0, 0, 0 },	//5
    { "QIncompatibleFlag", true, 0, 0, 0, 0, 0 },	//6
    { "QRegExp", true, 0, 0, 0, 0, 0 },	//7
    { "QSize", true, 0, 0, 0, 0, 0 },	//8
};

// List of all types needed by the methods (arguments and return values)
// Name, class ID if arg is a class, and TypeId
static Smoke::Type types[] = {
    { 0, 0, 0 },	//0 (no type)
    { "Blitz*", 1, Smoke::t_class|Smoke::tf_ptr },	//1
    { "Blitz::EffectQuality", 1, Smoke::t_enum|Smoke::tf_stack },	//2
    { "Blitz::GradientType", 1, Smoke::t_enum|Smoke::tf_stack },	//3
    { "Blitz::ModulationType", 1, Smoke::t_enum|Smoke::tf_stack },	//4
    { "Blitz::RGBChannel", 1, Smoke::t_enum|Smoke::tf_stack },	//5
    { "Blitz::ScaleFilterType", 1, Smoke::t_enum|Smoke::tf_stack },	//6
    { "QBool", 2, Smoke::t_class|Smoke::tf_stack },	//7
    { "QFlags<QtConcurrent::ReduceOptions::enum_type>", 0, Smoke::t_uint|Smoke::tf_stack },	//8
    { "QImage", 5, Smoke::t_class|Smoke::tf_stack },	//9
    { "QImage&", 5, Smoke::t_class|Smoke::tf_ref },	//10
    { "QImage::InvertMode", 5, Smoke::t_enum|Smoke::tf_stack },	//11
    { "QIncompatibleFlag", 6, Smoke::t_class|Smoke::tf_stack },	//12
    { "QRegExp&", 7, Smoke::t_class|Smoke::tf_ref },	//13
    { "QString", 0, Smoke::t_voidp|Smoke::tf_stack },	//14
    { "QStringList", 0, Smoke::t_voidp|Smoke::tf_stack },	//15
    { "QStringList*", 0, Smoke::t_voidp|Smoke::tf_ptr },	//16
    { "Qt::AlignmentFlag", 0, Smoke::t_enum|Smoke::tf_stack },	//17
    { "Qt::AnchorAttribute", 0, Smoke::t_enum|Smoke::tf_stack },	//18
    { "Qt::AnchorPoint", 0, Smoke::t_enum|Smoke::tf_stack },	//19
    { "Qt::ApplicationAttribute", 0, Smoke::t_enum|Smoke::tf_stack },	//20
    { "Qt::ArrowType", 0, Smoke::t_enum|Smoke::tf_stack },	//21
    { "Qt::AspectRatioMode", 0, Smoke::t_enum|Smoke::tf_stack },	//22
    { "Qt::Axis", 0, Smoke::t_enum|Smoke::tf_stack },	//23
    { "Qt::BGMode", 0, Smoke::t_enum|Smoke::tf_stack },	//24
    { "Qt::BrushStyle", 0, Smoke::t_enum|Smoke::tf_stack },	//25
    { "Qt::CaseSensitivity", 0, Smoke::t_enum|Smoke::tf_stack },	//26
    { "Qt::CheckState", 0, Smoke::t_enum|Smoke::tf_stack },	//27
    { "Qt::ClipOperation", 0, Smoke::t_enum|Smoke::tf_stack },	//28
    { "Qt::ConnectionType", 0, Smoke::t_enum|Smoke::tf_stack },	//29
    { "Qt::ContextMenuPolicy", 0, Smoke::t_enum|Smoke::tf_stack },	//30
    { "Qt::CoordinateSystem", 0, Smoke::t_enum|Smoke::tf_stack },	//31
    { "Qt::Corner", 0, Smoke::t_enum|Smoke::tf_stack },	//32
    { "Qt::CursorMoveStyle", 0, Smoke::t_enum|Smoke::tf_stack },	//33
    { "Qt::CursorShape", 0, Smoke::t_enum|Smoke::tf_stack },	//34
    { "Qt::DateFormat", 0, Smoke::t_enum|Smoke::tf_stack },	//35
    { "Qt::DayOfWeek", 0, Smoke::t_enum|Smoke::tf_stack },	//36
    { "Qt::DockWidgetArea", 0, Smoke::t_enum|Smoke::tf_stack },	//37
    { "Qt::DockWidgetAreaSizes", 0, Smoke::t_enum|Smoke::tf_stack },	//38
    { "Qt::DropAction", 0, Smoke::t_enum|Smoke::tf_stack },	//39
    { "Qt::EventPriority", 0, Smoke::t_enum|Smoke::tf_stack },	//40
    { "Qt::FillRule", 0, Smoke::t_enum|Smoke::tf_stack },	//41
    { "Qt::FocusPolicy", 0, Smoke::t_enum|Smoke::tf_stack },	//42
    { "Qt::FocusReason", 0, Smoke::t_enum|Smoke::tf_stack },	//43
    { "Qt::GestureFlag", 0, Smoke::t_enum|Smoke::tf_stack },	//44
    { "Qt::GestureState", 0, Smoke::t_enum|Smoke::tf_stack },	//45
    { "Qt::GestureType", 0, Smoke::t_enum|Smoke::tf_stack },	//46
    { "Qt::GlobalColor", 0, Smoke::t_enum|Smoke::tf_stack },	//47
    { "Qt::ImageConversionFlag", 0, Smoke::t_enum|Smoke::tf_stack },	//48
    { "Qt::Initialization", 0, Smoke::t_enum|Smoke::tf_stack },	//49
    { "Qt::InputMethodHint", 0, Smoke::t_enum|Smoke::tf_stack },	//50
    { "Qt::InputMethodQuery", 0, Smoke::t_enum|Smoke::tf_stack },	//51
    { "Qt::ItemDataRole", 0, Smoke::t_enum|Smoke::tf_stack },	//52
    { "Qt::ItemFlag", 0, Smoke::t_enum|Smoke::tf_stack },	//53
    { "Qt::ItemSelectionMode", 0, Smoke::t_enum|Smoke::tf_stack },	//54
    { "Qt::Key", 0, Smoke::t_enum|Smoke::tf_stack },	//55
    { "Qt::KeyboardModifier", 0, Smoke::t_enum|Smoke::tf_stack },	//56
    { "Qt::LayoutDirection", 0, Smoke::t_enum|Smoke::tf_stack },	//57
    { "Qt::MaskMode", 0, Smoke::t_enum|Smoke::tf_stack },	//58
    { "Qt::MatchFlag", 0, Smoke::t_enum|Smoke::tf_stack },	//59
    { "Qt::Modifier", 0, Smoke::t_enum|Smoke::tf_stack },	//60
    { "Qt::MouseButton", 0, Smoke::t_enum|Smoke::tf_stack },	//61
    { "Qt::NavigationMode", 0, Smoke::t_enum|Smoke::tf_stack },	//62
    { "Qt::Orientation", 0, Smoke::t_enum|Smoke::tf_stack },	//63
    { "Qt::PenCapStyle", 0, Smoke::t_enum|Smoke::tf_stack },	//64
    { "Qt::PenJoinStyle", 0, Smoke::t_enum|Smoke::tf_stack },	//65
    { "Qt::PenStyle", 0, Smoke::t_enum|Smoke::tf_stack },	//66
    { "Qt::ScrollBarPolicy", 0, Smoke::t_enum|Smoke::tf_stack },	//67
    { "Qt::ShortcutContext", 0, Smoke::t_enum|Smoke::tf_stack },	//68
    { "Qt::SizeHint", 0, Smoke::t_enum|Smoke::tf_stack },	//69
    { "Qt::SizeMode", 0, Smoke::t_enum|Smoke::tf_stack },	//70
    { "Qt::SortOrder", 0, Smoke::t_enum|Smoke::tf_stack },	//71
    { "Qt::TextElideMode", 0, Smoke::t_enum|Smoke::tf_stack },	//72
    { "Qt::TextFlag", 0, Smoke::t_enum|Smoke::tf_stack },	//73
    { "Qt::TextFormat", 0, Smoke::t_enum|Smoke::tf_stack },	//74
    { "Qt::TextInteractionFlag", 0, Smoke::t_enum|Smoke::tf_stack },	//75
    { "Qt::TileRule", 0, Smoke::t_enum|Smoke::tf_stack },	//76
    { "Qt::TimeSpec", 0, Smoke::t_enum|Smoke::tf_stack },	//77
    { "Qt::ToolBarArea", 0, Smoke::t_enum|Smoke::tf_stack },	//78
    { "Qt::ToolBarAreaSizes", 0, Smoke::t_enum|Smoke::tf_stack },	//79
    { "Qt::ToolButtonStyle", 0, Smoke::t_enum|Smoke::tf_stack },	//80
    { "Qt::TouchPointState", 0, Smoke::t_enum|Smoke::tf_stack },	//81
    { "Qt::TransformationMode", 0, Smoke::t_enum|Smoke::tf_stack },	//82
    { "Qt::UIEffect", 0, Smoke::t_enum|Smoke::tf_stack },	//83
    { "Qt::WidgetAttribute", 0, Smoke::t_enum|Smoke::tf_stack },	//84
    { "Qt::WindowFrameSection", 0, Smoke::t_enum|Smoke::tf_stack },	//85
    { "Qt::WindowModality", 0, Smoke::t_enum|Smoke::tf_stack },	//86
    { "Qt::WindowState", 0, Smoke::t_enum|Smoke::tf_stack },	//87
    { "Qt::WindowType", 0, Smoke::t_enum|Smoke::tf_stack },	//88
    { "QtConcurrent::ReduceOption", 0, Smoke::t_enum|Smoke::tf_stack },	//89
    { "QtConcurrent::ReduceOptions::enum_type", 0, Smoke::t_voidp|Smoke::tf_stack },	//90
    { "QtConcurrent::ThreadFunctionResult", 0, Smoke::t_enum|Smoke::tf_stack },	//91
    { "QtMsgType", 4, Smoke::t_enum|Smoke::tf_stack },	//92
    { "__codecvt_result", 4, Smoke::t_enum|Smoke::tf_stack },	//93
    { "bool", 0, Smoke::t_bool|Smoke::tf_stack },	//94
    { "const Blitz&", 1, Smoke::t_class|Smoke::tf_ref|Smoke::tf_const },	//95
    { "const QColor&", 3, Smoke::t_class|Smoke::tf_ref|Smoke::tf_const },	//96
    { "const QRegExp&", 7, Smoke::t_class|Smoke::tf_ref|Smoke::tf_const },	//97
    { "const QSize&", 8, Smoke::t_class|Smoke::tf_ref|Smoke::tf_const },	//98
    { "const QString&", 0, Smoke::t_voidp|Smoke::tf_ref|Smoke::tf_const },	//99
    { "const QStringList*", 0, Smoke::t_voidp|Smoke::tf_ptr|Smoke::tf_const },	//100
    { "const void*", 0, Smoke::t_voidp|Smoke::tf_ptr|Smoke::tf_const },	//101
    { "float", 0, Smoke::t_float|Smoke::tf_stack },	//102
    { "float*", 0, Smoke::t_voidp|Smoke::tf_ptr },	//103
    { "int", 0, Smoke::t_int|Smoke::tf_stack },	//104
    { "int*", 0, Smoke::t_voidp|Smoke::tf_ptr },	//105
    { "long", 0, Smoke::t_long|Smoke::tf_stack },	//106
    { "std::bidirectional_iterator_tag", 0, Smoke::t_voidp|Smoke::tf_stack },	//107
    { "std::forward_iterator_tag", 0, Smoke::t_voidp|Smoke::tf_stack },	//108
    { "std::random_access_iterator_tag", 0, Smoke::t_voidp|Smoke::tf_stack },	//109
    { "unsigned char", 0, Smoke::t_uchar|Smoke::tf_stack },	//110
    { "unsigned int", 0, Smoke::t_uint|Smoke::tf_stack },	//111
    { "volatile const void*", 0, Smoke::t_voidp|Smoke::tf_ptr|Smoke::tf_const },	//112
};

static Smoke::Index argumentList[] = {
    0,	//0  (void)
    10, 11, 0,	//1  QImage&, QImage::InvertMode
    10, 94, 0,	//4  QImage&, bool
    10, 98, 22, 0,	//7  QImage&, const QSize&, Qt::AspectRatioMode
    10, 104, 104, 22, 0,	//11  QImage&, int, int, Qt::AspectRatioMode
    10, 98, 102, 6, 22, 0,	//16  QImage&, const QSize&, float, Blitz::ScaleFilterType, Qt::AspectRatioMode
    10, 104, 104, 102, 6, 22, 0,	//22  QImage&, int, int, float, Blitz::ScaleFilterType, Qt::AspectRatioMode
    10, 104, 103, 0,	//29  QImage&, int, float*
    10, 104, 105, 104, 0,	//33  QImage&, int, int*, int
    10, 104, 0,	//38  QImage&, int
    10, 102, 102, 0,	//41  QImage&, float, float
    10, 0,	//45  QImage&
    10, 102, 2, 0,	//47  QImage&, float, Blitz::EffectQuality
    10, 102, 102, 2, 0,	//51  QImage&, float, float, Blitz::EffectQuality
    10, 94, 104, 0,	//56  QImage&, bool, int
    10, 102, 0,	//60  QImage&, float
    10, 102, 5, 0,	//63  QImage&, float, Blitz::RGBChannel
    10, 102, 96, 0,	//67  QImage&, float, const QColor&
    10, 96, 96, 0,	//71  QImage&, const QColor&, const QColor&
    10, 110, 5, 111, 111, 0,	//75  QImage&, unsigned char, Blitz::RGBChannel, unsigned int, unsigned int
    10, 102, 102, 111, 0,	//81  QImage&, float, float, unsigned int
    98, 96, 96, 3, 0,	//86  const QSize&, const QColor&, const QColor&, Blitz::GradientType
    98, 110, 110, 3, 0,	//91  const QSize&, unsigned char, unsigned char, Blitz::GradientType
    98, 96, 96, 3, 104, 104, 0,	//96  const QSize&, const QColor&, const QColor&, Blitz::GradientType, int, int
    98, 110, 110, 3, 104, 104, 0,	//103  const QSize&, unsigned char, unsigned char, Blitz::GradientType, int, int
    10, 10, 94, 4, 104, 5, 0,	//110  QImage&, QImage&, bool, Blitz::ModulationType, int, Blitz::RGBChannel
    95, 0,	//117  const Blitz&
    10, 98, 0,	//119  QImage&, const QSize&
    10, 104, 104, 0,	//122  QImage&, int, int
    10, 98, 102, 0,	//126  QImage&, const QSize&, float
    10, 98, 102, 6, 0,	//130  QImage&, const QSize&, float, Blitz::ScaleFilterType
    10, 104, 104, 102, 0,	//135  QImage&, int, int, float
    10, 104, 104, 102, 6, 0,	//140  QImage&, int, int, float, Blitz::ScaleFilterType
    10, 104, 105, 0,	//146  QImage&, int, int*
    10, 110, 0,	//150  QImage&, unsigned char
    10, 110, 5, 0,	//153  QImage&, unsigned char, Blitz::RGBChannel
    10, 110, 5, 111, 0,	//157  QImage&, unsigned char, Blitz::RGBChannel, unsigned int
    98, 96, 96, 3, 104, 0,	//162  const QSize&, const QColor&, const QColor&, Blitz::GradientType, int
    98, 110, 110, 3, 104, 0,	//168  const QSize&, unsigned char, unsigned char, Blitz::GradientType, int
};

// Raw list of all methods, using munged names
static const char *methodNames[] = {
    "",	//0
    "All",	//1
    "Alpha",	//2
    "BesselFilter",	//3
    "BlackmanFilter",	//4
    "Blitz",	//5
    "Blitz#",	//6
    "Blue",	//7
    "BoxFilter",	//8
    "Brightness",	//9
    "CatromFilter",	//10
    "Contrast",	//11
    "CrossDiagonalGradient",	//12
    "CubicFilter",	//13
    "DiagonalGradient",	//14
    "EllipticGradient",	//15
    "GaussianFilter",	//16
    "Grayscale",	//17
    "Green",	//18
    "HammingFilter",	//19
    "HanningFilter",	//20
    "HermiteFilter",	//21
    "High",	//22
    "HorizontalGradient",	//23
    "HueShift",	//24
    "Intensity",	//25
    "LanczosFilter",	//26
    "Low",	//27
    "MitchellFilter",	//28
    "PipeCrossGradient",	//29
    "PointFilter",	//30
    "PyramidGradient",	//31
    "QtCriticalMsg",	//32
    "QtDebugMsg",	//33
    "QtFatalMsg",	//34
    "QtSystemMsg",	//35
    "QtWarningMsg",	//36
    "QuadraticFilter",	//37
    "RectangleGradient",	//38
    "Red",	//39
    "Saturation",	//40
    "SincFilter",	//41
    "TriangleFilter",	//42
    "UndefinedFilter",	//43
    "VerticalGradient",	//44
    "_ISalnum",	//45
    "_ISalpha",	//46
    "_ISblank",	//47
    "_IScntrl",	//48
    "_ISdigit",	//49
    "_ISgraph",	//50
    "_ISlower",	//51
    "_ISprint",	//52
    "_ISpunct",	//53
    "_ISspace",	//54
    "_ISupper",	//55
    "_ISxdigit",	//56
    "__codecvt_error",	//57
    "__codecvt_noconv",	//58
    "__codecvt_ok",	//59
    "__codecvt_partial",	//60
    "antialias",	//61
    "antialias#",	//62
    "blur",	//63
    "blur#",	//64
    "blur#$",	//65
    "channelIntensity",	//66
    "channelIntensity#$$",	//67
    "charcoal",	//68
    "charcoal#",	//69
    "contrast",	//70
    "contrast#$",	//71
    "contrast#$$",	//72
    "convolve",	//73
    "convolve#$$",	//74
    "convolveEdge",	//75
    "convolveEdge#",	//76
    "convolveEdge#$",	//77
    "convolveEdge#$$",	//78
    "convolveInteger",	//79
    "convolveInteger#$$",	//80
    "convolveInteger#$$$",	//81
    "desaturate",	//82
    "desaturate#",	//83
    "desaturate#$",	//84
    "despeckle",	//85
    "despeckle#",	//86
    "edge",	//87
    "edge#",	//88
    "emboss",	//89
    "emboss#",	//90
    "emboss#$",	//91
    "emboss#$$",	//92
    "emboss#$$$",	//93
    "equalize",	//94
    "equalize#",	//95
    "fade",	//96
    "fade#$#",	//97
    "flatten",	//98
    "flatten###",	//99
    "gaussianBlur",	//100
    "gaussianBlur#",	//101
    "gaussianBlur#$",	//102
    "gaussianBlur#$$",	//103
    "gaussianSharpen",	//104
    "gaussianSharpen#",	//105
    "gaussianSharpen#$",	//106
    "gaussianSharpen#$$",	//107
    "gaussianSharpen#$$$",	//108
    "gradient",	//109
    "gradient###$",	//110
    "grayGradient",	//111
    "grayGradient#$$$",	//112
    "grayUnbalancedGradient",	//113
    "grayUnbalancedGradient#$$$",	//114
    "grayUnbalancedGradient#$$$$",	//115
    "grayUnbalancedGradient#$$$$$",	//116
    "grayscale",	//117
    "grayscale#",	//118
    "grayscale#$",	//119
    "implode",	//120
    "implode#",	//121
    "implode#$",	//122
    "intensity",	//123
    "intensity#$",	//124
    "invert",	//125
    "invert#",	//126
    "invert#$",	//127
    "modulate",	//128
    "modulate##$$$$",	//129
    "normalize",	//130
    "normalize#",	//131
    "oilPaint",	//132
    "oilPaint#",	//133
    "oilPaint#$",	//134
    "oilPaint#$$",	//135
    "sharpen",	//136
    "sharpen#",	//137
    "sharpen#$",	//138
    "smoothScale",	//139
    "smoothScale##",	//140
    "smoothScale##$",	//141
    "smoothScale#$$",	//142
    "smoothScale#$$$",	//143
    "smoothScaleFilter",	//144
    "smoothScaleFilter##",	//145
    "smoothScaleFilter##$",	//146
    "smoothScaleFilter##$$",	//147
    "smoothScaleFilter##$$$",	//148
    "smoothScaleFilter#$$",	//149
    "smoothScaleFilter#$$$",	//150
    "smoothScaleFilter#$$$$",	//151
    "smoothScaleFilter#$$$$$",	//152
    "swirl",	//153
    "swirl#",	//154
    "swirl#$",	//155
    "threshold",	//156
    "threshold#",	//157
    "threshold#$",	//158
    "threshold#$$",	//159
    "threshold#$$$",	//160
    "threshold#$$$$",	//161
    "unbalancedGradient",	//162
    "unbalancedGradient###$",	//163
    "unbalancedGradient###$$",	//164
    "unbalancedGradient###$$$",	//165
    "wave",	//166
    "wave#",	//167
    "wave#$",	//168
    "wave#$$",	//169
    "wave#$$$",	//170
    "~Blitz",	//171
};

// (classId, name (index in methodNames), argumentList index, number of args, method flags, return type (index in types), xcall() index)
static Smoke::Method methods[] = {
    { 0, 0, 0, 0, 0, 0, 0 },	// (no method)
    {1, 125, 1, 2, Smoke::mf_static, 94, 1},	//1 Blitz::invert(QImage&, QImage::InvertMode)
    {1, 117, 4, 2, Smoke::mf_static, 94, 2},	//2 Blitz::grayscale(QImage&, bool)
    {1, 139, 7, 3, Smoke::mf_static, 9, 3},	//3 Blitz::smoothScale(QImage&, const QSize&, Qt::AspectRatioMode)
    {1, 139, 11, 4, Smoke::mf_static, 9, 4},	//4 Blitz::smoothScale(QImage&, int, int, Qt::AspectRatioMode)
    {1, 144, 16, 5, Smoke::mf_static, 9, 5},	//5 Blitz::smoothScaleFilter(QImage&, const QSize&, float, Blitz::ScaleFilterType, Qt::AspectRatioMode)
    {1, 144, 22, 6, Smoke::mf_static, 9, 6},	//6 Blitz::smoothScaleFilter(QImage&, int, int, float, Blitz::ScaleFilterType, Qt::AspectRatioMode)
    {1, 73, 29, 3, Smoke::mf_static, 9, 7},	//7 Blitz::convolve(QImage&, int, float*)
    {1, 79, 33, 4, Smoke::mf_static, 9, 8},	//8 Blitz::convolveInteger(QImage&, int, int*, int)
    {1, 63, 38, 2, Smoke::mf_static, 9, 9},	//9 Blitz::blur(QImage&, int)
    {1, 100, 41, 3, Smoke::mf_static, 9, 10},	//10 Blitz::gaussianBlur(QImage&, float, float)
    {1, 87, 45, 1, Smoke::mf_static, 9, 11},	//11 Blitz::edge(QImage&)
    {1, 75, 47, 3, Smoke::mf_static, 9, 12},	//12 Blitz::convolveEdge(QImage&, float, Blitz::EffectQuality)
    {1, 104, 51, 4, Smoke::mf_static, 9, 13},	//13 Blitz::gaussianSharpen(QImage&, float, float, Blitz::EffectQuality)
    {1, 136, 38, 2, Smoke::mf_static, 9, 14},	//14 Blitz::sharpen(QImage&, int)
    {1, 89, 51, 4, Smoke::mf_static, 9, 15},	//15 Blitz::emboss(QImage&, float, float, Blitz::EffectQuality)
    {1, 61, 45, 1, Smoke::mf_static, 9, 16},	//16 Blitz::antialias(QImage&)
    {1, 85, 45, 1, Smoke::mf_static, 10, 17},	//17 Blitz::despeckle(QImage&)
    {1, 70, 56, 3, Smoke::mf_static, 10, 18},	//18 Blitz::contrast(QImage&, bool, int)
    {1, 94, 45, 1, Smoke::mf_static, 94, 19},	//19 Blitz::equalize(QImage&)
    {1, 130, 45, 1, Smoke::mf_static, 94, 20},	//20 Blitz::normalize(QImage&)
    {1, 123, 60, 2, Smoke::mf_static, 10, 21},	//21 Blitz::intensity(QImage&, float)
    {1, 66, 63, 3, Smoke::mf_static, 10, 22},	//22 Blitz::channelIntensity(QImage&, float, Blitz::RGBChannel)
    {1, 82, 60, 2, Smoke::mf_static, 10, 23},	//23 Blitz::desaturate(QImage&, float)
    {1, 96, 67, 3, Smoke::mf_static, 10, 24},	//24 Blitz::fade(QImage&, float, const QColor&)
    {1, 98, 71, 3, Smoke::mf_static, 10, 25},	//25 Blitz::flatten(QImage&, const QColor&, const QColor&)
    {1, 156, 75, 5, Smoke::mf_static, 9, 26},	//26 Blitz::threshold(QImage&, unsigned char, Blitz::RGBChannel, unsigned int, unsigned int)
    {1, 153, 60, 2, Smoke::mf_static, 9, 27},	//27 Blitz::swirl(QImage&, float)
    {1, 120, 60, 2, Smoke::mf_static, 9, 28},	//28 Blitz::implode(QImage&, float)
    {1, 166, 81, 4, Smoke::mf_static, 9, 29},	//29 Blitz::wave(QImage&, float, float, unsigned int)
    {1, 132, 47, 3, Smoke::mf_static, 9, 30},	//30 Blitz::oilPaint(QImage&, float, Blitz::EffectQuality)
    {1, 68, 45, 1, Smoke::mf_static, 9, 31},	//31 Blitz::charcoal(QImage&)
    {1, 109, 86, 4, Smoke::mf_static, 9, 32},	//32 Blitz::gradient(const QSize&, const QColor&, const QColor&, Blitz::GradientType)
    {1, 111, 91, 4, Smoke::mf_static, 9, 33},	//33 Blitz::grayGradient(const QSize&, unsigned char, unsigned char, Blitz::GradientType)
    {1, 162, 96, 6, Smoke::mf_static, 9, 34},	//34 Blitz::unbalancedGradient(const QSize&, const QColor&, const QColor&, Blitz::GradientType, int, int)
    {1, 113, 103, 6, Smoke::mf_static, 9, 35},	//35 Blitz::grayUnbalancedGradient(const QSize&, unsigned char, unsigned char, Blitz::GradientType, int, int)
    {1, 128, 110, 6, Smoke::mf_static, 10, 36},	//36 Blitz::modulate(QImage&, QImage&, bool, Blitz::ModulationType, int, Blitz::RGBChannel)
    {1, 5, 0, 0, Smoke::mf_ctor, 1, 37},	//37 Blitz::Blitz()
    {1, 5, 117, 1, Smoke::mf_ctor|Smoke::mf_copyctor, 1, 38},	//38 Blitz::Blitz(const Blitz&)
    {1, 125, 45, 1, Smoke::mf_static, 94, 39},	//39 Blitz::invert(QImage&)
    {1, 117, 45, 1, Smoke::mf_static, 94, 40},	//40 Blitz::grayscale(QImage&)
    {1, 139, 119, 2, Smoke::mf_static, 9, 41},	//41 Blitz::smoothScale(QImage&, const QSize&)
    {1, 139, 122, 3, Smoke::mf_static, 9, 42},	//42 Blitz::smoothScale(QImage&, int, int)
    {1, 144, 119, 2, Smoke::mf_static, 9, 43},	//43 Blitz::smoothScaleFilter(QImage&, const QSize&)
    {1, 144, 126, 3, Smoke::mf_static, 9, 44},	//44 Blitz::smoothScaleFilter(QImage&, const QSize&, float)
    {1, 144, 130, 4, Smoke::mf_static, 9, 45},	//45 Blitz::smoothScaleFilter(QImage&, const QSize&, float, Blitz::ScaleFilterType)
    {1, 144, 122, 3, Smoke::mf_static, 9, 46},	//46 Blitz::smoothScaleFilter(QImage&, int, int)
    {1, 144, 135, 4, Smoke::mf_static, 9, 47},	//47 Blitz::smoothScaleFilter(QImage&, int, int, float)
    {1, 144, 140, 5, Smoke::mf_static, 9, 48},	//48 Blitz::smoothScaleFilter(QImage&, int, int, float, Blitz::ScaleFilterType)
    {1, 79, 146, 3, Smoke::mf_static, 9, 49},	//49 Blitz::convolveInteger(QImage&, int, int*)
    {1, 63, 45, 1, Smoke::mf_static, 9, 50},	//50 Blitz::blur(QImage&)
    {1, 100, 45, 1, Smoke::mf_static, 9, 51},	//51 Blitz::gaussianBlur(QImage&)
    {1, 100, 60, 2, Smoke::mf_static, 9, 52},	//52 Blitz::gaussianBlur(QImage&, float)
    {1, 75, 45, 1, Smoke::mf_static, 9, 53},	//53 Blitz::convolveEdge(QImage&)
    {1, 75, 60, 2, Smoke::mf_static, 9, 54},	//54 Blitz::convolveEdge(QImage&, float)
    {1, 104, 45, 1, Smoke::mf_static, 9, 55},	//55 Blitz::gaussianSharpen(QImage&)
    {1, 104, 60, 2, Smoke::mf_static, 9, 56},	//56 Blitz::gaussianSharpen(QImage&, float)
    {1, 104, 41, 3, Smoke::mf_static, 9, 57},	//57 Blitz::gaussianSharpen(QImage&, float, float)
    {1, 136, 45, 1, Smoke::mf_static, 9, 58},	//58 Blitz::sharpen(QImage&)
    {1, 89, 45, 1, Smoke::mf_static, 9, 59},	//59 Blitz::emboss(QImage&)
    {1, 89, 60, 2, Smoke::mf_static, 9, 60},	//60 Blitz::emboss(QImage&, float)
    {1, 89, 41, 3, Smoke::mf_static, 9, 61},	//61 Blitz::emboss(QImage&, float, float)
    {1, 70, 4, 2, Smoke::mf_static, 10, 62},	//62 Blitz::contrast(QImage&, bool)
    {1, 82, 45, 1, Smoke::mf_static, 10, 63},	//63 Blitz::desaturate(QImage&)
    {1, 156, 45, 1, Smoke::mf_static, 9, 64},	//64 Blitz::threshold(QImage&)
    {1, 156, 150, 2, Smoke::mf_static, 9, 65},	//65 Blitz::threshold(QImage&, unsigned char)
    {1, 156, 153, 3, Smoke::mf_static, 9, 66},	//66 Blitz::threshold(QImage&, unsigned char, Blitz::RGBChannel)
    {1, 156, 157, 4, Smoke::mf_static, 9, 67},	//67 Blitz::threshold(QImage&, unsigned char, Blitz::RGBChannel, unsigned int)
    {1, 153, 45, 1, Smoke::mf_static, 9, 68},	//68 Blitz::swirl(QImage&)
    {1, 120, 45, 1, Smoke::mf_static, 9, 69},	//69 Blitz::implode(QImage&)
    {1, 166, 45, 1, Smoke::mf_static, 9, 70},	//70 Blitz::wave(QImage&)
    {1, 166, 60, 2, Smoke::mf_static, 9, 71},	//71 Blitz::wave(QImage&, float)
    {1, 166, 41, 3, Smoke::mf_static, 9, 72},	//72 Blitz::wave(QImage&, float, float)
    {1, 132, 45, 1, Smoke::mf_static, 9, 73},	//73 Blitz::oilPaint(QImage&)
    {1, 132, 60, 2, Smoke::mf_static, 9, 74},	//74 Blitz::oilPaint(QImage&, float)
    {1, 162, 86, 4, Smoke::mf_static, 9, 75},	//75 Blitz::unbalancedGradient(const QSize&, const QColor&, const QColor&, Blitz::GradientType)
    {1, 162, 162, 5, Smoke::mf_static, 9, 76},	//76 Blitz::unbalancedGradient(const QSize&, const QColor&, const QColor&, Blitz::GradientType, int)
    {1, 113, 91, 4, Smoke::mf_static, 9, 77},	//77 Blitz::grayUnbalancedGradient(const QSize&, unsigned char, unsigned char, Blitz::GradientType)
    {1, 113, 168, 5, Smoke::mf_static, 9, 78},	//78 Blitz::grayUnbalancedGradient(const QSize&, unsigned char, unsigned char, Blitz::GradientType, int)
    {1, 44, 0, 0, Smoke::mf_static|Smoke::mf_enum, 3, 79},	//79 Blitz::VerticalGradient (enum)
    {1, 23, 0, 0, Smoke::mf_static|Smoke::mf_enum, 3, 80},	//80 Blitz::HorizontalGradient (enum)
    {1, 14, 0, 0, Smoke::mf_static|Smoke::mf_enum, 3, 81},	//81 Blitz::DiagonalGradient (enum)
    {1, 12, 0, 0, Smoke::mf_static|Smoke::mf_enum, 3, 82},	//82 Blitz::CrossDiagonalGradient (enum)
    {1, 31, 0, 0, Smoke::mf_static|Smoke::mf_enum, 3, 83},	//83 Blitz::PyramidGradient (enum)
    {1, 38, 0, 0, Smoke::mf_static|Smoke::mf_enum, 3, 84},	//84 Blitz::RectangleGradient (enum)
    {1, 29, 0, 0, Smoke::mf_static|Smoke::mf_enum, 3, 85},	//85 Blitz::PipeCrossGradient (enum)
    {1, 15, 0, 0, Smoke::mf_static|Smoke::mf_enum, 3, 86},	//86 Blitz::EllipticGradient (enum)
    {1, 17, 0, 0, Smoke::mf_static|Smoke::mf_enum, 5, 87},	//87 Blitz::Grayscale (enum)
    {1, 9, 0, 0, Smoke::mf_static|Smoke::mf_enum, 5, 88},	//88 Blitz::Brightness (enum)
    {1, 39, 0, 0, Smoke::mf_static|Smoke::mf_enum, 5, 89},	//89 Blitz::Red (enum)
    {1, 18, 0, 0, Smoke::mf_static|Smoke::mf_enum, 5, 90},	//90 Blitz::Green (enum)
    {1, 7, 0, 0, Smoke::mf_static|Smoke::mf_enum, 5, 91},	//91 Blitz::Blue (enum)
    {1, 2, 0, 0, Smoke::mf_static|Smoke::mf_enum, 5, 92},	//92 Blitz::Alpha (enum)
    {1, 1, 0, 0, Smoke::mf_static|Smoke::mf_enum, 5, 93},	//93 Blitz::All (enum)
    {1, 27, 0, 0, Smoke::mf_static|Smoke::mf_enum, 2, 94},	//94 Blitz::Low (enum)
    {1, 22, 0, 0, Smoke::mf_static|Smoke::mf_enum, 2, 95},	//95 Blitz::High (enum)
    {1, 43, 0, 0, Smoke::mf_static|Smoke::mf_enum, 6, 96},	//96 Blitz::UndefinedFilter (enum)
    {1, 30, 0, 0, Smoke::mf_static|Smoke::mf_enum, 6, 97},	//97 Blitz::PointFilter (enum)
    {1, 8, 0, 0, Smoke::mf_static|Smoke::mf_enum, 6, 98},	//98 Blitz::BoxFilter (enum)
    {1, 42, 0, 0, Smoke::mf_static|Smoke::mf_enum, 6, 99},	//99 Blitz::TriangleFilter (enum)
    {1, 21, 0, 0, Smoke::mf_static|Smoke::mf_enum, 6, 100},	//100 Blitz::HermiteFilter (enum)
    {1, 20, 0, 0, Smoke::mf_static|Smoke::mf_enum, 6, 101},	//101 Blitz::HanningFilter (enum)
    {1, 19, 0, 0, Smoke::mf_static|Smoke::mf_enum, 6, 102},	//102 Blitz::HammingFilter (enum)
    {1, 4, 0, 0, Smoke::mf_static|Smoke::mf_enum, 6, 103},	//103 Blitz::BlackmanFilter (enum)
    {1, 16, 0, 0, Smoke::mf_static|Smoke::mf_enum, 6, 104},	//104 Blitz::GaussianFilter (enum)
    {1, 37, 0, 0, Smoke::mf_static|Smoke::mf_enum, 6, 105},	//105 Blitz::QuadraticFilter (enum)
    {1, 13, 0, 0, Smoke::mf_static|Smoke::mf_enum, 6, 106},	//106 Blitz::CubicFilter (enum)
    {1, 10, 0, 0, Smoke::mf_static|Smoke::mf_enum, 6, 107},	//107 Blitz::CatromFilter (enum)
    {1, 28, 0, 0, Smoke::mf_static|Smoke::mf_enum, 6, 108},	//108 Blitz::MitchellFilter (enum)
    {1, 26, 0, 0, Smoke::mf_static|Smoke::mf_enum, 6, 109},	//109 Blitz::LanczosFilter (enum)
    {1, 3, 0, 0, Smoke::mf_static|Smoke::mf_enum, 6, 110},	//110 Blitz::BesselFilter (enum)
    {1, 41, 0, 0, Smoke::mf_static|Smoke::mf_enum, 6, 111},	//111 Blitz::SincFilter (enum)
    {1, 25, 0, 0, Smoke::mf_static|Smoke::mf_enum, 4, 112},	//112 Blitz::Intensity (enum)
    {1, 40, 0, 0, Smoke::mf_static|Smoke::mf_enum, 4, 113},	//113 Blitz::Saturation (enum)
    {1, 24, 0, 0, Smoke::mf_static|Smoke::mf_enum, 4, 114},	//114 Blitz::HueShift (enum)
    {1, 11, 0, 0, Smoke::mf_static|Smoke::mf_enum, 4, 115},	//115 Blitz::Contrast (enum)
    {1, 171, 0, 0, Smoke::mf_dtor, 0, 116 },	//116 Blitz::~Blitz()
    {4, 55, 0, 0, Smoke::mf_static|Smoke::mf_enum, 106, 1},	//117 QGlobalSpace::_ISupper (enum)
    {4, 51, 0, 0, Smoke::mf_static|Smoke::mf_enum, 106, 2},	//118 QGlobalSpace::_ISlower (enum)
    {4, 46, 0, 0, Smoke::mf_static|Smoke::mf_enum, 106, 3},	//119 QGlobalSpace::_ISalpha (enum)
    {4, 49, 0, 0, Smoke::mf_static|Smoke::mf_enum, 106, 4},	//120 QGlobalSpace::_ISdigit (enum)
    {4, 56, 0, 0, Smoke::mf_static|Smoke::mf_enum, 106, 5},	//121 QGlobalSpace::_ISxdigit (enum)
    {4, 54, 0, 0, Smoke::mf_static|Smoke::mf_enum, 106, 6},	//122 QGlobalSpace::_ISspace (enum)
    {4, 52, 0, 0, Smoke::mf_static|Smoke::mf_enum, 106, 7},	//123 QGlobalSpace::_ISprint (enum)
    {4, 50, 0, 0, Smoke::mf_static|Smoke::mf_enum, 106, 8},	//124 QGlobalSpace::_ISgraph (enum)
    {4, 47, 0, 0, Smoke::mf_static|Smoke::mf_enum, 106, 9},	//125 QGlobalSpace::_ISblank (enum)
    {4, 48, 0, 0, Smoke::mf_static|Smoke::mf_enum, 106, 10},	//126 QGlobalSpace::_IScntrl (enum)
    {4, 53, 0, 0, Smoke::mf_static|Smoke::mf_enum, 106, 11},	//127 QGlobalSpace::_ISpunct (enum)
    {4, 45, 0, 0, Smoke::mf_static|Smoke::mf_enum, 106, 12},	//128 QGlobalSpace::_ISalnum (enum)
    {4, 33, 0, 0, Smoke::mf_static|Smoke::mf_enum, 92, 13},	//129 QGlobalSpace::QtDebugMsg (enum)
    {4, 36, 0, 0, Smoke::mf_static|Smoke::mf_enum, 92, 14},	//130 QGlobalSpace::QtWarningMsg (enum)
    {4, 32, 0, 0, Smoke::mf_static|Smoke::mf_enum, 92, 15},	//131 QGlobalSpace::QtCriticalMsg (enum)
    {4, 34, 0, 0, Smoke::mf_static|Smoke::mf_enum, 92, 16},	//132 QGlobalSpace::QtFatalMsg (enum)
    {4, 35, 0, 0, Smoke::mf_static|Smoke::mf_enum, 92, 17},	//133 QGlobalSpace::QtSystemMsg (enum)
    {4, 59, 0, 0, Smoke::mf_static|Smoke::mf_enum, 93, 18},	//134 QGlobalSpace::__codecvt_ok (enum)
    {4, 60, 0, 0, Smoke::mf_static|Smoke::mf_enum, 93, 19},	//135 QGlobalSpace::__codecvt_partial (enum)
    {4, 57, 0, 0, Smoke::mf_static|Smoke::mf_enum, 93, 20},	//136 QGlobalSpace::__codecvt_error (enum)
    {4, 58, 0, 0, Smoke::mf_static|Smoke::mf_enum, 93, 21},	//137 QGlobalSpace::__codecvt_noconv (enum)
};

static Smoke::Index ambiguousMethodList[] = {
    0,
};

// Class ID, munged name ID (index into methodNames), method def (see methods) if >0 or number of overloads if <0
static Smoke::MethodMap methodMaps[] = {
    {0, 0, 0},	//0 (no method)
    {1, 1, 93},	// Blitz::All
    {1, 2, 92},	// Blitz::Alpha
    {1, 3, 110},	// Blitz::BesselFilter
    {1, 4, 103},	// Blitz::BlackmanFilter
    {1, 5, 37},	// Blitz::Blitz
    {1, 6, 38},	// Blitz::Blitz#
    {1, 7, 91},	// Blitz::Blue
    {1, 8, 98},	// Blitz::BoxFilter
    {1, 9, 88},	// Blitz::Brightness
    {1, 10, 107},	// Blitz::CatromFilter
    {1, 11, 115},	// Blitz::Contrast
    {1, 12, 82},	// Blitz::CrossDiagonalGradient
    {1, 13, 106},	// Blitz::CubicFilter
    {1, 14, 81},	// Blitz::DiagonalGradient
    {1, 15, 86},	// Blitz::EllipticGradient
    {1, 16, 104},	// Blitz::GaussianFilter
    {1, 17, 87},	// Blitz::Grayscale
    {1, 18, 90},	// Blitz::Green
    {1, 19, 102},	// Blitz::HammingFilter
    {1, 20, 101},	// Blitz::HanningFilter
    {1, 21, 100},	// Blitz::HermiteFilter
    {1, 22, 95},	// Blitz::High
    {1, 23, 80},	// Blitz::HorizontalGradient
    {1, 24, 114},	// Blitz::HueShift
    {1, 25, 112},	// Blitz::Intensity
    {1, 26, 109},	// Blitz::LanczosFilter
    {1, 27, 94},	// Blitz::Low
    {1, 28, 108},	// Blitz::MitchellFilter
    {1, 29, 85},	// Blitz::PipeCrossGradient
    {1, 30, 97},	// Blitz::PointFilter
    {1, 31, 83},	// Blitz::PyramidGradient
    {1, 37, 105},	// Blitz::QuadraticFilter
    {1, 38, 84},	// Blitz::RectangleGradient
    {1, 39, 89},	// Blitz::Red
    {1, 40, 113},	// Blitz::Saturation
    {1, 41, 111},	// Blitz::SincFilter
    {1, 42, 99},	// Blitz::TriangleFilter
    {1, 43, 96},	// Blitz::UndefinedFilter
    {1, 44, 79},	// Blitz::VerticalGradient
    {1, 62, 16},	// Blitz::antialias#
    {1, 64, 50},	// Blitz::blur#
    {1, 65, 9},	// Blitz::blur#$
    {1, 67, 22},	// Blitz::channelIntensity#$$
    {1, 69, 31},	// Blitz::charcoal#
    {1, 71, 62},	// Blitz::contrast#$
    {1, 72, 18},	// Blitz::contrast#$$
    {1, 74, 7},	// Blitz::convolve#$$
    {1, 76, 53},	// Blitz::convolveEdge#
    {1, 77, 54},	// Blitz::convolveEdge#$
    {1, 78, 12},	// Blitz::convolveEdge#$$
    {1, 80, 49},	// Blitz::convolveInteger#$$
    {1, 81, 8},	// Blitz::convolveInteger#$$$
    {1, 83, 63},	// Blitz::desaturate#
    {1, 84, 23},	// Blitz::desaturate#$
    {1, 86, 17},	// Blitz::despeckle#
    {1, 88, 11},	// Blitz::edge#
    {1, 90, 59},	// Blitz::emboss#
    {1, 91, 60},	// Blitz::emboss#$
    {1, 92, 61},	// Blitz::emboss#$$
    {1, 93, 15},	// Blitz::emboss#$$$
    {1, 95, 19},	// Blitz::equalize#
    {1, 97, 24},	// Blitz::fade#$#
    {1, 99, 25},	// Blitz::flatten###
    {1, 101, 51},	// Blitz::gaussianBlur#
    {1, 102, 52},	// Blitz::gaussianBlur#$
    {1, 103, 10},	// Blitz::gaussianBlur#$$
    {1, 105, 55},	// Blitz::gaussianSharpen#
    {1, 106, 56},	// Blitz::gaussianSharpen#$
    {1, 107, 57},	// Blitz::gaussianSharpen#$$
    {1, 108, 13},	// Blitz::gaussianSharpen#$$$
    {1, 110, 32},	// Blitz::gradient###$
    {1, 112, 33},	// Blitz::grayGradient#$$$
    {1, 114, 77},	// Blitz::grayUnbalancedGradient#$$$
    {1, 115, 78},	// Blitz::grayUnbalancedGradient#$$$$
    {1, 116, 35},	// Blitz::grayUnbalancedGradient#$$$$$
    {1, 118, 40},	// Blitz::grayscale#
    {1, 119, 2},	// Blitz::grayscale#$
    {1, 121, 69},	// Blitz::implode#
    {1, 122, 28},	// Blitz::implode#$
    {1, 124, 21},	// Blitz::intensity#$
    {1, 126, 39},	// Blitz::invert#
    {1, 127, 1},	// Blitz::invert#$
    {1, 129, 36},	// Blitz::modulate##$$$$
    {1, 131, 20},	// Blitz::normalize#
    {1, 133, 73},	// Blitz::oilPaint#
    {1, 134, 74},	// Blitz::oilPaint#$
    {1, 135, 30},	// Blitz::oilPaint#$$
    {1, 137, 58},	// Blitz::sharpen#
    {1, 138, 14},	// Blitz::sharpen#$
    {1, 140, 41},	// Blitz::smoothScale##
    {1, 141, 3},	// Blitz::smoothScale##$
    {1, 142, 42},	// Blitz::smoothScale#$$
    {1, 143, 4},	// Blitz::smoothScale#$$$
    {1, 145, 43},	// Blitz::smoothScaleFilter##
    {1, 146, 44},	// Blitz::smoothScaleFilter##$
    {1, 147, 45},	// Blitz::smoothScaleFilter##$$
    {1, 148, 5},	// Blitz::smoothScaleFilter##$$$
    {1, 149, 46},	// Blitz::smoothScaleFilter#$$
    {1, 150, 47},	// Blitz::smoothScaleFilter#$$$
    {1, 151, 48},	// Blitz::smoothScaleFilter#$$$$
    {1, 152, 6},	// Blitz::smoothScaleFilter#$$$$$
    {1, 154, 68},	// Blitz::swirl#
    {1, 155, 27},	// Blitz::swirl#$
    {1, 157, 64},	// Blitz::threshold#
    {1, 158, 65},	// Blitz::threshold#$
    {1, 159, 66},	// Blitz::threshold#$$
    {1, 160, 67},	// Blitz::threshold#$$$
    {1, 161, 26},	// Blitz::threshold#$$$$
    {1, 163, 75},	// Blitz::unbalancedGradient###$
    {1, 164, 76},	// Blitz::unbalancedGradient###$$
    {1, 165, 34},	// Blitz::unbalancedGradient###$$$
    {1, 167, 70},	// Blitz::wave#
    {1, 168, 71},	// Blitz::wave#$
    {1, 169, 72},	// Blitz::wave#$$
    {1, 170, 29},	// Blitz::wave#$$$
    {1, 171, 116},	// Blitz::~Blitz
    {4, 32, 131},	// QGlobalSpace::QtCriticalMsg
    {4, 33, 129},	// QGlobalSpace::QtDebugMsg
    {4, 34, 132},	// QGlobalSpace::QtFatalMsg
    {4, 35, 133},	// QGlobalSpace::QtSystemMsg
    {4, 36, 130},	// QGlobalSpace::QtWarningMsg
    {4, 45, 128},	// QGlobalSpace::_ISalnum
    {4, 46, 119},	// QGlobalSpace::_ISalpha
    {4, 47, 125},	// QGlobalSpace::_ISblank
    {4, 48, 126},	// QGlobalSpace::_IScntrl
    {4, 49, 120},	// QGlobalSpace::_ISdigit
    {4, 50, 124},	// QGlobalSpace::_ISgraph
    {4, 51, 118},	// QGlobalSpace::_ISlower
    {4, 52, 123},	// QGlobalSpace::_ISprint
    {4, 53, 127},	// QGlobalSpace::_ISpunct
    {4, 54, 122},	// QGlobalSpace::_ISspace
    {4, 55, 117},	// QGlobalSpace::_ISupper
    {4, 56, 121},	// QGlobalSpace::_ISxdigit
    {4, 57, 136},	// QGlobalSpace::__codecvt_error
    {4, 58, 137},	// QGlobalSpace::__codecvt_noconv
    {4, 59, 134},	// QGlobalSpace::__codecvt_ok
    {4, 60, 135},	// QGlobalSpace::__codecvt_partial
};

}

extern "C" {

static bool initialized = false;
Smoke *qimageblitz_Smoke = 0;

// Create the Smoke instance encapsulating all the above.
void init_qimageblitz_Smoke() {
    if (initialized) return;
    qimageblitz_Smoke = new Smoke(
        "qimageblitz",
        __smokeqimageblitz::classes, 8,
        __smokeqimageblitz::methods, 138,
        __smokeqimageblitz::methodMaps, 138,
        __smokeqimageblitz::methodNames, 171,
        __smokeqimageblitz::types, 112,
        __smokeqimageblitz::inheritanceList,
        __smokeqimageblitz::argumentList,
        __smokeqimageblitz::ambiguousMethodList,
        __smokeqimageblitz::cast );
    initialized = true;
}

void delete_qimageblitz_Smoke() { delete qimageblitz_Smoke; }

}
