#include <qscintilla2_includes.h>

#include <smoke.h>
#include <qsci_smoke.h>

namespace __smokeqsci {

static void *cast(void *xptr, Smoke::Index from, Smoke::Index to) {
  switch(from) {
    case 1:   //QAbstractScrollArea
      switch(to) {
        case 16: return (void*)(QFrame*)(QAbstractScrollArea*)xptr;
        case 47: return (void*)(QWidget*)(QAbstractScrollArea*)xptr;
        case 28: return (void*)(QObject*)(QAbstractScrollArea*)xptr;
        case 1: return (void*)(QAbstractScrollArea*)xptr;
        case 87: return (void*)(QsciScintillaBase*)(QAbstractScrollArea*)xptr;
        case 86: return (void*)(QsciScintilla*)(QAbstractScrollArea*)xptr;
        default: return xptr;
      }
    case 2:   //QActionEvent
      switch(to) {
        case 2: return (void*)(QActionEvent*)xptr;
        default: return xptr;
      }
    case 3:   //QBool
      switch(to) {
        case 3: return (void*)(QBool*)xptr;
        default: return xptr;
      }
    case 4:   //QByteArray
      switch(to) {
        case 4: return (void*)(QByteArray*)xptr;
        default: return xptr;
      }
    case 5:   //QChildEvent
      switch(to) {
        case 5: return (void*)(QChildEvent*)xptr;
        default: return xptr;
      }
    case 6:   //QCloseEvent
      switch(to) {
        case 6: return (void*)(QCloseEvent*)xptr;
        default: return xptr;
      }
    case 7:   //QColor
      switch(to) {
        case 7: return (void*)(QColor*)xptr;
        default: return xptr;
      }
    case 8:   //QContextMenuEvent
      switch(to) {
        case 8: return (void*)(QContextMenuEvent*)xptr;
        default: return xptr;
      }
    case 9:   //QDragEnterEvent
      switch(to) {
        case 9: return (void*)(QDragEnterEvent*)xptr;
        default: return xptr;
      }
    case 10:   //QDragLeaveEvent
      switch(to) {
        case 10: return (void*)(QDragLeaveEvent*)xptr;
        default: return xptr;
      }
    case 11:   //QDragMoveEvent
      switch(to) {
        case 11: return (void*)(QDragMoveEvent*)xptr;
        default: return xptr;
      }
    case 12:   //QDropEvent
      switch(to) {
        case 12: return (void*)(QDropEvent*)xptr;
        default: return xptr;
      }
    case 13:   //QEvent
      switch(to) {
        case 13: return (void*)(QEvent*)xptr;
        default: return xptr;
      }
    case 14:   //QFocusEvent
      switch(to) {
        case 14: return (void*)(QFocusEvent*)xptr;
        default: return xptr;
      }
    case 15:   //QFont
      switch(to) {
        case 15: return (void*)(QFont*)xptr;
        default: return xptr;
      }
    case 16:   //QFrame
      switch(to) {
        case 47: return (void*)(QWidget*)(QFrame*)xptr;
        case 28: return (void*)(QObject*)(QFrame*)xptr;
        case 16: return (void*)(QFrame*)xptr;
        case 87: return (void*)(QsciScintillaBase*)(QFrame*)xptr;
        case 86: return (void*)(QsciScintilla*)(QFrame*)xptr;
        default: return xptr;
      }
    case 18:   //QHideEvent
      switch(to) {
        case 18: return (void*)(QHideEvent*)xptr;
        default: return xptr;
      }
    case 19:   //QIODevice
      switch(to) {
        case 28: return (void*)(QObject*)(QIODevice*)xptr;
        case 19: return (void*)(QIODevice*)xptr;
        default: return xptr;
      }
    case 20:   //QImage
      switch(to) {
        case 20: return (void*)(QImage*)xptr;
        default: return xptr;
      }
    case 21:   //QInputMethodEvent
      switch(to) {
        case 21: return (void*)(QInputMethodEvent*)xptr;
        default: return xptr;
      }
    case 22:   //QKeyEvent
      switch(to) {
        case 22: return (void*)(QKeyEvent*)xptr;
        default: return xptr;
      }
    case 23:   //QMenu
      switch(to) {
        case 23: return (void*)(QMenu*)xptr;
        default: return xptr;
      }
    case 24:   //QMetaObject
      switch(to) {
        case 24: return (void*)(QMetaObject*)xptr;
        default: return xptr;
      }
    case 25:   //QMimeData
      switch(to) {
        case 25: return (void*)(QMimeData*)xptr;
        default: return xptr;
      }
    case 26:   //QMouseEvent
      switch(to) {
        case 26: return (void*)(QMouseEvent*)xptr;
        default: return xptr;
      }
    case 27:   //QMoveEvent
      switch(to) {
        case 27: return (void*)(QMoveEvent*)xptr;
        default: return xptr;
      }
    case 28:   //QObject
      switch(to) {
        case 28: return (void*)(QObject*)xptr;
        case 66: return (void*)(QsciLexerIDL*)(QObject*)xptr;
        case 59: return (void*)(QsciLexerCSharp*)(QObject*)xptr;
        case 67: return (void*)(QsciLexerJava*)(QObject*)xptr;
        case 81: return (void*)(QsciLexerVHDL*)(QObject*)xptr;
        case 83: return (void*)(QsciLexerYAML*)(QObject*)xptr;
        case 69: return (void*)(QsciLexerLua*)(QObject*)xptr;
        case 76: return (void*)(QsciLexerPython*)(QObject*)xptr;
        case 54: return (void*)(QsciLexerBash*)(QObject*)xptr;
        case 49: return (void*)(QsciAbstractAPIs*)(QObject*)xptr;
        case 57: return (void*)(QsciLexerCPP*)(QObject*)xptr;
        case 62: return (void*)(QsciLexerDiff*)(QObject*)xptr;
        case 70: return (void*)(QsciLexerMakefile*)(QObject*)xptr;
        case 68: return (void*)(QsciLexerJavaScript*)(QObject*)xptr;
        case 65: return (void*)(QsciLexerHTML*)(QObject*)xptr;
        case 78: return (void*)(QsciLexerSQL*)(QObject*)xptr;
        case 87: return (void*)(QsciScintillaBase*)(QObject*)xptr;
        case 79: return (void*)(QsciLexerTCL*)(QObject*)xptr;
        case 75: return (void*)(QsciLexerProperties*)(QObject*)xptr;
        case 60: return (void*)(QsciLexerCustom*)(QObject*)xptr;
        case 48: return (void*)(QsciAPIs*)(QObject*)xptr;
        case 58: return (void*)(QsciLexerCSS*)(QObject*)xptr;
        case 73: return (void*)(QsciLexerPerl*)(QObject*)xptr;
        case 61: return (void*)(QsciLexerD*)(QObject*)xptr;
        case 55: return (void*)(QsciLexerBatch*)(QObject*)xptr;
        case 77: return (void*)(QsciLexerRuby*)(QObject*)xptr;
        case 80: return (void*)(QsciLexerTeX*)(QObject*)xptr;
        case 53: return (void*)(QsciLexer*)(QObject*)xptr;
        case 71: return (void*)(QsciLexerPOV*)(QObject*)xptr;
        case 86: return (void*)(QsciScintilla*)(QObject*)xptr;
        case 84: return (void*)(QsciMacro*)(QObject*)xptr;
        case 74: return (void*)(QsciLexerPostScript*)(QObject*)xptr;
        case 56: return (void*)(QsciLexerCMake*)(QObject*)xptr;
        case 63: return (void*)(QsciLexerFortran*)(QObject*)xptr;
        case 64: return (void*)(QsciLexerFortran77*)(QObject*)xptr;
        case 72: return (void*)(QsciLexerPascal*)(QObject*)xptr;
        case 82: return (void*)(QsciLexerXML*)(QObject*)xptr;
        default: return xptr;
      }
    case 29:   //QPaintEngine
      switch(to) {
        case 29: return (void*)(QPaintEngine*)xptr;
        default: return xptr;
      }
    case 30:   //QPaintEvent
      switch(to) {
        case 30: return (void*)(QPaintEvent*)xptr;
        default: return xptr;
      }
    case 31:   //QPainter
      switch(to) {
        case 31: return (void*)(QPainter*)xptr;
        default: return xptr;
      }
    case 32:   //QPalette
      switch(to) {
        case 32: return (void*)(QPalette*)xptr;
        default: return xptr;
      }
    case 33:   //QPixmap
      switch(to) {
        case 33: return (void*)(QPixmap*)xptr;
        default: return xptr;
      }
    case 34:   //QPoint
      switch(to) {
        case 34: return (void*)(QPoint*)xptr;
        default: return xptr;
      }
    case 35:   //QPrinter
      switch(to) {
        case 35: return (void*)(QPrinter*)xptr;
        case 85: return (void*)(QsciPrinter*)(QPrinter*)xptr;
        default: return xptr;
      }
    case 36:   //QRect
      switch(to) {
        case 36: return (void*)(QRect*)xptr;
        default: return xptr;
      }
    case 37:   //QRegExp
      switch(to) {
        case 37: return (void*)(QRegExp*)xptr;
        default: return xptr;
      }
    case 38:   //QResizeEvent
      switch(to) {
        case 38: return (void*)(QResizeEvent*)xptr;
        default: return xptr;
      }
    case 39:   //QSettings
      switch(to) {
        case 39: return (void*)(QSettings*)xptr;
        default: return xptr;
      }
    case 40:   //QShowEvent
      switch(to) {
        case 40: return (void*)(QShowEvent*)xptr;
        default: return xptr;
      }
    case 41:   //QSize
      switch(to) {
        case 41: return (void*)(QSize*)xptr;
        default: return xptr;
      }
    case 42:   //QStyle
      switch(to) {
        case 42: return (void*)(QStyle*)xptr;
        default: return xptr;
      }
    case 43:   //QTabletEvent
      switch(to) {
        case 43: return (void*)(QTabletEvent*)xptr;
        default: return xptr;
      }
    case 44:   //QTimerEvent
      switch(to) {
        case 44: return (void*)(QTimerEvent*)xptr;
        default: return xptr;
      }
    case 45:   //QVariant
      switch(to) {
        case 45: return (void*)(QVariant*)xptr;
        default: return xptr;
      }
    case 46:   //QWheelEvent
      switch(to) {
        case 46: return (void*)(QWheelEvent*)xptr;
        default: return xptr;
      }
    case 47:   //QWidget
      switch(to) {
        case 28: return (void*)(QObject*)(QWidget*)xptr;
        case 47: return (void*)(QWidget*)xptr;
        case 87: return (void*)(QsciScintillaBase*)(QWidget*)xptr;
        case 86: return (void*)(QsciScintilla*)(QWidget*)xptr;
        default: return xptr;
      }
    case 48:   //QsciAPIs
      switch(to) {
        case 49: return (void*)(QsciAbstractAPIs*)(QsciAPIs*)xptr;
        case 28: return (void*)(QObject*)(QsciAPIs*)xptr;
        case 48: return (void*)(QsciAPIs*)xptr;
        default: return xptr;
      }
    case 49:   //QsciAbstractAPIs
      switch(to) {
        case 28: return (void*)(QObject*)(QsciAbstractAPIs*)xptr;
        case 49: return (void*)(QsciAbstractAPIs*)xptr;
        case 48: return (void*)(QsciAPIs*)(QsciAbstractAPIs*)xptr;
        default: return xptr;
      }
    case 50:   //QsciCommand
      switch(to) {
        case 50: return (void*)(QsciCommand*)xptr;
        default: return xptr;
      }
    case 51:   //QsciCommandSet
      switch(to) {
        case 51: return (void*)(QsciCommandSet*)xptr;
        default: return xptr;
      }
    case 52:   //QsciDocument
      switch(to) {
        case 52: return (void*)(QsciDocument*)xptr;
        default: return xptr;
      }
    case 53:   //QsciLexer
      switch(to) {
        case 28: return (void*)(QObject*)(QsciLexer*)xptr;
        case 53: return (void*)(QsciLexer*)xptr;
        case 66: return (void*)(QsciLexerIDL*)(QsciLexer*)xptr;
        case 59: return (void*)(QsciLexerCSharp*)(QsciLexer*)xptr;
        case 67: return (void*)(QsciLexerJava*)(QsciLexer*)xptr;
        case 81: return (void*)(QsciLexerVHDL*)(QsciLexer*)xptr;
        case 83: return (void*)(QsciLexerYAML*)(QsciLexer*)xptr;
        case 69: return (void*)(QsciLexerLua*)(QsciLexer*)xptr;
        case 76: return (void*)(QsciLexerPython*)(QsciLexer*)xptr;
        case 54: return (void*)(QsciLexerBash*)(QsciLexer*)xptr;
        case 57: return (void*)(QsciLexerCPP*)(QsciLexer*)xptr;
        case 62: return (void*)(QsciLexerDiff*)(QsciLexer*)xptr;
        case 70: return (void*)(QsciLexerMakefile*)(QsciLexer*)xptr;
        case 68: return (void*)(QsciLexerJavaScript*)(QsciLexer*)xptr;
        case 65: return (void*)(QsciLexerHTML*)(QsciLexer*)xptr;
        case 78: return (void*)(QsciLexerSQL*)(QsciLexer*)xptr;
        case 79: return (void*)(QsciLexerTCL*)(QsciLexer*)xptr;
        case 75: return (void*)(QsciLexerProperties*)(QsciLexer*)xptr;
        case 60: return (void*)(QsciLexerCustom*)(QsciLexer*)xptr;
        case 58: return (void*)(QsciLexerCSS*)(QsciLexer*)xptr;
        case 73: return (void*)(QsciLexerPerl*)(QsciLexer*)xptr;
        case 61: return (void*)(QsciLexerD*)(QsciLexer*)xptr;
        case 55: return (void*)(QsciLexerBatch*)(QsciLexer*)xptr;
        case 77: return (void*)(QsciLexerRuby*)(QsciLexer*)xptr;
        case 80: return (void*)(QsciLexerTeX*)(QsciLexer*)xptr;
        case 71: return (void*)(QsciLexerPOV*)(QsciLexer*)xptr;
        case 74: return (void*)(QsciLexerPostScript*)(QsciLexer*)xptr;
        case 56: return (void*)(QsciLexerCMake*)(QsciLexer*)xptr;
        case 63: return (void*)(QsciLexerFortran*)(QsciLexer*)xptr;
        case 64: return (void*)(QsciLexerFortran77*)(QsciLexer*)xptr;
        case 72: return (void*)(QsciLexerPascal*)(QsciLexer*)xptr;
        case 82: return (void*)(QsciLexerXML*)(QsciLexer*)xptr;
        default: return xptr;
      }
    case 54:   //QsciLexerBash
      switch(to) {
        case 53: return (void*)(QsciLexer*)(QsciLexerBash*)xptr;
        case 28: return (void*)(QObject*)(QsciLexerBash*)xptr;
        case 54: return (void*)(QsciLexerBash*)xptr;
        default: return xptr;
      }
    case 55:   //QsciLexerBatch
      switch(to) {
        case 53: return (void*)(QsciLexer*)(QsciLexerBatch*)xptr;
        case 28: return (void*)(QObject*)(QsciLexerBatch*)xptr;
        case 55: return (void*)(QsciLexerBatch*)xptr;
        default: return xptr;
      }
    case 56:   //QsciLexerCMake
      switch(to) {
        case 53: return (void*)(QsciLexer*)(QsciLexerCMake*)xptr;
        case 28: return (void*)(QObject*)(QsciLexerCMake*)xptr;
        case 56: return (void*)(QsciLexerCMake*)xptr;
        default: return xptr;
      }
    case 57:   //QsciLexerCPP
      switch(to) {
        case 53: return (void*)(QsciLexer*)(QsciLexerCPP*)xptr;
        case 28: return (void*)(QObject*)(QsciLexerCPP*)xptr;
        case 57: return (void*)(QsciLexerCPP*)xptr;
        case 66: return (void*)(QsciLexerIDL*)(QsciLexerCPP*)xptr;
        case 59: return (void*)(QsciLexerCSharp*)(QsciLexerCPP*)xptr;
        case 67: return (void*)(QsciLexerJava*)(QsciLexerCPP*)xptr;
        case 68: return (void*)(QsciLexerJavaScript*)(QsciLexerCPP*)xptr;
        default: return xptr;
      }
    case 58:   //QsciLexerCSS
      switch(to) {
        case 53: return (void*)(QsciLexer*)(QsciLexerCSS*)xptr;
        case 28: return (void*)(QObject*)(QsciLexerCSS*)xptr;
        case 58: return (void*)(QsciLexerCSS*)xptr;
        default: return xptr;
      }
    case 59:   //QsciLexerCSharp
      switch(to) {
        case 57: return (void*)(QsciLexerCPP*)(QsciLexerCSharp*)xptr;
        case 53: return (void*)(QsciLexer*)(QsciLexerCSharp*)xptr;
        case 28: return (void*)(QObject*)(QsciLexerCSharp*)xptr;
        case 59: return (void*)(QsciLexerCSharp*)xptr;
        default: return xptr;
      }
    case 60:   //QsciLexerCustom
      switch(to) {
        case 53: return (void*)(QsciLexer*)(QsciLexerCustom*)xptr;
        case 28: return (void*)(QObject*)(QsciLexerCustom*)xptr;
        case 60: return (void*)(QsciLexerCustom*)xptr;
        default: return xptr;
      }
    case 61:   //QsciLexerD
      switch(to) {
        case 53: return (void*)(QsciLexer*)(QsciLexerD*)xptr;
        case 28: return (void*)(QObject*)(QsciLexerD*)xptr;
        case 61: return (void*)(QsciLexerD*)xptr;
        default: return xptr;
      }
    case 62:   //QsciLexerDiff
      switch(to) {
        case 53: return (void*)(QsciLexer*)(QsciLexerDiff*)xptr;
        case 28: return (void*)(QObject*)(QsciLexerDiff*)xptr;
        case 62: return (void*)(QsciLexerDiff*)xptr;
        default: return xptr;
      }
    case 63:   //QsciLexerFortran
      switch(to) {
        case 64: return (void*)(QsciLexerFortran77*)(QsciLexerFortran*)xptr;
        case 53: return (void*)(QsciLexer*)(QsciLexerFortran*)xptr;
        case 28: return (void*)(QObject*)(QsciLexerFortran*)xptr;
        case 63: return (void*)(QsciLexerFortran*)xptr;
        default: return xptr;
      }
    case 64:   //QsciLexerFortran77
      switch(to) {
        case 53: return (void*)(QsciLexer*)(QsciLexerFortran77*)xptr;
        case 28: return (void*)(QObject*)(QsciLexerFortran77*)xptr;
        case 64: return (void*)(QsciLexerFortran77*)xptr;
        case 63: return (void*)(QsciLexerFortran*)(QsciLexerFortran77*)xptr;
        default: return xptr;
      }
    case 65:   //QsciLexerHTML
      switch(to) {
        case 53: return (void*)(QsciLexer*)(QsciLexerHTML*)xptr;
        case 28: return (void*)(QObject*)(QsciLexerHTML*)xptr;
        case 65: return (void*)(QsciLexerHTML*)xptr;
        case 82: return (void*)(QsciLexerXML*)(QsciLexerHTML*)xptr;
        default: return xptr;
      }
    case 66:   //QsciLexerIDL
      switch(to) {
        case 57: return (void*)(QsciLexerCPP*)(QsciLexerIDL*)xptr;
        case 53: return (void*)(QsciLexer*)(QsciLexerIDL*)xptr;
        case 28: return (void*)(QObject*)(QsciLexerIDL*)xptr;
        case 66: return (void*)(QsciLexerIDL*)xptr;
        default: return xptr;
      }
    case 67:   //QsciLexerJava
      switch(to) {
        case 57: return (void*)(QsciLexerCPP*)(QsciLexerJava*)xptr;
        case 53: return (void*)(QsciLexer*)(QsciLexerJava*)xptr;
        case 28: return (void*)(QObject*)(QsciLexerJava*)xptr;
        case 67: return (void*)(QsciLexerJava*)xptr;
        default: return xptr;
      }
    case 68:   //QsciLexerJavaScript
      switch(to) {
        case 57: return (void*)(QsciLexerCPP*)(QsciLexerJavaScript*)xptr;
        case 53: return (void*)(QsciLexer*)(QsciLexerJavaScript*)xptr;
        case 28: return (void*)(QObject*)(QsciLexerJavaScript*)xptr;
        case 68: return (void*)(QsciLexerJavaScript*)xptr;
        default: return xptr;
      }
    case 69:   //QsciLexerLua
      switch(to) {
        case 53: return (void*)(QsciLexer*)(QsciLexerLua*)xptr;
        case 28: return (void*)(QObject*)(QsciLexerLua*)xptr;
        case 69: return (void*)(QsciLexerLua*)xptr;
        default: return xptr;
      }
    case 70:   //QsciLexerMakefile
      switch(to) {
        case 53: return (void*)(QsciLexer*)(QsciLexerMakefile*)xptr;
        case 28: return (void*)(QObject*)(QsciLexerMakefile*)xptr;
        case 70: return (void*)(QsciLexerMakefile*)xptr;
        default: return xptr;
      }
    case 71:   //QsciLexerPOV
      switch(to) {
        case 53: return (void*)(QsciLexer*)(QsciLexerPOV*)xptr;
        case 28: return (void*)(QObject*)(QsciLexerPOV*)xptr;
        case 71: return (void*)(QsciLexerPOV*)xptr;
        default: return xptr;
      }
    case 72:   //QsciLexerPascal
      switch(to) {
        case 53: return (void*)(QsciLexer*)(QsciLexerPascal*)xptr;
        case 28: return (void*)(QObject*)(QsciLexerPascal*)xptr;
        case 72: return (void*)(QsciLexerPascal*)xptr;
        default: return xptr;
      }
    case 73:   //QsciLexerPerl
      switch(to) {
        case 53: return (void*)(QsciLexer*)(QsciLexerPerl*)xptr;
        case 28: return (void*)(QObject*)(QsciLexerPerl*)xptr;
        case 73: return (void*)(QsciLexerPerl*)xptr;
        default: return xptr;
      }
    case 74:   //QsciLexerPostScript
      switch(to) {
        case 53: return (void*)(QsciLexer*)(QsciLexerPostScript*)xptr;
        case 28: return (void*)(QObject*)(QsciLexerPostScript*)xptr;
        case 74: return (void*)(QsciLexerPostScript*)xptr;
        default: return xptr;
      }
    case 75:   //QsciLexerProperties
      switch(to) {
        case 53: return (void*)(QsciLexer*)(QsciLexerProperties*)xptr;
        case 28: return (void*)(QObject*)(QsciLexerProperties*)xptr;
        case 75: return (void*)(QsciLexerProperties*)xptr;
        default: return xptr;
      }
    case 76:   //QsciLexerPython
      switch(to) {
        case 53: return (void*)(QsciLexer*)(QsciLexerPython*)xptr;
        case 28: return (void*)(QObject*)(QsciLexerPython*)xptr;
        case 76: return (void*)(QsciLexerPython*)xptr;
        default: return xptr;
      }
    case 77:   //QsciLexerRuby
      switch(to) {
        case 53: return (void*)(QsciLexer*)(QsciLexerRuby*)xptr;
        case 28: return (void*)(QObject*)(QsciLexerRuby*)xptr;
        case 77: return (void*)(QsciLexerRuby*)xptr;
        default: return xptr;
      }
    case 78:   //QsciLexerSQL
      switch(to) {
        case 53: return (void*)(QsciLexer*)(QsciLexerSQL*)xptr;
        case 28: return (void*)(QObject*)(QsciLexerSQL*)xptr;
        case 78: return (void*)(QsciLexerSQL*)xptr;
        default: return xptr;
      }
    case 79:   //QsciLexerTCL
      switch(to) {
        case 53: return (void*)(QsciLexer*)(QsciLexerTCL*)xptr;
        case 28: return (void*)(QObject*)(QsciLexerTCL*)xptr;
        case 79: return (void*)(QsciLexerTCL*)xptr;
        default: return xptr;
      }
    case 80:   //QsciLexerTeX
      switch(to) {
        case 53: return (void*)(QsciLexer*)(QsciLexerTeX*)xptr;
        case 28: return (void*)(QObject*)(QsciLexerTeX*)xptr;
        case 80: return (void*)(QsciLexerTeX*)xptr;
        default: return xptr;
      }
    case 81:   //QsciLexerVHDL
      switch(to) {
        case 53: return (void*)(QsciLexer*)(QsciLexerVHDL*)xptr;
        case 28: return (void*)(QObject*)(QsciLexerVHDL*)xptr;
        case 81: return (void*)(QsciLexerVHDL*)xptr;
        default: return xptr;
      }
    case 82:   //QsciLexerXML
      switch(to) {
        case 65: return (void*)(QsciLexerHTML*)(QsciLexerXML*)xptr;
        case 53: return (void*)(QsciLexer*)(QsciLexerXML*)xptr;
        case 28: return (void*)(QObject*)(QsciLexerXML*)xptr;
        case 82: return (void*)(QsciLexerXML*)xptr;
        default: return xptr;
      }
    case 83:   //QsciLexerYAML
      switch(to) {
        case 53: return (void*)(QsciLexer*)(QsciLexerYAML*)xptr;
        case 28: return (void*)(QObject*)(QsciLexerYAML*)xptr;
        case 83: return (void*)(QsciLexerYAML*)xptr;
        default: return xptr;
      }
    case 84:   //QsciMacro
      switch(to) {
        case 28: return (void*)(QObject*)(QsciMacro*)xptr;
        case 84: return (void*)(QsciMacro*)xptr;
        default: return xptr;
      }
    case 85:   //QsciPrinter
      switch(to) {
        case 35: return (void*)(QPrinter*)(QsciPrinter*)xptr;
        case 85: return (void*)(QsciPrinter*)xptr;
        default: return xptr;
      }
    case 86:   //QsciScintilla
      switch(to) {
        case 87: return (void*)(QsciScintillaBase*)(QsciScintilla*)xptr;
        case 1: return (void*)(QAbstractScrollArea*)(QsciScintilla*)xptr;
        case 16: return (void*)(QFrame*)(QsciScintilla*)xptr;
        case 47: return (void*)(QWidget*)(QsciScintilla*)xptr;
        case 28: return (void*)(QObject*)(QsciScintilla*)xptr;
        case 86: return (void*)(QsciScintilla*)xptr;
        default: return xptr;
      }
    case 87:   //QsciScintillaBase
      switch(to) {
        case 1: return (void*)(QAbstractScrollArea*)(QsciScintillaBase*)xptr;
        case 16: return (void*)(QFrame*)(QsciScintillaBase*)xptr;
        case 47: return (void*)(QWidget*)(QsciScintillaBase*)xptr;
        case 28: return (void*)(QObject*)(QsciScintillaBase*)xptr;
        case 87: return (void*)(QsciScintillaBase*)xptr;
        case 86: return (void*)(QsciScintilla*)(QsciScintillaBase*)xptr;
        default: return xptr;
      }
    case 88:   //QsciStyle
      switch(to) {
        case 88: return (void*)(QsciStyle*)xptr;
        default: return xptr;
      }
    case 89:   //QsciStyledText
      switch(to) {
        case 89: return (void*)(QsciStyledText*)xptr;
        default: return xptr;
      }
    default: return xptr;
  }
}

// Group of Indexes (0 separated) used as super class lists.
// Classes with super classes have an index into this array.
static Smoke::Index inheritanceList[] = {
    0,	// 0: (no super class)
    49, 0,	// 1: QsciAbstractAPIs
    28, 0,	// 3: QObject
    53, 0,	// 5: QsciLexer
    57, 0,	// 7: QsciLexerCPP
    64, 0,	// 9: QsciLexerFortran77
    65, 0,	// 11: QsciLexerHTML
    35, 0,	// 13: QPrinter
    87, 0,	// 15: QsciScintillaBase
    1, 0,	// 17: QAbstractScrollArea
};

// These are the xenum functions for manipulating enum pointers
void xenum_QsciScintilla(Smoke::EnumOperation, Smoke::Index, void*&, long&);
void xenum_QsciCommand(Smoke::EnumOperation, Smoke::Index, void*&, long&);
void xenum_QsciLexerPython(Smoke::EnumOperation, Smoke::Index, void*&, long&);
void xenum_QsciStyle(Smoke::EnumOperation, Smoke::Index, void*&, long&);

// Those are the xcall functions defined in each x_*.cpp file, for dispatching method calls
void xcall_QGlobalSpace(Smoke::Index, void*, Smoke::Stack);
void xcall_QsciAPIs(Smoke::Index, void*, Smoke::Stack);
void xcall_QsciAbstractAPIs(Smoke::Index, void*, Smoke::Stack);
void xcall_QsciCommand(Smoke::Index, void*, Smoke::Stack);
void xcall_QsciCommandSet(Smoke::Index, void*, Smoke::Stack);
void xcall_QsciDocument(Smoke::Index, void*, Smoke::Stack);
void xcall_QsciLexer(Smoke::Index, void*, Smoke::Stack);
void xcall_QsciLexerBash(Smoke::Index, void*, Smoke::Stack);
void xcall_QsciLexerBatch(Smoke::Index, void*, Smoke::Stack);
void xcall_QsciLexerCMake(Smoke::Index, void*, Smoke::Stack);
void xcall_QsciLexerCPP(Smoke::Index, void*, Smoke::Stack);
void xcall_QsciLexerCSS(Smoke::Index, void*, Smoke::Stack);
void xcall_QsciLexerCSharp(Smoke::Index, void*, Smoke::Stack);
void xcall_QsciLexerCustom(Smoke::Index, void*, Smoke::Stack);
void xcall_QsciLexerD(Smoke::Index, void*, Smoke::Stack);
void xcall_QsciLexerDiff(Smoke::Index, void*, Smoke::Stack);
void xcall_QsciLexerFortran(Smoke::Index, void*, Smoke::Stack);
void xcall_QsciLexerFortran77(Smoke::Index, void*, Smoke::Stack);
void xcall_QsciLexerHTML(Smoke::Index, void*, Smoke::Stack);
void xcall_QsciLexerIDL(Smoke::Index, void*, Smoke::Stack);
void xcall_QsciLexerJava(Smoke::Index, void*, Smoke::Stack);
void xcall_QsciLexerJavaScript(Smoke::Index, void*, Smoke::Stack);
void xcall_QsciLexerLua(Smoke::Index, void*, Smoke::Stack);
void xcall_QsciLexerMakefile(Smoke::Index, void*, Smoke::Stack);
void xcall_QsciLexerPOV(Smoke::Index, void*, Smoke::Stack);
void xcall_QsciLexerPascal(Smoke::Index, void*, Smoke::Stack);
void xcall_QsciLexerPerl(Smoke::Index, void*, Smoke::Stack);
void xcall_QsciLexerPostScript(Smoke::Index, void*, Smoke::Stack);
void xcall_QsciLexerProperties(Smoke::Index, void*, Smoke::Stack);
void xcall_QsciLexerPython(Smoke::Index, void*, Smoke::Stack);
void xcall_QsciLexerRuby(Smoke::Index, void*, Smoke::Stack);
void xcall_QsciLexerSQL(Smoke::Index, void*, Smoke::Stack);
void xcall_QsciLexerTCL(Smoke::Index, void*, Smoke::Stack);
void xcall_QsciLexerTeX(Smoke::Index, void*, Smoke::Stack);
void xcall_QsciLexerVHDL(Smoke::Index, void*, Smoke::Stack);
void xcall_QsciLexerXML(Smoke::Index, void*, Smoke::Stack);
void xcall_QsciLexerYAML(Smoke::Index, void*, Smoke::Stack);
void xcall_QsciMacro(Smoke::Index, void*, Smoke::Stack);
void xcall_QsciPrinter(Smoke::Index, void*, Smoke::Stack);
void xcall_QsciScintilla(Smoke::Index, void*, Smoke::Stack);
void xcall_QsciScintillaBase(Smoke::Index, void*, Smoke::Stack);
void xcall_QsciStyle(Smoke::Index, void*, Smoke::Stack);
void xcall_QsciStyledText(Smoke::Index, void*, Smoke::Stack);

// List of all classes
// Name, external, index into inheritanceList, method dispatcher, enum dispatcher, class flags, size
static Smoke::Class classes[] = {
    { 0L, false, 0, 0, 0, 0, 0 },	// 0 (no class)
    { "QAbstractScrollArea", true, 0, 0, 0, 0, 0 },	//1
    { "QActionEvent", true, 0, 0, 0, 0, 0 },	//2
    { "QBool", true, 0, 0, 0, 0, 0 },	//3
    { "QByteArray", true, 0, 0, 0, 0, 0 },	//4
    { "QChildEvent", true, 0, 0, 0, 0, 0 },	//5
    { "QCloseEvent", true, 0, 0, 0, 0, 0 },	//6
    { "QColor", true, 0, 0, 0, 0, 0 },	//7
    { "QContextMenuEvent", true, 0, 0, 0, 0, 0 },	//8
    { "QDragEnterEvent", true, 0, 0, 0, 0, 0 },	//9
    { "QDragLeaveEvent", true, 0, 0, 0, 0, 0 },	//10
    { "QDragMoveEvent", true, 0, 0, 0, 0, 0 },	//11
    { "QDropEvent", true, 0, 0, 0, 0, 0 },	//12
    { "QEvent", true, 0, 0, 0, 0, 0 },	//13
    { "QFocusEvent", true, 0, 0, 0, 0, 0 },	//14
    { "QFont", true, 0, 0, 0, 0, 0 },	//15
    { "QFrame", true, 0, 0, 0, 0, 0 },	//16
    { "QGlobalSpace", false, 0, xcall_QGlobalSpace, 0, Smoke::cf_namespace, 0 },	//17
    { "QHideEvent", true, 0, 0, 0, 0, 0 },	//18
    { "QIODevice", true, 0, 0, 0, 0, 0 },	//19
    { "QImage", true, 0, 0, 0, 0, 0 },	//20
    { "QInputMethodEvent", true, 0, 0, 0, 0, 0 },	//21
    { "QKeyEvent", true, 0, 0, 0, 0, 0 },	//22
    { "QMenu", true, 0, 0, 0, 0, 0 },	//23
    { "QMetaObject", true, 0, 0, 0, 0, 0 },	//24
    { "QMimeData", true, 0, 0, 0, 0, 0 },	//25
    { "QMouseEvent", true, 0, 0, 0, 0, 0 },	//26
    { "QMoveEvent", true, 0, 0, 0, 0, 0 },	//27
    { "QObject", true, 0, 0, 0, 0, 0 },	//28
    { "QPaintEngine", true, 0, 0, 0, 0, 0 },	//29
    { "QPaintEvent", true, 0, 0, 0, 0, 0 },	//30
    { "QPainter", true, 0, 0, 0, 0, 0 },	//31
    { "QPalette", true, 0, 0, 0, 0, 0 },	//32
    { "QPixmap", true, 0, 0, 0, 0, 0 },	//33
    { "QPoint", true, 0, 0, 0, 0, 0 },	//34
    { "QPrinter", true, 0, 0, 0, 0, 0 },	//35
    { "QRect", true, 0, 0, 0, 0, 0 },	//36
    { "QRegExp", true, 0, 0, 0, 0, 0 },	//37
    { "QResizeEvent", true, 0, 0, 0, 0, 0 },	//38
    { "QSettings", true, 0, 0, 0, 0, 0 },	//39
    { "QShowEvent", true, 0, 0, 0, 0, 0 },	//40
    { "QSize", true, 0, 0, 0, 0, 0 },	//41
    { "QStyle", true, 0, 0, 0, 0, 0 },	//42
    { "QTabletEvent", true, 0, 0, 0, 0, 0 },	//43
    { "QTimerEvent", true, 0, 0, 0, 0, 0 },	//44
    { "QVariant", true, 0, 0, 0, 0, 0 },	//45
    { "QWheelEvent", true, 0, 0, 0, 0, 0 },	//46
    { "QWidget", true, 0, 0, 0, 0, 0 },	//47
    { "QsciAPIs", false, 1, xcall_QsciAPIs, 0, Smoke::cf_constructor|Smoke::cf_virtual, sizeof(QsciAPIs) },	//48
    { "QsciAbstractAPIs", false, 3, xcall_QsciAbstractAPIs, 0, Smoke::cf_constructor|Smoke::cf_virtual, sizeof(QsciAbstractAPIs) },	//49
    { "QsciCommand", false, 0, xcall_QsciCommand, xenum_QsciCommand, 0, sizeof(QsciCommand) },	//50
    { "QsciCommandSet", false, 0, xcall_QsciCommandSet, 0, 0, sizeof(QsciCommandSet) },	//51
    { "QsciDocument", false, 0, xcall_QsciDocument, 0, Smoke::cf_constructor|Smoke::cf_deepcopy|Smoke::cf_virtual, sizeof(QsciDocument) },	//52
    { "QsciLexer", false, 3, xcall_QsciLexer, 0, Smoke::cf_constructor|Smoke::cf_virtual, sizeof(QsciLexer) },	//53
    { "QsciLexerBash", false, 5, xcall_QsciLexerBash, 0, Smoke::cf_constructor|Smoke::cf_virtual, sizeof(QsciLexerBash) },	//54
    { "QsciLexerBatch", false, 5, xcall_QsciLexerBatch, 0, Smoke::cf_constructor|Smoke::cf_virtual, sizeof(QsciLexerBatch) },	//55
    { "QsciLexerCMake", false, 5, xcall_QsciLexerCMake, 0, Smoke::cf_constructor|Smoke::cf_virtual, sizeof(QsciLexerCMake) },	//56
    { "QsciLexerCPP", false, 5, xcall_QsciLexerCPP, 0, Smoke::cf_constructor|Smoke::cf_virtual, sizeof(QsciLexerCPP) },	//57
    { "QsciLexerCSS", false, 5, xcall_QsciLexerCSS, 0, Smoke::cf_constructor|Smoke::cf_virtual, sizeof(QsciLexerCSS) },	//58
    { "QsciLexerCSharp", false, 7, xcall_QsciLexerCSharp, 0, Smoke::cf_constructor|Smoke::cf_virtual, sizeof(QsciLexerCSharp) },	//59
    { "QsciLexerCustom", false, 5, xcall_QsciLexerCustom, 0, Smoke::cf_constructor|Smoke::cf_virtual, sizeof(QsciLexerCustom) },	//60
    { "QsciLexerD", false, 5, xcall_QsciLexerD, 0, Smoke::cf_constructor|Smoke::cf_virtual, sizeof(QsciLexerD) },	//61
    { "QsciLexerDiff", false, 5, xcall_QsciLexerDiff, 0, Smoke::cf_constructor|Smoke::cf_virtual, sizeof(QsciLexerDiff) },	//62
    { "QsciLexerFortran", false, 9, xcall_QsciLexerFortran, 0, Smoke::cf_constructor|Smoke::cf_virtual, sizeof(QsciLexerFortran) },	//63
    { "QsciLexerFortran77", false, 5, xcall_QsciLexerFortran77, 0, Smoke::cf_constructor|Smoke::cf_virtual, sizeof(QsciLexerFortran77) },	//64
    { "QsciLexerHTML", false, 5, xcall_QsciLexerHTML, 0, Smoke::cf_constructor|Smoke::cf_virtual, sizeof(QsciLexerHTML) },	//65
    { "QsciLexerIDL", false, 7, xcall_QsciLexerIDL, 0, Smoke::cf_constructor|Smoke::cf_virtual, sizeof(QsciLexerIDL) },	//66
    { "QsciLexerJava", false, 7, xcall_QsciLexerJava, 0, Smoke::cf_constructor|Smoke::cf_virtual, sizeof(QsciLexerJava) },	//67
    { "QsciLexerJavaScript", false, 7, xcall_QsciLexerJavaScript, 0, Smoke::cf_constructor|Smoke::cf_virtual, sizeof(QsciLexerJavaScript) },	//68
    { "QsciLexerLua", false, 5, xcall_QsciLexerLua, 0, Smoke::cf_constructor|Smoke::cf_virtual, sizeof(QsciLexerLua) },	//69
    { "QsciLexerMakefile", false, 5, xcall_QsciLexerMakefile, 0, Smoke::cf_constructor|Smoke::cf_virtual, sizeof(QsciLexerMakefile) },	//70
    { "QsciLexerPOV", false, 5, xcall_QsciLexerPOV, 0, Smoke::cf_constructor|Smoke::cf_virtual, sizeof(QsciLexerPOV) },	//71
    { "QsciLexerPascal", false, 5, xcall_QsciLexerPascal, 0, Smoke::cf_constructor|Smoke::cf_virtual, sizeof(QsciLexerPascal) },	//72
    { "QsciLexerPerl", false, 5, xcall_QsciLexerPerl, 0, Smoke::cf_constructor|Smoke::cf_virtual, sizeof(QsciLexerPerl) },	//73
    { "QsciLexerPostScript", false, 5, xcall_QsciLexerPostScript, 0, Smoke::cf_constructor|Smoke::cf_virtual, sizeof(QsciLexerPostScript) },	//74
    { "QsciLexerProperties", false, 5, xcall_QsciLexerProperties, 0, Smoke::cf_constructor|Smoke::cf_virtual, sizeof(QsciLexerProperties) },	//75
    { "QsciLexerPython", false, 5, xcall_QsciLexerPython, xenum_QsciLexerPython, Smoke::cf_constructor|Smoke::cf_virtual, sizeof(QsciLexerPython) },	//76
    { "QsciLexerRuby", false, 5, xcall_QsciLexerRuby, 0, Smoke::cf_constructor|Smoke::cf_virtual, sizeof(QsciLexerRuby) },	//77
    { "QsciLexerSQL", false, 5, xcall_QsciLexerSQL, 0, Smoke::cf_constructor|Smoke::cf_virtual, sizeof(QsciLexerSQL) },	//78
    { "QsciLexerTCL", false, 5, xcall_QsciLexerTCL, 0, Smoke::cf_constructor|Smoke::cf_virtual, sizeof(QsciLexerTCL) },	//79
    { "QsciLexerTeX", false, 5, xcall_QsciLexerTeX, 0, Smoke::cf_constructor|Smoke::cf_virtual, sizeof(QsciLexerTeX) },	//80
    { "QsciLexerVHDL", false, 5, xcall_QsciLexerVHDL, 0, Smoke::cf_constructor|Smoke::cf_virtual, sizeof(QsciLexerVHDL) },	//81
    { "QsciLexerXML", false, 11, xcall_QsciLexerXML, 0, Smoke::cf_constructor|Smoke::cf_virtual, sizeof(QsciLexerXML) },	//82
    { "QsciLexerYAML", false, 5, xcall_QsciLexerYAML, 0, Smoke::cf_constructor|Smoke::cf_virtual, sizeof(QsciLexerYAML) },	//83
    { "QsciMacro", false, 3, xcall_QsciMacro, 0, Smoke::cf_constructor|Smoke::cf_virtual, sizeof(QsciMacro) },	//84
    { "QsciPrinter", false, 13, xcall_QsciPrinter, 0, Smoke::cf_constructor|Smoke::cf_virtual, sizeof(QsciPrinter) },	//85
    { "QsciScintilla", false, 15, xcall_QsciScintilla, xenum_QsciScintilla, Smoke::cf_constructor|Smoke::cf_virtual, sizeof(QsciScintilla) },	//86
    { "QsciScintillaBase", false, 17, xcall_QsciScintillaBase, 0, Smoke::cf_constructor|Smoke::cf_virtual, sizeof(QsciScintillaBase) },	//87
    { "QsciStyle", false, 0, xcall_QsciStyle, xenum_QsciStyle, Smoke::cf_constructor|Smoke::cf_deepcopy, sizeof(QsciStyle) },	//88
    { "QsciStyledText", false, 0, xcall_QsciStyledText, 0, Smoke::cf_constructor|Smoke::cf_deepcopy, sizeof(QsciStyledText) },	//89
};

// List of all types needed by the methods (arguments and return values)
// Name, class ID if arg is a class, and TypeId
static Smoke::Type types[] = {
    { 0, 0, 0 },	//0 (no type)
    { "QActionEvent*", 2, Smoke::t_class|Smoke::tf_ptr },	//1
    { "QBool", 3, Smoke::t_class|Smoke::tf_stack },	//2
    { "QByteArray", 4, Smoke::t_class|Smoke::tf_stack },	//3
    { "QChildEvent*", 5, Smoke::t_class|Smoke::tf_ptr },	//4
    { "QCloseEvent*", 6, Smoke::t_class|Smoke::tf_ptr },	//5
    { "QColor", 7, Smoke::t_class|Smoke::tf_stack },	//6
    { "QContextMenuEvent*", 8, Smoke::t_class|Smoke::tf_ptr },	//7
    { "QDragEnterEvent*", 9, Smoke::t_class|Smoke::tf_ptr },	//8
    { "QDragLeaveEvent*", 10, Smoke::t_class|Smoke::tf_ptr },	//9
    { "QDragMoveEvent*", 11, Smoke::t_class|Smoke::tf_ptr },	//10
    { "QDropEvent*", 12, Smoke::t_class|Smoke::tf_ptr },	//11
    { "QEvent*", 13, Smoke::t_class|Smoke::tf_ptr },	//12
    { "QFocusEvent*", 14, Smoke::t_class|Smoke::tf_ptr },	//13
    { "QFont", 15, Smoke::t_class|Smoke::tf_stack },	//14
    { "QHideEvent*", 18, Smoke::t_class|Smoke::tf_ptr },	//15
    { "QIODevice*", 19, Smoke::t_class|Smoke::tf_ptr },	//16
    { "QInputMethodEvent*", 21, Smoke::t_class|Smoke::tf_ptr },	//17
    { "QKeyEvent*", 22, Smoke::t_class|Smoke::tf_ptr },	//18
    { "QList<QsciCommand*>&", 0, Smoke::t_voidp|Smoke::tf_ref },	//19
    { "QList<int>", 0, Smoke::t_voidp|Smoke::tf_stack },	//20
    { "QList<int>&", 0, Smoke::t_voidp|Smoke::tf_ref },	//21
    { "QMenu*", 23, Smoke::t_class|Smoke::tf_ptr },	//22
    { "QMetaObject::Call", 24, Smoke::t_enum|Smoke::tf_stack },	//23
    { "QMimeData*", 25, Smoke::t_class|Smoke::tf_ptr },	//24
    { "QMouseEvent*", 26, Smoke::t_class|Smoke::tf_ptr },	//25
    { "QMoveEvent*", 27, Smoke::t_class|Smoke::tf_ptr },	//26
    { "QObject*", 28, Smoke::t_class|Smoke::tf_ptr },	//27
    { "QPaintDevice::PaintDeviceMetric", 0, Smoke::t_enum|Smoke::tf_stack },	//28
    { "QPaintEngine*", 29, Smoke::t_class|Smoke::tf_ptr },	//29
    { "QPaintEvent*", 30, Smoke::t_class|Smoke::tf_ptr },	//30
    { "QPainter&", 31, Smoke::t_class|Smoke::tf_ref },	//31
    { "QPainter*", 31, Smoke::t_class|Smoke::tf_ptr },	//32
    { "QPrinter::PrinterMode", 35, Smoke::t_enum|Smoke::tf_stack },	//33
    { "QRect&", 36, Smoke::t_class|Smoke::tf_ref },	//34
    { "QRegExp&", 37, Smoke::t_class|Smoke::tf_ref },	//35
    { "QResizeEvent*", 38, Smoke::t_class|Smoke::tf_ptr },	//36
    { "QSettings&", 39, Smoke::t_class|Smoke::tf_ref },	//37
    { "QShowEvent*", 40, Smoke::t_class|Smoke::tf_ptr },	//38
    { "QSize", 41, Smoke::t_class|Smoke::tf_stack },	//39
    { "QString", 0, Smoke::t_voidp|Smoke::tf_stack },	//40
    { "QStringList", 0, Smoke::t_voidp|Smoke::tf_stack },	//41
    { "QStringList&", 0, Smoke::t_voidp|Smoke::tf_ref },	//42
    { "QStringList*", 0, Smoke::t_voidp|Smoke::tf_ptr },	//43
    { "QStyle&", 42, Smoke::t_class|Smoke::tf_ref },	//44
    { "QTabletEvent*", 43, Smoke::t_class|Smoke::tf_ptr },	//45
    { "QTimerEvent*", 44, Smoke::t_class|Smoke::tf_ptr },	//46
    { "QVariant", 45, Smoke::t_class|Smoke::tf_stack },	//47
    { "QWheelEvent*", 46, Smoke::t_class|Smoke::tf_ptr },	//48
    { "QWidget*", 47, Smoke::t_class|Smoke::tf_ptr },	//49
    { "QsciAPIs*", 48, Smoke::t_class|Smoke::tf_ptr },	//50
    { "QsciAbstractAPIs*", 49, Smoke::t_class|Smoke::tf_ptr },	//51
    { "QsciCommand*", 50, Smoke::t_class|Smoke::tf_ptr },	//52
    { "QsciCommand::Command", 50, Smoke::t_enum|Smoke::tf_stack },	//53
    { "QsciCommandSet*", 51, Smoke::t_class|Smoke::tf_ptr },	//54
    { "QsciDocument", 52, Smoke::t_class|Smoke::tf_stack },	//55
    { "QsciDocument&", 52, Smoke::t_class|Smoke::tf_ref },	//56
    { "QsciDocument*", 52, Smoke::t_class|Smoke::tf_ptr },	//57
    { "QsciLexer*", 53, Smoke::t_class|Smoke::tf_ptr },	//58
    { "QsciLexerBash*", 54, Smoke::t_class|Smoke::tf_ptr },	//59
    { "QsciLexerBatch*", 55, Smoke::t_class|Smoke::tf_ptr },	//60
    { "QsciLexerCMake*", 56, Smoke::t_class|Smoke::tf_ptr },	//61
    { "QsciLexerCPP*", 57, Smoke::t_class|Smoke::tf_ptr },	//62
    { "QsciLexerCSS*", 58, Smoke::t_class|Smoke::tf_ptr },	//63
    { "QsciLexerCSharp*", 59, Smoke::t_class|Smoke::tf_ptr },	//64
    { "QsciLexerCustom*", 60, Smoke::t_class|Smoke::tf_ptr },	//65
    { "QsciLexerD*", 61, Smoke::t_class|Smoke::tf_ptr },	//66
    { "QsciLexerDiff*", 62, Smoke::t_class|Smoke::tf_ptr },	//67
    { "QsciLexerFortran*", 63, Smoke::t_class|Smoke::tf_ptr },	//68
    { "QsciLexerFortran77*", 64, Smoke::t_class|Smoke::tf_ptr },	//69
    { "QsciLexerHTML*", 65, Smoke::t_class|Smoke::tf_ptr },	//70
    { "QsciLexerIDL*", 66, Smoke::t_class|Smoke::tf_ptr },	//71
    { "QsciLexerJava*", 67, Smoke::t_class|Smoke::tf_ptr },	//72
    { "QsciLexerJavaScript*", 68, Smoke::t_class|Smoke::tf_ptr },	//73
    { "QsciLexerLua*", 69, Smoke::t_class|Smoke::tf_ptr },	//74
    { "QsciLexerMakefile*", 70, Smoke::t_class|Smoke::tf_ptr },	//75
    { "QsciLexerPOV*", 71, Smoke::t_class|Smoke::tf_ptr },	//76
    { "QsciLexerPascal*", 72, Smoke::t_class|Smoke::tf_ptr },	//77
    { "QsciLexerPerl*", 73, Smoke::t_class|Smoke::tf_ptr },	//78
    { "QsciLexerPostScript*", 74, Smoke::t_class|Smoke::tf_ptr },	//79
    { "QsciLexerProperties*", 75, Smoke::t_class|Smoke::tf_ptr },	//80
    { "QsciLexerPython*", 76, Smoke::t_class|Smoke::tf_ptr },	//81
    { "QsciLexerPython::IndentationWarning", 76, Smoke::t_enum|Smoke::tf_stack },	//82
    { "QsciLexerRuby*", 77, Smoke::t_class|Smoke::tf_ptr },	//83
    { "QsciLexerSQL*", 78, Smoke::t_class|Smoke::tf_ptr },	//84
    { "QsciLexerTCL*", 79, Smoke::t_class|Smoke::tf_ptr },	//85
    { "QsciLexerTeX*", 80, Smoke::t_class|Smoke::tf_ptr },	//86
    { "QsciLexerVHDL*", 81, Smoke::t_class|Smoke::tf_ptr },	//87
    { "QsciLexerXML*", 82, Smoke::t_class|Smoke::tf_ptr },	//88
    { "QsciLexerYAML*", 83, Smoke::t_class|Smoke::tf_ptr },	//89
    { "QsciMacro*", 84, Smoke::t_class|Smoke::tf_ptr },	//90
    { "QsciPrinter*", 85, Smoke::t_class|Smoke::tf_ptr },	//91
    { "QsciScintilla*", 86, Smoke::t_class|Smoke::tf_ptr },	//92
    { "QsciScintilla::AnnotationDisplay", 86, Smoke::t_enum|Smoke::tf_stack },	//93
    { "QsciScintilla::AutoCompletionSource", 86, Smoke::t_enum|Smoke::tf_stack },	//94
    { "QsciScintilla::AutoCompletionUseSingle", 86, Smoke::t_enum|Smoke::tf_stack },	//95
    { "QsciScintilla::BraceMatch", 86, Smoke::t_enum|Smoke::tf_stack },	//96
    { "QsciScintilla::CallTipsPosition", 86, Smoke::t_enum|Smoke::tf_stack },	//97
    { "QsciScintilla::CallTipsStyle", 86, Smoke::t_enum|Smoke::tf_stack },	//98
    { "QsciScintilla::EdgeMode", 86, Smoke::t_enum|Smoke::tf_stack },	//99
    { "QsciScintilla::EolMode", 86, Smoke::t_enum|Smoke::tf_stack },	//100
    { "QsciScintilla::FoldStyle", 86, Smoke::t_enum|Smoke::tf_stack },	//101
    { "QsciScintilla::IndentState", 86, Smoke::t_enum|Smoke::tf_stack },	//102
    { "QsciScintilla::IndicatorStyle", 86, Smoke::t_enum|Smoke::tf_stack },	//103
    { "QsciScintilla::MarginType", 86, Smoke::t_enum|Smoke::tf_stack },	//104
    { "QsciScintilla::MarkerSymbol", 86, Smoke::t_enum|Smoke::tf_stack },	//105
    { "QsciScintilla::WhitespaceVisibility", 86, Smoke::t_enum|Smoke::tf_stack },	//106
    { "QsciScintilla::WrapIndentMode", 86, Smoke::t_enum|Smoke::tf_stack },	//107
    { "QsciScintilla::WrapMode", 86, Smoke::t_enum|Smoke::tf_stack },	//108
    { "QsciScintilla::WrapVisualFlag", 86, Smoke::t_enum|Smoke::tf_stack },	//109
    { "QsciScintillaBase*", 87, Smoke::t_class|Smoke::tf_ptr },	//110
    { "QsciStyle*", 88, Smoke::t_class|Smoke::tf_ptr },	//111
    { "QsciStyle::TextCase", 88, Smoke::t_enum|Smoke::tf_stack },	//112
    { "QsciStyledText", 89, Smoke::t_class|Smoke::tf_stack },	//113
    { "QsciStyledText*", 89, Smoke::t_class|Smoke::tf_ptr },	//114
    { "Qt::AlignmentFlag", 0, Smoke::t_enum|Smoke::tf_stack },	//115
    { "Qt::AnchorAttribute", 0, Smoke::t_enum|Smoke::tf_stack },	//116
    { "Qt::AnchorPoint", 0, Smoke::t_enum|Smoke::tf_stack },	//117
    { "Qt::ApplicationAttribute", 0, Smoke::t_enum|Smoke::tf_stack },	//118
    { "Qt::ArrowType", 0, Smoke::t_enum|Smoke::tf_stack },	//119
    { "Qt::AspectRatioMode", 0, Smoke::t_enum|Smoke::tf_stack },	//120
    { "Qt::Axis", 0, Smoke::t_enum|Smoke::tf_stack },	//121
    { "Qt::BGMode", 0, Smoke::t_enum|Smoke::tf_stack },	//122
    { "Qt::BrushStyle", 0, Smoke::t_enum|Smoke::tf_stack },	//123
    { "Qt::CaseSensitivity", 0, Smoke::t_enum|Smoke::tf_stack },	//124
    { "Qt::CheckState", 0, Smoke::t_enum|Smoke::tf_stack },	//125
    { "Qt::ClipOperation", 0, Smoke::t_enum|Smoke::tf_stack },	//126
    { "Qt::ConnectionType", 0, Smoke::t_enum|Smoke::tf_stack },	//127
    { "Qt::ContextMenuPolicy", 0, Smoke::t_enum|Smoke::tf_stack },	//128
    { "Qt::CoordinateSystem", 0, Smoke::t_enum|Smoke::tf_stack },	//129
    { "Qt::Corner", 0, Smoke::t_enum|Smoke::tf_stack },	//130
    { "Qt::CursorMoveStyle", 0, Smoke::t_enum|Smoke::tf_stack },	//131
    { "Qt::CursorShape", 0, Smoke::t_enum|Smoke::tf_stack },	//132
    { "Qt::DateFormat", 0, Smoke::t_enum|Smoke::tf_stack },	//133
    { "Qt::DayOfWeek", 0, Smoke::t_enum|Smoke::tf_stack },	//134
    { "Qt::DockWidgetArea", 0, Smoke::t_enum|Smoke::tf_stack },	//135
    { "Qt::DockWidgetAreaSizes", 0, Smoke::t_enum|Smoke::tf_stack },	//136
    { "Qt::DropAction", 0, Smoke::t_enum|Smoke::tf_stack },	//137
    { "Qt::EventPriority", 0, Smoke::t_enum|Smoke::tf_stack },	//138
    { "Qt::FillRule", 0, Smoke::t_enum|Smoke::tf_stack },	//139
    { "Qt::FocusPolicy", 0, Smoke::t_enum|Smoke::tf_stack },	//140
    { "Qt::FocusReason", 0, Smoke::t_enum|Smoke::tf_stack },	//141
    { "Qt::GestureFlag", 0, Smoke::t_enum|Smoke::tf_stack },	//142
    { "Qt::GestureState", 0, Smoke::t_enum|Smoke::tf_stack },	//143
    { "Qt::GestureType", 0, Smoke::t_enum|Smoke::tf_stack },	//144
    { "Qt::GlobalColor", 0, Smoke::t_enum|Smoke::tf_stack },	//145
    { "Qt::ImageConversionFlag", 0, Smoke::t_enum|Smoke::tf_stack },	//146
    { "Qt::Initialization", 0, Smoke::t_enum|Smoke::tf_stack },	//147
    { "Qt::InputMethodHint", 0, Smoke::t_enum|Smoke::tf_stack },	//148
    { "Qt::InputMethodQuery", 0, Smoke::t_enum|Smoke::tf_stack },	//149
    { "Qt::ItemDataRole", 0, Smoke::t_enum|Smoke::tf_stack },	//150
    { "Qt::ItemFlag", 0, Smoke::t_enum|Smoke::tf_stack },	//151
    { "Qt::ItemSelectionMode", 0, Smoke::t_enum|Smoke::tf_stack },	//152
    { "Qt::Key", 0, Smoke::t_enum|Smoke::tf_stack },	//153
    { "Qt::KeyboardModifier", 0, Smoke::t_enum|Smoke::tf_stack },	//154
    { "Qt::KeyboardModifiers", 0, Smoke::t_uint|Smoke::tf_stack },	//155
    { "Qt::LayoutDirection", 0, Smoke::t_enum|Smoke::tf_stack },	//156
    { "Qt::MaskMode", 0, Smoke::t_enum|Smoke::tf_stack },	//157
    { "Qt::MatchFlag", 0, Smoke::t_enum|Smoke::tf_stack },	//158
    { "Qt::Modifier", 0, Smoke::t_enum|Smoke::tf_stack },	//159
    { "Qt::MouseButton", 0, Smoke::t_enum|Smoke::tf_stack },	//160
    { "Qt::NavigationMode", 0, Smoke::t_enum|Smoke::tf_stack },	//161
    { "Qt::Orientation", 0, Smoke::t_enum|Smoke::tf_stack },	//162
    { "Qt::PenCapStyle", 0, Smoke::t_enum|Smoke::tf_stack },	//163
    { "Qt::PenJoinStyle", 0, Smoke::t_enum|Smoke::tf_stack },	//164
    { "Qt::PenStyle", 0, Smoke::t_enum|Smoke::tf_stack },	//165
    { "Qt::ScrollBarPolicy", 0, Smoke::t_enum|Smoke::tf_stack },	//166
    { "Qt::ShortcutContext", 0, Smoke::t_enum|Smoke::tf_stack },	//167
    { "Qt::SizeHint", 0, Smoke::t_enum|Smoke::tf_stack },	//168
    { "Qt::SizeMode", 0, Smoke::t_enum|Smoke::tf_stack },	//169
    { "Qt::SortOrder", 0, Smoke::t_enum|Smoke::tf_stack },	//170
    { "Qt::TextElideMode", 0, Smoke::t_enum|Smoke::tf_stack },	//171
    { "Qt::TextFlag", 0, Smoke::t_enum|Smoke::tf_stack },	//172
    { "Qt::TextFormat", 0, Smoke::t_enum|Smoke::tf_stack },	//173
    { "Qt::TextInteractionFlag", 0, Smoke::t_enum|Smoke::tf_stack },	//174
    { "Qt::TileRule", 0, Smoke::t_enum|Smoke::tf_stack },	//175
    { "Qt::TimeSpec", 0, Smoke::t_enum|Smoke::tf_stack },	//176
    { "Qt::ToolBarArea", 0, Smoke::t_enum|Smoke::tf_stack },	//177
    { "Qt::ToolBarAreaSizes", 0, Smoke::t_enum|Smoke::tf_stack },	//178
    { "Qt::ToolButtonStyle", 0, Smoke::t_enum|Smoke::tf_stack },	//179
    { "Qt::TouchPointState", 0, Smoke::t_enum|Smoke::tf_stack },	//180
    { "Qt::TransformationMode", 0, Smoke::t_enum|Smoke::tf_stack },	//181
    { "Qt::UIEffect", 0, Smoke::t_enum|Smoke::tf_stack },	//182
    { "Qt::WidgetAttribute", 0, Smoke::t_enum|Smoke::tf_stack },	//183
    { "Qt::WindowFrameSection", 0, Smoke::t_enum|Smoke::tf_stack },	//184
    { "Qt::WindowModality", 0, Smoke::t_enum|Smoke::tf_stack },	//185
    { "Qt::WindowState", 0, Smoke::t_enum|Smoke::tf_stack },	//186
    { "Qt::WindowType", 0, Smoke::t_enum|Smoke::tf_stack },	//187
    { "_XEvent*", 0, Smoke::t_voidp|Smoke::tf_ptr },	//188
    { "bool", 0, Smoke::t_bool|Smoke::tf_stack },	//189
    { "bool&", 0, Smoke::t_voidp|Smoke::tf_ref },	//190
    { "char", 0, Smoke::t_char|Smoke::tf_stack },	//191
    { "char*", 0, Smoke::t_voidp|Smoke::tf_ptr },	//192
    { "const QByteArray&", 4, Smoke::t_class|Smoke::tf_ref|Smoke::tf_const },	//193
    { "const QColor&", 7, Smoke::t_class|Smoke::tf_ref|Smoke::tf_const },	//194
    { "const QFont&", 15, Smoke::t_class|Smoke::tf_ref|Smoke::tf_const },	//195
    { "const QImage&", 20, Smoke::t_class|Smoke::tf_ref|Smoke::tf_const },	//196
    { "const QList<QsciStyledText>&", 0, Smoke::t_voidp|Smoke::tf_ref|Smoke::tf_const },	//197
    { "const QList<int>&", 0, Smoke::t_voidp|Smoke::tf_ref|Smoke::tf_const },	//198
    { "const QMetaObject&", 24, Smoke::t_class|Smoke::tf_ref|Smoke::tf_const },	//199
    { "const QMetaObject*", 24, Smoke::t_class|Smoke::tf_ptr|Smoke::tf_const },	//200
    { "const QMimeData*", 25, Smoke::t_class|Smoke::tf_ptr|Smoke::tf_const },	//201
    { "const QPalette&", 32, Smoke::t_class|Smoke::tf_ref|Smoke::tf_const },	//202
    { "const QPixmap&", 33, Smoke::t_class|Smoke::tf_ref|Smoke::tf_const },	//203
    { "const QPoint&", 34, Smoke::t_class|Smoke::tf_ref|Smoke::tf_const },	//204
    { "const QRect&", 36, Smoke::t_class|Smoke::tf_ref|Smoke::tf_const },	//205
    { "const QRegExp&", 37, Smoke::t_class|Smoke::tf_ref|Smoke::tf_const },	//206
    { "const QString&", 0, Smoke::t_voidp|Smoke::tf_ref|Smoke::tf_const },	//207
    { "const QStringList&", 0, Smoke::t_voidp|Smoke::tf_ref|Smoke::tf_const },	//208
    { "const QStringList*", 0, Smoke::t_voidp|Smoke::tf_ptr|Smoke::tf_const },	//209
    { "const QsciDocument&", 52, Smoke::t_class|Smoke::tf_ref|Smoke::tf_const },	//210
    { "const QsciStyle&", 88, Smoke::t_class|Smoke::tf_ref|Smoke::tf_const },	//211
    { "const QsciStyledText&", 89, Smoke::t_class|Smoke::tf_ref|Smoke::tf_const },	//212
    { "const char*", 0, Smoke::t_voidp|Smoke::tf_ptr|Smoke::tf_const },	//213
    { "const void*", 0, Smoke::t_voidp|Smoke::tf_ptr|Smoke::tf_const },	//214
    { "int", 0, Smoke::t_int|Smoke::tf_stack },	//215
    { "int&", 0, Smoke::t_voidp|Smoke::tf_ref },	//216
    { "int*", 0, Smoke::t_voidp|Smoke::tf_ptr },	//217
    { "long", 0, Smoke::t_long|Smoke::tf_stack },	//218
    { "unsigned int", 0, Smoke::t_uint|Smoke::tf_stack },	//219
    { "unsigned long", 0, Smoke::t_ulong|Smoke::tf_stack },	//220
    { "void*", 0, Smoke::t_voidp|Smoke::tf_ptr },	//221
    { "void**", 0, Smoke::t_voidp|Smoke::tf_ptr },	//222
    { "volatile const void*", 0, Smoke::t_voidp|Smoke::tf_ptr|Smoke::tf_const },	//223
};

static Smoke::Index argumentList[] = {
    0,	//0  (void)
    12, 0,	//1  QEvent*
    48, 0,	//3  QWheelEvent*
    27, 12, 0,	//5  QObject*, QEvent*
    46, 0,	//8  QTimerEvent*
    4, 0,	//10  QChildEvent*
    213, 0,	//12  const char*
    28, 0,	//14  QPaintDevice::PaintDeviceMetric
    189, 0,	//16  bool
    215, 0,	//18  int
    18, 0,	//20  QKeyEvent*
    26, 0,	//22  QMoveEvent*
    5, 0,	//24  QCloseEvent*
    45, 0,	//26  QTabletEvent*
    1, 0,	//28  QActionEvent*
    38, 0,	//30  QShowEvent*
    15, 0,	//32  QHideEvent*
    188, 0,	//34  _XEvent*
    44, 0,	//36  QStyle&
    202, 0,	//38  const QPalette&
    195, 0,	//40  const QFont&
    213, 213, 0,	//42  const char*, const char*
    213, 213, 215, 0,	//45  const char*, const char*, int
    23, 215, 222, 0,	//49  QMetaObject::Call, int, void**
    58, 0,	//53  QsciLexer*
    207, 0,	//55  const QString&
    208, 42, 0,	//57  const QStringList&, QStringList&
    208, 215, 98, 21, 0,	//60  const QStringList&, int, QsciScintilla::CallTipsStyle, QList<int>&
    37, 213, 0,	//65  QSettings&, const char*
    53, 0,	//68  QsciCommand::Command
    37, 0,	//70  QSettings&
    210, 0,	//72  const QsciDocument&
    27, 0,	//74  QObject*
    217, 0,	//76  int*
    51, 0,	//78  QsciAbstractAPIs*
    194, 0,	//80  const QColor&
    92, 0,	//82  QsciScintilla*
    194, 215, 0,	//84  const QColor&, int
    189, 215, 0,	//87  bool, int
    195, 215, 0,	//90  const QFont&, int
    37, 207, 0,	//93  QSettings&, const QString&
    27, 189, 0,	//96  QObject*, bool
    215, 215, 0,	//99  int, int
    215, 211, 0,	//102  int, const QsciStyle&
    82, 0,	//105  QsciLexerPython::IndentationWarning
    207, 92, 0,	//107  const QString&, QsciScintilla*
    33, 0,	//110  QPrinter::PrinterMode
    31, 189, 34, 215, 0,	//112  QPainter&, bool, QRect&, int
    110, 215, 215, 0,	//117  QsciScintillaBase*, int, int
    108, 0,	//121  QsciScintilla::WrapMode
    110, 0,	//123  QsciScintillaBase*
    110, 215, 0,	//125  QsciScintillaBase*, int
    49, 0,	//128  QWidget*
    215, 216, 216, 0,	//130  int, int&, int&
    215, 207, 215, 0,	//134  int, const QString&, int
    215, 207, 211, 0,	//138  int, const QString&, const QsciStyle&
    215, 212, 0,	//142  int, const QsciStyledText&
    215, 197, 0,	//145  int, const QList<QsciStyledText>&
    215, 215, 215, 215, 215, 0,	//148  int, int, int, int, int
    100, 0,	//154  QsciScintilla::EolMode
    207, 189, 189, 189, 189, 189, 215, 215, 189, 189, 0,	//156  const QString&, bool, bool, bool, bool, bool, int, int, bool, bool
    207, 189, 189, 189, 189, 189, 189, 0,	//167  const QString&, bool, bool, bool, bool, bool, bool
    217, 217, 0,	//175  int*, int*
    217, 217, 217, 217, 0,	//178  int*, int*, int*, int*
    103, 215, 0,	//183  QsciScintilla::IndicatorStyle, int
    191, 0,	//186  char
    204, 0,	//188  const QPoint&
    215, 217, 217, 0,	//190  int, int*, int*
    105, 215, 0,	//194  QsciScintilla::MarkerSymbol, int
    191, 215, 0,	//197  char, int
    203, 215, 0,	//200  const QPixmap&, int
    196, 215, 0,	//203  const QImage&, int
    215, 219, 0,	//206  int, unsigned int
    16, 0,	//209  QIODevice*
    215, 203, 0,	//211  int, const QPixmap&
    215, 196, 0,	//214  int, const QImage&
    194, 194, 0,	//217  const QColor&, const QColor&
    93, 0,	//220  QsciScintilla::AnnotationDisplay
    208, 0,	//222  const QStringList&
    97, 0,	//224  QsciScintilla::CallTipsPosition
    98, 0,	//226  QsciScintilla::CallTipsStyle
    198, 0,	//228  const QList<int>&
    99, 0,	//230  QsciScintilla::EdgeMode
    215, 104, 0,	//232  int, QsciScintilla::MarginType
    109, 109, 215, 0,	//235  QsciScintilla::WrapVisualFlag, QsciScintilla::WrapVisualFlag, int
    107, 0,	//239  QsciScintilla::WrapIndentMode
    215, 208, 0,	//241  int, const QStringList&
    207, 215, 215, 0,	//244  const QString&, int, int
    94, 0,	//248  QsciScintilla::AutoCompletionSource
    95, 0,	//250  QsciScintilla::AutoCompletionUseSingle
    96, 0,	//252  QsciScintilla::BraceMatch
    101, 215, 0,	//254  QsciScintilla::FoldStyle, int
    215, 189, 0,	//257  int, bool
    215, 207, 0,	//260  int, const QString&
    215, 215, 215, 215, 0,	//263  int, int, int, int
    106, 0,	//268  QsciScintilla::WhitespaceVisibility
    215, 215, 155, 0,	//270  int, int, Qt::KeyboardModifiers
    7, 0,	//274  QContextMenuEvent*
    207, 189, 189, 189, 189, 0,	//276  const QString&, bool, bool, bool, bool
    207, 189, 189, 189, 189, 189, 0,	//282  const QString&, bool, bool, bool, bool, bool
    207, 189, 189, 189, 189, 189, 215, 0,	//289  const QString&, bool, bool, bool, bool, bool, int
    207, 189, 189, 189, 189, 189, 215, 215, 0,	//297  const QString&, bool, bool, bool, bool, bool, int, int
    207, 189, 189, 189, 189, 189, 215, 215, 189, 0,	//306  const QString&, bool, bool, bool, bool, bool, int, int, bool
    207, 189, 189, 189, 0,	//316  const QString&, bool, bool, bool
    103, 0,	//321  QsciScintilla::IndicatorStyle
    105, 0,	//323  QsciScintilla::MarkerSymbol
    203, 0,	//325  const QPixmap&
    196, 0,	//327  const QImage&
    109, 0,	//329  QsciScintilla::WrapVisualFlag
    109, 109, 0,	//331  QsciScintilla::WrapVisualFlag, QsciScintilla::WrapVisualFlag
    101, 0,	//334  QsciScintilla::FoldStyle
    219, 220, 218, 0,	//336  unsigned int, unsigned long, long
    219, 220, 221, 0,	//340  unsigned int, unsigned long, void*
    219, 220, 213, 0,	//344  unsigned int, unsigned long, const char*
    219, 213, 0,	//348  unsigned int, const char*
    219, 213, 213, 0,	//351  unsigned int, const char*, const char*
    219, 218, 0,	//355  unsigned int, long
    219, 215, 0,	//358  unsigned int, int
    219, 218, 218, 192, 0,	//361  unsigned int, long, long, char*
    219, 220, 194, 0,	//366  unsigned int, unsigned long, const QColor&
    219, 194, 0,	//370  unsigned int, const QColor&
    219, 220, 32, 205, 218, 218, 0,	//373  unsigned int, unsigned long, QPainter*, const QRect&, long, long
    219, 220, 203, 0,	//380  unsigned int, unsigned long, const QPixmap&
    219, 220, 196, 0,	//384  unsigned int, unsigned long, const QImage&
    219, 0,	//388  unsigned int
    215, 216, 0,	//390  int, int&
    213, 215, 0,	//393  const char*, int
    215, 215, 215, 0,	//396  int, int, int
    215, 215, 213, 215, 215, 215, 215, 215, 215, 215, 0,	//400  int, int, const char*, int, int, int, int, int, int, int
    201, 0,	//411  const QMimeData*
    201, 190, 0,	//413  const QMimeData*, bool&
    193, 189, 0,	//416  const QByteArray&, bool
    8, 0,	//419  QDragEnterEvent*
    9, 0,	//421  QDragLeaveEvent*
    10, 0,	//423  QDragMoveEvent*
    11, 0,	//425  QDropEvent*
    13, 0,	//427  QFocusEvent*
    17, 0,	//429  QInputMethodEvent*
    149, 0,	//431  Qt::InputMethodQuery
    25, 0,	//433  QMouseEvent*
    30, 0,	//435  QPaintEvent*
    36, 0,	//437  QResizeEvent*
    219, 220, 0,	//439  unsigned int, unsigned long
    215, 207, 194, 194, 195, 189, 0,	//442  int, const QString&, const QColor&, const QColor&, const QFont&, bool
    112, 0,	//449  QsciStyle::TextCase
    211, 0,	//451  const QsciStyle&
    215, 207, 194, 194, 195, 0,	//453  int, const QString&, const QColor&, const QColor&, const QFont&
    207, 215, 0,	//459  const QString&, int
    207, 211, 0,	//462  const QString&, const QsciStyle&
    212, 0,	//465  const QsciStyledText&
};

// Raw list of all methods, using munged names
static const char *methodNames[] = {
    "",	//0
    "A0",	//1
    "A1",	//2
    "A2",	//3
    "A3",	//4
    "A4",	//5
    "A5",	//6
    "A6",	//7
    "A7",	//8
    "A8",	//9
    "A9",	//10
    "ASPAtStart",	//11
    "ASPJavaScriptComment",	//12
    "ASPJavaScriptCommentDoc",	//13
    "ASPJavaScriptCommentLine",	//14
    "ASPJavaScriptDefault",	//15
    "ASPJavaScriptDoubleQuotedString",	//16
    "ASPJavaScriptKeyword",	//17
    "ASPJavaScriptNumber",	//18
    "ASPJavaScriptRegex",	//19
    "ASPJavaScriptSingleQuotedString",	//20
    "ASPJavaScriptStart",	//21
    "ASPJavaScriptSymbol",	//22
    "ASPJavaScriptUnclosedString",	//23
    "ASPJavaScriptWord",	//24
    "ASPPythonClassName",	//25
    "ASPPythonComment",	//26
    "ASPPythonDefault",	//27
    "ASPPythonDoubleQuotedString",	//28
    "ASPPythonFunctionMethodName",	//29
    "ASPPythonIdentifier",	//30
    "ASPPythonKeyword",	//31
    "ASPPythonNumber",	//32
    "ASPPythonOperator",	//33
    "ASPPythonSingleQuotedString",	//34
    "ASPPythonStart",	//35
    "ASPPythonTripleDoubleQuotedString",	//36
    "ASPPythonTripleSingleQuotedString",	//37
    "ASPStart",	//38
    "ASPVBScriptComment",	//39
    "ASPVBScriptDefault",	//40
    "ASPVBScriptIdentifier",	//41
    "ASPVBScriptKeyword",	//42
    "ASPVBScriptNumber",	//43
    "ASPVBScriptStart",	//44
    "ASPVBScriptString",	//45
    "ASPVBScriptUnclosedString",	//46
    "ASPXCComment",	//47
    "Aborted",	//48
    "AcsAPIs",	//49
    "AcsAll",	//50
    "AcsDocument",	//51
    "AcsNone",	//52
    "Active",	//53
    "AcusAlways",	//54
    "AcusExplicit",	//55
    "AcusNever",	//56
    "AllPages",	//57
    "AnnotationBoxed",	//58
    "AnnotationHidden",	//59
    "AnnotationIndented",	//60
    "AnnotationStandard",	//61
    "Array",	//62
    "ArrayParenthesis",	//63
    "Asm",	//64
    "Assignment",	//65
    "AtRule",	//66
    "Attribute",	//67
    "Auto",	//68
    "B0",	//69
    "B1",	//70
    "B10",	//71
    "B2",	//72
    "B3",	//73
    "B4",	//74
    "B5",	//75
    "B6",	//76
    "B7",	//77
    "B8",	//78
    "B9",	//79
    "Background",	//80
    "BackquoteString",	//81
    "Backtab",	//82
    "BacktickHereDocument",	//83
    "BacktickHereDocumentVar",	//84
    "Backticks",	//85
    "BackticksVar",	//86
    "BadDirective",	//87
    "BadStringCharacter",	//88
    "Base85String",	//89
    "BasicFunctions",	//90
    "BlockForeach",	//91
    "BlockIf",	//92
    "BlockMacro",	//93
    "BlockWhile",	//94
    "Bookmark",	//95
    "BottomLeftCorner",	//96
    "Box",	//97
    "BoxIndicator",	//98
    "BoxedFoldStyle",	//99
    "BoxedMinus",	//100
    "BoxedMinusConnected",	//101
    "BoxedPlus",	//102
    "BoxedPlusConnected",	//103
    "BoxedTreeFoldStyle",	//104
    "C5E",	//105
    "CDATA",	//106
    "CSS1Property",	//107
    "CSS2Property",	//108
    "CSS3Property",	//109
    "CallTipsAboveText",	//110
    "CallTipsBelowText",	//111
    "CallTipsContext",	//112
    "CallTipsNoAutoCompletionContext",	//113
    "CallTipsNoContext",	//114
    "CallTipsNone",	//115
    "Cancel",	//116
    "Cassette",	//117
    "CharLeft",	//118
    "CharLeftExtend",	//119
    "CharLeftRectExtend",	//120
    "CharRight",	//121
    "CharRightExtend",	//122
    "CharRightRectExtend",	//123
    "Character",	//124
    "Cicero",	//125
    "Circle",	//126
    "CircledFoldStyle",	//127
    "CircledMinus",	//128
    "CircledMinusConnected",	//129
    "CircledPlus",	//130
    "CircledPlusConnected",	//131
    "CircledTreeFoldStyle",	//132
    "ClassName",	//133
    "ClassSelector",	//134
    "ClassVariable",	//135
    "Color",	//136
    "Comm10E",	//137
    "Command",	//138
    "Comment",	//139
    "CommentBlock",	//140
    "CommentBox",	//141
    "CommentDoc",	//142
    "CommentDocKeyword",	//143
    "CommentDocKeywordError",	//144
    "CommentLine",	//145
    "CommentLineDoc",	//146
    "CommentLineHash",	//147
    "CommentNested",	//148
    "CommentParenthesis",	//149
    "Continuation",	//150
    "CoroutinesIOSystemFacilities",	//151
    "CurrentPage",	//152
    "Custom",	//153
    "DLE",	//154
    "DSCComment",	//155
    "DSCCommentValue",	//156
    "DashesIndicator",	//157
    "DataSection",	//158
    "Decorator",	//159
    "Default",	//160
    "DefaultValue",	//161
    "Delete",	//162
    "DeleteBack",	//163
    "DeleteBackNotLine",	//164
    "DeleteLineLeft",	//165
    "DeleteLineRight",	//166
    "DeleteWordLeft",	//167
    "DeleteWordRight",	//168
    "DeleteWordRightEnd",	//169
    "DemotedKeyword",	//170
    "DevicePixel",	//171
    "DiagonalIndicator",	//172
    "DictionaryParenthesis",	//173
    "Didot",	//174
    "Directive",	//175
    "DocumentDelimiter",	//176
    "DocumentEnd",	//177
    "DocumentEndExtend",	//178
    "DocumentStart",	//179
    "DocumentStartExtend",	//180
    "DotBoxIndicator",	//181
    "DotsIndicator",	//182
    "DottedOperator",	//183
    "DoubleQuotedHereDocument",	//184
    "DoubleQuotedHereDocumentVar",	//185
    "DoubleQuotedString",	//186
    "DoubleQuotedStringVar",	//187
    "DownTriangle",	//188
    "DrawChildren",	//189
    "DrawWindowBackground",	//190
    "DuplexAuto",	//191
    "DuplexLongSide",	//192
    "DuplexNone",	//193
    "DuplexShortSide",	//194
    "EdgeBackground",	//195
    "EdgeLine",	//196
    "EdgeNone",	//197
    "EditToggleOvertype",	//198
    "Entity",	//199
    "Envelope",	//200
    "EnvelopeManual",	//201
    "EolMac",	//202
    "EolUnix",	//203
    "EolWindows",	//204
    "Error",	//205
    "EscapeSequence",	//206
    "Executive",	//207
    "ExpandKeyword",	//208
    "ExtendedCSSProperty",	//209
    "ExtendedFunction",	//210
    "ExtendedPseudoClass",	//211
    "ExtendedPseudoElement",	//212
    "ExternalCommand",	//213
    "FirstPageFirst",	//214
    "Folio",	//215
    "FormSource",	//216
    "FormatBody",	//217
    "FormatIdentifier",	//218
    "Formfeed",	//219
    "FullBoxIndicator",	//220
    "FullRectangle",	//221
    "Function",	//222
    "FunctionMethodName",	//223
    "Global",	//224
    "GlobalClass",	//225
    "GrayScale",	//226
    "Group",	//227
    "HLine",	//228
    "HSSLanguage",	//229
    "HTMLComment",	//230
    "HTMLDoubleQuotedString",	//231
    "HTMLNumber",	//232
    "HTMLSingleQuotedString",	//233
    "HTMLValue",	//234
    "Hash",	//235
    "HashQuotedString",	//236
    "Header",	//237
    "HereDocument",	//238
    "HereDocumentDelimiter",	//239
    "HexNumber",	//240
    "HexString",	//241
    "HiddenIndicator",	//242
    "HideCommandChar",	//243
    "HighResolution",	//244
    "HighlightedIdentifier",	//245
    "Home",	//246
    "HomeDisplay",	//247
    "HomeDisplayExtend",	//248
    "HomeExtend",	//249
    "HomeRectExtend",	//250
    "HomeWrap",	//251
    "HomeWrapExtend",	//252
    "IDSelector",	//253
    "ITCLKeyword",	//254
    "Identifier",	//255
    "Idle",	//256
    "IgnoreMask",	//257
    "ImmediateEvalLiteral",	//258
    "Important",	//259
    "InactiveComment",	//260
    "InactiveCommentDoc",	//261
    "InactiveCommentDocKeyword",	//262
    "InactiveCommentDocKeywordError",	//263
    "InactiveCommentLine",	//264
    "InactiveCommentLineDoc",	//265
    "InactiveDefault",	//266
    "InactiveDoubleQuotedString",	//267
    "InactiveEscapeSequence",	//268
    "InactiveGlobalClass",	//269
    "InactiveHashQuotedString",	//270
    "InactiveIdentifier",	//271
    "InactiveKeyword",	//272
    "InactiveKeywordSet2",	//273
    "InactiveNumber",	//274
    "InactiveOperator",	//275
    "InactivePreProcessor",	//276
    "InactivePreProcessorComment",	//277
    "InactivePreProcessorCommentLineDoc",	//278
    "InactiveRawString",	//279
    "InactiveRegex",	//280
    "InactiveSingleQuotedString",	//281
    "InactiveTaskMarker",	//282
    "InactiveTripleQuotedVerbatimString",	//283
    "InactiveUUID",	//284
    "InactiveUnclosedString",	//285
    "InactiveUserLiteral",	//286
    "InactiveVerbatimString",	//287
    "Inch",	//288
    "Inconsistent",	//289
    "InstanceVariable",	//290
    "IntrinsicFunction",	//291
    "Invisible",	//292
    "JavaScriptComment",	//293
    "JavaScriptCommentDoc",	//294
    "JavaScriptCommentLine",	//295
    "JavaScriptDefault",	//296
    "JavaScriptDoubleQuotedString",	//297
    "JavaScriptKeyword",	//298
    "JavaScriptNumber",	//299
    "JavaScriptRegex",	//300
    "JavaScriptSingleQuotedString",	//301
    "JavaScriptStart",	//302
    "JavaScriptSymbol",	//303
    "JavaScriptUnclosedString",	//304
    "JavaScriptWord",	//305
    "Key",	//306
    "Keyword",	//307
    "KeywordDoc",	//308
    "KeywordSecondary",	//309
    "KeywordSet2",	//310
    "KeywordSet3",	//311
    "KeywordSet5",	//312
    "KeywordSet6",	//313
    "KeywordSet7",	//314
    "KeywordSet8",	//315
    "KeywordSet9",	//316
    "Label",	//317
    "Landscape",	//318
    "LargeCapacity",	//319
    "LargeFormat",	//320
    "LastPageFirst",	//321
    "Ledger",	//322
    "LeftRectangle",	//323
    "LeftSideRoundedSplitter",	//324
    "LeftSideSplitter",	//325
    "Legal",	//326
    "LessLanguage",	//327
    "Letter",	//328
    "LineAdded",	//329
    "LineChanged",	//330
    "LineComment",	//331
    "LineCopy",	//332
    "LineCut",	//333
    "LineDelete",	//334
    "LineDown",	//335
    "LineDownExtend",	//336
    "LineDownRectExtend",	//337
    "LineDuplicate",	//338
    "LineEnd",	//339
    "LineEndDisplay",	//340
    "LineEndDisplayExtend",	//341
    "LineEndExtend",	//342
    "LineEndRectExtend",	//343
    "LineEndWrap",	//344
    "LineEndWrapExtend",	//345
    "LineRemoved",	//346
    "LineScrollDown",	//347
    "LineScrollUp",	//348
    "LineTranspose",	//349
    "LineUp",	//350
    "LineUpExtend",	//351
    "LineUpRectExtend",	//352
    "Literal",	//353
    "LiteralString",	//354
    "Lower",	//355
    "LowerCase",	//356
    "Manual",	//357
    "MaxPageSource",	//358
    "MediaRule",	//359
    "Middle",	//360
    "Millimeter",	//361
    "Minus",	//362
    "MoNone",	//363
    "MoSublineSelect",	//364
    "Modifier",	//365
    "ModuleName",	//366
    "MoveSelectedLinesDown",	//367
    "MoveSelectedLinesUp",	//368
    "NPageSize",	//369
    "NPaperSize",	//370
    "Name",	//371
    "NativeFormat",	//372
    "Newline",	//373
    "NoBraceMatch",	//374
    "NoFoldStyle",	//375
    "NoFrame",	//376
    "NoWarning",	//377
    "Number",	//378
    "NumberMargin",	//379
    "ObjectsCSGAppearance",	//380
    "OnlyOne",	//381
    "Operator",	//382
    "OriginalCase",	//383
    "OtherInTag",	//384
    "PHPComment",	//385
    "PHPCommentLine",	//386
    "PHPDefault",	//387
    "PHPDoubleQuotedString",	//388
    "PHPDoubleQuotedVariable",	//389
    "PHPKeyword",	//390
    "PHPNumber",	//391
    "PHPOperator",	//392
    "PHPSingleQuotedString",	//393
    "PHPStart",	//394
    "PHPVariable",	//395
    "POD",	//396
    "PODVerbatim",	//397
    "PageDown",	//398
    "PageDownExtend",	//399
    "PageDownRectExtend",	//400
    "PageRange",	//401
    "PageUp",	//402
    "PageUpExtend",	//403
    "PageUpRectExtend",	//404
    "Panel",	//405
    "ParaDown",	//406
    "ParaDownExtend",	//407
    "ParaUp",	//408
    "ParaUpExtend",	//409
    "ParameterExpansion",	//410
    "Paste",	//411
    "PdfFormat",	//412
    "PercentStringQ",	//413
    "PercentStringq",	//414
    "PercentStringr",	//415
    "PercentStringw",	//416
    "PercentStringx",	//417
    "Pica",	//418
    "Plain",	//419
    "PlainFoldStyle",	//420
    "PlainIndicator",	//421
    "Plus",	//422
    "PlusComment",	//423
    "PlusKeyword",	//424
    "PlusPrompt",	//425
    "Point",	//426
    "Portrait",	//427
    "Position",	//428
    "PostScriptFormat",	//429
    "PreProcessor",	//430
    "PreProcessorComment",	//431
    "PreProcessorCommentLineDoc",	//432
    "PreProcessorParenthesis",	//433
    "PredefinedFunctions",	//434
    "PredefinedIdentifiers",	//435
    "Preprocessor",	//436
    "PrinterResolution",	//437
    "ProcedureParenthesis",	//438
    "PseudoClass",	//439
    "PseudoElement",	//440
    "PythonClassName",	//441
    "PythonComment",	//442
    "PythonDefault",	//443
    "PythonDoubleQuotedString",	//444
    "PythonFunctionMethodName",	//445
    "PythonIdentifier",	//446
    "PythonKeyword",	//447
    "PythonNumber",	//448
    "PythonOperator",	//449
    "PythonSingleQuotedString",	//450
    "PythonStart",	//451
    "PythonTripleDoubleQuotedString",	//452
    "PythonTripleSingleQuotedString",	//453
    "QSCN_SELCHANGED",	//454
    "QSCN_SELCHANGED$",	//455
    "Q_COMPLEX_TYPE",	//456
    "Q_DUMMY_TYPE",	//457
    "Q_MOVABLE_TYPE",	//458
    "Q_PRIMITIVE_TYPE",	//459
    "Q_STATIC_TYPE",	//460
    "QsciAPIs",	//461
    "QsciAPIs#",	//462
    "QsciAbstractAPIs",	//463
    "QsciAbstractAPIs#",	//464
    "QsciDocument",	//465
    "QsciDocument#",	//466
    "QsciLexer",	//467
    "QsciLexer#",	//468
    "QsciLexerBash",	//469
    "QsciLexerBash#",	//470
    "QsciLexerBatch",	//471
    "QsciLexerBatch#",	//472
    "QsciLexerCMake",	//473
    "QsciLexerCMake#",	//474
    "QsciLexerCPP",	//475
    "QsciLexerCPP#",	//476
    "QsciLexerCPP#$",	//477
    "QsciLexerCSS",	//478
    "QsciLexerCSS#",	//479
    "QsciLexerCSharp",	//480
    "QsciLexerCSharp#",	//481
    "QsciLexerCustom",	//482
    "QsciLexerCustom#",	//483
    "QsciLexerD",	//484
    "QsciLexerD#",	//485
    "QsciLexerDiff",	//486
    "QsciLexerDiff#",	//487
    "QsciLexerFortran",	//488
    "QsciLexerFortran#",	//489
    "QsciLexerFortran77",	//490
    "QsciLexerFortran77#",	//491
    "QsciLexerHTML",	//492
    "QsciLexerHTML#",	//493
    "QsciLexerIDL",	//494
    "QsciLexerIDL#",	//495
    "QsciLexerJava",	//496
    "QsciLexerJava#",	//497
    "QsciLexerJavaScript",	//498
    "QsciLexerJavaScript#",	//499
    "QsciLexerLua",	//500
    "QsciLexerLua#",	//501
    "QsciLexerMakefile",	//502
    "QsciLexerMakefile#",	//503
    "QsciLexerPOV",	//504
    "QsciLexerPOV#",	//505
    "QsciLexerPascal",	//506
    "QsciLexerPascal#",	//507
    "QsciLexerPerl",	//508
    "QsciLexerPerl#",	//509
    "QsciLexerPostScript",	//510
    "QsciLexerPostScript#",	//511
    "QsciLexerProperties",	//512
    "QsciLexerProperties#",	//513
    "QsciLexerPython",	//514
    "QsciLexerPython#",	//515
    "QsciLexerRuby",	//516
    "QsciLexerRuby#",	//517
    "QsciLexerSQL",	//518
    "QsciLexerSQL#",	//519
    "QsciLexerTCL",	//520
    "QsciLexerTCL#",	//521
    "QsciLexerTeX",	//522
    "QsciLexerTeX#",	//523
    "QsciLexerVHDL",	//524
    "QsciLexerVHDL#",	//525
    "QsciLexerXML",	//526
    "QsciLexerXML#",	//527
    "QsciLexerYAML",	//528
    "QsciLexerYAML#",	//529
    "QsciMacro",	//530
    "QsciMacro#",	//531
    "QsciMacro$#",	//532
    "QsciPrinter",	//533
    "QsciPrinter$",	//534
    "QsciScintilla",	//535
    "QsciScintilla#",	//536
    "QsciScintillaBase",	//537
    "QsciScintillaBase#",	//538
    "QsciStyle",	//539
    "QsciStyle#",	//540
    "QsciStyle$",	//541
    "QsciStyle$$###",	//542
    "QsciStyle$$###$",	//543
    "QsciStyledText",	//544
    "QsciStyledText#",	//545
    "QsciStyledText$#",	//546
    "QsciStyledText$$",	//547
    "QuotedIdentifier",	//548
    "QuotedKeyword",	//549
    "QuotedOperator",	//550
    "QuotedString",	//551
    "QuotedStringQ",	//552
    "QuotedStringQQ",	//553
    "QuotedStringQQVar",	//554
    "QuotedStringQR",	//555
    "QuotedStringQRVar",	//556
    "QuotedStringQW",	//557
    "QuotedStringQX",	//558
    "QuotedStringQXVar",	//559
    "Raised",	//560
    "RawString",	//561
    "Rectangle",	//562
    "Redo",	//563
    "Reference",	//564
    "Regex",	//565
    "RegexVar",	//566
    "RightArrow",	//567
    "RightTriangle",	//568
    "RoundBoxIndicator",	//569
    "RoundedBottomLeftCorner",	//570
    "SCEN_CHANGE",	//571
    "SCN_AUTOCCANCELLED",	//572
    "SCN_AUTOCCHARDELETED",	//573
    "SCN_AUTOCSELECTION",	//574
    "SCN_AUTOCSELECTION$$",	//575
    "SCN_CALLTIPCLICK",	//576
    "SCN_CALLTIPCLICK$",	//577
    "SCN_CHARADDED",	//578
    "SCN_CHARADDED$",	//579
    "SCN_DOUBLECLICK",	//580
    "SCN_DOUBLECLICK$$$",	//581
    "SCN_DWELLEND",	//582
    "SCN_DWELLEND$$$",	//583
    "SCN_DWELLSTART",	//584
    "SCN_DWELLSTART$$$",	//585
    "SCN_FOCUSIN",	//586
    "SCN_FOCUSOUT",	//587
    "SCN_HOTSPOTCLICK",	//588
    "SCN_HOTSPOTCLICK$$",	//589
    "SCN_HOTSPOTDOUBLECLICK",	//590
    "SCN_HOTSPOTDOUBLECLICK$$",	//591
    "SCN_HOTSPOTRELEASECLICK",	//592
    "SCN_HOTSPOTRELEASECLICK$$",	//593
    "SCN_INDICATORCLICK",	//594
    "SCN_INDICATORCLICK$$",	//595
    "SCN_INDICATORRELEASE",	//596
    "SCN_INDICATORRELEASE$$",	//597
    "SCN_MACRORECORD",	//598
    "SCN_MACRORECORD$$$",	//599
    "SCN_MARGINCLICK",	//600
    "SCN_MARGINCLICK$$$",	//601
    "SCN_MODIFIED",	//602
    "SCN_MODIFIED$$$$$$$$$$",	//603
    "SCN_MODIFYATTEMPTRO",	//604
    "SCN_NEEDSHOWN",	//605
    "SCN_NEEDSHOWN$$",	//606
    "SCN_PAINTED",	//607
    "SCN_SAVEPOINTLEFT",	//608
    "SCN_SAVEPOINTREACHED",	//609
    "SCN_STYLENEEDED",	//610
    "SCN_STYLENEEDED$",	//611
    "SCN_UPDATEUI",	//612
    "SCN_UPDATEUI$",	//613
    "SCN_USERLISTSELECTION",	//614
    "SCN_USERLISTSELECTION$$",	//615
    "SCN_ZOOM",	//616
    "SCSSLanguage",	//617
    "SC_ORDER_CUSTOM",	//618
    "SC_ORDER_PERFORMSORT",	//619
    "SC_ORDER_PRESORTED",	//620
    "SGMLBlockDefault",	//621
    "SGMLCommand",	//622
    "SGMLComment",	//623
    "SGMLDefault",	//624
    "SGMLDoubleQuotedString",	//625
    "SGMLEntity",	//626
    "SGMLError",	//627
    "SGMLParameter",	//628
    "SGMLParameterComment",	//629
    "SGMLSingleQuotedString",	//630
    "SGMLSpecial",	//631
    "Scalar",	//632
    "ScreenResolution",	//633
    "Script",	//634
    "ScrollToEnd",	//635
    "ScrollToStart",	//636
    "Section",	//637
    "SelectAll",	//638
    "Selection",	//639
    "SelectionCopy",	//640
    "SelectionCut",	//641
    "SelectionDuplicate",	//642
    "SelectionLowerCase",	//643
    "SelectionUpperCase",	//644
    "SendScintilla",	//645
    "SendScintilla$",	//646
    "SendScintilla$#",	//647
    "SendScintilla$$",	//648
    "SendScintilla$$#",	//649
    "SendScintilla$$##$$",	//650
    "SendScintilla$$$",	//651
    "SendScintilla$$$$",	//652
    "SendScintillaPtrResult",	//653
    "SendScintillaPtrResult$",	//654
    "Shadow_Mask",	//655
    "Shape_Mask",	//656
    "SingleQuotedHereDocument",	//657
    "SingleQuotedString",	//658
    "SloppyBraceMatch",	//659
    "SmallFormat",	//660
    "SmallRectangle",	//661
    "Spaces",	//662
    "Special",	//663
    "SquiggleIndicator",	//664
    "SquiggleLowIndicator",	//665
    "SquigglePixmapIndicator",	//666
    "StandardFunction",	//667
    "StandardOperator",	//668
    "StandardPackage",	//669
    "StandardType",	//670
    "Stderr",	//671
    "Stdin",	//672
    "Stdout",	//673
    "StraightBoxIndicator",	//674
    "StrictBraceMatch",	//675
    "StrikeIndicator",	//676
    "String",	//677
    "StringLeftQuote",	//678
    "StringRightQuote",	//679
    "StringTableMathsFunctions",	//680
    "StringVariable",	//681
    "StutteredPageDown",	//682
    "StutteredPageDownExtend",	//683
    "StutteredPageUp",	//684
    "StutteredPageUpExtend",	//685
    "StyledPanel",	//686
    "SubroutinePrototype",	//687
    "Substitution",	//688
    "SubstitutionBrace",	//689
    "SubstitutionVar",	//690
    "Sunken",	//691
    "Symbol",	//692
    "SymbolMargin",	//693
    "SymbolMarginDefaultBackgroundColor",	//694
    "SymbolMarginDefaultForegroundColor",	//695
    "SymbolTable",	//696
    "SyntaxErrorMarker",	//697
    "TCLKeyword",	//698
    "TTIndicator",	//699
    "Tab",	//700
    "Tabloid",	//701
    "Tabs",	//702
    "TabsAfterSpaces",	//703
    "Tag",	//704
    "Target",	//705
    "TaskMarker",	//706
    "Text",	//707
    "TextBlockMarker",	//708
    "TextColorIndicator",	//709
    "TextMargin",	//710
    "TextMarginRightJustified",	//711
    "ThickCompositionIndicator",	//712
    "ThinCompositionIndicator",	//713
    "ThreeDots",	//714
    "ThreeRightArrows",	//715
    "TkCommand",	//716
    "TkKeyword",	//717
    "Tractor",	//718
    "Translation",	//719
    "TripleDoubleQuotedString",	//720
    "TripleQuotedVerbatimString",	//721
    "TripleSingleQuotedString",	//722
    "Typedefs",	//723
    "TypesModifiersItems",	//724
    "UUID",	//725
    "UnclosedString",	//726
    "Underline",	//727
    "Undo",	//728
    "UnknownAttribute",	//729
    "UnknownProperty",	//730
    "UnknownPseudoClass",	//731
    "UnknownTag",	//732
    "UpperCase",	//733
    "UserLiteral",	//734
    "VBScriptComment",	//735
    "VBScriptDefault",	//736
    "VBScriptIdentifier",	//737
    "VBScriptKeyword",	//738
    "VBScriptNumber",	//739
    "VBScriptStart",	//740
    "VBScriptString",	//741
    "VBScriptUnclosedString",	//742
    "VCHome",	//743
    "VCHomeExtend",	//744
    "VCHomeRectExtend",	//745
    "VCHomeWrap",	//746
    "VCHomeWrapExtend",	//747
    "VLine",	//748
    "Value",	//749
    "Variable",	//750
    "VerbatimString",	//751
    "VerticalCentreCaret",	//752
    "VerticalLine",	//753
    "WinPanel",	//754
    "WordLeft",	//755
    "WordLeftEnd",	//756
    "WordLeftEndExtend",	//757
    "WordLeftExtend",	//758
    "WordPartLeft",	//759
    "WordPartLeftExtend",	//760
    "WordPartRight",	//761
    "WordPartRightExtend",	//762
    "WordRight",	//763
    "WordRightEnd",	//764
    "WordRightEndExtend",	//765
    "WordRightExtend",	//766
    "WrapCharacter",	//767
    "WrapFlagByBorder",	//768
    "WrapFlagByText",	//769
    "WrapFlagInMargin",	//770
    "WrapFlagNone",	//771
    "WrapIndentFixed",	//772
    "WrapIndentIndented",	//773
    "WrapIndentSame",	//774
    "WrapNone",	//775
    "WrapWhitespace",	//776
    "WrapWord",	//777
    "WsInvisible",	//778
    "WsVisible",	//779
    "WsVisibleAfterIndent",	//780
    "XMLEnd",	//781
    "XMLStart",	//782
    "XMLTagEnd",	//783
    "ZoomIn",	//784
    "ZoomOut",	//785
    "actionEvent",	//786
    "add",	//787
    "add$",	//788
    "alternateKey",	//789
    "annotate",	//790
    "annotate$#",	//791
    "annotate$$#",	//792
    "annotate$$$",	//793
    "annotate$?",	//794
    "annotation",	//795
    "annotation$",	//796
    "annotationDisplay",	//797
    "apiContext",	//798
    "apiContext$$$",	//799
    "apiPreparationCancelled",	//800
    "apiPreparationFinished",	//801
    "apiPreparationStarted",	//802
    "apis",	//803
    "append",	//804
    "append$",	//805
    "apply",	//806
    "apply#",	//807
    "autoCompleteFromAPIs",	//808
    "autoCompleteFromAll",	//809
    "autoCompleteFromDocument",	//810
    "autoCompletionCaseSensitivity",	//811
    "autoCompletionFillups",	//812
    "autoCompletionFillupsEnabled",	//813
    "autoCompletionReplaceWord",	//814
    "autoCompletionSelected",	//815
    "autoCompletionSelected$",	//816
    "autoCompletionShowSingle",	//817
    "autoCompletionSource",	//818
    "autoCompletionThreshold",	//819
    "autoCompletionUseSingle",	//820
    "autoCompletionWordSeparators",	//821
    "autoIndent",	//822
    "autoIndentStyle",	//823
    "backslashEscapes",	//824
    "backspaceUnindents",	//825
    "beginUndoAction",	//826
    "blockEnd",	//827
    "blockEnd$",	//828
    "blockLookback",	//829
    "blockStart",	//830
    "blockStart$",	//831
    "blockStartKeyword",	//832
    "blockStartKeyword$",	//833
    "boundTo",	//834
    "boundTo$",	//835
    "braceMatching",	//836
    "braceStyle",	//837
    "bytesAsText",	//838
    "bytesAsText$",	//839
    "callTip",	//840
    "callTips",	//841
    "callTips?$$?",	//842
    "callTipsPosition",	//843
    "callTipsStyle",	//844
    "callTipsVisible",	//845
    "canInsertFromMimeData",	//846
    "canInsertFromMimeData#",	//847
    "cancelList",	//848
    "cancelPreparation",	//849
    "caseSensitive",	//850
    "caseSensitiveTags",	//851
    "changeEvent",	//852
    "changeEvent#",	//853
    "changeable",	//854
    "childEvent",	//855
    "clear",	//856
    "clearAlternateKeys",	//857
    "clearAnnotations",	//858
    "clearAnnotations$",	//859
    "clearFolds",	//860
    "clearIndicatorRange",	//861
    "clearIndicatorRange$$$$$",	//862
    "clearKeys",	//863
    "clearMarginText",	//864
    "clearMarginText$",	//865
    "clearRegisteredImages",	//866
    "closeEvent",	//867
    "color",	//868
    "color$",	//869
    "colorChanged",	//870
    "colorChanged#$",	//871
    "command",	//872
    "commandKey",	//873
    "commandKey$$",	//874
    "commands",	//875
    "connectNotify",	//876
    "contextMenuEvent",	//877
    "contextMenuEvent#",	//878
    "contractedFolds",	//879
    "convertEols",	//880
    "convertEols$",	//881
    "copy",	//882
    "copyAvailable",	//883
    "copyAvailable$",	//884
    "createStandardContextMenu",	//885
    "cursorPositionChanged",	//886
    "cursorPositionChanged$$",	//887
    "customEvent",	//888
    "cut",	//889
    "defaultColor",	//890
    "defaultColor$",	//891
    "defaultEolFill",	//892
    "defaultEolFill$",	//893
    "defaultFont",	//894
    "defaultFont$",	//895
    "defaultPaper",	//896
    "defaultPaper$",	//897
    "defaultPreparedName",	//898
    "defaultStyle",	//899
    "description",	//900
    "description$",	//901
    "devType",	//902
    "disconnectNotify",	//903
    "djangoTemplates",	//904
    "document",	//905
    "dollarsAllowed",	//906
    "dottedWords",	//907
    "dragEnterEvent",	//908
    "dragEnterEvent#",	//909
    "dragLeaveEvent",	//910
    "dragLeaveEvent#",	//911
    "dragMoveEvent",	//912
    "dragMoveEvent#",	//913
    "dropEvent",	//914
    "dropEvent#",	//915
    "edgeColor",	//916
    "edgeColumn",	//917
    "edgeMode",	//918
    "editor",	//919
    "enabledChange",	//920
    "endRecording",	//921
    "endUndoAction",	//922
    "ensureCursorVisible",	//923
    "ensureLineVisible",	//924
    "ensureLineVisible$",	//925
    "enterEvent",	//926
    "eolFill",	//927
    "eolFill$",	//928
    "eolFillChanged",	//929
    "eolFillChanged$$",	//930
    "eolMode",	//931
    "eolVisibility",	//932
    "event",	//933
    "event#",	//934
    "eventFilter",	//935
    "execute",	//936
    "extraAscent",	//937
    "extraDescent",	//938
    "fillIndicatorRange",	//939
    "fillIndicatorRange$$$$$",	//940
    "find",	//941
    "find$",	//942
    "findFirst",	//943
    "findFirst$$$$$",	//944
    "findFirst$$$$$$",	//945
    "findFirst$$$$$$$",	//946
    "findFirst$$$$$$$$",	//947
    "findFirst$$$$$$$$$",	//948
    "findFirst$$$$$$$$$$",	//949
    "findFirstInSelection",	//950
    "findFirstInSelection$$$$",	//951
    "findFirstInSelection$$$$$",	//952
    "findFirstInSelection$$$$$$",	//953
    "findFirstInSelection$$$$$$$",	//954
    "findNext",	//955
    "firstVisibleLine",	//956
    "focusInEvent",	//957
    "focusInEvent#",	//958
    "focusNextPrevChild",	//959
    "focusNextPrevChild$",	//960
    "focusOutEvent",	//961
    "focusOutEvent#",	//962
    "foldAll",	//963
    "foldAll$",	//964
    "foldAtBegin",	//965
    "foldAtElse",	//966
    "foldAtParenthesis",	//967
    "foldComments",	//968
    "foldCompact",	//969
    "foldDirectives",	//970
    "foldLine",	//971
    "foldLine$",	//972
    "foldOnlyBegin",	//973
    "foldPODBlocks",	//974
    "foldPackages",	//975
    "foldPreprocessor",	//976
    "foldQuotes",	//977
    "foldScriptComments",	//978
    "foldScriptHeredocs",	//979
    "folding",	//980
    "font",	//981
    "font$",	//982
    "fontChange",	//983
    "fontChanged",	//984
    "fontChanged#$",	//985
    "formatPage",	//986
    "formatPage#$#$",	//987
    "fromMimeData",	//988
    "fromMimeData#$",	//989
    "getCursorPosition",	//990
    "getCursorPosition$$",	//991
    "getSelection",	//992
    "getSelection$$$$",	//993
    "hasSelectedText",	//994
    "hashComments",	//995
    "heightForWidth",	//996
    "hideEvent",	//997
    "highlightBackQuotedStrings",	//998
    "highlightEscapeSequences",	//999
    "highlightHashQuotedStrings",	//1000
    "highlightSubidentifiers",	//1001
    "highlightTripleQuotedStrings",	//1002
    "hotspot",	//1003
    "indent",	//1004
    "indent$",	//1005
    "indentation",	//1006
    "indentation$",	//1007
    "indentationGuideView",	//1008
    "indentationGuides",	//1009
    "indentationWarning",	//1010
    "indentationWidth",	//1011
    "indentationsUseTabs",	//1012
    "indicatorClicked",	//1013
    "indicatorClicked$$$",	//1014
    "indicatorDefine",	//1015
    "indicatorDefine$",	//1016
    "indicatorDefine$$",	//1017
    "indicatorDrawUnder",	//1018
    "indicatorDrawUnder$",	//1019
    "indicatorReleased",	//1020
    "indicatorReleased$$$",	//1021
    "initialSpaces",	//1022
    "inputMethodEvent",	//1023
    "inputMethodEvent#",	//1024
    "inputMethodQuery",	//1025
    "inputMethodQuery$",	//1026
    "insert",	//1027
    "insert$",	//1028
    "insertAt",	//1029
    "insertAt$$$",	//1030
    "installedAPIFiles",	//1031
    "isCallTipActive",	//1032
    "isListActive",	//1033
    "isModified",	//1034
    "isPrepared",	//1035
    "isPrepared$",	//1036
    "isReadOnly",	//1037
    "isRedoAvailable",	//1038
    "isUndoAvailable",	//1039
    "isUtf8",	//1040
    "isWordCharacter",	//1041
    "isWordCharacter$",	//1042
    "key",	//1043
    "keyPressEvent",	//1044
    "keyPressEvent#",	//1045
    "keyReleaseEvent",	//1046
    "keywords",	//1047
    "keywords$",	//1048
    "language",	//1049
    "languageChange",	//1050
    "leaveEvent",	//1051
    "length",	//1052
    "level",	//1053
    "lexer",	//1054
    "lexerId",	//1055
    "lineAt",	//1056
    "lineAt#",	//1057
    "lineIndexFromPosition",	//1058
    "lineIndexFromPosition$$$",	//1059
    "lineLength",	//1060
    "lineLength$",	//1061
    "lines",	//1062
    "linesChanged",	//1063
    "load",	//1064
    "load$",	//1065
    "loadPrepared",	//1066
    "loadPrepared$",	//1067
    "magnification",	//1068
    "makoTemplates",	//1069
    "marginClicked",	//1070
    "marginClicked$$$",	//1071
    "marginLineNumbers",	//1072
    "marginLineNumbers$",	//1073
    "marginMarkerMask",	//1074
    "marginMarkerMask$",	//1075
    "marginOptions",	//1076
    "marginSensitivity",	//1077
    "marginSensitivity$",	//1078
    "marginType",	//1079
    "marginType$",	//1080
    "marginWidth",	//1081
    "marginWidth$",	//1082
    "markerAdd",	//1083
    "markerAdd$$",	//1084
    "markerDefine",	//1085
    "markerDefine#",	//1086
    "markerDefine#$",	//1087
    "markerDefine$",	//1088
    "markerDefine$$",	//1089
    "markerDelete",	//1090
    "markerDelete$",	//1091
    "markerDelete$$",	//1092
    "markerDeleteAll",	//1093
    "markerDeleteAll$",	//1094
    "markerDeleteHandle",	//1095
    "markerDeleteHandle$",	//1096
    "markerFindNext",	//1097
    "markerFindNext$$",	//1098
    "markerFindPrevious",	//1099
    "markerFindPrevious$$",	//1100
    "markerLine",	//1101
    "markerLine$",	//1102
    "markersAtLine",	//1103
    "markersAtLine$",	//1104
    "metaObject",	//1105
    "metric",	//1106
    "minimumSizeHint",	//1107
    "modificationAttempted",	//1108
    "modificationChanged",	//1109
    "modificationChanged$",	//1110
    "mouseDoubleClickEvent",	//1111
    "mouseDoubleClickEvent#",	//1112
    "mouseMoveEvent",	//1113
    "mouseMoveEvent#",	//1114
    "mousePressEvent",	//1115
    "mousePressEvent#",	//1116
    "mouseReleaseEvent",	//1117
    "mouseReleaseEvent#",	//1118
    "moveEvent",	//1119
    "moveToMatchingBrace",	//1120
    "operator=",	//1121
    "operator=#",	//1122
    "overwriteMode",	//1123
    "paintEngine",	//1124
    "paintEvent",	//1125
    "paintEvent#",	//1126
    "paletteChange",	//1127
    "paper",	//1128
    "paper$",	//1129
    "paperChanged",	//1130
    "paperChanged#$",	//1131
    "paste",	//1132
    "play",	//1133
    "pool",	//1134
    "positionFromLineIndex",	//1135
    "positionFromLineIndex$$",	//1136
    "prepare",	//1137
    "printRange",	//1138
    "printRange#",	//1139
    "printRange#$",	//1140
    "printRange#$$",	//1141
    "processComments",	//1142
    "processIf",	//1143
    "propertyChanged",	//1144
    "propertyChanged$$",	//1145
    "qt_metacall",	//1146
    "qt_metacall$$?",	//1147
    "qt_metacast",	//1148
    "qt_metacast$",	//1149
    "quotedIdentifiers",	//1150
    "read",	//1151
    "read#",	//1152
    "readProperties",	//1153
    "readProperties#$",	//1154
    "readSettings",	//1155
    "readSettings#",	//1156
    "readSettings#$",	//1157
    "recolor",	//1158
    "recolor$",	//1159
    "recolor$$",	//1160
    "redo",	//1161
    "refresh",	//1162
    "refreshProperties",	//1163
    "registerImage",	//1164
    "registerImage$#",	//1165
    "remove",	//1166
    "remove$",	//1167
    "removeSelectedText",	//1168
    "replace",	//1169
    "replace$",	//1170
    "replaceSelectedText",	//1171
    "replaceSelectedText$",	//1172
    "resetFoldMarginColors",	//1173
    "resetHotspotBackgroundColor",	//1174
    "resetHotspotForegroundColor",	//1175
    "resetMatchedBraceIndicator",	//1176
    "resetSelectionBackgroundColor",	//1177
    "resetSelectionForegroundColor",	//1178
    "resetUnmatchedBraceIndicator",	//1179
    "resizeEvent",	//1180
    "resizeEvent#",	//1181
    "save",	//1182
    "savePrepared",	//1183
    "savePrepared$",	//1184
    "scriptsStyled",	//1185
    "scrollContentsBy",	//1186
    "scrollContentsBy$$",	//1187
    "selectAll",	//1188
    "selectAll$",	//1189
    "selectToMatchingBrace",	//1190
    "selectedText",	//1191
    "selectionChanged",	//1192
    "selectionToEol",	//1193
    "setAPIs",	//1194
    "setAPIs#",	//1195
    "setAlternateKey",	//1196
    "setAlternateKey$",	//1197
    "setAnnotationDisplay",	//1198
    "setAnnotationDisplay$",	//1199
    "setAutoCompletionCaseSensitivity",	//1200
    "setAutoCompletionCaseSensitivity$",	//1201
    "setAutoCompletionFillups",	//1202
    "setAutoCompletionFillups$",	//1203
    "setAutoCompletionFillupsEnabled",	//1204
    "setAutoCompletionFillupsEnabled$",	//1205
    "setAutoCompletionReplaceWord",	//1206
    "setAutoCompletionReplaceWord$",	//1207
    "setAutoCompletionShowSingle",	//1208
    "setAutoCompletionShowSingle$",	//1209
    "setAutoCompletionSource",	//1210
    "setAutoCompletionSource$",	//1211
    "setAutoCompletionThreshold",	//1212
    "setAutoCompletionThreshold$",	//1213
    "setAutoCompletionUseSingle",	//1214
    "setAutoCompletionUseSingle$",	//1215
    "setAutoCompletionWordSeparators",	//1216
    "setAutoCompletionWordSeparators?",	//1217
    "setAutoIndent",	//1218
    "setAutoIndent$",	//1219
    "setAutoIndentStyle",	//1220
    "setAutoIndentStyle$",	//1221
    "setBackslashEscapes",	//1222
    "setBackslashEscapes$",	//1223
    "setBackspaceUnindents",	//1224
    "setBackspaceUnindents$",	//1225
    "setBraceMatching",	//1226
    "setBraceMatching$",	//1227
    "setCallTipsBackgroundColor",	//1228
    "setCallTipsBackgroundColor#",	//1229
    "setCallTipsForegroundColor",	//1230
    "setCallTipsForegroundColor#",	//1231
    "setCallTipsHighlightColor",	//1232
    "setCallTipsHighlightColor#",	//1233
    "setCallTipsPosition",	//1234
    "setCallTipsPosition$",	//1235
    "setCallTipsStyle",	//1236
    "setCallTipsStyle$",	//1237
    "setCallTipsVisible",	//1238
    "setCallTipsVisible$",	//1239
    "setCaretForegroundColor",	//1240
    "setCaretForegroundColor#",	//1241
    "setCaretLineBackgroundColor",	//1242
    "setCaretLineBackgroundColor#",	//1243
    "setCaretLineVisible",	//1244
    "setCaretLineVisible$",	//1245
    "setCaretWidth",	//1246
    "setCaretWidth$",	//1247
    "setCaseSensitiveTags",	//1248
    "setCaseSensitiveTags$",	//1249
    "setChangeable",	//1250
    "setChangeable$",	//1251
    "setColor",	//1252
    "setColor#",	//1253
    "setColor#$",	//1254
    "setContractedFolds",	//1255
    "setContractedFolds?",	//1256
    "setCursorPosition",	//1257
    "setCursorPosition$$",	//1258
    "setDefaultColor",	//1259
    "setDefaultColor#",	//1260
    "setDefaultFont",	//1261
    "setDefaultFont#",	//1262
    "setDefaultPaper",	//1263
    "setDefaultPaper#",	//1264
    "setDescription",	//1265
    "setDescription$",	//1266
    "setDjangoTemplates",	//1267
    "setDjangoTemplates$",	//1268
    "setDocument",	//1269
    "setDocument#",	//1270
    "setDollarsAllowed",	//1271
    "setDollarsAllowed$",	//1272
    "setDottedWords",	//1273
    "setDottedWords$",	//1274
    "setEdgeColor",	//1275
    "setEdgeColor#",	//1276
    "setEdgeColumn",	//1277
    "setEdgeColumn$",	//1278
    "setEdgeMode",	//1279
    "setEdgeMode$",	//1280
    "setEditor",	//1281
    "setEditor#",	//1282
    "setEolFill",	//1283
    "setEolFill$",	//1284
    "setEolFill$$",	//1285
    "setEolMode",	//1286
    "setEolMode$",	//1287
    "setEolVisibility",	//1288
    "setEolVisibility$",	//1289
    "setExtraAscent",	//1290
    "setExtraAscent$",	//1291
    "setExtraDescent",	//1292
    "setExtraDescent$",	//1293
    "setFirstVisibleLine",	//1294
    "setFirstVisibleLine$",	//1295
    "setFoldAtBegin",	//1296
    "setFoldAtBegin$",	//1297
    "setFoldAtElse",	//1298
    "setFoldAtElse$",	//1299
    "setFoldAtParenthesis",	//1300
    "setFoldAtParenthesis$",	//1301
    "setFoldComments",	//1302
    "setFoldComments$",	//1303
    "setFoldCompact",	//1304
    "setFoldCompact$",	//1305
    "setFoldDirectives",	//1306
    "setFoldDirectives$",	//1307
    "setFoldMarginColors",	//1308
    "setFoldMarginColors##",	//1309
    "setFoldOnlyBegin",	//1310
    "setFoldOnlyBegin$",	//1311
    "setFoldPODBlocks",	//1312
    "setFoldPODBlocks$",	//1313
    "setFoldPackages",	//1314
    "setFoldPackages$",	//1315
    "setFoldPreprocessor",	//1316
    "setFoldPreprocessor$",	//1317
    "setFoldQuotes",	//1318
    "setFoldQuotes$",	//1319
    "setFoldScriptComments",	//1320
    "setFoldScriptComments$",	//1321
    "setFoldScriptHeredocs",	//1322
    "setFoldScriptHeredocs$",	//1323
    "setFolding",	//1324
    "setFolding$",	//1325
    "setFolding$$",	//1326
    "setFont",	//1327
    "setFont#",	//1328
    "setFont#$",	//1329
    "setHSSLanguage",	//1330
    "setHSSLanguage$",	//1331
    "setHashComments",	//1332
    "setHashComments$",	//1333
    "setHighlightBackQuotedStrings",	//1334
    "setHighlightBackQuotedStrings$",	//1335
    "setHighlightEscapeSequences",	//1336
    "setHighlightEscapeSequences$",	//1337
    "setHighlightHashQuotedStrings",	//1338
    "setHighlightHashQuotedStrings$",	//1339
    "setHighlightSubidentifiers",	//1340
    "setHighlightSubidentifiers$",	//1341
    "setHighlightTripleQuotedStrings",	//1342
    "setHighlightTripleQuotedStrings$",	//1343
    "setHotspot",	//1344
    "setHotspot$",	//1345
    "setHotspotBackgroundColor",	//1346
    "setHotspotBackgroundColor#",	//1347
    "setHotspotForegroundColor",	//1348
    "setHotspotForegroundColor#",	//1349
    "setHotspotUnderline",	//1350
    "setHotspotUnderline$",	//1351
    "setHotspotWrap",	//1352
    "setHotspotWrap$",	//1353
    "setIndentation",	//1354
    "setIndentation$$",	//1355
    "setIndentationGuides",	//1356
    "setIndentationGuides$",	//1357
    "setIndentationGuidesBackgroundColor",	//1358
    "setIndentationGuidesBackgroundColor#",	//1359
    "setIndentationGuidesForegroundColor",	//1360
    "setIndentationGuidesForegroundColor#",	//1361
    "setIndentationWarning",	//1362
    "setIndentationWarning$",	//1363
    "setIndentationWidth",	//1364
    "setIndentationWidth$",	//1365
    "setIndentationsUseTabs",	//1366
    "setIndentationsUseTabs$",	//1367
    "setIndicatorDrawUnder",	//1368
    "setIndicatorDrawUnder$",	//1369
    "setIndicatorDrawUnder$$",	//1370
    "setIndicatorForegroundColor",	//1371
    "setIndicatorForegroundColor#",	//1372
    "setIndicatorForegroundColor#$",	//1373
    "setIndicatorHoverForegroundColor",	//1374
    "setIndicatorHoverForegroundColor#",	//1375
    "setIndicatorHoverForegroundColor#$",	//1376
    "setIndicatorHoverStyle",	//1377
    "setIndicatorHoverStyle$",	//1378
    "setIndicatorHoverStyle$$",	//1379
    "setIndicatorOutlineColor",	//1380
    "setIndicatorOutlineColor#",	//1381
    "setIndicatorOutlineColor#$",	//1382
    "setInitialSpaces",	//1383
    "setInitialSpaces$",	//1384
    "setKey",	//1385
    "setKey$",	//1386
    "setLessLanguage",	//1387
    "setLessLanguage$",	//1388
    "setLevel",	//1389
    "setLevel$",	//1390
    "setLexer",	//1391
    "setLexer#",	//1392
    "setMagnification",	//1393
    "setMagnification$",	//1394
    "setMakoTemplates",	//1395
    "setMakoTemplates$",	//1396
    "setMarginLineNumbers",	//1397
    "setMarginLineNumbers$$",	//1398
    "setMarginMarkerMask",	//1399
    "setMarginMarkerMask$$",	//1400
    "setMarginOptions",	//1401
    "setMarginOptions$",	//1402
    "setMarginSensitivity",	//1403
    "setMarginSensitivity$$",	//1404
    "setMarginText",	//1405
    "setMarginText$#",	//1406
    "setMarginText$$#",	//1407
    "setMarginText$$$",	//1408
    "setMarginText$?",	//1409
    "setMarginType",	//1410
    "setMarginType$$",	//1411
    "setMarginWidth",	//1412
    "setMarginWidth$$",	//1413
    "setMarginsBackgroundColor",	//1414
    "setMarginsBackgroundColor#",	//1415
    "setMarginsFont",	//1416
    "setMarginsFont#",	//1417
    "setMarginsForegroundColor",	//1418
    "setMarginsForegroundColor#",	//1419
    "setMarkerBackgroundColor",	//1420
    "setMarkerBackgroundColor#",	//1421
    "setMarkerBackgroundColor#$",	//1422
    "setMarkerForegroundColor",	//1423
    "setMarkerForegroundColor#",	//1424
    "setMarkerForegroundColor#$",	//1425
    "setMatchedBraceBackgroundColor",	//1426
    "setMatchedBraceBackgroundColor#",	//1427
    "setMatchedBraceForegroundColor",	//1428
    "setMatchedBraceForegroundColor#",	//1429
    "setMatchedBraceIndicator",	//1430
    "setMatchedBraceIndicator$",	//1431
    "setModified",	//1432
    "setModified$",	//1433
    "setOverwriteMode",	//1434
    "setOverwriteMode$",	//1435
    "setPaper",	//1436
    "setPaper#",	//1437
    "setPaper#$",	//1438
    "setProcessComments",	//1439
    "setProcessComments$",	//1440
    "setProcessIf",	//1441
    "setProcessIf$",	//1442
    "setQuotedIdentifiers",	//1443
    "setQuotedIdentifiers$",	//1444
    "setReadOnly",	//1445
    "setReadOnly$",	//1446
    "setSCSSLanguage",	//1447
    "setSCSSLanguage$",	//1448
    "setScriptsStyled",	//1449
    "setScriptsStyled$",	//1450
    "setScrollBars",	//1451
    "setSelection",	//1452
    "setSelection$$$$",	//1453
    "setSelectionBackgroundColor",	//1454
    "setSelectionBackgroundColor#",	//1455
    "setSelectionForegroundColor",	//1456
    "setSelectionForegroundColor#",	//1457
    "setSelectionToEol",	//1458
    "setSelectionToEol$",	//1459
    "setSmartHighlighting",	//1460
    "setSmartHighlighting$",	//1461
    "setStringsOverNewlineAllowed",	//1462
    "setStringsOverNewlineAllowed$",	//1463
    "setStylePreprocessor",	//1464
    "setStylePreprocessor$",	//1465
    "setStyling",	//1466
    "setStyling$#",	//1467
    "setStyling$$",	//1468
    "setTabIndents",	//1469
    "setTabIndents$",	//1470
    "setTabWidth",	//1471
    "setTabWidth$",	//1472
    "setText",	//1473
    "setText$",	//1474
    "setTextCase",	//1475
    "setTextCase$",	//1476
    "setTokenize",	//1477
    "setTokenize$",	//1478
    "setUnmatchedBraceBackgroundColor",	//1479
    "setUnmatchedBraceBackgroundColor#",	//1480
    "setUnmatchedBraceForegroundColor",	//1481
    "setUnmatchedBraceForegroundColor#",	//1482
    "setUnmatchedBraceIndicator",	//1483
    "setUnmatchedBraceIndicator$",	//1484
    "setUtf8",	//1485
    "setUtf8$",	//1486
    "setV2UnicodeAllowed",	//1487
    "setV2UnicodeAllowed$",	//1488
    "setV3BinaryOctalAllowed",	//1489
    "setV3BinaryOctalAllowed$",	//1490
    "setV3BytesAllowed",	//1491
    "setV3BytesAllowed$",	//1492
    "setVerbatimStringEscapeSequencesAllowed",	//1493
    "setVerbatimStringEscapeSequencesAllowed$",	//1494
    "setVisible",	//1495
    "setVisible$",	//1496
    "setWhitespaceBackgroundColor",	//1497
    "setWhitespaceBackgroundColor#",	//1498
    "setWhitespaceForegroundColor",	//1499
    "setWhitespaceForegroundColor#",	//1500
    "setWhitespaceSize",	//1501
    "setWhitespaceSize$",	//1502
    "setWhitespaceVisibility",	//1503
    "setWhitespaceVisibility$",	//1504
    "setWrapIndentMode",	//1505
    "setWrapIndentMode$",	//1506
    "setWrapMode",	//1507
    "setWrapMode$",	//1508
    "setWrapVisualFlags",	//1509
    "setWrapVisualFlags$",	//1510
    "setWrapVisualFlags$$",	//1511
    "setWrapVisualFlags$$$",	//1512
    "showEvent",	//1513
    "showUserList",	//1514
    "showUserList$?",	//1515
    "sizeHint",	//1516
    "smartHighlighting",	//1517
    "standardCommands",	//1518
    "startRecording",	//1519
    "startStyling",	//1520
    "startStyling$",	//1521
    "startStyling$$",	//1522
    "staticMetaObject",	//1523
    "stringsOverNewlineAllowed",	//1524
    "style",	//1525
    "styleBitsNeeded",	//1526
    "styleChange",	//1527
    "stylePreprocessor",	//1528
    "styleText",	//1529
    "styleText$$",	//1530
    "tabIndents",	//1531
    "tabWidth",	//1532
    "tabletEvent",	//1533
    "text",	//1534
    "text$",	//1535
    "textAsBytes",	//1536
    "textAsBytes$",	//1537
    "textCase",	//1538
    "textChanged",	//1539
    "textHeight",	//1540
    "textHeight$",	//1541
    "timerEvent",	//1542
    "toMimeData",	//1543
    "toMimeData#$",	//1544
    "tokenize",	//1545
    "tr",	//1546
    "tr$",	//1547
    "tr$$",	//1548
    "tr$$$",	//1549
    "trUtf8",	//1550
    "trUtf8$",	//1551
    "trUtf8$$",	//1552
    "trUtf8$$$",	//1553
    "undo",	//1554
    "unindent",	//1555
    "unindent$",	//1556
    "updateAutoCompletionList",	//1557
    "updateAutoCompletionList??",	//1558
    "userListActivated",	//1559
    "userListActivated$$",	//1560
    "v2UnicodeAllowed",	//1561
    "v3BinaryOctalAllowed",	//1562
    "v3BytesAllowed",	//1563
    "validKey",	//1564
    "validKey$",	//1565
    "verbatimStringEscapeSequencesAllowed",	//1566
    "viewportEvent",	//1567
    "visible",	//1568
    "wheelEvent",	//1569
    "whitespaceSize",	//1570
    "whitespaceVisibility",	//1571
    "windowActivationChange",	//1572
    "wordAtLineIndex",	//1573
    "wordAtLineIndex$$",	//1574
    "wordAtPoint",	//1575
    "wordAtPoint#",	//1576
    "wordCharacters",	//1577
    "wrapIndentMode",	//1578
    "wrapMode",	//1579
    "write",	//1580
    "write#",	//1581
    "writeProperties",	//1582
    "writeProperties#$",	//1583
    "writeSettings",	//1584
    "writeSettings#",	//1585
    "writeSettings#$",	//1586
    "x11Event",	//1587
    "zoomIn",	//1588
    "zoomIn$",	//1589
    "zoomOut",	//1590
    "zoomOut$",	//1591
    "zoomTo",	//1592
    "zoomTo$",	//1593
    "~QsciAPIs",	//1594
    "~QsciAbstractAPIs",	//1595
    "~QsciCommand",	//1596
    "~QsciDocument",	//1597
    "~QsciLexer",	//1598
    "~QsciLexerBash",	//1599
    "~QsciLexerBatch",	//1600
    "~QsciLexerCMake",	//1601
    "~QsciLexerCPP",	//1602
    "~QsciLexerCSS",	//1603
    "~QsciLexerCSharp",	//1604
    "~QsciLexerCustom",	//1605
    "~QsciLexerD",	//1606
    "~QsciLexerDiff",	//1607
    "~QsciLexerFortran",	//1608
    "~QsciLexerFortran77",	//1609
    "~QsciLexerHTML",	//1610
    "~QsciLexerIDL",	//1611
    "~QsciLexerJava",	//1612
    "~QsciLexerJavaScript",	//1613
    "~QsciLexerLua",	//1614
    "~QsciLexerMakefile",	//1615
    "~QsciLexerPOV",	//1616
    "~QsciLexerPascal",	//1617
    "~QsciLexerPerl",	//1618
    "~QsciLexerPostScript",	//1619
    "~QsciLexerProperties",	//1620
    "~QsciLexerPython",	//1621
    "~QsciLexerRuby",	//1622
    "~QsciLexerSQL",	//1623
    "~QsciLexerTCL",	//1624
    "~QsciLexerTeX",	//1625
    "~QsciLexerVHDL",	//1626
    "~QsciLexerXML",	//1627
    "~QsciLexerYAML",	//1628
    "~QsciMacro",	//1629
    "~QsciPrinter",	//1630
    "~QsciScintilla",	//1631
    "~QsciScintillaBase",	//1632
    "~QsciStyle",	//1633
    "~QsciStyledText",	//1634
};

// (classId, name (index in methodNames), argumentList index, number of args, method flags, return type (index in types), xcall() index)
static Smoke::Method methods[] = {
    { 0, 0, 0, 0, 0, 0, 0 },	// (no method)
    {1, 1107, 0, 0, Smoke::mf_const|Smoke::mf_virtual, 39, 0},	//1 QAbstractScrollArea::minimumSizeHint() const
    {1, 1516, 0, 0, Smoke::mf_const|Smoke::mf_virtual, 39, 0},	//2 QAbstractScrollArea::sizeHint() const
    {1, 933, 1, 1, Smoke::mf_protected|Smoke::mf_virtual, 189, 0},	//3 QAbstractScrollArea::event(QEvent*)
    {1, 1567, 1, 1, Smoke::mf_protected|Smoke::mf_virtual, 189, 0},	//4 QAbstractScrollArea::viewportEvent(QEvent*)
    {1, 1569, 3, 1, Smoke::mf_protected|Smoke::mf_virtual, 0, 0},	//5 QAbstractScrollArea::wheelEvent(QWheelEvent*)
    {16, 852, 1, 1, Smoke::mf_protected|Smoke::mf_virtual, 0, 0},	//6 QFrame::changeEvent(QEvent*)
    {17, 456, 0, 0, Smoke::mf_static|Smoke::mf_enum, 218, 1},	//7 QGlobalSpace::Q_COMPLEX_TYPE (enum)
    {17, 459, 0, 0, Smoke::mf_static|Smoke::mf_enum, 218, 2},	//8 QGlobalSpace::Q_PRIMITIVE_TYPE (enum)
    {17, 460, 0, 0, Smoke::mf_static|Smoke::mf_enum, 218, 3},	//9 QGlobalSpace::Q_STATIC_TYPE (enum)
    {17, 458, 0, 0, Smoke::mf_static|Smoke::mf_enum, 218, 4},	//10 QGlobalSpace::Q_MOVABLE_TYPE (enum)
    {17, 457, 0, 0, Smoke::mf_static|Smoke::mf_enum, 218, 5},	//11 QGlobalSpace::Q_DUMMY_TYPE (enum)
    {28, 933, 1, 1, Smoke::mf_virtual, 189, 0},	//12 QObject::event(QEvent*)
    {28, 935, 5, 2, Smoke::mf_virtual, 189, 0},	//13 QObject::eventFilter(QObject*, QEvent*)
    {28, 1542, 8, 1, Smoke::mf_protected|Smoke::mf_virtual, 0, 0},	//14 QObject::timerEvent(QTimerEvent*)
    {28, 855, 10, 1, Smoke::mf_protected|Smoke::mf_virtual, 0, 0},	//15 QObject::childEvent(QChildEvent*)
    {28, 888, 1, 1, Smoke::mf_protected|Smoke::mf_virtual, 0, 0},	//16 QObject::customEvent(QEvent*)
    {28, 876, 12, 1, Smoke::mf_protected|Smoke::mf_virtual, 0, 0},	//17 QObject::connectNotify(const char*)
    {28, 903, 12, 1, Smoke::mf_protected|Smoke::mf_virtual, 0, 0},	//18 QObject::disconnectNotify(const char*)
    {35, 902, 0, 0, Smoke::mf_const|Smoke::mf_virtual, 215, 0},	//19 QPrinter::devType() const
    {35, 1124, 0, 0, Smoke::mf_const|Smoke::mf_virtual, 29, 0},	//20 QPrinter::paintEngine() const
    {35, 1106, 14, 1, Smoke::mf_const|Smoke::mf_protected|Smoke::mf_virtual, 215, 0},	//21 QPrinter::metric(QPaintDevice::PaintDeviceMetric) const
    {35, 633, 0, 0, Smoke::mf_static|Smoke::mf_enum, 33, 4},	//22 QPrinter::ScreenResolution (enum)
    {35, 437, 0, 0, Smoke::mf_static|Smoke::mf_enum, 33, 5},	//23 QPrinter::PrinterResolution (enum)
    {35, 244, 0, 0, Smoke::mf_static|Smoke::mf_enum, 33, 6},	//24 QPrinter::HighResolution (enum)
    {47, 902, 0, 0, Smoke::mf_const|Smoke::mf_virtual, 215, 0},	//25 QWidget::devType() const
    {47, 1495, 16, 1, Smoke::mf_property|Smoke::mf_virtual|Smoke::mf_slot, 0, 0},	//26 QWidget::setVisible(bool)
    {47, 996, 18, 1, Smoke::mf_const|Smoke::mf_virtual, 215, 0},	//27 QWidget::heightForWidth(int) const
    {47, 1124, 0, 0, Smoke::mf_const|Smoke::mf_virtual, 29, 0},	//28 QWidget::paintEngine() const
    {47, 1046, 20, 1, Smoke::mf_protected|Smoke::mf_virtual, 0, 0},	//29 QWidget::keyReleaseEvent(QKeyEvent*)
    {47, 926, 1, 1, Smoke::mf_protected|Smoke::mf_virtual, 0, 0},	//30 QWidget::enterEvent(QEvent*)
    {47, 1051, 1, 1, Smoke::mf_protected|Smoke::mf_virtual, 0, 0},	//31 QWidget::leaveEvent(QEvent*)
    {47, 1119, 22, 1, Smoke::mf_protected|Smoke::mf_virtual, 0, 0},	//32 QWidget::moveEvent(QMoveEvent*)
    {47, 867, 24, 1, Smoke::mf_protected|Smoke::mf_virtual, 0, 0},	//33 QWidget::closeEvent(QCloseEvent*)
    {47, 1533, 26, 1, Smoke::mf_protected|Smoke::mf_virtual, 0, 0},	//34 QWidget::tabletEvent(QTabletEvent*)
    {47, 786, 28, 1, Smoke::mf_protected|Smoke::mf_virtual, 0, 0},	//35 QWidget::actionEvent(QActionEvent*)
    {47, 1513, 30, 1, Smoke::mf_protected|Smoke::mf_virtual, 0, 0},	//36 QWidget::showEvent(QShowEvent*)
    {47, 997, 32, 1, Smoke::mf_protected|Smoke::mf_virtual, 0, 0},	//37 QWidget::hideEvent(QHideEvent*)
    {47, 1587, 34, 1, Smoke::mf_protected|Smoke::mf_virtual, 189, 0},	//38 QWidget::x11Event(_XEvent*)
    {47, 1106, 14, 1, Smoke::mf_const|Smoke::mf_protected|Smoke::mf_virtual, 215, 0},	//39 QWidget::metric(QPaintDevice::PaintDeviceMetric) const
    {47, 1527, 36, 1, Smoke::mf_protected|Smoke::mf_virtual, 0, 0},	//40 QWidget::styleChange(QStyle&)
    {47, 920, 16, 1, Smoke::mf_protected|Smoke::mf_virtual, 0, 0},	//41 QWidget::enabledChange(bool)
    {47, 1127, 38, 1, Smoke::mf_protected|Smoke::mf_virtual, 0, 0},	//42 QWidget::paletteChange(const QPalette&)
    {47, 983, 40, 1, Smoke::mf_protected|Smoke::mf_virtual, 0, 0},	//43 QWidget::fontChange(const QFont&)
    {47, 1572, 16, 1, Smoke::mf_protected|Smoke::mf_virtual, 0, 0},	//44 QWidget::windowActivationChange(bool)
    {47, 1050, 0, 0, Smoke::mf_protected|Smoke::mf_virtual, 0, 0},	//45 QWidget::languageChange()
    {48, 1105, 0, 0, Smoke::mf_const|Smoke::mf_virtual, 200, 1},	//46 QsciAPIs::metaObject() const
    {48, 1148, 12, 1, Smoke::mf_virtual, 221, 2},	//47 QsciAPIs::qt_metacast(const char*)
    {48, 1546, 42, 2, Smoke::mf_static, 40, 3},	//48 QsciAPIs::tr(const char*, const char*)
    {48, 1550, 42, 2, Smoke::mf_static, 40, 4},	//49 QsciAPIs::trUtf8(const char*, const char*)
    {48, 1546, 45, 3, Smoke::mf_static, 40, 5},	//50 QsciAPIs::tr(const char*, const char*, int)
    {48, 1550, 45, 3, Smoke::mf_static, 40, 6},	//51 QsciAPIs::trUtf8(const char*, const char*, int)
    {48, 1146, 49, 3, Smoke::mf_virtual, 215, 7},	//52 QsciAPIs::qt_metacall(QMetaObject::Call, int, void**)
    {48, 461, 53, 1, Smoke::mf_ctor, 50, 8},	//53 QsciAPIs::QsciAPIs(QsciLexer*)
    {48, 787, 55, 1, 0, 0, 9},	//54 QsciAPIs::add(const QString&)
    {48, 856, 0, 0, 0, 0, 10},	//55 QsciAPIs::clear()
    {48, 1064, 55, 1, 0, 189, 11},	//56 QsciAPIs::load(const QString&)
    {48, 1166, 55, 1, 0, 0, 12},	//57 QsciAPIs::remove(const QString&)
    {48, 1137, 0, 0, 0, 0, 13},	//58 QsciAPIs::prepare()
    {48, 849, 0, 0, 0, 0, 14},	//59 QsciAPIs::cancelPreparation()
    {48, 898, 0, 0, Smoke::mf_const, 40, 15},	//60 QsciAPIs::defaultPreparedName() const
    {48, 1035, 55, 1, Smoke::mf_const, 189, 16},	//61 QsciAPIs::isPrepared(const QString&) const
    {48, 1066, 55, 1, 0, 189, 17},	//62 QsciAPIs::loadPrepared(const QString&)
    {48, 1183, 55, 1, Smoke::mf_const, 189, 18},	//63 QsciAPIs::savePrepared(const QString&) const
    {48, 1557, 57, 2, Smoke::mf_virtual, 0, 19},	//64 QsciAPIs::updateAutoCompletionList(const QStringList&, QStringList&)
    {48, 815, 55, 1, Smoke::mf_virtual, 0, 20},	//65 QsciAPIs::autoCompletionSelected(const QString&)
    {48, 841, 60, 4, Smoke::mf_virtual, 41, 21},	//66 QsciAPIs::callTips(const QStringList&, int, QsciScintilla::CallTipsStyle, QList<int>&)
    {48, 933, 1, 1, Smoke::mf_virtual, 189, 22},	//67 QsciAPIs::event(QEvent*)
    {48, 1031, 0, 0, Smoke::mf_const, 41, 23},	//68 QsciAPIs::installedAPIFiles() const
    {48, 800, 0, 0, Smoke::mf_protected|Smoke::mf_signal, 0, 24},	//69 QsciAPIs::apiPreparationCancelled()
    {48, 802, 0, 0, Smoke::mf_protected|Smoke::mf_signal, 0, 25},	//70 QsciAPIs::apiPreparationStarted()
    {48, 801, 0, 0, Smoke::mf_protected|Smoke::mf_signal, 0, 26},	//71 QsciAPIs::apiPreparationFinished()
    {48, 1546, 12, 1, Smoke::mf_static, 40, 27},	//72 QsciAPIs::tr(const char*)
    {48, 1550, 12, 1, Smoke::mf_static, 40, 28},	//73 QsciAPIs::trUtf8(const char*)
    {48, 1035, 0, 0, Smoke::mf_const, 189, 29},	//74 QsciAPIs::isPrepared() const
    {48, 1066, 0, 0, 0, 189, 30},	//75 QsciAPIs::loadPrepared()
    {48, 1183, 0, 0, Smoke::mf_const, 189, 31},	//76 QsciAPIs::savePrepared() const
    {48, 1523, 0, 0, Smoke::mf_const|Smoke::mf_static|Smoke::mf_attribute, 199, 32},	//77 QsciAPIs::staticMetaObject() const
    {48, 1594, 0, 0, Smoke::mf_dtor, 0, 33 },	//78 QsciAPIs::~QsciAPIs()
    {49, 1105, 0, 0, Smoke::mf_const|Smoke::mf_virtual, 200, 1},	//79 QsciAbstractAPIs::metaObject() const
    {49, 1148, 12, 1, Smoke::mf_virtual, 221, 2},	//80 QsciAbstractAPIs::qt_metacast(const char*)
    {49, 1546, 42, 2, Smoke::mf_static, 40, 3},	//81 QsciAbstractAPIs::tr(const char*, const char*)
    {49, 1550, 42, 2, Smoke::mf_static, 40, 4},	//82 QsciAbstractAPIs::trUtf8(const char*, const char*)
    {49, 1546, 45, 3, Smoke::mf_static, 40, 5},	//83 QsciAbstractAPIs::tr(const char*, const char*, int)
    {49, 1550, 45, 3, Smoke::mf_static, 40, 6},	//84 QsciAbstractAPIs::trUtf8(const char*, const char*, int)
    {49, 1146, 49, 3, Smoke::mf_virtual, 215, 7},	//85 QsciAbstractAPIs::qt_metacall(QMetaObject::Call, int, void**)
    {49, 463, 53, 1, Smoke::mf_ctor, 51, 8},	//86 QsciAbstractAPIs::QsciAbstractAPIs(QsciLexer*)
    {49, 1054, 0, 0, Smoke::mf_const, 58, 9},	//87 QsciAbstractAPIs::lexer() const
    {49, 1557, 57, 2, Smoke::mf_virtual|Smoke::mf_purevirtual, 0, 10},	//88 QsciAbstractAPIs::updateAutoCompletionList(const QStringList&, QStringList&) [pure virtual]
    {49, 815, 55, 1, Smoke::mf_virtual, 0, 11},	//89 QsciAbstractAPIs::autoCompletionSelected(const QString&)
    {49, 841, 60, 4, Smoke::mf_virtual|Smoke::mf_purevirtual, 41, 12},	//90 QsciAbstractAPIs::callTips(const QStringList&, int, QsciScintilla::CallTipsStyle, QList<int>&) [pure virtual]
    {49, 1546, 12, 1, Smoke::mf_static, 40, 13},	//91 QsciAbstractAPIs::tr(const char*)
    {49, 1550, 12, 1, Smoke::mf_static, 40, 14},	//92 QsciAbstractAPIs::trUtf8(const char*)
    {49, 1523, 0, 0, Smoke::mf_const|Smoke::mf_static|Smoke::mf_attribute, 199, 15},	//93 QsciAbstractAPIs::staticMetaObject() const
    {49, 1595, 0, 0, Smoke::mf_dtor, 0, 16 },	//94 QsciAbstractAPIs::~QsciAbstractAPIs()
    {50, 872, 0, 0, Smoke::mf_const, 53, 1},	//95 QsciCommand::command() const
    {50, 936, 0, 0, 0, 0, 2},	//96 QsciCommand::execute()
    {50, 1385, 18, 1, 0, 0, 3},	//97 QsciCommand::setKey(int)
    {50, 1196, 18, 1, 0, 0, 4},	//98 QsciCommand::setAlternateKey(int)
    {50, 1043, 0, 0, Smoke::mf_const, 215, 5},	//99 QsciCommand::key() const
    {50, 789, 0, 0, Smoke::mf_const, 215, 6},	//100 QsciCommand::alternateKey() const
    {50, 1564, 18, 1, Smoke::mf_static, 189, 7},	//101 QsciCommand::validKey(int)
    {50, 900, 0, 0, Smoke::mf_const, 40, 8},	//102 QsciCommand::description() const
    {50, 335, 0, 0, Smoke::mf_static|Smoke::mf_enum, 53, 9},	//103 QsciCommand::LineDown (enum)
    {50, 336, 0, 0, Smoke::mf_static|Smoke::mf_enum, 53, 10},	//104 QsciCommand::LineDownExtend (enum)
    {50, 337, 0, 0, Smoke::mf_static|Smoke::mf_enum, 53, 11},	//105 QsciCommand::LineDownRectExtend (enum)
    {50, 347, 0, 0, Smoke::mf_static|Smoke::mf_enum, 53, 12},	//106 QsciCommand::LineScrollDown (enum)
    {50, 350, 0, 0, Smoke::mf_static|Smoke::mf_enum, 53, 13},	//107 QsciCommand::LineUp (enum)
    {50, 351, 0, 0, Smoke::mf_static|Smoke::mf_enum, 53, 14},	//108 QsciCommand::LineUpExtend (enum)
    {50, 352, 0, 0, Smoke::mf_static|Smoke::mf_enum, 53, 15},	//109 QsciCommand::LineUpRectExtend (enum)
    {50, 348, 0, 0, Smoke::mf_static|Smoke::mf_enum, 53, 16},	//110 QsciCommand::LineScrollUp (enum)
    {50, 636, 0, 0, Smoke::mf_static|Smoke::mf_enum, 53, 17},	//111 QsciCommand::ScrollToStart (enum)
    {50, 635, 0, 0, Smoke::mf_static|Smoke::mf_enum, 53, 18},	//112 QsciCommand::ScrollToEnd (enum)
    {50, 752, 0, 0, Smoke::mf_static|Smoke::mf_enum, 53, 19},	//113 QsciCommand::VerticalCentreCaret (enum)
    {50, 406, 0, 0, Smoke::mf_static|Smoke::mf_enum, 53, 20},	//114 QsciCommand::ParaDown (enum)
    {50, 407, 0, 0, Smoke::mf_static|Smoke::mf_enum, 53, 21},	//115 QsciCommand::ParaDownExtend (enum)
    {50, 408, 0, 0, Smoke::mf_static|Smoke::mf_enum, 53, 22},	//116 QsciCommand::ParaUp (enum)
    {50, 409, 0, 0, Smoke::mf_static|Smoke::mf_enum, 53, 23},	//117 QsciCommand::ParaUpExtend (enum)
    {50, 118, 0, 0, Smoke::mf_static|Smoke::mf_enum, 53, 24},	//118 QsciCommand::CharLeft (enum)
    {50, 119, 0, 0, Smoke::mf_static|Smoke::mf_enum, 53, 25},	//119 QsciCommand::CharLeftExtend (enum)
    {50, 120, 0, 0, Smoke::mf_static|Smoke::mf_enum, 53, 26},	//120 QsciCommand::CharLeftRectExtend (enum)
    {50, 121, 0, 0, Smoke::mf_static|Smoke::mf_enum, 53, 27},	//121 QsciCommand::CharRight (enum)
    {50, 122, 0, 0, Smoke::mf_static|Smoke::mf_enum, 53, 28},	//122 QsciCommand::CharRightExtend (enum)
    {50, 123, 0, 0, Smoke::mf_static|Smoke::mf_enum, 53, 29},	//123 QsciCommand::CharRightRectExtend (enum)
    {50, 755, 0, 0, Smoke::mf_static|Smoke::mf_enum, 53, 30},	//124 QsciCommand::WordLeft (enum)
    {50, 758, 0, 0, Smoke::mf_static|Smoke::mf_enum, 53, 31},	//125 QsciCommand::WordLeftExtend (enum)
    {50, 763, 0, 0, Smoke::mf_static|Smoke::mf_enum, 53, 32},	//126 QsciCommand::WordRight (enum)
    {50, 766, 0, 0, Smoke::mf_static|Smoke::mf_enum, 53, 33},	//127 QsciCommand::WordRightExtend (enum)
    {50, 756, 0, 0, Smoke::mf_static|Smoke::mf_enum, 53, 34},	//128 QsciCommand::WordLeftEnd (enum)
    {50, 757, 0, 0, Smoke::mf_static|Smoke::mf_enum, 53, 35},	//129 QsciCommand::WordLeftEndExtend (enum)
    {50, 764, 0, 0, Smoke::mf_static|Smoke::mf_enum, 53, 36},	//130 QsciCommand::WordRightEnd (enum)
    {50, 765, 0, 0, Smoke::mf_static|Smoke::mf_enum, 53, 37},	//131 QsciCommand::WordRightEndExtend (enum)
    {50, 759, 0, 0, Smoke::mf_static|Smoke::mf_enum, 53, 38},	//132 QsciCommand::WordPartLeft (enum)
    {50, 760, 0, 0, Smoke::mf_static|Smoke::mf_enum, 53, 39},	//133 QsciCommand::WordPartLeftExtend (enum)
    {50, 761, 0, 0, Smoke::mf_static|Smoke::mf_enum, 53, 40},	//134 QsciCommand::WordPartRight (enum)
    {50, 762, 0, 0, Smoke::mf_static|Smoke::mf_enum, 53, 41},	//135 QsciCommand::WordPartRightExtend (enum)
    {50, 246, 0, 0, Smoke::mf_static|Smoke::mf_enum, 53, 42},	//136 QsciCommand::Home (enum)
    {50, 249, 0, 0, Smoke::mf_static|Smoke::mf_enum, 53, 43},	//137 QsciCommand::HomeExtend (enum)
    {50, 250, 0, 0, Smoke::mf_static|Smoke::mf_enum, 53, 44},	//138 QsciCommand::HomeRectExtend (enum)
    {50, 247, 0, 0, Smoke::mf_static|Smoke::mf_enum, 53, 45},	//139 QsciCommand::HomeDisplay (enum)
    {50, 248, 0, 0, Smoke::mf_static|Smoke::mf_enum, 53, 46},	//140 QsciCommand::HomeDisplayExtend (enum)
    {50, 251, 0, 0, Smoke::mf_static|Smoke::mf_enum, 53, 47},	//141 QsciCommand::HomeWrap (enum)
    {50, 252, 0, 0, Smoke::mf_static|Smoke::mf_enum, 53, 48},	//142 QsciCommand::HomeWrapExtend (enum)
    {50, 743, 0, 0, Smoke::mf_static|Smoke::mf_enum, 53, 49},	//143 QsciCommand::VCHome (enum)
    {50, 744, 0, 0, Smoke::mf_static|Smoke::mf_enum, 53, 50},	//144 QsciCommand::VCHomeExtend (enum)
    {50, 745, 0, 0, Smoke::mf_static|Smoke::mf_enum, 53, 51},	//145 QsciCommand::VCHomeRectExtend (enum)
    {50, 746, 0, 0, Smoke::mf_static|Smoke::mf_enum, 53, 52},	//146 QsciCommand::VCHomeWrap (enum)
    {50, 747, 0, 0, Smoke::mf_static|Smoke::mf_enum, 53, 53},	//147 QsciCommand::VCHomeWrapExtend (enum)
    {50, 339, 0, 0, Smoke::mf_static|Smoke::mf_enum, 53, 54},	//148 QsciCommand::LineEnd (enum)
    {50, 342, 0, 0, Smoke::mf_static|Smoke::mf_enum, 53, 55},	//149 QsciCommand::LineEndExtend (enum)
    {50, 343, 0, 0, Smoke::mf_static|Smoke::mf_enum, 53, 56},	//150 QsciCommand::LineEndRectExtend (enum)
    {50, 340, 0, 0, Smoke::mf_static|Smoke::mf_enum, 53, 57},	//151 QsciCommand::LineEndDisplay (enum)
    {50, 341, 0, 0, Smoke::mf_static|Smoke::mf_enum, 53, 58},	//152 QsciCommand::LineEndDisplayExtend (enum)
    {50, 344, 0, 0, Smoke::mf_static|Smoke::mf_enum, 53, 59},	//153 QsciCommand::LineEndWrap (enum)
    {50, 345, 0, 0, Smoke::mf_static|Smoke::mf_enum, 53, 60},	//154 QsciCommand::LineEndWrapExtend (enum)
    {50, 179, 0, 0, Smoke::mf_static|Smoke::mf_enum, 53, 61},	//155 QsciCommand::DocumentStart (enum)
    {50, 180, 0, 0, Smoke::mf_static|Smoke::mf_enum, 53, 62},	//156 QsciCommand::DocumentStartExtend (enum)
    {50, 177, 0, 0, Smoke::mf_static|Smoke::mf_enum, 53, 63},	//157 QsciCommand::DocumentEnd (enum)
    {50, 178, 0, 0, Smoke::mf_static|Smoke::mf_enum, 53, 64},	//158 QsciCommand::DocumentEndExtend (enum)
    {50, 402, 0, 0, Smoke::mf_static|Smoke::mf_enum, 53, 65},	//159 QsciCommand::PageUp (enum)
    {50, 403, 0, 0, Smoke::mf_static|Smoke::mf_enum, 53, 66},	//160 QsciCommand::PageUpExtend (enum)
    {50, 404, 0, 0, Smoke::mf_static|Smoke::mf_enum, 53, 67},	//161 QsciCommand::PageUpRectExtend (enum)
    {50, 398, 0, 0, Smoke::mf_static|Smoke::mf_enum, 53, 68},	//162 QsciCommand::PageDown (enum)
    {50, 399, 0, 0, Smoke::mf_static|Smoke::mf_enum, 53, 69},	//163 QsciCommand::PageDownExtend (enum)
    {50, 400, 0, 0, Smoke::mf_static|Smoke::mf_enum, 53, 70},	//164 QsciCommand::PageDownRectExtend (enum)
    {50, 684, 0, 0, Smoke::mf_static|Smoke::mf_enum, 53, 71},	//165 QsciCommand::StutteredPageUp (enum)
    {50, 685, 0, 0, Smoke::mf_static|Smoke::mf_enum, 53, 72},	//166 QsciCommand::StutteredPageUpExtend (enum)
    {50, 682, 0, 0, Smoke::mf_static|Smoke::mf_enum, 53, 73},	//167 QsciCommand::StutteredPageDown (enum)
    {50, 683, 0, 0, Smoke::mf_static|Smoke::mf_enum, 53, 74},	//168 QsciCommand::StutteredPageDownExtend (enum)
    {50, 162, 0, 0, Smoke::mf_static|Smoke::mf_enum, 53, 75},	//169 QsciCommand::Delete (enum)
    {50, 163, 0, 0, Smoke::mf_static|Smoke::mf_enum, 53, 76},	//170 QsciCommand::DeleteBack (enum)
    {50, 164, 0, 0, Smoke::mf_static|Smoke::mf_enum, 53, 77},	//171 QsciCommand::DeleteBackNotLine (enum)
    {50, 167, 0, 0, Smoke::mf_static|Smoke::mf_enum, 53, 78},	//172 QsciCommand::DeleteWordLeft (enum)
    {50, 168, 0, 0, Smoke::mf_static|Smoke::mf_enum, 53, 79},	//173 QsciCommand::DeleteWordRight (enum)
    {50, 169, 0, 0, Smoke::mf_static|Smoke::mf_enum, 53, 80},	//174 QsciCommand::DeleteWordRightEnd (enum)
    {50, 165, 0, 0, Smoke::mf_static|Smoke::mf_enum, 53, 81},	//175 QsciCommand::DeleteLineLeft (enum)
    {50, 166, 0, 0, Smoke::mf_static|Smoke::mf_enum, 53, 82},	//176 QsciCommand::DeleteLineRight (enum)
    {50, 334, 0, 0, Smoke::mf_static|Smoke::mf_enum, 53, 83},	//177 QsciCommand::LineDelete (enum)
    {50, 333, 0, 0, Smoke::mf_static|Smoke::mf_enum, 53, 84},	//178 QsciCommand::LineCut (enum)
    {50, 332, 0, 0, Smoke::mf_static|Smoke::mf_enum, 53, 85},	//179 QsciCommand::LineCopy (enum)
    {50, 349, 0, 0, Smoke::mf_static|Smoke::mf_enum, 53, 86},	//180 QsciCommand::LineTranspose (enum)
    {50, 338, 0, 0, Smoke::mf_static|Smoke::mf_enum, 53, 87},	//181 QsciCommand::LineDuplicate (enum)
    {50, 638, 0, 0, Smoke::mf_static|Smoke::mf_enum, 53, 88},	//182 QsciCommand::SelectAll (enum)
    {50, 368, 0, 0, Smoke::mf_static|Smoke::mf_enum, 53, 89},	//183 QsciCommand::MoveSelectedLinesUp (enum)
    {50, 367, 0, 0, Smoke::mf_static|Smoke::mf_enum, 53, 90},	//184 QsciCommand::MoveSelectedLinesDown (enum)
    {50, 642, 0, 0, Smoke::mf_static|Smoke::mf_enum, 53, 91},	//185 QsciCommand::SelectionDuplicate (enum)
    {50, 643, 0, 0, Smoke::mf_static|Smoke::mf_enum, 53, 92},	//186 QsciCommand::SelectionLowerCase (enum)
    {50, 644, 0, 0, Smoke::mf_static|Smoke::mf_enum, 53, 93},	//187 QsciCommand::SelectionUpperCase (enum)
    {50, 641, 0, 0, Smoke::mf_static|Smoke::mf_enum, 53, 94},	//188 QsciCommand::SelectionCut (enum)
    {50, 640, 0, 0, Smoke::mf_static|Smoke::mf_enum, 53, 95},	//189 QsciCommand::SelectionCopy (enum)
    {50, 411, 0, 0, Smoke::mf_static|Smoke::mf_enum, 53, 96},	//190 QsciCommand::Paste (enum)
    {50, 198, 0, 0, Smoke::mf_static|Smoke::mf_enum, 53, 97},	//191 QsciCommand::EditToggleOvertype (enum)
    {50, 373, 0, 0, Smoke::mf_static|Smoke::mf_enum, 53, 98},	//192 QsciCommand::Newline (enum)
    {50, 219, 0, 0, Smoke::mf_static|Smoke::mf_enum, 53, 99},	//193 QsciCommand::Formfeed (enum)
    {50, 700, 0, 0, Smoke::mf_static|Smoke::mf_enum, 53, 100},	//194 QsciCommand::Tab (enum)
    {50, 82, 0, 0, Smoke::mf_static|Smoke::mf_enum, 53, 101},	//195 QsciCommand::Backtab (enum)
    {50, 116, 0, 0, Smoke::mf_static|Smoke::mf_enum, 53, 102},	//196 QsciCommand::Cancel (enum)
    {50, 728, 0, 0, Smoke::mf_static|Smoke::mf_enum, 53, 103},	//197 QsciCommand::Undo (enum)
    {50, 563, 0, 0, Smoke::mf_static|Smoke::mf_enum, 53, 104},	//198 QsciCommand::Redo (enum)
    {50, 784, 0, 0, Smoke::mf_static|Smoke::mf_enum, 53, 105},	//199 QsciCommand::ZoomIn (enum)
    {50, 785, 0, 0, Smoke::mf_static|Smoke::mf_enum, 53, 106},	//200 QsciCommand::ZoomOut (enum)
    {50, 1596, 0, 0, Smoke::mf_dtor, 0, 107 },	//201 QsciCommand::~QsciCommand()
    {51, 1155, 65, 2, 0, 189, 1},	//202 QsciCommandSet::readSettings(QSettings&, const char*)
    {51, 1584, 65, 2, 0, 189, 2},	//203 QsciCommandSet::writeSettings(QSettings&, const char*)
    {51, 875, 0, 0, 0, 19, 3},	//204 QsciCommandSet::commands()
    {51, 863, 0, 0, 0, 0, 4},	//205 QsciCommandSet::clearKeys()
    {51, 857, 0, 0, 0, 0, 5},	//206 QsciCommandSet::clearAlternateKeys()
    {51, 834, 18, 1, Smoke::mf_const, 52, 6},	//207 QsciCommandSet::boundTo(int) const
    {51, 941, 68, 1, Smoke::mf_const, 52, 7},	//208 QsciCommandSet::find(QsciCommand::Command) const
    {51, 1155, 70, 1, 0, 189, 8},	//209 QsciCommandSet::readSettings(QSettings&)
    {51, 1584, 70, 1, 0, 189, 9},	//210 QsciCommandSet::writeSettings(QSettings&)
    {52, 465, 0, 0, Smoke::mf_ctor, 57, 1},	//211 QsciDocument::QsciDocument()
    {52, 465, 72, 1, Smoke::mf_ctor|Smoke::mf_copyctor, 57, 2},	//212 QsciDocument::QsciDocument(const QsciDocument&)
    {52, 1121, 72, 1, 0, 56, 3},	//213 QsciDocument::operator=(const QsciDocument&)
    {52, 1597, 0, 0, Smoke::mf_dtor, 0, 4 },	//214 QsciDocument::~QsciDocument()
    {53, 1105, 0, 0, Smoke::mf_const|Smoke::mf_virtual, 200, 1},	//215 QsciLexer::metaObject() const
    {53, 1148, 12, 1, Smoke::mf_virtual, 221, 2},	//216 QsciLexer::qt_metacast(const char*)
    {53, 1546, 42, 2, Smoke::mf_static, 40, 3},	//217 QsciLexer::tr(const char*, const char*)
    {53, 1550, 42, 2, Smoke::mf_static, 40, 4},	//218 QsciLexer::trUtf8(const char*, const char*)
    {53, 1546, 45, 3, Smoke::mf_static, 40, 5},	//219 QsciLexer::tr(const char*, const char*, int)
    {53, 1550, 45, 3, Smoke::mf_static, 40, 6},	//220 QsciLexer::trUtf8(const char*, const char*, int)
    {53, 1146, 49, 3, Smoke::mf_virtual, 215, 7},	//221 QsciLexer::qt_metacall(QMetaObject::Call, int, void**)
    {53, 467, 74, 1, Smoke::mf_ctor, 58, 8},	//222 QsciLexer::QsciLexer(QObject*)
    {53, 1049, 0, 0, Smoke::mf_const|Smoke::mf_virtual|Smoke::mf_purevirtual, 213, 9},	//223 QsciLexer::language() const [pure virtual]
    {53, 1054, 0, 0, Smoke::mf_const|Smoke::mf_virtual, 213, 10},	//224 QsciLexer::lexer() const
    {53, 1055, 0, 0, Smoke::mf_const|Smoke::mf_virtual, 215, 11},	//225 QsciLexer::lexerId() const
    {53, 803, 0, 0, Smoke::mf_const, 51, 12},	//226 QsciLexer::apis() const
    {53, 812, 0, 0, Smoke::mf_const|Smoke::mf_virtual, 213, 13},	//227 QsciLexer::autoCompletionFillups() const
    {53, 821, 0, 0, Smoke::mf_const|Smoke::mf_virtual, 41, 14},	//228 QsciLexer::autoCompletionWordSeparators() const
    {53, 823, 0, 0, 0, 215, 15},	//229 QsciLexer::autoIndentStyle()
    {53, 827, 76, 1, Smoke::mf_const|Smoke::mf_virtual, 213, 16},	//230 QsciLexer::blockEnd(int*) const
    {53, 829, 0, 0, Smoke::mf_const|Smoke::mf_virtual, 215, 17},	//231 QsciLexer::blockLookback() const
    {53, 830, 76, 1, Smoke::mf_const|Smoke::mf_virtual, 213, 18},	//232 QsciLexer::blockStart(int*) const
    {53, 832, 76, 1, Smoke::mf_const|Smoke::mf_virtual, 213, 19},	//233 QsciLexer::blockStartKeyword(int*) const
    {53, 837, 0, 0, Smoke::mf_const|Smoke::mf_virtual, 215, 20},	//234 QsciLexer::braceStyle() const
    {53, 850, 0, 0, Smoke::mf_const|Smoke::mf_virtual, 189, 21},	//235 QsciLexer::caseSensitive() const
    {53, 868, 18, 1, Smoke::mf_const|Smoke::mf_virtual, 6, 22},	//236 QsciLexer::color(int) const
    {53, 927, 18, 1, Smoke::mf_const|Smoke::mf_virtual, 189, 23},	//237 QsciLexer::eolFill(int) const
    {53, 981, 18, 1, Smoke::mf_const|Smoke::mf_virtual, 14, 24},	//238 QsciLexer::font(int) const
    {53, 1008, 0, 0, Smoke::mf_const|Smoke::mf_virtual, 215, 25},	//239 QsciLexer::indentationGuideView() const
    {53, 1047, 18, 1, Smoke::mf_const|Smoke::mf_virtual, 213, 26},	//240 QsciLexer::keywords(int) const
    {53, 899, 0, 0, Smoke::mf_const|Smoke::mf_virtual, 215, 27},	//241 QsciLexer::defaultStyle() const
    {53, 900, 18, 1, Smoke::mf_const|Smoke::mf_virtual|Smoke::mf_purevirtual, 40, 28},	//242 QsciLexer::description(int) const [pure virtual]
    {53, 1128, 18, 1, Smoke::mf_const|Smoke::mf_virtual, 6, 29},	//243 QsciLexer::paper(int) const
    {53, 890, 0, 0, Smoke::mf_const, 6, 30},	//244 QsciLexer::defaultColor() const
    {53, 890, 18, 1, Smoke::mf_const|Smoke::mf_virtual, 6, 31},	//245 QsciLexer::defaultColor(int) const
    {53, 892, 18, 1, Smoke::mf_const|Smoke::mf_virtual, 189, 32},	//246 QsciLexer::defaultEolFill(int) const
    {53, 894, 0, 0, Smoke::mf_const, 14, 33},	//247 QsciLexer::defaultFont() const
    {53, 894, 18, 1, Smoke::mf_const|Smoke::mf_virtual, 14, 34},	//248 QsciLexer::defaultFont(int) const
    {53, 896, 0, 0, Smoke::mf_const, 6, 35},	//249 QsciLexer::defaultPaper() const
    {53, 896, 18, 1, Smoke::mf_const|Smoke::mf_virtual, 6, 36},	//250 QsciLexer::defaultPaper(int) const
    {53, 919, 0, 0, Smoke::mf_const, 92, 37},	//251 QsciLexer::editor() const
    {53, 1194, 78, 1, 0, 0, 38},	//252 QsciLexer::setAPIs(QsciAbstractAPIs*)
    {53, 1259, 80, 1, 0, 0, 39},	//253 QsciLexer::setDefaultColor(const QColor&)
    {53, 1261, 40, 1, 0, 0, 40},	//254 QsciLexer::setDefaultFont(const QFont&)
    {53, 1263, 80, 1, 0, 0, 41},	//255 QsciLexer::setDefaultPaper(const QColor&)
    {53, 1281, 82, 1, Smoke::mf_virtual, 0, 42},	//256 QsciLexer::setEditor(QsciScintilla*)
    {53, 1155, 65, 2, 0, 189, 43},	//257 QsciLexer::readSettings(QSettings&, const char*)
    {53, 1163, 0, 0, Smoke::mf_virtual, 0, 44},	//258 QsciLexer::refreshProperties()
    {53, 1526, 0, 0, Smoke::mf_const|Smoke::mf_virtual, 215, 45},	//259 QsciLexer::styleBitsNeeded() const
    {53, 1577, 0, 0, Smoke::mf_const|Smoke::mf_virtual, 213, 46},	//260 QsciLexer::wordCharacters() const
    {53, 1584, 65, 2, Smoke::mf_const, 189, 47},	//261 QsciLexer::writeSettings(QSettings&, const char*) const
    {53, 1220, 18, 1, Smoke::mf_virtual|Smoke::mf_slot, 0, 48},	//262 QsciLexer::setAutoIndentStyle(int)
    {53, 1252, 84, 2, Smoke::mf_virtual|Smoke::mf_slot, 0, 49},	//263 QsciLexer::setColor(const QColor&, int)
    {53, 1283, 87, 2, Smoke::mf_virtual|Smoke::mf_slot, 0, 50},	//264 QsciLexer::setEolFill(bool, int)
    {53, 1327, 90, 2, Smoke::mf_virtual|Smoke::mf_slot, 0, 51},	//265 QsciLexer::setFont(const QFont&, int)
    {53, 1436, 84, 2, Smoke::mf_virtual|Smoke::mf_slot, 0, 52},	//266 QsciLexer::setPaper(const QColor&, int)
    {53, 870, 84, 2, Smoke::mf_protected|Smoke::mf_signal, 0, 53},	//267 QsciLexer::colorChanged(const QColor&, int)
    {53, 929, 87, 2, Smoke::mf_protected|Smoke::mf_signal, 0, 54},	//268 QsciLexer::eolFillChanged(bool, int)
    {53, 984, 90, 2, Smoke::mf_protected|Smoke::mf_signal, 0, 55},	//269 QsciLexer::fontChanged(const QFont&, int)
    {53, 1130, 84, 2, Smoke::mf_protected|Smoke::mf_signal, 0, 56},	//270 QsciLexer::paperChanged(const QColor&, int)
    {53, 1144, 42, 2, Smoke::mf_protected|Smoke::mf_signal, 0, 57},	//271 QsciLexer::propertyChanged(const char*, const char*)
    {53, 1153, 93, 2, Smoke::mf_protected|Smoke::mf_virtual, 189, 58},	//272 QsciLexer::readProperties(QSettings&, const QString&)
    {53, 1582, 93, 2, Smoke::mf_const|Smoke::mf_protected|Smoke::mf_virtual, 189, 59},	//273 QsciLexer::writeProperties(QSettings&, const QString&) const
    {53, 1546, 12, 1, Smoke::mf_static, 40, 60},	//274 QsciLexer::tr(const char*)
    {53, 1550, 12, 1, Smoke::mf_static, 40, 61},	//275 QsciLexer::trUtf8(const char*)
    {53, 467, 0, 0, Smoke::mf_ctor, 58, 62},	//276 QsciLexer::QsciLexer()
    {53, 827, 0, 0, Smoke::mf_const, 213, 63},	//277 QsciLexer::blockEnd() const
    {53, 830, 0, 0, Smoke::mf_const, 213, 64},	//278 QsciLexer::blockStart() const
    {53, 832, 0, 0, Smoke::mf_const, 213, 65},	//279 QsciLexer::blockStartKeyword() const
    {53, 1155, 70, 1, 0, 189, 66},	//280 QsciLexer::readSettings(QSettings&)
    {53, 1584, 70, 1, Smoke::mf_const, 189, 67},	//281 QsciLexer::writeSettings(QSettings&) const
    {53, 1252, 80, 1, Smoke::mf_slot, 0, 68},	//282 QsciLexer::setColor(const QColor&)
    {53, 1283, 16, 1, Smoke::mf_slot, 0, 69},	//283 QsciLexer::setEolFill(bool)
    {53, 1327, 40, 1, Smoke::mf_slot, 0, 70},	//284 QsciLexer::setFont(const QFont&)
    {53, 1436, 80, 1, Smoke::mf_slot, 0, 71},	//285 QsciLexer::setPaper(const QColor&)
    {53, 1523, 0, 0, Smoke::mf_const|Smoke::mf_static|Smoke::mf_attribute, 199, 72},	//286 QsciLexer::staticMetaObject() const
    {53, 1598, 0, 0, Smoke::mf_dtor, 0, 73 },	//287 QsciLexer::~QsciLexer()
    {54, 1105, 0, 0, Smoke::mf_const|Smoke::mf_virtual, 200, 1},	//288 QsciLexerBash::metaObject() const
    {54, 1148, 12, 1, Smoke::mf_virtual, 221, 2},	//289 QsciLexerBash::qt_metacast(const char*)
    {54, 1546, 42, 2, Smoke::mf_static, 40, 3},	//290 QsciLexerBash::tr(const char*, const char*)
    {54, 1550, 42, 2, Smoke::mf_static, 40, 4},	//291 QsciLexerBash::trUtf8(const char*, const char*)
    {54, 1546, 45, 3, Smoke::mf_static, 40, 5},	//292 QsciLexerBash::tr(const char*, const char*, int)
    {54, 1550, 45, 3, Smoke::mf_static, 40, 6},	//293 QsciLexerBash::trUtf8(const char*, const char*, int)
    {54, 1146, 49, 3, Smoke::mf_virtual, 215, 7},	//294 QsciLexerBash::qt_metacall(QMetaObject::Call, int, void**)
    {54, 469, 74, 1, Smoke::mf_ctor, 59, 8},	//295 QsciLexerBash::QsciLexerBash(QObject*)
    {54, 1049, 0, 0, Smoke::mf_const|Smoke::mf_virtual, 213, 9},	//296 QsciLexerBash::language() const
    {54, 1054, 0, 0, Smoke::mf_const|Smoke::mf_virtual, 213, 10},	//297 QsciLexerBash::lexer() const
    {54, 837, 0, 0, Smoke::mf_const|Smoke::mf_virtual, 215, 11},	//298 QsciLexerBash::braceStyle() const
    {54, 1577, 0, 0, Smoke::mf_const|Smoke::mf_virtual, 213, 12},	//299 QsciLexerBash::wordCharacters() const
    {54, 890, 18, 1, Smoke::mf_const|Smoke::mf_virtual, 6, 13},	//300 QsciLexerBash::defaultColor(int) const
    {54, 892, 18, 1, Smoke::mf_const|Smoke::mf_virtual, 189, 14},	//301 QsciLexerBash::defaultEolFill(int) const
    {54, 894, 18, 1, Smoke::mf_const|Smoke::mf_virtual, 14, 15},	//302 QsciLexerBash::defaultFont(int) const
    {54, 896, 18, 1, Smoke::mf_const|Smoke::mf_virtual, 6, 16},	//303 QsciLexerBash::defaultPaper(int) const
    {54, 1047, 18, 1, Smoke::mf_const|Smoke::mf_virtual, 213, 17},	//304 QsciLexerBash::keywords(int) const
    {54, 900, 18, 1, Smoke::mf_const|Smoke::mf_virtual, 40, 18},	//305 QsciLexerBash::description(int) const
    {54, 1163, 0, 0, Smoke::mf_virtual, 0, 19},	//306 QsciLexerBash::refreshProperties()
    {54, 968, 0, 0, Smoke::mf_const, 189, 20},	//307 QsciLexerBash::foldComments() const
    {54, 969, 0, 0, Smoke::mf_const, 189, 21},	//308 QsciLexerBash::foldCompact() const
    {54, 1302, 16, 1, Smoke::mf_virtual|Smoke::mf_slot, 0, 22},	//309 QsciLexerBash::setFoldComments(bool)
    {54, 1304, 16, 1, Smoke::mf_virtual|Smoke::mf_slot, 0, 23},	//310 QsciLexerBash::setFoldCompact(bool)
    {54, 1153, 93, 2, Smoke::mf_protected|Smoke::mf_virtual, 189, 24},	//311 QsciLexerBash::readProperties(QSettings&, const QString&)
    {54, 1582, 93, 2, Smoke::mf_const|Smoke::mf_protected|Smoke::mf_virtual, 189, 25},	//312 QsciLexerBash::writeProperties(QSettings&, const QString&) const
    {54, 1546, 12, 1, Smoke::mf_static, 40, 26},	//313 QsciLexerBash::tr(const char*)
    {54, 1550, 12, 1, Smoke::mf_static, 40, 27},	//314 QsciLexerBash::trUtf8(const char*)
    {54, 469, 0, 0, Smoke::mf_ctor, 59, 28},	//315 QsciLexerBash::QsciLexerBash()
    {54, 1523, 0, 0, Smoke::mf_const|Smoke::mf_static|Smoke::mf_attribute, 199, 29},	//316 QsciLexerBash::staticMetaObject() const
    {54, 160, 0, 0, Smoke::mf_static|Smoke::mf_enum, 218, 30},	//317 QsciLexerBash::Default (enum)
    {54, 205, 0, 0, Smoke::mf_static|Smoke::mf_enum, 218, 31},	//318 QsciLexerBash::Error (enum)
    {54, 139, 0, 0, Smoke::mf_static|Smoke::mf_enum, 218, 32},	//319 QsciLexerBash::Comment (enum)
    {54, 378, 0, 0, Smoke::mf_static|Smoke::mf_enum, 218, 33},	//320 QsciLexerBash::Number (enum)
    {54, 307, 0, 0, Smoke::mf_static|Smoke::mf_enum, 218, 34},	//321 QsciLexerBash::Keyword (enum)
    {54, 186, 0, 0, Smoke::mf_static|Smoke::mf_enum, 218, 35},	//322 QsciLexerBash::DoubleQuotedString (enum)
    {54, 658, 0, 0, Smoke::mf_static|Smoke::mf_enum, 218, 36},	//323 QsciLexerBash::SingleQuotedString (enum)
    {54, 382, 0, 0, Smoke::mf_static|Smoke::mf_enum, 218, 37},	//324 QsciLexerBash::Operator (enum)
    {54, 255, 0, 0, Smoke::mf_static|Smoke::mf_enum, 218, 38},	//325 QsciLexerBash::Identifier (enum)
    {54, 632, 0, 0, Smoke::mf_static|Smoke::mf_enum, 218, 39},	//326 QsciLexerBash::Scalar (enum)
    {54, 410, 0, 0, Smoke::mf_static|Smoke::mf_enum, 218, 40},	//327 QsciLexerBash::ParameterExpansion (enum)
    {54, 85, 0, 0, Smoke::mf_static|Smoke::mf_enum, 218, 41},	//328 QsciLexerBash::Backticks (enum)
    {54, 239, 0, 0, Smoke::mf_static|Smoke::mf_enum, 218, 42},	//329 QsciLexerBash::HereDocumentDelimiter (enum)
    {54, 657, 0, 0, Smoke::mf_static|Smoke::mf_enum, 218, 43},	//330 QsciLexerBash::SingleQuotedHereDocument (enum)
    {54, 1599, 0, 0, Smoke::mf_dtor, 0, 44 },	//331 QsciLexerBash::~QsciLexerBash()
    {55, 1105, 0, 0, Smoke::mf_const|Smoke::mf_virtual, 200, 1},	//332 QsciLexerBatch::metaObject() const
    {55, 1148, 12, 1, Smoke::mf_virtual, 221, 2},	//333 QsciLexerBatch::qt_metacast(const char*)
    {55, 1546, 42, 2, Smoke::mf_static, 40, 3},	//334 QsciLexerBatch::tr(const char*, const char*)
    {55, 1550, 42, 2, Smoke::mf_static, 40, 4},	//335 QsciLexerBatch::trUtf8(const char*, const char*)
    {55, 1546, 45, 3, Smoke::mf_static, 40, 5},	//336 QsciLexerBatch::tr(const char*, const char*, int)
    {55, 1550, 45, 3, Smoke::mf_static, 40, 6},	//337 QsciLexerBatch::trUtf8(const char*, const char*, int)
    {55, 1146, 49, 3, Smoke::mf_virtual, 215, 7},	//338 QsciLexerBatch::qt_metacall(QMetaObject::Call, int, void**)
    {55, 471, 74, 1, Smoke::mf_ctor, 60, 8},	//339 QsciLexerBatch::QsciLexerBatch(QObject*)
    {55, 1049, 0, 0, Smoke::mf_const|Smoke::mf_virtual, 213, 9},	//340 QsciLexerBatch::language() const
    {55, 1054, 0, 0, Smoke::mf_const|Smoke::mf_virtual, 213, 10},	//341 QsciLexerBatch::lexer() const
    {55, 1577, 0, 0, Smoke::mf_const|Smoke::mf_virtual, 213, 11},	//342 QsciLexerBatch::wordCharacters() const
    {55, 850, 0, 0, Smoke::mf_const|Smoke::mf_virtual, 189, 12},	//343 QsciLexerBatch::caseSensitive() const
    {55, 890, 18, 1, Smoke::mf_const|Smoke::mf_virtual, 6, 13},	//344 QsciLexerBatch::defaultColor(int) const
    {55, 892, 18, 1, Smoke::mf_const|Smoke::mf_virtual, 189, 14},	//345 QsciLexerBatch::defaultEolFill(int) const
    {55, 894, 18, 1, Smoke::mf_const|Smoke::mf_virtual, 14, 15},	//346 QsciLexerBatch::defaultFont(int) const
    {55, 896, 18, 1, Smoke::mf_const|Smoke::mf_virtual, 6, 16},	//347 QsciLexerBatch::defaultPaper(int) const
    {55, 1047, 18, 1, Smoke::mf_const|Smoke::mf_virtual, 213, 17},	//348 QsciLexerBatch::keywords(int) const
    {55, 900, 18, 1, Smoke::mf_const|Smoke::mf_virtual, 40, 18},	//349 QsciLexerBatch::description(int) const
    {55, 1546, 12, 1, Smoke::mf_static, 40, 19},	//350 QsciLexerBatch::tr(const char*)
    {55, 1550, 12, 1, Smoke::mf_static, 40, 20},	//351 QsciLexerBatch::trUtf8(const char*)
    {55, 471, 0, 0, Smoke::mf_ctor, 60, 21},	//352 QsciLexerBatch::QsciLexerBatch()
    {55, 1523, 0, 0, Smoke::mf_const|Smoke::mf_static|Smoke::mf_attribute, 199, 22},	//353 QsciLexerBatch::staticMetaObject() const
    {55, 160, 0, 0, Smoke::mf_static|Smoke::mf_enum, 218, 23},	//354 QsciLexerBatch::Default (enum)
    {55, 139, 0, 0, Smoke::mf_static|Smoke::mf_enum, 218, 24},	//355 QsciLexerBatch::Comment (enum)
    {55, 307, 0, 0, Smoke::mf_static|Smoke::mf_enum, 218, 25},	//356 QsciLexerBatch::Keyword (enum)
    {55, 317, 0, 0, Smoke::mf_static|Smoke::mf_enum, 218, 26},	//357 QsciLexerBatch::Label (enum)
    {55, 243, 0, 0, Smoke::mf_static|Smoke::mf_enum, 218, 27},	//358 QsciLexerBatch::HideCommandChar (enum)
    {55, 213, 0, 0, Smoke::mf_static|Smoke::mf_enum, 218, 28},	//359 QsciLexerBatch::ExternalCommand (enum)
    {55, 750, 0, 0, Smoke::mf_static|Smoke::mf_enum, 218, 29},	//360 QsciLexerBatch::Variable (enum)
    {55, 382, 0, 0, Smoke::mf_static|Smoke::mf_enum, 218, 30},	//361 QsciLexerBatch::Operator (enum)
    {55, 1600, 0, 0, Smoke::mf_dtor, 0, 31 },	//362 QsciLexerBatch::~QsciLexerBatch()
    {56, 1105, 0, 0, Smoke::mf_const|Smoke::mf_virtual, 200, 1},	//363 QsciLexerCMake::metaObject() const
    {56, 1148, 12, 1, Smoke::mf_virtual, 221, 2},	//364 QsciLexerCMake::qt_metacast(const char*)
    {56, 1546, 42, 2, Smoke::mf_static, 40, 3},	//365 QsciLexerCMake::tr(const char*, const char*)
    {56, 1550, 42, 2, Smoke::mf_static, 40, 4},	//366 QsciLexerCMake::trUtf8(const char*, const char*)
    {56, 1546, 45, 3, Smoke::mf_static, 40, 5},	//367 QsciLexerCMake::tr(const char*, const char*, int)
    {56, 1550, 45, 3, Smoke::mf_static, 40, 6},	//368 QsciLexerCMake::trUtf8(const char*, const char*, int)
    {56, 1146, 49, 3, Smoke::mf_virtual, 215, 7},	//369 QsciLexerCMake::qt_metacall(QMetaObject::Call, int, void**)
    {56, 473, 74, 1, Smoke::mf_ctor, 61, 8},	//370 QsciLexerCMake::QsciLexerCMake(QObject*)
    {56, 1049, 0, 0, Smoke::mf_const|Smoke::mf_virtual, 213, 9},	//371 QsciLexerCMake::language() const
    {56, 1054, 0, 0, Smoke::mf_const|Smoke::mf_virtual, 213, 10},	//372 QsciLexerCMake::lexer() const
    {56, 890, 18, 1, Smoke::mf_const|Smoke::mf_virtual, 6, 11},	//373 QsciLexerCMake::defaultColor(int) const
    {56, 894, 18, 1, Smoke::mf_const|Smoke::mf_virtual, 14, 12},	//374 QsciLexerCMake::defaultFont(int) const
    {56, 896, 18, 1, Smoke::mf_const|Smoke::mf_virtual, 6, 13},	//375 QsciLexerCMake::defaultPaper(int) const
    {56, 1047, 18, 1, Smoke::mf_const|Smoke::mf_virtual, 213, 14},	//376 QsciLexerCMake::keywords(int) const
    {56, 900, 18, 1, Smoke::mf_const|Smoke::mf_virtual, 40, 15},	//377 QsciLexerCMake::description(int) const
    {56, 1163, 0, 0, Smoke::mf_virtual, 0, 16},	//378 QsciLexerCMake::refreshProperties()
    {56, 966, 0, 0, Smoke::mf_const, 189, 17},	//379 QsciLexerCMake::foldAtElse() const
    {56, 1298, 16, 1, Smoke::mf_virtual|Smoke::mf_slot, 0, 18},	//380 QsciLexerCMake::setFoldAtElse(bool)
    {56, 1153, 93, 2, Smoke::mf_protected|Smoke::mf_virtual, 189, 19},	//381 QsciLexerCMake::readProperties(QSettings&, const QString&)
    {56, 1582, 93, 2, Smoke::mf_const|Smoke::mf_protected|Smoke::mf_virtual, 189, 20},	//382 QsciLexerCMake::writeProperties(QSettings&, const QString&) const
    {56, 1546, 12, 1, Smoke::mf_static, 40, 21},	//383 QsciLexerCMake::tr(const char*)
    {56, 1550, 12, 1, Smoke::mf_static, 40, 22},	//384 QsciLexerCMake::trUtf8(const char*)
    {56, 473, 0, 0, Smoke::mf_ctor, 61, 23},	//385 QsciLexerCMake::QsciLexerCMake()
    {56, 1523, 0, 0, Smoke::mf_const|Smoke::mf_static|Smoke::mf_attribute, 199, 24},	//386 QsciLexerCMake::staticMetaObject() const
    {56, 160, 0, 0, Smoke::mf_static|Smoke::mf_enum, 218, 25},	//387 QsciLexerCMake::Default (enum)
    {56, 139, 0, 0, Smoke::mf_static|Smoke::mf_enum, 218, 26},	//388 QsciLexerCMake::Comment (enum)
    {56, 677, 0, 0, Smoke::mf_static|Smoke::mf_enum, 218, 27},	//389 QsciLexerCMake::String (enum)
    {56, 678, 0, 0, Smoke::mf_static|Smoke::mf_enum, 218, 28},	//390 QsciLexerCMake::StringLeftQuote (enum)
    {56, 679, 0, 0, Smoke::mf_static|Smoke::mf_enum, 218, 29},	//391 QsciLexerCMake::StringRightQuote (enum)
    {56, 222, 0, 0, Smoke::mf_static|Smoke::mf_enum, 218, 30},	//392 QsciLexerCMake::Function (enum)
    {56, 750, 0, 0, Smoke::mf_static|Smoke::mf_enum, 218, 31},	//393 QsciLexerCMake::Variable (enum)
    {56, 317, 0, 0, Smoke::mf_static|Smoke::mf_enum, 218, 32},	//394 QsciLexerCMake::Label (enum)
    {56, 311, 0, 0, Smoke::mf_static|Smoke::mf_enum, 218, 33},	//395 QsciLexerCMake::KeywordSet3 (enum)
    {56, 94, 0, 0, Smoke::mf_static|Smoke::mf_enum, 218, 34},	//396 QsciLexerCMake::BlockWhile (enum)
    {56, 91, 0, 0, Smoke::mf_static|Smoke::mf_enum, 218, 35},	//397 QsciLexerCMake::BlockForeach (enum)
    {56, 92, 0, 0, Smoke::mf_static|Smoke::mf_enum, 218, 36},	//398 QsciLexerCMake::BlockIf (enum)
    {56, 93, 0, 0, Smoke::mf_static|Smoke::mf_enum, 218, 37},	//399 QsciLexerCMake::BlockMacro (enum)
    {56, 681, 0, 0, Smoke::mf_static|Smoke::mf_enum, 218, 38},	//400 QsciLexerCMake::StringVariable (enum)
    {56, 378, 0, 0, Smoke::mf_static|Smoke::mf_enum, 218, 39},	//401 QsciLexerCMake::Number (enum)
    {56, 1601, 0, 0, Smoke::mf_dtor, 0, 40 },	//402 QsciLexerCMake::~QsciLexerCMake()
    {57, 1105, 0, 0, Smoke::mf_const|Smoke::mf_virtual, 200, 1},	//403 QsciLexerCPP::metaObject() const
    {57, 1148, 12, 1, Smoke::mf_virtual, 221, 2},	//404 QsciLexerCPP::qt_metacast(const char*)
    {57, 1546, 42, 2, Smoke::mf_static, 40, 3},	//405 QsciLexerCPP::tr(const char*, const char*)
    {57, 1550, 42, 2, Smoke::mf_static, 40, 4},	//406 QsciLexerCPP::trUtf8(const char*, const char*)
    {57, 1546, 45, 3, Smoke::mf_static, 40, 5},	//407 QsciLexerCPP::tr(const char*, const char*, int)
    {57, 1550, 45, 3, Smoke::mf_static, 40, 6},	//408 QsciLexerCPP::trUtf8(const char*, const char*, int)
    {57, 1146, 49, 3, Smoke::mf_virtual, 215, 7},	//409 QsciLexerCPP::qt_metacall(QMetaObject::Call, int, void**)
    {57, 475, 96, 2, Smoke::mf_ctor, 62, 8},	//410 QsciLexerCPP::QsciLexerCPP(QObject*, bool)
    {57, 1049, 0, 0, Smoke::mf_const|Smoke::mf_virtual, 213, 9},	//411 QsciLexerCPP::language() const
    {57, 1054, 0, 0, Smoke::mf_const|Smoke::mf_virtual, 213, 10},	//412 QsciLexerCPP::lexer() const
    {57, 821, 0, 0, Smoke::mf_const|Smoke::mf_virtual, 41, 11},	//413 QsciLexerCPP::autoCompletionWordSeparators() const
    {57, 827, 76, 1, Smoke::mf_const|Smoke::mf_virtual, 213, 12},	//414 QsciLexerCPP::blockEnd(int*) const
    {57, 830, 76, 1, Smoke::mf_const|Smoke::mf_virtual, 213, 13},	//415 QsciLexerCPP::blockStart(int*) const
    {57, 832, 76, 1, Smoke::mf_const|Smoke::mf_virtual, 213, 14},	//416 QsciLexerCPP::blockStartKeyword(int*) const
    {57, 837, 0, 0, Smoke::mf_const|Smoke::mf_virtual, 215, 15},	//417 QsciLexerCPP::braceStyle() const
    {57, 1577, 0, 0, Smoke::mf_const|Smoke::mf_virtual, 213, 16},	//418 QsciLexerCPP::wordCharacters() const
    {57, 890, 18, 1, Smoke::mf_const|Smoke::mf_virtual, 6, 17},	//419 QsciLexerCPP::defaultColor(int) const
    {57, 892, 18, 1, Smoke::mf_const|Smoke::mf_virtual, 189, 18},	//420 QsciLexerCPP::defaultEolFill(int) const
    {57, 894, 18, 1, Smoke::mf_const|Smoke::mf_virtual, 14, 19},	//421 QsciLexerCPP::defaultFont(int) const
    {57, 896, 18, 1, Smoke::mf_const|Smoke::mf_virtual, 6, 20},	//422 QsciLexerCPP::defaultPaper(int) const
    {57, 1047, 18, 1, Smoke::mf_const|Smoke::mf_virtual, 213, 21},	//423 QsciLexerCPP::keywords(int) const
    {57, 900, 18, 1, Smoke::mf_const|Smoke::mf_virtual, 40, 22},	//424 QsciLexerCPP::description(int) const
    {57, 1163, 0, 0, Smoke::mf_virtual, 0, 23},	//425 QsciLexerCPP::refreshProperties()
    {57, 966, 0, 0, Smoke::mf_const, 189, 24},	//426 QsciLexerCPP::foldAtElse() const
    {57, 968, 0, 0, Smoke::mf_const, 189, 25},	//427 QsciLexerCPP::foldComments() const
    {57, 969, 0, 0, Smoke::mf_const, 189, 26},	//428 QsciLexerCPP::foldCompact() const
    {57, 976, 0, 0, Smoke::mf_const, 189, 27},	//429 QsciLexerCPP::foldPreprocessor() const
    {57, 1528, 0, 0, Smoke::mf_const, 189, 28},	//430 QsciLexerCPP::stylePreprocessor() const
    {57, 1271, 16, 1, 0, 0, 29},	//431 QsciLexerCPP::setDollarsAllowed(bool)
    {57, 906, 0, 0, Smoke::mf_const, 189, 30},	//432 QsciLexerCPP::dollarsAllowed() const
    {57, 1342, 16, 1, 0, 0, 31},	//433 QsciLexerCPP::setHighlightTripleQuotedStrings(bool)
    {57, 1002, 0, 0, Smoke::mf_const, 189, 32},	//434 QsciLexerCPP::highlightTripleQuotedStrings() const
    {57, 1338, 16, 1, 0, 0, 33},	//435 QsciLexerCPP::setHighlightHashQuotedStrings(bool)
    {57, 1000, 0, 0, Smoke::mf_const, 189, 34},	//436 QsciLexerCPP::highlightHashQuotedStrings() const
    {57, 1334, 16, 1, 0, 0, 35},	//437 QsciLexerCPP::setHighlightBackQuotedStrings(bool)
    {57, 998, 0, 0, Smoke::mf_const, 189, 36},	//438 QsciLexerCPP::highlightBackQuotedStrings() const
    {57, 1336, 16, 1, 0, 0, 37},	//439 QsciLexerCPP::setHighlightEscapeSequences(bool)
    {57, 999, 0, 0, Smoke::mf_const, 189, 38},	//440 QsciLexerCPP::highlightEscapeSequences() const
    {57, 1493, 16, 1, 0, 0, 39},	//441 QsciLexerCPP::setVerbatimStringEscapeSequencesAllowed(bool)
    {57, 1566, 0, 0, Smoke::mf_const, 189, 40},	//442 QsciLexerCPP::verbatimStringEscapeSequencesAllowed() const
    {57, 1298, 16, 1, Smoke::mf_virtual|Smoke::mf_slot, 0, 41},	//443 QsciLexerCPP::setFoldAtElse(bool)
    {57, 1302, 16, 1, Smoke::mf_virtual|Smoke::mf_slot, 0, 42},	//444 QsciLexerCPP::setFoldComments(bool)
    {57, 1304, 16, 1, Smoke::mf_virtual|Smoke::mf_slot, 0, 43},	//445 QsciLexerCPP::setFoldCompact(bool)
    {57, 1316, 16, 1, Smoke::mf_virtual|Smoke::mf_slot, 0, 44},	//446 QsciLexerCPP::setFoldPreprocessor(bool)
    {57, 1464, 16, 1, Smoke::mf_virtual|Smoke::mf_slot, 0, 45},	//447 QsciLexerCPP::setStylePreprocessor(bool)
    {57, 1153, 93, 2, Smoke::mf_protected|Smoke::mf_virtual, 189, 46},	//448 QsciLexerCPP::readProperties(QSettings&, const QString&)
    {57, 1582, 93, 2, Smoke::mf_const|Smoke::mf_protected|Smoke::mf_virtual, 189, 47},	//449 QsciLexerCPP::writeProperties(QSettings&, const QString&) const
    {57, 1546, 12, 1, Smoke::mf_static, 40, 48},	//450 QsciLexerCPP::tr(const char*)
    {57, 1550, 12, 1, Smoke::mf_static, 40, 49},	//451 QsciLexerCPP::trUtf8(const char*)
    {57, 475, 0, 0, Smoke::mf_ctor, 62, 50},	//452 QsciLexerCPP::QsciLexerCPP()
    {57, 475, 74, 1, Smoke::mf_ctor, 62, 51},	//453 QsciLexerCPP::QsciLexerCPP(QObject*)
    {57, 827, 0, 0, Smoke::mf_const, 213, 52},	//454 QsciLexerCPP::blockEnd() const
    {57, 830, 0, 0, Smoke::mf_const, 213, 53},	//455 QsciLexerCPP::blockStart() const
    {57, 832, 0, 0, Smoke::mf_const, 213, 54},	//456 QsciLexerCPP::blockStartKeyword() const
    {57, 1523, 0, 0, Smoke::mf_const|Smoke::mf_static|Smoke::mf_attribute, 199, 55},	//457 QsciLexerCPP::staticMetaObject() const
    {57, 160, 0, 0, Smoke::mf_static|Smoke::mf_enum, 218, 56},	//458 QsciLexerCPP::Default (enum)
    {57, 266, 0, 0, Smoke::mf_static|Smoke::mf_enum, 218, 57},	//459 QsciLexerCPP::InactiveDefault (enum)
    {57, 139, 0, 0, Smoke::mf_static|Smoke::mf_enum, 218, 58},	//460 QsciLexerCPP::Comment (enum)
    {57, 260, 0, 0, Smoke::mf_static|Smoke::mf_enum, 218, 59},	//461 QsciLexerCPP::InactiveComment (enum)
    {57, 145, 0, 0, Smoke::mf_static|Smoke::mf_enum, 218, 60},	//462 QsciLexerCPP::CommentLine (enum)
    {57, 264, 0, 0, Smoke::mf_static|Smoke::mf_enum, 218, 61},	//463 QsciLexerCPP::InactiveCommentLine (enum)
    {57, 142, 0, 0, Smoke::mf_static|Smoke::mf_enum, 218, 62},	//464 QsciLexerCPP::CommentDoc (enum)
    {57, 261, 0, 0, Smoke::mf_static|Smoke::mf_enum, 218, 63},	//465 QsciLexerCPP::InactiveCommentDoc (enum)
    {57, 378, 0, 0, Smoke::mf_static|Smoke::mf_enum, 218, 64},	//466 QsciLexerCPP::Number (enum)
    {57, 274, 0, 0, Smoke::mf_static|Smoke::mf_enum, 218, 65},	//467 QsciLexerCPP::InactiveNumber (enum)
    {57, 307, 0, 0, Smoke::mf_static|Smoke::mf_enum, 218, 66},	//468 QsciLexerCPP::Keyword (enum)
    {57, 272, 0, 0, Smoke::mf_static|Smoke::mf_enum, 218, 67},	//469 QsciLexerCPP::InactiveKeyword (enum)
    {57, 186, 0, 0, Smoke::mf_static|Smoke::mf_enum, 218, 68},	//470 QsciLexerCPP::DoubleQuotedString (enum)
    {57, 267, 0, 0, Smoke::mf_static|Smoke::mf_enum, 218, 69},	//471 QsciLexerCPP::InactiveDoubleQuotedString (enum)
    {57, 658, 0, 0, Smoke::mf_static|Smoke::mf_enum, 218, 70},	//472 QsciLexerCPP::SingleQuotedString (enum)
    {57, 281, 0, 0, Smoke::mf_static|Smoke::mf_enum, 218, 71},	//473 QsciLexerCPP::InactiveSingleQuotedString (enum)
    {57, 725, 0, 0, Smoke::mf_static|Smoke::mf_enum, 218, 72},	//474 QsciLexerCPP::UUID (enum)
    {57, 284, 0, 0, Smoke::mf_static|Smoke::mf_enum, 218, 73},	//475 QsciLexerCPP::InactiveUUID (enum)
    {57, 430, 0, 0, Smoke::mf_static|Smoke::mf_enum, 218, 74},	//476 QsciLexerCPP::PreProcessor (enum)
    {57, 276, 0, 0, Smoke::mf_static|Smoke::mf_enum, 218, 75},	//477 QsciLexerCPP::InactivePreProcessor (enum)
    {57, 382, 0, 0, Smoke::mf_static|Smoke::mf_enum, 218, 76},	//478 QsciLexerCPP::Operator (enum)
    {57, 275, 0, 0, Smoke::mf_static|Smoke::mf_enum, 218, 77},	//479 QsciLexerCPP::InactiveOperator (enum)
    {57, 255, 0, 0, Smoke::mf_static|Smoke::mf_enum, 218, 78},	//480 QsciLexerCPP::Identifier (enum)
    {57, 271, 0, 0, Smoke::mf_static|Smoke::mf_enum, 218, 79},	//481 QsciLexerCPP::InactiveIdentifier (enum)
    {57, 726, 0, 0, Smoke::mf_static|Smoke::mf_enum, 218, 80},	//482 QsciLexerCPP::UnclosedString (enum)
    {57, 285, 0, 0, Smoke::mf_static|Smoke::mf_enum, 218, 81},	//483 QsciLexerCPP::InactiveUnclosedString (enum)
    {57, 751, 0, 0, Smoke::mf_static|Smoke::mf_enum, 218, 82},	//484 QsciLexerCPP::VerbatimString (enum)
    {57, 287, 0, 0, Smoke::mf_static|Smoke::mf_enum, 218, 83},	//485 QsciLexerCPP::InactiveVerbatimString (enum)
    {57, 565, 0, 0, Smoke::mf_static|Smoke::mf_enum, 218, 84},	//486 QsciLexerCPP::Regex (enum)
    {57, 280, 0, 0, Smoke::mf_static|Smoke::mf_enum, 218, 85},	//487 QsciLexerCPP::InactiveRegex (enum)
    {57, 146, 0, 0, Smoke::mf_static|Smoke::mf_enum, 218, 86},	//488 QsciLexerCPP::CommentLineDoc (enum)
    {57, 265, 0, 0, Smoke::mf_static|Smoke::mf_enum, 218, 87},	//489 QsciLexerCPP::InactiveCommentLineDoc (enum)
    {57, 310, 0, 0, Smoke::mf_static|Smoke::mf_enum, 218, 88},	//490 QsciLexerCPP::KeywordSet2 (enum)
    {57, 273, 0, 0, Smoke::mf_static|Smoke::mf_enum, 218, 89},	//491 QsciLexerCPP::InactiveKeywordSet2 (enum)
    {57, 143, 0, 0, Smoke::mf_static|Smoke::mf_enum, 218, 90},	//492 QsciLexerCPP::CommentDocKeyword (enum)
    {57, 262, 0, 0, Smoke::mf_static|Smoke::mf_enum, 218, 91},	//493 QsciLexerCPP::InactiveCommentDocKeyword (enum)
    {57, 144, 0, 0, Smoke::mf_static|Smoke::mf_enum, 218, 92},	//494 QsciLexerCPP::CommentDocKeywordError (enum)
    {57, 263, 0, 0, Smoke::mf_static|Smoke::mf_enum, 218, 93},	//495 QsciLexerCPP::InactiveCommentDocKeywordError (enum)
    {57, 225, 0, 0, Smoke::mf_static|Smoke::mf_enum, 218, 94},	//496 QsciLexerCPP::GlobalClass (enum)
    {57, 269, 0, 0, Smoke::mf_static|Smoke::mf_enum, 218, 95},	//497 QsciLexerCPP::InactiveGlobalClass (enum)
    {57, 561, 0, 0, Smoke::mf_static|Smoke::mf_enum, 218, 96},	//498 QsciLexerCPP::RawString (enum)
    {57, 279, 0, 0, Smoke::mf_static|Smoke::mf_enum, 218, 97},	//499 QsciLexerCPP::InactiveRawString (enum)
    {57, 721, 0, 0, Smoke::mf_static|Smoke::mf_enum, 218, 98},	//500 QsciLexerCPP::TripleQuotedVerbatimString (enum)
    {57, 283, 0, 0, Smoke::mf_static|Smoke::mf_enum, 218, 99},	//501 QsciLexerCPP::InactiveTripleQuotedVerbatimString (enum)
    {57, 236, 0, 0, Smoke::mf_static|Smoke::mf_enum, 218, 100},	//502 QsciLexerCPP::HashQuotedString (enum)
    {57, 270, 0, 0, Smoke::mf_static|Smoke::mf_enum, 218, 101},	//503 QsciLexerCPP::InactiveHashQuotedString (enum)
    {57, 431, 0, 0, Smoke::mf_static|Smoke::mf_enum, 218, 102},	//504 QsciLexerCPP::PreProcessorComment (enum)
    {57, 277, 0, 0, Smoke::mf_static|Smoke::mf_enum, 218, 103},	//505 QsciLexerCPP::InactivePreProcessorComment (enum)
    {57, 432, 0, 0, Smoke::mf_static|Smoke::mf_enum, 218, 104},	//506 QsciLexerCPP::PreProcessorCommentLineDoc (enum)
    {57, 278, 0, 0, Smoke::mf_static|Smoke::mf_enum, 218, 105},	//507 QsciLexerCPP::InactivePreProcessorCommentLineDoc (enum)
    {57, 734, 0, 0, Smoke::mf_static|Smoke::mf_enum, 218, 106},	//508 QsciLexerCPP::UserLiteral (enum)
    {57, 286, 0, 0, Smoke::mf_static|Smoke::mf_enum, 218, 107},	//509 QsciLexerCPP::InactiveUserLiteral (enum)
    {57, 706, 0, 0, Smoke::mf_static|Smoke::mf_enum, 218, 108},	//510 QsciLexerCPP::TaskMarker (enum)
    {57, 282, 0, 0, Smoke::mf_static|Smoke::mf_enum, 218, 109},	//511 QsciLexerCPP::InactiveTaskMarker (enum)
    {57, 206, 0, 0, Smoke::mf_static|Smoke::mf_enum, 218, 110},	//512 QsciLexerCPP::EscapeSequence (enum)
    {57, 268, 0, 0, Smoke::mf_static|Smoke::mf_enum, 218, 111},	//513 QsciLexerCPP::InactiveEscapeSequence (enum)
    {57, 1602, 0, 0, Smoke::mf_dtor, 0, 112 },	//514 QsciLexerCPP::~QsciLexerCPP()
    {58, 1105, 0, 0, Smoke::mf_const|Smoke::mf_virtual, 200, 1},	//515 QsciLexerCSS::metaObject() const
    {58, 1148, 12, 1, Smoke::mf_virtual, 221, 2},	//516 QsciLexerCSS::qt_metacast(const char*)
    {58, 1546, 42, 2, Smoke::mf_static, 40, 3},	//517 QsciLexerCSS::tr(const char*, const char*)
    {58, 1550, 42, 2, Smoke::mf_static, 40, 4},	//518 QsciLexerCSS::trUtf8(const char*, const char*)
    {58, 1546, 45, 3, Smoke::mf_static, 40, 5},	//519 QsciLexerCSS::tr(const char*, const char*, int)
    {58, 1550, 45, 3, Smoke::mf_static, 40, 6},	//520 QsciLexerCSS::trUtf8(const char*, const char*, int)
    {58, 1146, 49, 3, Smoke::mf_virtual, 215, 7},	//521 QsciLexerCSS::qt_metacall(QMetaObject::Call, int, void**)
    {58, 478, 74, 1, Smoke::mf_ctor, 63, 8},	//522 QsciLexerCSS::QsciLexerCSS(QObject*)
    {58, 1049, 0, 0, Smoke::mf_const|Smoke::mf_virtual, 213, 9},	//523 QsciLexerCSS::language() const
    {58, 1054, 0, 0, Smoke::mf_const|Smoke::mf_virtual, 213, 10},	//524 QsciLexerCSS::lexer() const
    {58, 827, 76, 1, Smoke::mf_const|Smoke::mf_virtual, 213, 11},	//525 QsciLexerCSS::blockEnd(int*) const
    {58, 830, 76, 1, Smoke::mf_const|Smoke::mf_virtual, 213, 12},	//526 QsciLexerCSS::blockStart(int*) const
    {58, 1577, 0, 0, Smoke::mf_const|Smoke::mf_virtual, 213, 13},	//527 QsciLexerCSS::wordCharacters() const
    {58, 890, 18, 1, Smoke::mf_const|Smoke::mf_virtual, 6, 14},	//528 QsciLexerCSS::defaultColor(int) const
    {58, 894, 18, 1, Smoke::mf_const|Smoke::mf_virtual, 14, 15},	//529 QsciLexerCSS::defaultFont(int) const
    {58, 1047, 18, 1, Smoke::mf_const|Smoke::mf_virtual, 213, 16},	//530 QsciLexerCSS::keywords(int) const
    {58, 900, 18, 1, Smoke::mf_const|Smoke::mf_virtual, 40, 17},	//531 QsciLexerCSS::description(int) const
    {58, 1163, 0, 0, Smoke::mf_virtual, 0, 18},	//532 QsciLexerCSS::refreshProperties()
    {58, 968, 0, 0, Smoke::mf_const, 189, 19},	//533 QsciLexerCSS::foldComments() const
    {58, 969, 0, 0, Smoke::mf_const, 189, 20},	//534 QsciLexerCSS::foldCompact() const
    {58, 1330, 16, 1, 0, 0, 21},	//535 QsciLexerCSS::setHSSLanguage(bool)
    {58, 229, 0, 0, Smoke::mf_const, 189, 22},	//536 QsciLexerCSS::HSSLanguage() const
    {58, 1387, 16, 1, 0, 0, 23},	//537 QsciLexerCSS::setLessLanguage(bool)
    {58, 327, 0, 0, Smoke::mf_const, 189, 24},	//538 QsciLexerCSS::LessLanguage() const
    {58, 1447, 16, 1, 0, 0, 25},	//539 QsciLexerCSS::setSCSSLanguage(bool)
    {58, 617, 0, 0, Smoke::mf_const, 189, 26},	//540 QsciLexerCSS::SCSSLanguage() const
    {58, 1302, 16, 1, Smoke::mf_virtual|Smoke::mf_slot, 0, 27},	//541 QsciLexerCSS::setFoldComments(bool)
    {58, 1304, 16, 1, Smoke::mf_virtual|Smoke::mf_slot, 0, 28},	//542 QsciLexerCSS::setFoldCompact(bool)
    {58, 1153, 93, 2, Smoke::mf_protected|Smoke::mf_virtual, 189, 29},	//543 QsciLexerCSS::readProperties(QSettings&, const QString&)
    {58, 1582, 93, 2, Smoke::mf_const|Smoke::mf_protected|Smoke::mf_virtual, 189, 30},	//544 QsciLexerCSS::writeProperties(QSettings&, const QString&) const
    {58, 1546, 12, 1, Smoke::mf_static, 40, 31},	//545 QsciLexerCSS::tr(const char*)
    {58, 1550, 12, 1, Smoke::mf_static, 40, 32},	//546 QsciLexerCSS::trUtf8(const char*)
    {58, 478, 0, 0, Smoke::mf_ctor, 63, 33},	//547 QsciLexerCSS::QsciLexerCSS()
    {58, 827, 0, 0, Smoke::mf_const, 213, 34},	//548 QsciLexerCSS::blockEnd() const
    {58, 830, 0, 0, Smoke::mf_const, 213, 35},	//549 QsciLexerCSS::blockStart() const
    {58, 1523, 0, 0, Smoke::mf_const|Smoke::mf_static|Smoke::mf_attribute, 199, 36},	//550 QsciLexerCSS::staticMetaObject() const
    {58, 160, 0, 0, Smoke::mf_static|Smoke::mf_enum, 218, 37},	//551 QsciLexerCSS::Default (enum)
    {58, 704, 0, 0, Smoke::mf_static|Smoke::mf_enum, 218, 38},	//552 QsciLexerCSS::Tag (enum)
    {58, 134, 0, 0, Smoke::mf_static|Smoke::mf_enum, 218, 39},	//553 QsciLexerCSS::ClassSelector (enum)
    {58, 439, 0, 0, Smoke::mf_static|Smoke::mf_enum, 218, 40},	//554 QsciLexerCSS::PseudoClass (enum)
    {58, 731, 0, 0, Smoke::mf_static|Smoke::mf_enum, 218, 41},	//555 QsciLexerCSS::UnknownPseudoClass (enum)
    {58, 382, 0, 0, Smoke::mf_static|Smoke::mf_enum, 218, 42},	//556 QsciLexerCSS::Operator (enum)
    {58, 107, 0, 0, Smoke::mf_static|Smoke::mf_enum, 218, 43},	//557 QsciLexerCSS::CSS1Property (enum)
    {58, 730, 0, 0, Smoke::mf_static|Smoke::mf_enum, 218, 44},	//558 QsciLexerCSS::UnknownProperty (enum)
    {58, 749, 0, 0, Smoke::mf_static|Smoke::mf_enum, 218, 45},	//559 QsciLexerCSS::Value (enum)
    {58, 139, 0, 0, Smoke::mf_static|Smoke::mf_enum, 218, 46},	//560 QsciLexerCSS::Comment (enum)
    {58, 253, 0, 0, Smoke::mf_static|Smoke::mf_enum, 218, 47},	//561 QsciLexerCSS::IDSelector (enum)
    {58, 259, 0, 0, Smoke::mf_static|Smoke::mf_enum, 218, 48},	//562 QsciLexerCSS::Important (enum)
    {58, 66, 0, 0, Smoke::mf_static|Smoke::mf_enum, 218, 49},	//563 QsciLexerCSS::AtRule (enum)
    {58, 186, 0, 0, Smoke::mf_static|Smoke::mf_enum, 218, 50},	//564 QsciLexerCSS::DoubleQuotedString (enum)
    {58, 658, 0, 0, Smoke::mf_static|Smoke::mf_enum, 218, 51},	//565 QsciLexerCSS::SingleQuotedString (enum)
    {58, 108, 0, 0, Smoke::mf_static|Smoke::mf_enum, 218, 52},	//566 QsciLexerCSS::CSS2Property (enum)
    {58, 67, 0, 0, Smoke::mf_static|Smoke::mf_enum, 218, 53},	//567 QsciLexerCSS::Attribute (enum)
    {58, 109, 0, 0, Smoke::mf_static|Smoke::mf_enum, 218, 54},	//568 QsciLexerCSS::CSS3Property (enum)
    {58, 440, 0, 0, Smoke::mf_static|Smoke::mf_enum, 218, 55},	//569 QsciLexerCSS::PseudoElement (enum)
    {58, 209, 0, 0, Smoke::mf_static|Smoke::mf_enum, 218, 56},	//570 QsciLexerCSS::ExtendedCSSProperty (enum)
    {58, 211, 0, 0, Smoke::mf_static|Smoke::mf_enum, 218, 57},	//571 QsciLexerCSS::ExtendedPseudoClass (enum)
    {58, 212, 0, 0, Smoke::mf_static|Smoke::mf_enum, 218, 58},	//572 QsciLexerCSS::ExtendedPseudoElement (enum)
    {58, 359, 0, 0, Smoke::mf_static|Smoke::mf_enum, 218, 59},	//573 QsciLexerCSS::MediaRule (enum)
    {58, 750, 0, 0, Smoke::mf_static|Smoke::mf_enum, 218, 60},	//574 QsciLexerCSS::Variable (enum)
    {58, 1603, 0, 0, Smoke::mf_dtor, 0, 61 },	//575 QsciLexerCSS::~QsciLexerCSS()
    {59, 1105, 0, 0, Smoke::mf_const|Smoke::mf_virtual, 200, 1},	//576 QsciLexerCSharp::metaObject() const
    {59, 1148, 12, 1, Smoke::mf_virtual, 221, 2},	//577 QsciLexerCSharp::qt_metacast(const char*)
    {59, 1546, 42, 2, Smoke::mf_static, 40, 3},	//578 QsciLexerCSharp::tr(const char*, const char*)
    {59, 1550, 42, 2, Smoke::mf_static, 40, 4},	//579 QsciLexerCSharp::trUtf8(const char*, const char*)
    {59, 1546, 45, 3, Smoke::mf_static, 40, 5},	//580 QsciLexerCSharp::tr(const char*, const char*, int)
    {59, 1550, 45, 3, Smoke::mf_static, 40, 6},	//581 QsciLexerCSharp::trUtf8(const char*, const char*, int)
    {59, 1146, 49, 3, Smoke::mf_virtual, 215, 7},	//582 QsciLexerCSharp::qt_metacall(QMetaObject::Call, int, void**)
    {59, 480, 74, 1, Smoke::mf_ctor, 64, 8},	//583 QsciLexerCSharp::QsciLexerCSharp(QObject*)
    {59, 1049, 0, 0, Smoke::mf_const|Smoke::mf_virtual, 213, 9},	//584 QsciLexerCSharp::language() const
    {59, 890, 18, 1, Smoke::mf_const|Smoke::mf_virtual, 6, 10},	//585 QsciLexerCSharp::defaultColor(int) const
    {59, 892, 18, 1, Smoke::mf_const|Smoke::mf_virtual, 189, 11},	//586 QsciLexerCSharp::defaultEolFill(int) const
    {59, 894, 18, 1, Smoke::mf_const|Smoke::mf_virtual, 14, 12},	//587 QsciLexerCSharp::defaultFont(int) const
    {59, 896, 18, 1, Smoke::mf_const|Smoke::mf_virtual, 6, 13},	//588 QsciLexerCSharp::defaultPaper(int) const
    {59, 1047, 18, 1, Smoke::mf_const|Smoke::mf_virtual, 213, 14},	//589 QsciLexerCSharp::keywords(int) const
    {59, 900, 18, 1, Smoke::mf_const|Smoke::mf_virtual, 40, 15},	//590 QsciLexerCSharp::description(int) const
    {59, 1546, 12, 1, Smoke::mf_static, 40, 16},	//591 QsciLexerCSharp::tr(const char*)
    {59, 1550, 12, 1, Smoke::mf_static, 40, 17},	//592 QsciLexerCSharp::trUtf8(const char*)
    {59, 480, 0, 0, Smoke::mf_ctor, 64, 18},	//593 QsciLexerCSharp::QsciLexerCSharp()
    {59, 1523, 0, 0, Smoke::mf_const|Smoke::mf_static|Smoke::mf_attribute, 199, 19},	//594 QsciLexerCSharp::staticMetaObject() const
    {59, 1604, 0, 0, Smoke::mf_dtor, 0, 20 },	//595 QsciLexerCSharp::~QsciLexerCSharp()
    {60, 1105, 0, 0, Smoke::mf_const|Smoke::mf_virtual, 200, 1},	//596 QsciLexerCustom::metaObject() const
    {60, 1148, 12, 1, Smoke::mf_virtual, 221, 2},	//597 QsciLexerCustom::qt_metacast(const char*)
    {60, 1546, 42, 2, Smoke::mf_static, 40, 3},	//598 QsciLexerCustom::tr(const char*, const char*)
    {60, 1550, 42, 2, Smoke::mf_static, 40, 4},	//599 QsciLexerCustom::trUtf8(const char*, const char*)
    {60, 1546, 45, 3, Smoke::mf_static, 40, 5},	//600 QsciLexerCustom::tr(const char*, const char*, int)
    {60, 1550, 45, 3, Smoke::mf_static, 40, 6},	//601 QsciLexerCustom::trUtf8(const char*, const char*, int)
    {60, 1146, 49, 3, Smoke::mf_virtual, 215, 7},	//602 QsciLexerCustom::qt_metacall(QMetaObject::Call, int, void**)
    {60, 482, 74, 1, Smoke::mf_ctor, 65, 8},	//603 QsciLexerCustom::QsciLexerCustom(QObject*)
    {60, 1466, 99, 2, 0, 0, 9},	//604 QsciLexerCustom::setStyling(int, int)
    {60, 1466, 102, 2, 0, 0, 10},	//605 QsciLexerCustom::setStyling(int, const QsciStyle&)
    {60, 1520, 99, 2, 0, 0, 11},	//606 QsciLexerCustom::startStyling(int, int)
    {60, 1529, 99, 2, Smoke::mf_virtual|Smoke::mf_purevirtual, 0, 12},	//607 QsciLexerCustom::styleText(int, int) [pure virtual]
    {60, 1281, 82, 1, Smoke::mf_virtual, 0, 13},	//608 QsciLexerCustom::setEditor(QsciScintilla*)
    {60, 1526, 0, 0, Smoke::mf_const|Smoke::mf_virtual, 215, 14},	//609 QsciLexerCustom::styleBitsNeeded() const
    {60, 1546, 12, 1, Smoke::mf_static, 40, 15},	//610 QsciLexerCustom::tr(const char*)
    {60, 1550, 12, 1, Smoke::mf_static, 40, 16},	//611 QsciLexerCustom::trUtf8(const char*)
    {60, 482, 0, 0, Smoke::mf_ctor, 65, 17},	//612 QsciLexerCustom::QsciLexerCustom()
    {60, 1520, 18, 1, 0, 0, 18},	//613 QsciLexerCustom::startStyling(int)
    {60, 1523, 0, 0, Smoke::mf_const|Smoke::mf_static|Smoke::mf_attribute, 199, 19},	//614 QsciLexerCustom::staticMetaObject() const
    {60, 1605, 0, 0, Smoke::mf_dtor, 0, 20 },	//615 QsciLexerCustom::~QsciLexerCustom()
    {61, 1105, 0, 0, Smoke::mf_const|Smoke::mf_virtual, 200, 1},	//616 QsciLexerD::metaObject() const
    {61, 1148, 12, 1, Smoke::mf_virtual, 221, 2},	//617 QsciLexerD::qt_metacast(const char*)
    {61, 1546, 42, 2, Smoke::mf_static, 40, 3},	//618 QsciLexerD::tr(const char*, const char*)
    {61, 1550, 42, 2, Smoke::mf_static, 40, 4},	//619 QsciLexerD::trUtf8(const char*, const char*)
    {61, 1546, 45, 3, Smoke::mf_static, 40, 5},	//620 QsciLexerD::tr(const char*, const char*, int)
    {61, 1550, 45, 3, Smoke::mf_static, 40, 6},	//621 QsciLexerD::trUtf8(const char*, const char*, int)
    {61, 1146, 49, 3, Smoke::mf_virtual, 215, 7},	//622 QsciLexerD::qt_metacall(QMetaObject::Call, int, void**)
    {61, 484, 74, 1, Smoke::mf_ctor, 66, 8},	//623 QsciLexerD::QsciLexerD(QObject*)
    {61, 1049, 0, 0, Smoke::mf_const|Smoke::mf_virtual, 213, 9},	//624 QsciLexerD::language() const
    {61, 1054, 0, 0, Smoke::mf_const|Smoke::mf_virtual, 213, 10},	//625 QsciLexerD::lexer() const
    {61, 821, 0, 0, Smoke::mf_const|Smoke::mf_virtual, 41, 11},	//626 QsciLexerD::autoCompletionWordSeparators() const
    {61, 827, 76, 1, Smoke::mf_const|Smoke::mf_virtual, 213, 12},	//627 QsciLexerD::blockEnd(int*) const
    {61, 830, 76, 1, Smoke::mf_const|Smoke::mf_virtual, 213, 13},	//628 QsciLexerD::blockStart(int*) const
    {61, 832, 76, 1, Smoke::mf_const|Smoke::mf_virtual, 213, 14},	//629 QsciLexerD::blockStartKeyword(int*) const
    {61, 837, 0, 0, Smoke::mf_const|Smoke::mf_virtual, 215, 15},	//630 QsciLexerD::braceStyle() const
    {61, 1577, 0, 0, Smoke::mf_const|Smoke::mf_virtual, 213, 16},	//631 QsciLexerD::wordCharacters() const
    {61, 890, 18, 1, Smoke::mf_const|Smoke::mf_virtual, 6, 17},	//632 QsciLexerD::defaultColor(int) const
    {61, 892, 18, 1, Smoke::mf_const|Smoke::mf_virtual, 189, 18},	//633 QsciLexerD::defaultEolFill(int) const
    {61, 894, 18, 1, Smoke::mf_const|Smoke::mf_virtual, 14, 19},	//634 QsciLexerD::defaultFont(int) const
    {61, 896, 18, 1, Smoke::mf_const|Smoke::mf_virtual, 6, 20},	//635 QsciLexerD::defaultPaper(int) const
    {61, 1047, 18, 1, Smoke::mf_const|Smoke::mf_virtual, 213, 21},	//636 QsciLexerD::keywords(int) const
    {61, 900, 18, 1, Smoke::mf_const|Smoke::mf_virtual, 40, 22},	//637 QsciLexerD::description(int) const
    {61, 1163, 0, 0, Smoke::mf_virtual, 0, 23},	//638 QsciLexerD::refreshProperties()
    {61, 966, 0, 0, Smoke::mf_const, 189, 24},	//639 QsciLexerD::foldAtElse() const
    {61, 968, 0, 0, Smoke::mf_const, 189, 25},	//640 QsciLexerD::foldComments() const
    {61, 969, 0, 0, Smoke::mf_const, 189, 26},	//641 QsciLexerD::foldCompact() const
    {61, 1298, 16, 1, Smoke::mf_virtual|Smoke::mf_slot, 0, 27},	//642 QsciLexerD::setFoldAtElse(bool)
    {61, 1302, 16, 1, Smoke::mf_virtual|Smoke::mf_slot, 0, 28},	//643 QsciLexerD::setFoldComments(bool)
    {61, 1304, 16, 1, Smoke::mf_virtual|Smoke::mf_slot, 0, 29},	//644 QsciLexerD::setFoldCompact(bool)
    {61, 1153, 93, 2, Smoke::mf_protected|Smoke::mf_virtual, 189, 30},	//645 QsciLexerD::readProperties(QSettings&, const QString&)
    {61, 1582, 93, 2, Smoke::mf_const|Smoke::mf_protected|Smoke::mf_virtual, 189, 31},	//646 QsciLexerD::writeProperties(QSettings&, const QString&) const
    {61, 1546, 12, 1, Smoke::mf_static, 40, 32},	//647 QsciLexerD::tr(const char*)
    {61, 1550, 12, 1, Smoke::mf_static, 40, 33},	//648 QsciLexerD::trUtf8(const char*)
    {61, 484, 0, 0, Smoke::mf_ctor, 66, 34},	//649 QsciLexerD::QsciLexerD()
    {61, 827, 0, 0, Smoke::mf_const, 213, 35},	//650 QsciLexerD::blockEnd() const
    {61, 830, 0, 0, Smoke::mf_const, 213, 36},	//651 QsciLexerD::blockStart() const
    {61, 832, 0, 0, Smoke::mf_const, 213, 37},	//652 QsciLexerD::blockStartKeyword() const
    {61, 1523, 0, 0, Smoke::mf_const|Smoke::mf_static|Smoke::mf_attribute, 199, 38},	//653 QsciLexerD::staticMetaObject() const
    {61, 160, 0, 0, Smoke::mf_static|Smoke::mf_enum, 218, 39},	//654 QsciLexerD::Default (enum)
    {61, 139, 0, 0, Smoke::mf_static|Smoke::mf_enum, 218, 40},	//655 QsciLexerD::Comment (enum)
    {61, 145, 0, 0, Smoke::mf_static|Smoke::mf_enum, 218, 41},	//656 QsciLexerD::CommentLine (enum)
    {61, 142, 0, 0, Smoke::mf_static|Smoke::mf_enum, 218, 42},	//657 QsciLexerD::CommentDoc (enum)
    {61, 148, 0, 0, Smoke::mf_static|Smoke::mf_enum, 218, 43},	//658 QsciLexerD::CommentNested (enum)
    {61, 378, 0, 0, Smoke::mf_static|Smoke::mf_enum, 218, 44},	//659 QsciLexerD::Number (enum)
    {61, 307, 0, 0, Smoke::mf_static|Smoke::mf_enum, 218, 45},	//660 QsciLexerD::Keyword (enum)
    {61, 309, 0, 0, Smoke::mf_static|Smoke::mf_enum, 218, 46},	//661 QsciLexerD::KeywordSecondary (enum)
    {61, 308, 0, 0, Smoke::mf_static|Smoke::mf_enum, 218, 47},	//662 QsciLexerD::KeywordDoc (enum)
    {61, 723, 0, 0, Smoke::mf_static|Smoke::mf_enum, 218, 48},	//663 QsciLexerD::Typedefs (enum)
    {61, 677, 0, 0, Smoke::mf_static|Smoke::mf_enum, 218, 49},	//664 QsciLexerD::String (enum)
    {61, 726, 0, 0, Smoke::mf_static|Smoke::mf_enum, 218, 50},	//665 QsciLexerD::UnclosedString (enum)
    {61, 124, 0, 0, Smoke::mf_static|Smoke::mf_enum, 218, 51},	//666 QsciLexerD::Character (enum)
    {61, 382, 0, 0, Smoke::mf_static|Smoke::mf_enum, 218, 52},	//667 QsciLexerD::Operator (enum)
    {61, 255, 0, 0, Smoke::mf_static|Smoke::mf_enum, 218, 53},	//668 QsciLexerD::Identifier (enum)
    {61, 146, 0, 0, Smoke::mf_static|Smoke::mf_enum, 218, 54},	//669 QsciLexerD::CommentLineDoc (enum)
    {61, 143, 0, 0, Smoke::mf_static|Smoke::mf_enum, 218, 55},	//670 QsciLexerD::CommentDocKeyword (enum)
    {61, 144, 0, 0, Smoke::mf_static|Smoke::mf_enum, 218, 56},	//671 QsciLexerD::CommentDocKeywordError (enum)
    {61, 81, 0, 0, Smoke::mf_static|Smoke::mf_enum, 218, 57},	//672 QsciLexerD::BackquoteString (enum)
    {61, 561, 0, 0, Smoke::mf_static|Smoke::mf_enum, 218, 58},	//673 QsciLexerD::RawString (enum)
    {61, 312, 0, 0, Smoke::mf_static|Smoke::mf_enum, 218, 59},	//674 QsciLexerD::KeywordSet5 (enum)
    {61, 313, 0, 0, Smoke::mf_static|Smoke::mf_enum, 218, 60},	//675 QsciLexerD::KeywordSet6 (enum)
    {61, 314, 0, 0, Smoke::mf_static|Smoke::mf_enum, 218, 61},	//676 QsciLexerD::KeywordSet7 (enum)
    {61, 1606, 0, 0, Smoke::mf_dtor, 0, 62 },	//677 QsciLexerD::~QsciLexerD()
    {62, 1105, 0, 0, Smoke::mf_const|Smoke::mf_virtual, 200, 1},	//678 QsciLexerDiff::metaObject() const
    {62, 1148, 12, 1, Smoke::mf_virtual, 221, 2},	//679 QsciLexerDiff::qt_metacast(const char*)
    {62, 1546, 42, 2, Smoke::mf_static, 40, 3},	//680 QsciLexerDiff::tr(const char*, const char*)
    {62, 1550, 42, 2, Smoke::mf_static, 40, 4},	//681 QsciLexerDiff::trUtf8(const char*, const char*)
    {62, 1546, 45, 3, Smoke::mf_static, 40, 5},	//682 QsciLexerDiff::tr(const char*, const char*, int)
    {62, 1550, 45, 3, Smoke::mf_static, 40, 6},	//683 QsciLexerDiff::trUtf8(const char*, const char*, int)
    {62, 1146, 49, 3, Smoke::mf_virtual, 215, 7},	//684 QsciLexerDiff::qt_metacall(QMetaObject::Call, int, void**)
    {62, 486, 74, 1, Smoke::mf_ctor, 67, 8},	//685 QsciLexerDiff::QsciLexerDiff(QObject*)
    {62, 1049, 0, 0, Smoke::mf_const|Smoke::mf_virtual, 213, 9},	//686 QsciLexerDiff::language() const
    {62, 1054, 0, 0, Smoke::mf_const|Smoke::mf_virtual, 213, 10},	//687 QsciLexerDiff::lexer() const
    {62, 1577, 0, 0, Smoke::mf_const|Smoke::mf_virtual, 213, 11},	//688 QsciLexerDiff::wordCharacters() const
    {62, 890, 18, 1, Smoke::mf_const|Smoke::mf_virtual, 6, 12},	//689 QsciLexerDiff::defaultColor(int) const
    {62, 900, 18, 1, Smoke::mf_const|Smoke::mf_virtual, 40, 13},	//690 QsciLexerDiff::description(int) const
    {62, 1546, 12, 1, Smoke::mf_static, 40, 14},	//691 QsciLexerDiff::tr(const char*)
    {62, 1550, 12, 1, Smoke::mf_static, 40, 15},	//692 QsciLexerDiff::trUtf8(const char*)
    {62, 486, 0, 0, Smoke::mf_ctor, 67, 16},	//693 QsciLexerDiff::QsciLexerDiff()
    {62, 1523, 0, 0, Smoke::mf_const|Smoke::mf_static|Smoke::mf_attribute, 199, 17},	//694 QsciLexerDiff::staticMetaObject() const
    {62, 160, 0, 0, Smoke::mf_static|Smoke::mf_enum, 218, 18},	//695 QsciLexerDiff::Default (enum)
    {62, 139, 0, 0, Smoke::mf_static|Smoke::mf_enum, 218, 19},	//696 QsciLexerDiff::Comment (enum)
    {62, 138, 0, 0, Smoke::mf_static|Smoke::mf_enum, 218, 20},	//697 QsciLexerDiff::Command (enum)
    {62, 237, 0, 0, Smoke::mf_static|Smoke::mf_enum, 218, 21},	//698 QsciLexerDiff::Header (enum)
    {62, 428, 0, 0, Smoke::mf_static|Smoke::mf_enum, 218, 22},	//699 QsciLexerDiff::Position (enum)
    {62, 346, 0, 0, Smoke::mf_static|Smoke::mf_enum, 218, 23},	//700 QsciLexerDiff::LineRemoved (enum)
    {62, 329, 0, 0, Smoke::mf_static|Smoke::mf_enum, 218, 24},	//701 QsciLexerDiff::LineAdded (enum)
    {62, 330, 0, 0, Smoke::mf_static|Smoke::mf_enum, 218, 25},	//702 QsciLexerDiff::LineChanged (enum)
    {62, 1607, 0, 0, Smoke::mf_dtor, 0, 26 },	//703 QsciLexerDiff::~QsciLexerDiff()
    {63, 1105, 0, 0, Smoke::mf_const|Smoke::mf_virtual, 200, 1},	//704 QsciLexerFortran::metaObject() const
    {63, 1148, 12, 1, Smoke::mf_virtual, 221, 2},	//705 QsciLexerFortran::qt_metacast(const char*)
    {63, 1546, 42, 2, Smoke::mf_static, 40, 3},	//706 QsciLexerFortran::tr(const char*, const char*)
    {63, 1550, 42, 2, Smoke::mf_static, 40, 4},	//707 QsciLexerFortran::trUtf8(const char*, const char*)
    {63, 1546, 45, 3, Smoke::mf_static, 40, 5},	//708 QsciLexerFortran::tr(const char*, const char*, int)
    {63, 1550, 45, 3, Smoke::mf_static, 40, 6},	//709 QsciLexerFortran::trUtf8(const char*, const char*, int)
    {63, 1146, 49, 3, Smoke::mf_virtual, 215, 7},	//710 QsciLexerFortran::qt_metacall(QMetaObject::Call, int, void**)
    {63, 488, 74, 1, Smoke::mf_ctor, 68, 8},	//711 QsciLexerFortran::QsciLexerFortran(QObject*)
    {63, 1049, 0, 0, Smoke::mf_const|Smoke::mf_virtual, 213, 9},	//712 QsciLexerFortran::language() const
    {63, 1054, 0, 0, Smoke::mf_const|Smoke::mf_virtual, 213, 10},	//713 QsciLexerFortran::lexer() const
    {63, 1047, 18, 1, Smoke::mf_const|Smoke::mf_virtual, 213, 11},	//714 QsciLexerFortran::keywords(int) const
    {63, 1546, 12, 1, Smoke::mf_static, 40, 12},	//715 QsciLexerFortran::tr(const char*)
    {63, 1550, 12, 1, Smoke::mf_static, 40, 13},	//716 QsciLexerFortran::trUtf8(const char*)
    {63, 488, 0, 0, Smoke::mf_ctor, 68, 14},	//717 QsciLexerFortran::QsciLexerFortran()
    {63, 1523, 0, 0, Smoke::mf_const|Smoke::mf_static|Smoke::mf_attribute, 199, 15},	//718 QsciLexerFortran::staticMetaObject() const
    {63, 1608, 0, 0, Smoke::mf_dtor, 0, 16 },	//719 QsciLexerFortran::~QsciLexerFortran()
    {64, 1105, 0, 0, Smoke::mf_const|Smoke::mf_virtual, 200, 1},	//720 QsciLexerFortran77::metaObject() const
    {64, 1148, 12, 1, Smoke::mf_virtual, 221, 2},	//721 QsciLexerFortran77::qt_metacast(const char*)
    {64, 1546, 42, 2, Smoke::mf_static, 40, 3},	//722 QsciLexerFortran77::tr(const char*, const char*)
    {64, 1550, 42, 2, Smoke::mf_static, 40, 4},	//723 QsciLexerFortran77::trUtf8(const char*, const char*)
    {64, 1546, 45, 3, Smoke::mf_static, 40, 5},	//724 QsciLexerFortran77::tr(const char*, const char*, int)
    {64, 1550, 45, 3, Smoke::mf_static, 40, 6},	//725 QsciLexerFortran77::trUtf8(const char*, const char*, int)
    {64, 1146, 49, 3, Smoke::mf_virtual, 215, 7},	//726 QsciLexerFortran77::qt_metacall(QMetaObject::Call, int, void**)
    {64, 490, 74, 1, Smoke::mf_ctor, 69, 8},	//727 QsciLexerFortran77::QsciLexerFortran77(QObject*)
    {64, 1049, 0, 0, Smoke::mf_const|Smoke::mf_virtual, 213, 9},	//728 QsciLexerFortran77::language() const
    {64, 1054, 0, 0, Smoke::mf_const|Smoke::mf_virtual, 213, 10},	//729 QsciLexerFortran77::lexer() const
    {64, 837, 0, 0, Smoke::mf_const|Smoke::mf_virtual, 215, 11},	//730 QsciLexerFortran77::braceStyle() const
    {64, 890, 18, 1, Smoke::mf_const|Smoke::mf_virtual, 6, 12},	//731 QsciLexerFortran77::defaultColor(int) const
    {64, 892, 18, 1, Smoke::mf_const|Smoke::mf_virtual, 189, 13},	//732 QsciLexerFortran77::defaultEolFill(int) const
    {64, 894, 18, 1, Smoke::mf_const|Smoke::mf_virtual, 14, 14},	//733 QsciLexerFortran77::defaultFont(int) const
    {64, 896, 18, 1, Smoke::mf_const|Smoke::mf_virtual, 6, 15},	//734 QsciLexerFortran77::defaultPaper(int) const
    {64, 1047, 18, 1, Smoke::mf_const|Smoke::mf_virtual, 213, 16},	//735 QsciLexerFortran77::keywords(int) const
    {64, 900, 18, 1, Smoke::mf_const|Smoke::mf_virtual, 40, 17},	//736 QsciLexerFortran77::description(int) const
    {64, 1163, 0, 0, Smoke::mf_virtual, 0, 18},	//737 QsciLexerFortran77::refreshProperties()
    {64, 969, 0, 0, Smoke::mf_const, 189, 19},	//738 QsciLexerFortran77::foldCompact() const
    {64, 1304, 16, 1, Smoke::mf_virtual|Smoke::mf_slot, 0, 20},	//739 QsciLexerFortran77::setFoldCompact(bool)
    {64, 1153, 93, 2, Smoke::mf_protected|Smoke::mf_virtual, 189, 21},	//740 QsciLexerFortran77::readProperties(QSettings&, const QString&)
    {64, 1582, 93, 2, Smoke::mf_const|Smoke::mf_protected|Smoke::mf_virtual, 189, 22},	//741 QsciLexerFortran77::writeProperties(QSettings&, const QString&) const
    {64, 1546, 12, 1, Smoke::mf_static, 40, 23},	//742 QsciLexerFortran77::tr(const char*)
    {64, 1550, 12, 1, Smoke::mf_static, 40, 24},	//743 QsciLexerFortran77::trUtf8(const char*)
    {64, 490, 0, 0, Smoke::mf_ctor, 69, 25},	//744 QsciLexerFortran77::QsciLexerFortran77()
    {64, 1523, 0, 0, Smoke::mf_const|Smoke::mf_static|Smoke::mf_attribute, 199, 26},	//745 QsciLexerFortran77::staticMetaObject() const
    {64, 160, 0, 0, Smoke::mf_static|Smoke::mf_enum, 218, 27},	//746 QsciLexerFortran77::Default (enum)
    {64, 139, 0, 0, Smoke::mf_static|Smoke::mf_enum, 218, 28},	//747 QsciLexerFortran77::Comment (enum)
    {64, 378, 0, 0, Smoke::mf_static|Smoke::mf_enum, 218, 29},	//748 QsciLexerFortran77::Number (enum)
    {64, 658, 0, 0, Smoke::mf_static|Smoke::mf_enum, 218, 30},	//749 QsciLexerFortran77::SingleQuotedString (enum)
    {64, 186, 0, 0, Smoke::mf_static|Smoke::mf_enum, 218, 31},	//750 QsciLexerFortran77::DoubleQuotedString (enum)
    {64, 726, 0, 0, Smoke::mf_static|Smoke::mf_enum, 218, 32},	//751 QsciLexerFortran77::UnclosedString (enum)
    {64, 382, 0, 0, Smoke::mf_static|Smoke::mf_enum, 218, 33},	//752 QsciLexerFortran77::Operator (enum)
    {64, 255, 0, 0, Smoke::mf_static|Smoke::mf_enum, 218, 34},	//753 QsciLexerFortran77::Identifier (enum)
    {64, 307, 0, 0, Smoke::mf_static|Smoke::mf_enum, 218, 35},	//754 QsciLexerFortran77::Keyword (enum)
    {64, 291, 0, 0, Smoke::mf_static|Smoke::mf_enum, 218, 36},	//755 QsciLexerFortran77::IntrinsicFunction (enum)
    {64, 210, 0, 0, Smoke::mf_static|Smoke::mf_enum, 218, 37},	//756 QsciLexerFortran77::ExtendedFunction (enum)
    {64, 430, 0, 0, Smoke::mf_static|Smoke::mf_enum, 218, 38},	//757 QsciLexerFortran77::PreProcessor (enum)
    {64, 183, 0, 0, Smoke::mf_static|Smoke::mf_enum, 218, 39},	//758 QsciLexerFortran77::DottedOperator (enum)
    {64, 317, 0, 0, Smoke::mf_static|Smoke::mf_enum, 218, 40},	//759 QsciLexerFortran77::Label (enum)
    {64, 150, 0, 0, Smoke::mf_static|Smoke::mf_enum, 218, 41},	//760 QsciLexerFortran77::Continuation (enum)
    {64, 1609, 0, 0, Smoke::mf_dtor, 0, 42 },	//761 QsciLexerFortran77::~QsciLexerFortran77()
    {65, 1105, 0, 0, Smoke::mf_const|Smoke::mf_virtual, 200, 1},	//762 QsciLexerHTML::metaObject() const
    {65, 1148, 12, 1, Smoke::mf_virtual, 221, 2},	//763 QsciLexerHTML::qt_metacast(const char*)
    {65, 1546, 42, 2, Smoke::mf_static, 40, 3},	//764 QsciLexerHTML::tr(const char*, const char*)
    {65, 1550, 42, 2, Smoke::mf_static, 40, 4},	//765 QsciLexerHTML::trUtf8(const char*, const char*)
    {65, 1546, 45, 3, Smoke::mf_static, 40, 5},	//766 QsciLexerHTML::tr(const char*, const char*, int)
    {65, 1550, 45, 3, Smoke::mf_static, 40, 6},	//767 QsciLexerHTML::trUtf8(const char*, const char*, int)
    {65, 1146, 49, 3, Smoke::mf_virtual, 215, 7},	//768 QsciLexerHTML::qt_metacall(QMetaObject::Call, int, void**)
    {65, 492, 74, 1, Smoke::mf_ctor, 70, 8},	//769 QsciLexerHTML::QsciLexerHTML(QObject*)
    {65, 1049, 0, 0, Smoke::mf_const|Smoke::mf_virtual, 213, 9},	//770 QsciLexerHTML::language() const
    {65, 1054, 0, 0, Smoke::mf_const|Smoke::mf_virtual, 213, 10},	//771 QsciLexerHTML::lexer() const
    {65, 812, 0, 0, Smoke::mf_const|Smoke::mf_virtual, 213, 11},	//772 QsciLexerHTML::autoCompletionFillups() const
    {65, 1577, 0, 0, Smoke::mf_const|Smoke::mf_virtual, 213, 12},	//773 QsciLexerHTML::wordCharacters() const
    {65, 890, 18, 1, Smoke::mf_const|Smoke::mf_virtual, 6, 13},	//774 QsciLexerHTML::defaultColor(int) const
    {65, 892, 18, 1, Smoke::mf_const|Smoke::mf_virtual, 189, 14},	//775 QsciLexerHTML::defaultEolFill(int) const
    {65, 894, 18, 1, Smoke::mf_const|Smoke::mf_virtual, 14, 15},	//776 QsciLexerHTML::defaultFont(int) const
    {65, 896, 18, 1, Smoke::mf_const|Smoke::mf_virtual, 6, 16},	//777 QsciLexerHTML::defaultPaper(int) const
    {65, 1047, 18, 1, Smoke::mf_const|Smoke::mf_virtual, 213, 17},	//778 QsciLexerHTML::keywords(int) const
    {65, 900, 18, 1, Smoke::mf_const|Smoke::mf_virtual, 40, 18},	//779 QsciLexerHTML::description(int) const
    {65, 1163, 0, 0, Smoke::mf_virtual, 0, 19},	//780 QsciLexerHTML::refreshProperties()
    {65, 851, 0, 0, Smoke::mf_const, 189, 20},	//781 QsciLexerHTML::caseSensitiveTags() const
    {65, 1267, 16, 1, 0, 0, 21},	//782 QsciLexerHTML::setDjangoTemplates(bool)
    {65, 904, 0, 0, Smoke::mf_const, 189, 22},	//783 QsciLexerHTML::djangoTemplates() const
    {65, 969, 0, 0, Smoke::mf_const, 189, 23},	//784 QsciLexerHTML::foldCompact() const
    {65, 976, 0, 0, Smoke::mf_const, 189, 24},	//785 QsciLexerHTML::foldPreprocessor() const
    {65, 1320, 16, 1, 0, 0, 25},	//786 QsciLexerHTML::setFoldScriptComments(bool)
    {65, 978, 0, 0, Smoke::mf_const, 189, 26},	//787 QsciLexerHTML::foldScriptComments() const
    {65, 1322, 16, 1, 0, 0, 27},	//788 QsciLexerHTML::setFoldScriptHeredocs(bool)
    {65, 979, 0, 0, Smoke::mf_const, 189, 28},	//789 QsciLexerHTML::foldScriptHeredocs() const
    {65, 1395, 16, 1, 0, 0, 29},	//790 QsciLexerHTML::setMakoTemplates(bool)
    {65, 1069, 0, 0, Smoke::mf_const, 189, 30},	//791 QsciLexerHTML::makoTemplates() const
    {65, 1304, 16, 1, Smoke::mf_virtual|Smoke::mf_slot, 0, 31},	//792 QsciLexerHTML::setFoldCompact(bool)
    {65, 1316, 16, 1, Smoke::mf_virtual|Smoke::mf_slot, 0, 32},	//793 QsciLexerHTML::setFoldPreprocessor(bool)
    {65, 1248, 16, 1, Smoke::mf_virtual|Smoke::mf_slot, 0, 33},	//794 QsciLexerHTML::setCaseSensitiveTags(bool)
    {65, 1153, 93, 2, Smoke::mf_protected|Smoke::mf_virtual, 189, 34},	//795 QsciLexerHTML::readProperties(QSettings&, const QString&)
    {65, 1582, 93, 2, Smoke::mf_const|Smoke::mf_protected|Smoke::mf_virtual, 189, 35},	//796 QsciLexerHTML::writeProperties(QSettings&, const QString&) const
    {65, 1546, 12, 1, Smoke::mf_static, 40, 36},	//797 QsciLexerHTML::tr(const char*)
    {65, 1550, 12, 1, Smoke::mf_static, 40, 37},	//798 QsciLexerHTML::trUtf8(const char*)
    {65, 492, 0, 0, Smoke::mf_ctor, 70, 38},	//799 QsciLexerHTML::QsciLexerHTML()
    {65, 1523, 0, 0, Smoke::mf_const|Smoke::mf_static|Smoke::mf_attribute, 199, 39},	//800 QsciLexerHTML::staticMetaObject() const
    {65, 160, 0, 0, Smoke::mf_static|Smoke::mf_enum, 218, 40},	//801 QsciLexerHTML::Default (enum)
    {65, 704, 0, 0, Smoke::mf_static|Smoke::mf_enum, 218, 41},	//802 QsciLexerHTML::Tag (enum)
    {65, 732, 0, 0, Smoke::mf_static|Smoke::mf_enum, 218, 42},	//803 QsciLexerHTML::UnknownTag (enum)
    {65, 67, 0, 0, Smoke::mf_static|Smoke::mf_enum, 218, 43},	//804 QsciLexerHTML::Attribute (enum)
    {65, 729, 0, 0, Smoke::mf_static|Smoke::mf_enum, 218, 44},	//805 QsciLexerHTML::UnknownAttribute (enum)
    {65, 232, 0, 0, Smoke::mf_static|Smoke::mf_enum, 218, 45},	//806 QsciLexerHTML::HTMLNumber (enum)
    {65, 231, 0, 0, Smoke::mf_static|Smoke::mf_enum, 218, 46},	//807 QsciLexerHTML::HTMLDoubleQuotedString (enum)
    {65, 233, 0, 0, Smoke::mf_static|Smoke::mf_enum, 218, 47},	//808 QsciLexerHTML::HTMLSingleQuotedString (enum)
    {65, 384, 0, 0, Smoke::mf_static|Smoke::mf_enum, 218, 48},	//809 QsciLexerHTML::OtherInTag (enum)
    {65, 230, 0, 0, Smoke::mf_static|Smoke::mf_enum, 218, 49},	//810 QsciLexerHTML::HTMLComment (enum)
    {65, 199, 0, 0, Smoke::mf_static|Smoke::mf_enum, 218, 50},	//811 QsciLexerHTML::Entity (enum)
    {65, 783, 0, 0, Smoke::mf_static|Smoke::mf_enum, 218, 51},	//812 QsciLexerHTML::XMLTagEnd (enum)
    {65, 782, 0, 0, Smoke::mf_static|Smoke::mf_enum, 218, 52},	//813 QsciLexerHTML::XMLStart (enum)
    {65, 781, 0, 0, Smoke::mf_static|Smoke::mf_enum, 218, 53},	//814 QsciLexerHTML::XMLEnd (enum)
    {65, 634, 0, 0, Smoke::mf_static|Smoke::mf_enum, 218, 54},	//815 QsciLexerHTML::Script (enum)
    {65, 11, 0, 0, Smoke::mf_static|Smoke::mf_enum, 218, 55},	//816 QsciLexerHTML::ASPAtStart (enum)
    {65, 38, 0, 0, Smoke::mf_static|Smoke::mf_enum, 218, 56},	//817 QsciLexerHTML::ASPStart (enum)
    {65, 106, 0, 0, Smoke::mf_static|Smoke::mf_enum, 218, 57},	//818 QsciLexerHTML::CDATA (enum)
    {65, 394, 0, 0, Smoke::mf_static|Smoke::mf_enum, 218, 58},	//819 QsciLexerHTML::PHPStart (enum)
    {65, 234, 0, 0, Smoke::mf_static|Smoke::mf_enum, 218, 59},	//820 QsciLexerHTML::HTMLValue (enum)
    {65, 47, 0, 0, Smoke::mf_static|Smoke::mf_enum, 218, 60},	//821 QsciLexerHTML::ASPXCComment (enum)
    {65, 624, 0, 0, Smoke::mf_static|Smoke::mf_enum, 218, 61},	//822 QsciLexerHTML::SGMLDefault (enum)
    {65, 622, 0, 0, Smoke::mf_static|Smoke::mf_enum, 218, 62},	//823 QsciLexerHTML::SGMLCommand (enum)
    {65, 628, 0, 0, Smoke::mf_static|Smoke::mf_enum, 218, 63},	//824 QsciLexerHTML::SGMLParameter (enum)
    {65, 625, 0, 0, Smoke::mf_static|Smoke::mf_enum, 218, 64},	//825 QsciLexerHTML::SGMLDoubleQuotedString (enum)
    {65, 630, 0, 0, Smoke::mf_static|Smoke::mf_enum, 218, 65},	//826 QsciLexerHTML::SGMLSingleQuotedString (enum)
    {65, 627, 0, 0, Smoke::mf_static|Smoke::mf_enum, 218, 66},	//827 QsciLexerHTML::SGMLError (enum)
    {65, 631, 0, 0, Smoke::mf_static|Smoke::mf_enum, 218, 67},	//828 QsciLexerHTML::SGMLSpecial (enum)
    {65, 626, 0, 0, Smoke::mf_static|Smoke::mf_enum, 218, 68},	//829 QsciLexerHTML::SGMLEntity (enum)
    {65, 623, 0, 0, Smoke::mf_static|Smoke::mf_enum, 218, 69},	//830 QsciLexerHTML::SGMLComment (enum)
    {65, 629, 0, 0, Smoke::mf_static|Smoke::mf_enum, 218, 70},	//831 QsciLexerHTML::SGMLParameterComment (enum)
    {65, 621, 0, 0, Smoke::mf_static|Smoke::mf_enum, 218, 71},	//832 QsciLexerHTML::SGMLBlockDefault (enum)
    {65, 302, 0, 0, Smoke::mf_static|Smoke::mf_enum, 218, 72},	//833 QsciLexerHTML::JavaScriptStart (enum)
    {65, 296, 0, 0, Smoke::mf_static|Smoke::mf_enum, 218, 73},	//834 QsciLexerHTML::JavaScriptDefault (enum)
    {65, 293, 0, 0, Smoke::mf_static|Smoke::mf_enum, 218, 74},	//835 QsciLexerHTML::JavaScriptComment (enum)
    {65, 295, 0, 0, Smoke::mf_static|Smoke::mf_enum, 218, 75},	//836 QsciLexerHTML::JavaScriptCommentLine (enum)
    {65, 294, 0, 0, Smoke::mf_static|Smoke::mf_enum, 218, 76},	//837 QsciLexerHTML::JavaScriptCommentDoc (enum)
    {65, 299, 0, 0, Smoke::mf_static|Smoke::mf_enum, 218, 77},	//838 QsciLexerHTML::JavaScriptNumber (enum)
    {65, 305, 0, 0, Smoke::mf_static|Smoke::mf_enum, 218, 78},	//839 QsciLexerHTML::JavaScriptWord (enum)
    {65, 298, 0, 0, Smoke::mf_static|Smoke::mf_enum, 218, 79},	//840 QsciLexerHTML::JavaScriptKeyword (enum)
    {65, 297, 0, 0, Smoke::mf_static|Smoke::mf_enum, 218, 80},	//841 QsciLexerHTML::JavaScriptDoubleQuotedString (enum)
    {65, 301, 0, 0, Smoke::mf_static|Smoke::mf_enum, 218, 81},	//842 QsciLexerHTML::JavaScriptSingleQuotedString (enum)
    {65, 303, 0, 0, Smoke::mf_static|Smoke::mf_enum, 218, 82},	//843 QsciLexerHTML::JavaScriptSymbol (enum)
    {65, 304, 0, 0, Smoke::mf_static|Smoke::mf_enum, 218, 83},	//844 QsciLexerHTML::JavaScriptUnclosedString (enum)
    {65, 300, 0, 0, Smoke::mf_static|Smoke::mf_enum, 218, 84},	//845 QsciLexerHTML::JavaScriptRegex (enum)
    {65, 21, 0, 0, Smoke::mf_static|Smoke::mf_enum, 218, 85},	//846 QsciLexerHTML::ASPJavaScriptStart (enum)
    {65, 15, 0, 0, Smoke::mf_static|Smoke::mf_enum, 218, 86},	//847 QsciLexerHTML::ASPJavaScriptDefault (enum)
    {65, 12, 0, 0, Smoke::mf_static|Smoke::mf_enum, 218, 87},	//848 QsciLexerHTML::ASPJavaScriptComment (enum)
    {65, 14, 0, 0, Smoke::mf_static|Smoke::mf_enum, 218, 88},	//849 QsciLexerHTML::ASPJavaScriptCommentLine (enum)
    {65, 13, 0, 0, Smoke::mf_static|Smoke::mf_enum, 218, 89},	//850 QsciLexerHTML::ASPJavaScriptCommentDoc (enum)
    {65, 18, 0, 0, Smoke::mf_static|Smoke::mf_enum, 218, 90},	//851 QsciLexerHTML::ASPJavaScriptNumber (enum)
    {65, 24, 0, 0, Smoke::mf_static|Smoke::mf_enum, 218, 91},	//852 QsciLexerHTML::ASPJavaScriptWord (enum)
    {65, 17, 0, 0, Smoke::mf_static|Smoke::mf_enum, 218, 92},	//853 QsciLexerHTML::ASPJavaScriptKeyword (enum)
    {65, 16, 0, 0, Smoke::mf_static|Smoke::mf_enum, 218, 93},	//854 QsciLexerHTML::ASPJavaScriptDoubleQuotedString (enum)
    {65, 20, 0, 0, Smoke::mf_static|Smoke::mf_enum, 218, 94},	//855 QsciLexerHTML::ASPJavaScriptSingleQuotedString (enum)
    {65, 22, 0, 0, Smoke::mf_static|Smoke::mf_enum, 218, 95},	//856 QsciLexerHTML::ASPJavaScriptSymbol (enum)
    {65, 23, 0, 0, Smoke::mf_static|Smoke::mf_enum, 218, 96},	//857 QsciLexerHTML::ASPJavaScriptUnclosedString (enum)
    {65, 19, 0, 0, Smoke::mf_static|Smoke::mf_enum, 218, 97},	//858 QsciLexerHTML::ASPJavaScriptRegex (enum)
    {65, 740, 0, 0, Smoke::mf_static|Smoke::mf_enum, 218, 98},	//859 QsciLexerHTML::VBScriptStart (enum)
    {65, 736, 0, 0, Smoke::mf_static|Smoke::mf_enum, 218, 99},	//860 QsciLexerHTML::VBScriptDefault (enum)
    {65, 735, 0, 0, Smoke::mf_static|Smoke::mf_enum, 218, 100},	//861 QsciLexerHTML::VBScriptComment (enum)
    {65, 739, 0, 0, Smoke::mf_static|Smoke::mf_enum, 218, 101},	//862 QsciLexerHTML::VBScriptNumber (enum)
    {65, 738, 0, 0, Smoke::mf_static|Smoke::mf_enum, 218, 102},	//863 QsciLexerHTML::VBScriptKeyword (enum)
    {65, 741, 0, 0, Smoke::mf_static|Smoke::mf_enum, 218, 103},	//864 QsciLexerHTML::VBScriptString (enum)
    {65, 737, 0, 0, Smoke::mf_static|Smoke::mf_enum, 218, 104},	//865 QsciLexerHTML::VBScriptIdentifier (enum)
    {65, 742, 0, 0, Smoke::mf_static|Smoke::mf_enum, 218, 105},	//866 QsciLexerHTML::VBScriptUnclosedString (enum)
    {65, 44, 0, 0, Smoke::mf_static|Smoke::mf_enum, 218, 106},	//867 QsciLexerHTML::ASPVBScriptStart (enum)
    {65, 40, 0, 0, Smoke::mf_static|Smoke::mf_enum, 218, 107},	//868 QsciLexerHTML::ASPVBScriptDefault (enum)
    {65, 39, 0, 0, Smoke::mf_static|Smoke::mf_enum, 218, 108},	//869 QsciLexerHTML::ASPVBScriptComment (enum)
    {65, 43, 0, 0, Smoke::mf_static|Smoke::mf_enum, 218, 109},	//870 QsciLexerHTML::ASPVBScriptNumber (enum)
    {65, 42, 0, 0, Smoke::mf_static|Smoke::mf_enum, 218, 110},	//871 QsciLexerHTML::ASPVBScriptKeyword (enum)
    {65, 45, 0, 0, Smoke::mf_static|Smoke::mf_enum, 218, 111},	//872 QsciLexerHTML::ASPVBScriptString (enum)
    {65, 41, 0, 0, Smoke::mf_static|Smoke::mf_enum, 218, 112},	//873 QsciLexerHTML::ASPVBScriptIdentifier (enum)
    {65, 46, 0, 0, Smoke::mf_static|Smoke::mf_enum, 218, 113},	//874 QsciLexerHTML::ASPVBScriptUnclosedString (enum)
    {65, 451, 0, 0, Smoke::mf_static|Smoke::mf_enum, 218, 114},	//875 QsciLexerHTML::PythonStart (enum)
    {65, 443, 0, 0, Smoke::mf_static|Smoke::mf_enum, 218, 115},	//876 QsciLexerHTML::PythonDefault (enum)
    {65, 442, 0, 0, Smoke::mf_static|Smoke::mf_enum, 218, 116},	//877 QsciLexerHTML::PythonComment (enum)
    {65, 448, 0, 0, Smoke::mf_static|Smoke::mf_enum, 218, 117},	//878 QsciLexerHTML::PythonNumber (enum)
    {65, 444, 0, 0, Smoke::mf_static|Smoke::mf_enum, 218, 118},	//879 QsciLexerHTML::PythonDoubleQuotedString (enum)
    {65, 450, 0, 0, Smoke::mf_static|Smoke::mf_enum, 218, 119},	//880 QsciLexerHTML::PythonSingleQuotedString (enum)
    {65, 447, 0, 0, Smoke::mf_static|Smoke::mf_enum, 218, 120},	//881 QsciLexerHTML::PythonKeyword (enum)
    {65, 453, 0, 0, Smoke::mf_static|Smoke::mf_enum, 218, 121},	//882 QsciLexerHTML::PythonTripleSingleQuotedString (enum)
    {65, 452, 0, 0, Smoke::mf_static|Smoke::mf_enum, 218, 122},	//883 QsciLexerHTML::PythonTripleDoubleQuotedString (enum)
    {65, 441, 0, 0, Smoke::mf_static|Smoke::mf_enum, 218, 123},	//884 QsciLexerHTML::PythonClassName (enum)
    {65, 445, 0, 0, Smoke::mf_static|Smoke::mf_enum, 218, 124},	//885 QsciLexerHTML::PythonFunctionMethodName (enum)
    {65, 449, 0, 0, Smoke::mf_static|Smoke::mf_enum, 218, 125},	//886 QsciLexerHTML::PythonOperator (enum)
    {65, 446, 0, 0, Smoke::mf_static|Smoke::mf_enum, 218, 126},	//887 QsciLexerHTML::PythonIdentifier (enum)
    {65, 35, 0, 0, Smoke::mf_static|Smoke::mf_enum, 218, 127},	//888 QsciLexerHTML::ASPPythonStart (enum)
    {65, 27, 0, 0, Smoke::mf_static|Smoke::mf_enum, 218, 128},	//889 QsciLexerHTML::ASPPythonDefault (enum)
    {65, 26, 0, 0, Smoke::mf_static|Smoke::mf_enum, 218, 129},	//890 QsciLexerHTML::ASPPythonComment (enum)
    {65, 32, 0, 0, Smoke::mf_static|Smoke::mf_enum, 218, 130},	//891 QsciLexerHTML::ASPPythonNumber (enum)
    {65, 28, 0, 0, Smoke::mf_static|Smoke::mf_enum, 218, 131},	//892 QsciLexerHTML::ASPPythonDoubleQuotedString (enum)
    {65, 34, 0, 0, Smoke::mf_static|Smoke::mf_enum, 218, 132},	//893 QsciLexerHTML::ASPPythonSingleQuotedString (enum)
    {65, 31, 0, 0, Smoke::mf_static|Smoke::mf_enum, 218, 133},	//894 QsciLexerHTML::ASPPythonKeyword (enum)
    {65, 37, 0, 0, Smoke::mf_static|Smoke::mf_enum, 218, 134},	//895 QsciLexerHTML::ASPPythonTripleSingleQuotedString (enum)
    {65, 36, 0, 0, Smoke::mf_static|Smoke::mf_enum, 218, 135},	//896 QsciLexerHTML::ASPPythonTripleDoubleQuotedString (enum)
    {65, 25, 0, 0, Smoke::mf_static|Smoke::mf_enum, 218, 136},	//897 QsciLexerHTML::ASPPythonClassName (enum)
    {65, 29, 0, 0, Smoke::mf_static|Smoke::mf_enum, 218, 137},	//898 QsciLexerHTML::ASPPythonFunctionMethodName (enum)
    {65, 33, 0, 0, Smoke::mf_static|Smoke::mf_enum, 218, 138},	//899 QsciLexerHTML::ASPPythonOperator (enum)
    {65, 30, 0, 0, Smoke::mf_static|Smoke::mf_enum, 218, 139},	//900 QsciLexerHTML::ASPPythonIdentifier (enum)
    {65, 387, 0, 0, Smoke::mf_static|Smoke::mf_enum, 218, 140},	//901 QsciLexerHTML::PHPDefault (enum)
    {65, 388, 0, 0, Smoke::mf_static|Smoke::mf_enum, 218, 141},	//902 QsciLexerHTML::PHPDoubleQuotedString (enum)
    {65, 393, 0, 0, Smoke::mf_static|Smoke::mf_enum, 218, 142},	//903 QsciLexerHTML::PHPSingleQuotedString (enum)
    {65, 390, 0, 0, Smoke::mf_static|Smoke::mf_enum, 218, 143},	//904 QsciLexerHTML::PHPKeyword (enum)
    {65, 391, 0, 0, Smoke::mf_static|Smoke::mf_enum, 218, 144},	//905 QsciLexerHTML::PHPNumber (enum)
    {65, 395, 0, 0, Smoke::mf_static|Smoke::mf_enum, 218, 145},	//906 QsciLexerHTML::PHPVariable (enum)
    {65, 385, 0, 0, Smoke::mf_static|Smoke::mf_enum, 218, 146},	//907 QsciLexerHTML::PHPComment (enum)
    {65, 386, 0, 0, Smoke::mf_static|Smoke::mf_enum, 218, 147},	//908 QsciLexerHTML::PHPCommentLine (enum)
    {65, 389, 0, 0, Smoke::mf_static|Smoke::mf_enum, 218, 148},	//909 QsciLexerHTML::PHPDoubleQuotedVariable (enum)
    {65, 392, 0, 0, Smoke::mf_static|Smoke::mf_enum, 218, 149},	//910 QsciLexerHTML::PHPOperator (enum)
    {65, 1610, 0, 0, Smoke::mf_dtor, 0, 150 },	//911 QsciLexerHTML::~QsciLexerHTML()
    {66, 1105, 0, 0, Smoke::mf_const|Smoke::mf_virtual, 200, 1},	//912 QsciLexerIDL::metaObject() const
    {66, 1148, 12, 1, Smoke::mf_virtual, 221, 2},	//913 QsciLexerIDL::qt_metacast(const char*)
    {66, 1546, 42, 2, Smoke::mf_static, 40, 3},	//914 QsciLexerIDL::tr(const char*, const char*)
    {66, 1550, 42, 2, Smoke::mf_static, 40, 4},	//915 QsciLexerIDL::trUtf8(const char*, const char*)
    {66, 1546, 45, 3, Smoke::mf_static, 40, 5},	//916 QsciLexerIDL::tr(const char*, const char*, int)
    {66, 1550, 45, 3, Smoke::mf_static, 40, 6},	//917 QsciLexerIDL::trUtf8(const char*, const char*, int)
    {66, 1146, 49, 3, Smoke::mf_virtual, 215, 7},	//918 QsciLexerIDL::qt_metacall(QMetaObject::Call, int, void**)
    {66, 494, 74, 1, Smoke::mf_ctor, 71, 8},	//919 QsciLexerIDL::QsciLexerIDL(QObject*)
    {66, 1049, 0, 0, Smoke::mf_const|Smoke::mf_virtual, 213, 9},	//920 QsciLexerIDL::language() const
    {66, 890, 18, 1, Smoke::mf_const|Smoke::mf_virtual, 6, 10},	//921 QsciLexerIDL::defaultColor(int) const
    {66, 1047, 18, 1, Smoke::mf_const|Smoke::mf_virtual, 213, 11},	//922 QsciLexerIDL::keywords(int) const
    {66, 900, 18, 1, Smoke::mf_const|Smoke::mf_virtual, 40, 12},	//923 QsciLexerIDL::description(int) const
    {66, 1546, 12, 1, Smoke::mf_static, 40, 13},	//924 QsciLexerIDL::tr(const char*)
    {66, 1550, 12, 1, Smoke::mf_static, 40, 14},	//925 QsciLexerIDL::trUtf8(const char*)
    {66, 494, 0, 0, Smoke::mf_ctor, 71, 15},	//926 QsciLexerIDL::QsciLexerIDL()
    {66, 1523, 0, 0, Smoke::mf_const|Smoke::mf_static|Smoke::mf_attribute, 199, 16},	//927 QsciLexerIDL::staticMetaObject() const
    {66, 1611, 0, 0, Smoke::mf_dtor, 0, 17 },	//928 QsciLexerIDL::~QsciLexerIDL()
    {67, 1105, 0, 0, Smoke::mf_const|Smoke::mf_virtual, 200, 1},	//929 QsciLexerJava::metaObject() const
    {67, 1148, 12, 1, Smoke::mf_virtual, 221, 2},	//930 QsciLexerJava::qt_metacast(const char*)
    {67, 1546, 42, 2, Smoke::mf_static, 40, 3},	//931 QsciLexerJava::tr(const char*, const char*)
    {67, 1550, 42, 2, Smoke::mf_static, 40, 4},	//932 QsciLexerJava::trUtf8(const char*, const char*)
    {67, 1546, 45, 3, Smoke::mf_static, 40, 5},	//933 QsciLexerJava::tr(const char*, const char*, int)
    {67, 1550, 45, 3, Smoke::mf_static, 40, 6},	//934 QsciLexerJava::trUtf8(const char*, const char*, int)
    {67, 1146, 49, 3, Smoke::mf_virtual, 215, 7},	//935 QsciLexerJava::qt_metacall(QMetaObject::Call, int, void**)
    {67, 496, 74, 1, Smoke::mf_ctor, 72, 8},	//936 QsciLexerJava::QsciLexerJava(QObject*)
    {67, 1049, 0, 0, Smoke::mf_const|Smoke::mf_virtual, 213, 9},	//937 QsciLexerJava::language() const
    {67, 1047, 18, 1, Smoke::mf_const|Smoke::mf_virtual, 213, 10},	//938 QsciLexerJava::keywords(int) const
    {67, 1546, 12, 1, Smoke::mf_static, 40, 11},	//939 QsciLexerJava::tr(const char*)
    {67, 1550, 12, 1, Smoke::mf_static, 40, 12},	//940 QsciLexerJava::trUtf8(const char*)
    {67, 496, 0, 0, Smoke::mf_ctor, 72, 13},	//941 QsciLexerJava::QsciLexerJava()
    {67, 1523, 0, 0, Smoke::mf_const|Smoke::mf_static|Smoke::mf_attribute, 199, 14},	//942 QsciLexerJava::staticMetaObject() const
    {67, 1612, 0, 0, Smoke::mf_dtor, 0, 15 },	//943 QsciLexerJava::~QsciLexerJava()
    {68, 1105, 0, 0, Smoke::mf_const|Smoke::mf_virtual, 200, 1},	//944 QsciLexerJavaScript::metaObject() const
    {68, 1148, 12, 1, Smoke::mf_virtual, 221, 2},	//945 QsciLexerJavaScript::qt_metacast(const char*)
    {68, 1546, 42, 2, Smoke::mf_static, 40, 3},	//946 QsciLexerJavaScript::tr(const char*, const char*)
    {68, 1550, 42, 2, Smoke::mf_static, 40, 4},	//947 QsciLexerJavaScript::trUtf8(const char*, const char*)
    {68, 1546, 45, 3, Smoke::mf_static, 40, 5},	//948 QsciLexerJavaScript::tr(const char*, const char*, int)
    {68, 1550, 45, 3, Smoke::mf_static, 40, 6},	//949 QsciLexerJavaScript::trUtf8(const char*, const char*, int)
    {68, 1146, 49, 3, Smoke::mf_virtual, 215, 7},	//950 QsciLexerJavaScript::qt_metacall(QMetaObject::Call, int, void**)
    {68, 498, 74, 1, Smoke::mf_ctor, 73, 8},	//951 QsciLexerJavaScript::QsciLexerJavaScript(QObject*)
    {68, 1049, 0, 0, Smoke::mf_const|Smoke::mf_virtual, 213, 9},	//952 QsciLexerJavaScript::language() const
    {68, 890, 18, 1, Smoke::mf_const|Smoke::mf_virtual, 6, 10},	//953 QsciLexerJavaScript::defaultColor(int) const
    {68, 892, 18, 1, Smoke::mf_const|Smoke::mf_virtual, 189, 11},	//954 QsciLexerJavaScript::defaultEolFill(int) const
    {68, 894, 18, 1, Smoke::mf_const|Smoke::mf_virtual, 14, 12},	//955 QsciLexerJavaScript::defaultFont(int) const
    {68, 896, 18, 1, Smoke::mf_const|Smoke::mf_virtual, 6, 13},	//956 QsciLexerJavaScript::defaultPaper(int) const
    {68, 1047, 18, 1, Smoke::mf_const|Smoke::mf_virtual, 213, 14},	//957 QsciLexerJavaScript::keywords(int) const
    {68, 900, 18, 1, Smoke::mf_const|Smoke::mf_virtual, 40, 15},	//958 QsciLexerJavaScript::description(int) const
    {68, 1546, 12, 1, Smoke::mf_static, 40, 16},	//959 QsciLexerJavaScript::tr(const char*)
    {68, 1550, 12, 1, Smoke::mf_static, 40, 17},	//960 QsciLexerJavaScript::trUtf8(const char*)
    {68, 498, 0, 0, Smoke::mf_ctor, 73, 18},	//961 QsciLexerJavaScript::QsciLexerJavaScript()
    {68, 1523, 0, 0, Smoke::mf_const|Smoke::mf_static|Smoke::mf_attribute, 199, 19},	//962 QsciLexerJavaScript::staticMetaObject() const
    {68, 1613, 0, 0, Smoke::mf_dtor, 0, 20 },	//963 QsciLexerJavaScript::~QsciLexerJavaScript()
    {69, 1105, 0, 0, Smoke::mf_const|Smoke::mf_virtual, 200, 1},	//964 QsciLexerLua::metaObject() const
    {69, 1148, 12, 1, Smoke::mf_virtual, 221, 2},	//965 QsciLexerLua::qt_metacast(const char*)
    {69, 1546, 42, 2, Smoke::mf_static, 40, 3},	//966 QsciLexerLua::tr(const char*, const char*)
    {69, 1550, 42, 2, Smoke::mf_static, 40, 4},	//967 QsciLexerLua::trUtf8(const char*, const char*)
    {69, 1546, 45, 3, Smoke::mf_static, 40, 5},	//968 QsciLexerLua::tr(const char*, const char*, int)
    {69, 1550, 45, 3, Smoke::mf_static, 40, 6},	//969 QsciLexerLua::trUtf8(const char*, const char*, int)
    {69, 1146, 49, 3, Smoke::mf_virtual, 215, 7},	//970 QsciLexerLua::qt_metacall(QMetaObject::Call, int, void**)
    {69, 500, 74, 1, Smoke::mf_ctor, 74, 8},	//971 QsciLexerLua::QsciLexerLua(QObject*)
    {69, 1049, 0, 0, Smoke::mf_const|Smoke::mf_virtual, 213, 9},	//972 QsciLexerLua::language() const
    {69, 1054, 0, 0, Smoke::mf_const|Smoke::mf_virtual, 213, 10},	//973 QsciLexerLua::lexer() const
    {69, 821, 0, 0, Smoke::mf_const|Smoke::mf_virtual, 41, 11},	//974 QsciLexerLua::autoCompletionWordSeparators() const
    {69, 830, 76, 1, Smoke::mf_const|Smoke::mf_virtual, 213, 12},	//975 QsciLexerLua::blockStart(int*) const
    {69, 837, 0, 0, Smoke::mf_const|Smoke::mf_virtual, 215, 13},	//976 QsciLexerLua::braceStyle() const
    {69, 890, 18, 1, Smoke::mf_const|Smoke::mf_virtual, 6, 14},	//977 QsciLexerLua::defaultColor(int) const
    {69, 892, 18, 1, Smoke::mf_const|Smoke::mf_virtual, 189, 15},	//978 QsciLexerLua::defaultEolFill(int) const
    {69, 894, 18, 1, Smoke::mf_const|Smoke::mf_virtual, 14, 16},	//979 QsciLexerLua::defaultFont(int) const
    {69, 896, 18, 1, Smoke::mf_const|Smoke::mf_virtual, 6, 17},	//980 QsciLexerLua::defaultPaper(int) const
    {69, 1047, 18, 1, Smoke::mf_const|Smoke::mf_virtual, 213, 18},	//981 QsciLexerLua::keywords(int) const
    {69, 900, 18, 1, Smoke::mf_const|Smoke::mf_virtual, 40, 19},	//982 QsciLexerLua::description(int) const
    {69, 1163, 0, 0, Smoke::mf_virtual, 0, 20},	//983 QsciLexerLua::refreshProperties()
    {69, 969, 0, 0, Smoke::mf_const, 189, 21},	//984 QsciLexerLua::foldCompact() const
    {69, 1304, 16, 1, Smoke::mf_virtual|Smoke::mf_slot, 0, 22},	//985 QsciLexerLua::setFoldCompact(bool)
    {69, 1153, 93, 2, Smoke::mf_protected|Smoke::mf_virtual, 189, 23},	//986 QsciLexerLua::readProperties(QSettings&, const QString&)
    {69, 1582, 93, 2, Smoke::mf_const|Smoke::mf_protected|Smoke::mf_virtual, 189, 24},	//987 QsciLexerLua::writeProperties(QSettings&, const QString&) const
    {69, 1546, 12, 1, Smoke::mf_static, 40, 25},	//988 QsciLexerLua::tr(const char*)
    {69, 1550, 12, 1, Smoke::mf_static, 40, 26},	//989 QsciLexerLua::trUtf8(const char*)
    {69, 500, 0, 0, Smoke::mf_ctor, 74, 27},	//990 QsciLexerLua::QsciLexerLua()
    {69, 830, 0, 0, Smoke::mf_const, 213, 28},	//991 QsciLexerLua::blockStart() const
    {69, 1523, 0, 0, Smoke::mf_const|Smoke::mf_static|Smoke::mf_attribute, 199, 29},	//992 QsciLexerLua::staticMetaObject() const
    {69, 160, 0, 0, Smoke::mf_static|Smoke::mf_enum, 218, 30},	//993 QsciLexerLua::Default (enum)
    {69, 139, 0, 0, Smoke::mf_static|Smoke::mf_enum, 218, 31},	//994 QsciLexerLua::Comment (enum)
    {69, 331, 0, 0, Smoke::mf_static|Smoke::mf_enum, 218, 32},	//995 QsciLexerLua::LineComment (enum)
    {69, 378, 0, 0, Smoke::mf_static|Smoke::mf_enum, 218, 33},	//996 QsciLexerLua::Number (enum)
    {69, 307, 0, 0, Smoke::mf_static|Smoke::mf_enum, 218, 34},	//997 QsciLexerLua::Keyword (enum)
    {69, 677, 0, 0, Smoke::mf_static|Smoke::mf_enum, 218, 35},	//998 QsciLexerLua::String (enum)
    {69, 124, 0, 0, Smoke::mf_static|Smoke::mf_enum, 218, 36},	//999 QsciLexerLua::Character (enum)
    {69, 354, 0, 0, Smoke::mf_static|Smoke::mf_enum, 218, 37},	//1000 QsciLexerLua::LiteralString (enum)
    {69, 436, 0, 0, Smoke::mf_static|Smoke::mf_enum, 218, 38},	//1001 QsciLexerLua::Preprocessor (enum)
    {69, 382, 0, 0, Smoke::mf_static|Smoke::mf_enum, 218, 39},	//1002 QsciLexerLua::Operator (enum)
    {69, 255, 0, 0, Smoke::mf_static|Smoke::mf_enum, 218, 40},	//1003 QsciLexerLua::Identifier (enum)
    {69, 726, 0, 0, Smoke::mf_static|Smoke::mf_enum, 218, 41},	//1004 QsciLexerLua::UnclosedString (enum)
    {69, 90, 0, 0, Smoke::mf_static|Smoke::mf_enum, 218, 42},	//1005 QsciLexerLua::BasicFunctions (enum)
    {69, 680, 0, 0, Smoke::mf_static|Smoke::mf_enum, 218, 43},	//1006 QsciLexerLua::StringTableMathsFunctions (enum)
    {69, 151, 0, 0, Smoke::mf_static|Smoke::mf_enum, 218, 44},	//1007 QsciLexerLua::CoroutinesIOSystemFacilities (enum)
    {69, 312, 0, 0, Smoke::mf_static|Smoke::mf_enum, 218, 45},	//1008 QsciLexerLua::KeywordSet5 (enum)
    {69, 313, 0, 0, Smoke::mf_static|Smoke::mf_enum, 218, 46},	//1009 QsciLexerLua::KeywordSet6 (enum)
    {69, 314, 0, 0, Smoke::mf_static|Smoke::mf_enum, 218, 47},	//1010 QsciLexerLua::KeywordSet7 (enum)
    {69, 315, 0, 0, Smoke::mf_static|Smoke::mf_enum, 218, 48},	//1011 QsciLexerLua::KeywordSet8 (enum)
    {69, 317, 0, 0, Smoke::mf_static|Smoke::mf_enum, 218, 49},	//1012 QsciLexerLua::Label (enum)
    {69, 1614, 0, 0, Smoke::mf_dtor, 0, 50 },	//1013 QsciLexerLua::~QsciLexerLua()
    {70, 1105, 0, 0, Smoke::mf_const|Smoke::mf_virtual, 200, 1},	//1014 QsciLexerMakefile::metaObject() const
    {70, 1148, 12, 1, Smoke::mf_virtual, 221, 2},	//1015 QsciLexerMakefile::qt_metacast(const char*)
    {70, 1546, 42, 2, Smoke::mf_static, 40, 3},	//1016 QsciLexerMakefile::tr(const char*, const char*)
    {70, 1550, 42, 2, Smoke::mf_static, 40, 4},	//1017 QsciLexerMakefile::trUtf8(const char*, const char*)
    {70, 1546, 45, 3, Smoke::mf_static, 40, 5},	//1018 QsciLexerMakefile::tr(const char*, const char*, int)
    {70, 1550, 45, 3, Smoke::mf_static, 40, 6},	//1019 QsciLexerMakefile::trUtf8(const char*, const char*, int)
    {70, 1146, 49, 3, Smoke::mf_virtual, 215, 7},	//1020 QsciLexerMakefile::qt_metacall(QMetaObject::Call, int, void**)
    {70, 502, 74, 1, Smoke::mf_ctor, 75, 8},	//1021 QsciLexerMakefile::QsciLexerMakefile(QObject*)
    {70, 1049, 0, 0, Smoke::mf_const|Smoke::mf_virtual, 213, 9},	//1022 QsciLexerMakefile::language() const
    {70, 1054, 0, 0, Smoke::mf_const|Smoke::mf_virtual, 213, 10},	//1023 QsciLexerMakefile::lexer() const
    {70, 1577, 0, 0, Smoke::mf_const|Smoke::mf_virtual, 213, 11},	//1024 QsciLexerMakefile::wordCharacters() const
    {70, 890, 18, 1, Smoke::mf_const|Smoke::mf_virtual, 6, 12},	//1025 QsciLexerMakefile::defaultColor(int) const
    {70, 892, 18, 1, Smoke::mf_const|Smoke::mf_virtual, 189, 13},	//1026 QsciLexerMakefile::defaultEolFill(int) const
    {70, 894, 18, 1, Smoke::mf_const|Smoke::mf_virtual, 14, 14},	//1027 QsciLexerMakefile::defaultFont(int) const
    {70, 896, 18, 1, Smoke::mf_const|Smoke::mf_virtual, 6, 15},	//1028 QsciLexerMakefile::defaultPaper(int) const
    {70, 900, 18, 1, Smoke::mf_const|Smoke::mf_virtual, 40, 16},	//1029 QsciLexerMakefile::description(int) const
    {70, 1546, 12, 1, Smoke::mf_static, 40, 17},	//1030 QsciLexerMakefile::tr(const char*)
    {70, 1550, 12, 1, Smoke::mf_static, 40, 18},	//1031 QsciLexerMakefile::trUtf8(const char*)
    {70, 502, 0, 0, Smoke::mf_ctor, 75, 19},	//1032 QsciLexerMakefile::QsciLexerMakefile()
    {70, 1523, 0, 0, Smoke::mf_const|Smoke::mf_static|Smoke::mf_attribute, 199, 20},	//1033 QsciLexerMakefile::staticMetaObject() const
    {70, 160, 0, 0, Smoke::mf_static|Smoke::mf_enum, 218, 21},	//1034 QsciLexerMakefile::Default (enum)
    {70, 139, 0, 0, Smoke::mf_static|Smoke::mf_enum, 218, 22},	//1035 QsciLexerMakefile::Comment (enum)
    {70, 436, 0, 0, Smoke::mf_static|Smoke::mf_enum, 218, 23},	//1036 QsciLexerMakefile::Preprocessor (enum)
    {70, 750, 0, 0, Smoke::mf_static|Smoke::mf_enum, 218, 24},	//1037 QsciLexerMakefile::Variable (enum)
    {70, 382, 0, 0, Smoke::mf_static|Smoke::mf_enum, 218, 25},	//1038 QsciLexerMakefile::Operator (enum)
    {70, 705, 0, 0, Smoke::mf_static|Smoke::mf_enum, 218, 26},	//1039 QsciLexerMakefile::Target (enum)
    {70, 205, 0, 0, Smoke::mf_static|Smoke::mf_enum, 218, 27},	//1040 QsciLexerMakefile::Error (enum)
    {70, 1615, 0, 0, Smoke::mf_dtor, 0, 28 },	//1041 QsciLexerMakefile::~QsciLexerMakefile()
    {71, 1105, 0, 0, Smoke::mf_const|Smoke::mf_virtual, 200, 1},	//1042 QsciLexerPOV::metaObject() const
    {71, 1148, 12, 1, Smoke::mf_virtual, 221, 2},	//1043 QsciLexerPOV::qt_metacast(const char*)
    {71, 1546, 42, 2, Smoke::mf_static, 40, 3},	//1044 QsciLexerPOV::tr(const char*, const char*)
    {71, 1550, 42, 2, Smoke::mf_static, 40, 4},	//1045 QsciLexerPOV::trUtf8(const char*, const char*)
    {71, 1546, 45, 3, Smoke::mf_static, 40, 5},	//1046 QsciLexerPOV::tr(const char*, const char*, int)
    {71, 1550, 45, 3, Smoke::mf_static, 40, 6},	//1047 QsciLexerPOV::trUtf8(const char*, const char*, int)
    {71, 1146, 49, 3, Smoke::mf_virtual, 215, 7},	//1048 QsciLexerPOV::qt_metacall(QMetaObject::Call, int, void**)
    {71, 504, 74, 1, Smoke::mf_ctor, 76, 8},	//1049 QsciLexerPOV::QsciLexerPOV(QObject*)
    {71, 1049, 0, 0, Smoke::mf_const|Smoke::mf_virtual, 213, 9},	//1050 QsciLexerPOV::language() const
    {71, 1054, 0, 0, Smoke::mf_const|Smoke::mf_virtual, 213, 10},	//1051 QsciLexerPOV::lexer() const
    {71, 837, 0, 0, Smoke::mf_const|Smoke::mf_virtual, 215, 11},	//1052 QsciLexerPOV::braceStyle() const
    {71, 1577, 0, 0, Smoke::mf_const|Smoke::mf_virtual, 213, 12},	//1053 QsciLexerPOV::wordCharacters() const
    {71, 890, 18, 1, Smoke::mf_const|Smoke::mf_virtual, 6, 13},	//1054 QsciLexerPOV::defaultColor(int) const
    {71, 892, 18, 1, Smoke::mf_const|Smoke::mf_virtual, 189, 14},	//1055 QsciLexerPOV::defaultEolFill(int) const
    {71, 894, 18, 1, Smoke::mf_const|Smoke::mf_virtual, 14, 15},	//1056 QsciLexerPOV::defaultFont(int) const
    {71, 896, 18, 1, Smoke::mf_const|Smoke::mf_virtual, 6, 16},	//1057 QsciLexerPOV::defaultPaper(int) const
    {71, 1047, 18, 1, Smoke::mf_const|Smoke::mf_virtual, 213, 17},	//1058 QsciLexerPOV::keywords(int) const
    {71, 900, 18, 1, Smoke::mf_const|Smoke::mf_virtual, 40, 18},	//1059 QsciLexerPOV::description(int) const
    {71, 1163, 0, 0, Smoke::mf_virtual, 0, 19},	//1060 QsciLexerPOV::refreshProperties()
    {71, 968, 0, 0, Smoke::mf_const, 189, 20},	//1061 QsciLexerPOV::foldComments() const
    {71, 969, 0, 0, Smoke::mf_const, 189, 21},	//1062 QsciLexerPOV::foldCompact() const
    {71, 970, 0, 0, Smoke::mf_const, 189, 22},	//1063 QsciLexerPOV::foldDirectives() const
    {71, 1302, 16, 1, Smoke::mf_virtual|Smoke::mf_slot, 0, 23},	//1064 QsciLexerPOV::setFoldComments(bool)
    {71, 1304, 16, 1, Smoke::mf_virtual|Smoke::mf_slot, 0, 24},	//1065 QsciLexerPOV::setFoldCompact(bool)
    {71, 1306, 16, 1, Smoke::mf_virtual|Smoke::mf_slot, 0, 25},	//1066 QsciLexerPOV::setFoldDirectives(bool)
    {71, 1153, 93, 2, Smoke::mf_protected|Smoke::mf_virtual, 189, 26},	//1067 QsciLexerPOV::readProperties(QSettings&, const QString&)
    {71, 1582, 93, 2, Smoke::mf_const|Smoke::mf_protected|Smoke::mf_virtual, 189, 27},	//1068 QsciLexerPOV::writeProperties(QSettings&, const QString&) const
    {71, 1546, 12, 1, Smoke::mf_static, 40, 28},	//1069 QsciLexerPOV::tr(const char*)
    {71, 1550, 12, 1, Smoke::mf_static, 40, 29},	//1070 QsciLexerPOV::trUtf8(const char*)
    {71, 504, 0, 0, Smoke::mf_ctor, 76, 30},	//1071 QsciLexerPOV::QsciLexerPOV()
    {71, 1523, 0, 0, Smoke::mf_const|Smoke::mf_static|Smoke::mf_attribute, 199, 31},	//1072 QsciLexerPOV::staticMetaObject() const
    {71, 160, 0, 0, Smoke::mf_static|Smoke::mf_enum, 218, 32},	//1073 QsciLexerPOV::Default (enum)
    {71, 139, 0, 0, Smoke::mf_static|Smoke::mf_enum, 218, 33},	//1074 QsciLexerPOV::Comment (enum)
    {71, 145, 0, 0, Smoke::mf_static|Smoke::mf_enum, 218, 34},	//1075 QsciLexerPOV::CommentLine (enum)
    {71, 378, 0, 0, Smoke::mf_static|Smoke::mf_enum, 218, 35},	//1076 QsciLexerPOV::Number (enum)
    {71, 382, 0, 0, Smoke::mf_static|Smoke::mf_enum, 218, 36},	//1077 QsciLexerPOV::Operator (enum)
    {71, 255, 0, 0, Smoke::mf_static|Smoke::mf_enum, 218, 37},	//1078 QsciLexerPOV::Identifier (enum)
    {71, 677, 0, 0, Smoke::mf_static|Smoke::mf_enum, 218, 38},	//1079 QsciLexerPOV::String (enum)
    {71, 726, 0, 0, Smoke::mf_static|Smoke::mf_enum, 218, 39},	//1080 QsciLexerPOV::UnclosedString (enum)
    {71, 175, 0, 0, Smoke::mf_static|Smoke::mf_enum, 218, 40},	//1081 QsciLexerPOV::Directive (enum)
    {71, 87, 0, 0, Smoke::mf_static|Smoke::mf_enum, 218, 41},	//1082 QsciLexerPOV::BadDirective (enum)
    {71, 380, 0, 0, Smoke::mf_static|Smoke::mf_enum, 218, 42},	//1083 QsciLexerPOV::ObjectsCSGAppearance (enum)
    {71, 724, 0, 0, Smoke::mf_static|Smoke::mf_enum, 218, 43},	//1084 QsciLexerPOV::TypesModifiersItems (enum)
    {71, 435, 0, 0, Smoke::mf_static|Smoke::mf_enum, 218, 44},	//1085 QsciLexerPOV::PredefinedIdentifiers (enum)
    {71, 434, 0, 0, Smoke::mf_static|Smoke::mf_enum, 218, 45},	//1086 QsciLexerPOV::PredefinedFunctions (enum)
    {71, 313, 0, 0, Smoke::mf_static|Smoke::mf_enum, 218, 46},	//1087 QsciLexerPOV::KeywordSet6 (enum)
    {71, 314, 0, 0, Smoke::mf_static|Smoke::mf_enum, 218, 47},	//1088 QsciLexerPOV::KeywordSet7 (enum)
    {71, 315, 0, 0, Smoke::mf_static|Smoke::mf_enum, 218, 48},	//1089 QsciLexerPOV::KeywordSet8 (enum)
    {71, 1616, 0, 0, Smoke::mf_dtor, 0, 49 },	//1090 QsciLexerPOV::~QsciLexerPOV()
    {72, 1105, 0, 0, Smoke::mf_const|Smoke::mf_virtual, 200, 1},	//1091 QsciLexerPascal::metaObject() const
    {72, 1148, 12, 1, Smoke::mf_virtual, 221, 2},	//1092 QsciLexerPascal::qt_metacast(const char*)
    {72, 1546, 42, 2, Smoke::mf_static, 40, 3},	//1093 QsciLexerPascal::tr(const char*, const char*)
    {72, 1550, 42, 2, Smoke::mf_static, 40, 4},	//1094 QsciLexerPascal::trUtf8(const char*, const char*)
    {72, 1546, 45, 3, Smoke::mf_static, 40, 5},	//1095 QsciLexerPascal::tr(const char*, const char*, int)
    {72, 1550, 45, 3, Smoke::mf_static, 40, 6},	//1096 QsciLexerPascal::trUtf8(const char*, const char*, int)
    {72, 1146, 49, 3, Smoke::mf_virtual, 215, 7},	//1097 QsciLexerPascal::qt_metacall(QMetaObject::Call, int, void**)
    {72, 506, 74, 1, Smoke::mf_ctor, 77, 8},	//1098 QsciLexerPascal::QsciLexerPascal(QObject*)
    {72, 1049, 0, 0, Smoke::mf_const|Smoke::mf_virtual, 213, 9},	//1099 QsciLexerPascal::language() const
    {72, 1054, 0, 0, Smoke::mf_const|Smoke::mf_virtual, 213, 10},	//1100 QsciLexerPascal::lexer() const
    {72, 821, 0, 0, Smoke::mf_const|Smoke::mf_virtual, 41, 11},	//1101 QsciLexerPascal::autoCompletionWordSeparators() const
    {72, 827, 76, 1, Smoke::mf_const|Smoke::mf_virtual, 213, 12},	//1102 QsciLexerPascal::blockEnd(int*) const
    {72, 830, 76, 1, Smoke::mf_const|Smoke::mf_virtual, 213, 13},	//1103 QsciLexerPascal::blockStart(int*) const
    {72, 832, 76, 1, Smoke::mf_const|Smoke::mf_virtual, 213, 14},	//1104 QsciLexerPascal::blockStartKeyword(int*) const
    {72, 837, 0, 0, Smoke::mf_const|Smoke::mf_virtual, 215, 15},	//1105 QsciLexerPascal::braceStyle() const
    {72, 890, 18, 1, Smoke::mf_const|Smoke::mf_virtual, 6, 16},	//1106 QsciLexerPascal::defaultColor(int) const
    {72, 892, 18, 1, Smoke::mf_const|Smoke::mf_virtual, 189, 17},	//1107 QsciLexerPascal::defaultEolFill(int) const
    {72, 894, 18, 1, Smoke::mf_const|Smoke::mf_virtual, 14, 18},	//1108 QsciLexerPascal::defaultFont(int) const
    {72, 896, 18, 1, Smoke::mf_const|Smoke::mf_virtual, 6, 19},	//1109 QsciLexerPascal::defaultPaper(int) const
    {72, 1047, 18, 1, Smoke::mf_const|Smoke::mf_virtual, 213, 20},	//1110 QsciLexerPascal::keywords(int) const
    {72, 900, 18, 1, Smoke::mf_const|Smoke::mf_virtual, 40, 21},	//1111 QsciLexerPascal::description(int) const
    {72, 1163, 0, 0, Smoke::mf_virtual, 0, 22},	//1112 QsciLexerPascal::refreshProperties()
    {72, 968, 0, 0, Smoke::mf_const, 189, 23},	//1113 QsciLexerPascal::foldComments() const
    {72, 969, 0, 0, Smoke::mf_const, 189, 24},	//1114 QsciLexerPascal::foldCompact() const
    {72, 976, 0, 0, Smoke::mf_const, 189, 25},	//1115 QsciLexerPascal::foldPreprocessor() const
    {72, 1460, 16, 1, 0, 0, 26},	//1116 QsciLexerPascal::setSmartHighlighting(bool)
    {72, 1517, 0, 0, Smoke::mf_const, 189, 27},	//1117 QsciLexerPascal::smartHighlighting() const
    {72, 1302, 16, 1, Smoke::mf_virtual|Smoke::mf_slot, 0, 28},	//1118 QsciLexerPascal::setFoldComments(bool)
    {72, 1304, 16, 1, Smoke::mf_virtual|Smoke::mf_slot, 0, 29},	//1119 QsciLexerPascal::setFoldCompact(bool)
    {72, 1316, 16, 1, Smoke::mf_virtual|Smoke::mf_slot, 0, 30},	//1120 QsciLexerPascal::setFoldPreprocessor(bool)
    {72, 1153, 93, 2, Smoke::mf_protected|Smoke::mf_virtual, 189, 31},	//1121 QsciLexerPascal::readProperties(QSettings&, const QString&)
    {72, 1582, 93, 2, Smoke::mf_const|Smoke::mf_protected|Smoke::mf_virtual, 189, 32},	//1122 QsciLexerPascal::writeProperties(QSettings&, const QString&) const
    {72, 1546, 12, 1, Smoke::mf_static, 40, 33},	//1123 QsciLexerPascal::tr(const char*)
    {72, 1550, 12, 1, Smoke::mf_static, 40, 34},	//1124 QsciLexerPascal::trUtf8(const char*)
    {72, 506, 0, 0, Smoke::mf_ctor, 77, 35},	//1125 QsciLexerPascal::QsciLexerPascal()
    {72, 827, 0, 0, Smoke::mf_const, 213, 36},	//1126 QsciLexerPascal::blockEnd() const
    {72, 830, 0, 0, Smoke::mf_const, 213, 37},	//1127 QsciLexerPascal::blockStart() const
    {72, 832, 0, 0, Smoke::mf_const, 213, 38},	//1128 QsciLexerPascal::blockStartKeyword() const
    {72, 1523, 0, 0, Smoke::mf_const|Smoke::mf_static|Smoke::mf_attribute, 199, 39},	//1129 QsciLexerPascal::staticMetaObject() const
    {72, 160, 0, 0, Smoke::mf_static|Smoke::mf_enum, 218, 40},	//1130 QsciLexerPascal::Default (enum)
    {72, 255, 0, 0, Smoke::mf_static|Smoke::mf_enum, 218, 41},	//1131 QsciLexerPascal::Identifier (enum)
    {72, 139, 0, 0, Smoke::mf_static|Smoke::mf_enum, 218, 42},	//1132 QsciLexerPascal::Comment (enum)
    {72, 149, 0, 0, Smoke::mf_static|Smoke::mf_enum, 218, 43},	//1133 QsciLexerPascal::CommentParenthesis (enum)
    {72, 145, 0, 0, Smoke::mf_static|Smoke::mf_enum, 218, 44},	//1134 QsciLexerPascal::CommentLine (enum)
    {72, 430, 0, 0, Smoke::mf_static|Smoke::mf_enum, 218, 45},	//1135 QsciLexerPascal::PreProcessor (enum)
    {72, 433, 0, 0, Smoke::mf_static|Smoke::mf_enum, 218, 46},	//1136 QsciLexerPascal::PreProcessorParenthesis (enum)
    {72, 378, 0, 0, Smoke::mf_static|Smoke::mf_enum, 218, 47},	//1137 QsciLexerPascal::Number (enum)
    {72, 240, 0, 0, Smoke::mf_static|Smoke::mf_enum, 218, 48},	//1138 QsciLexerPascal::HexNumber (enum)
    {72, 307, 0, 0, Smoke::mf_static|Smoke::mf_enum, 218, 49},	//1139 QsciLexerPascal::Keyword (enum)
    {72, 658, 0, 0, Smoke::mf_static|Smoke::mf_enum, 218, 50},	//1140 QsciLexerPascal::SingleQuotedString (enum)
    {72, 726, 0, 0, Smoke::mf_static|Smoke::mf_enum, 218, 51},	//1141 QsciLexerPascal::UnclosedString (enum)
    {72, 124, 0, 0, Smoke::mf_static|Smoke::mf_enum, 218, 52},	//1142 QsciLexerPascal::Character (enum)
    {72, 382, 0, 0, Smoke::mf_static|Smoke::mf_enum, 218, 53},	//1143 QsciLexerPascal::Operator (enum)
    {72, 64, 0, 0, Smoke::mf_static|Smoke::mf_enum, 218, 54},	//1144 QsciLexerPascal::Asm (enum)
    {72, 1617, 0, 0, Smoke::mf_dtor, 0, 55 },	//1145 QsciLexerPascal::~QsciLexerPascal()
    {73, 1105, 0, 0, Smoke::mf_const|Smoke::mf_virtual, 200, 1},	//1146 QsciLexerPerl::metaObject() const
    {73, 1148, 12, 1, Smoke::mf_virtual, 221, 2},	//1147 QsciLexerPerl::qt_metacast(const char*)
    {73, 1546, 42, 2, Smoke::mf_static, 40, 3},	//1148 QsciLexerPerl::tr(const char*, const char*)
    {73, 1550, 42, 2, Smoke::mf_static, 40, 4},	//1149 QsciLexerPerl::trUtf8(const char*, const char*)
    {73, 1546, 45, 3, Smoke::mf_static, 40, 5},	//1150 QsciLexerPerl::tr(const char*, const char*, int)
    {73, 1550, 45, 3, Smoke::mf_static, 40, 6},	//1151 QsciLexerPerl::trUtf8(const char*, const char*, int)
    {73, 1146, 49, 3, Smoke::mf_virtual, 215, 7},	//1152 QsciLexerPerl::qt_metacall(QMetaObject::Call, int, void**)
    {73, 508, 74, 1, Smoke::mf_ctor, 78, 8},	//1153 QsciLexerPerl::QsciLexerPerl(QObject*)
    {73, 1049, 0, 0, Smoke::mf_const|Smoke::mf_virtual, 213, 9},	//1154 QsciLexerPerl::language() const
    {73, 1054, 0, 0, Smoke::mf_const|Smoke::mf_virtual, 213, 10},	//1155 QsciLexerPerl::lexer() const
    {73, 821, 0, 0, Smoke::mf_const|Smoke::mf_virtual, 41, 11},	//1156 QsciLexerPerl::autoCompletionWordSeparators() const
    {73, 827, 76, 1, Smoke::mf_const|Smoke::mf_virtual, 213, 12},	//1157 QsciLexerPerl::blockEnd(int*) const
    {73, 830, 76, 1, Smoke::mf_const|Smoke::mf_virtual, 213, 13},	//1158 QsciLexerPerl::blockStart(int*) const
    {73, 837, 0, 0, Smoke::mf_const|Smoke::mf_virtual, 215, 14},	//1159 QsciLexerPerl::braceStyle() const
    {73, 1577, 0, 0, Smoke::mf_const|Smoke::mf_virtual, 213, 15},	//1160 QsciLexerPerl::wordCharacters() const
    {73, 890, 18, 1, Smoke::mf_const|Smoke::mf_virtual, 6, 16},	//1161 QsciLexerPerl::defaultColor(int) const
    {73, 892, 18, 1, Smoke::mf_const|Smoke::mf_virtual, 189, 17},	//1162 QsciLexerPerl::defaultEolFill(int) const
    {73, 894, 18, 1, Smoke::mf_const|Smoke::mf_virtual, 14, 18},	//1163 QsciLexerPerl::defaultFont(int) const
    {73, 896, 18, 1, Smoke::mf_const|Smoke::mf_virtual, 6, 19},	//1164 QsciLexerPerl::defaultPaper(int) const
    {73, 1047, 18, 1, Smoke::mf_const|Smoke::mf_virtual, 213, 20},	//1165 QsciLexerPerl::keywords(int) const
    {73, 900, 18, 1, Smoke::mf_const|Smoke::mf_virtual, 40, 21},	//1166 QsciLexerPerl::description(int) const
    {73, 1163, 0, 0, Smoke::mf_virtual, 0, 22},	//1167 QsciLexerPerl::refreshProperties()
    {73, 1298, 16, 1, 0, 0, 23},	//1168 QsciLexerPerl::setFoldAtElse(bool)
    {73, 966, 0, 0, Smoke::mf_const, 189, 24},	//1169 QsciLexerPerl::foldAtElse() const
    {73, 968, 0, 0, Smoke::mf_const, 189, 25},	//1170 QsciLexerPerl::foldComments() const
    {73, 969, 0, 0, Smoke::mf_const, 189, 26},	//1171 QsciLexerPerl::foldCompact() const
    {73, 1314, 16, 1, 0, 0, 27},	//1172 QsciLexerPerl::setFoldPackages(bool)
    {73, 975, 0, 0, Smoke::mf_const, 189, 28},	//1173 QsciLexerPerl::foldPackages() const
    {73, 1312, 16, 1, 0, 0, 29},	//1174 QsciLexerPerl::setFoldPODBlocks(bool)
    {73, 974, 0, 0, Smoke::mf_const, 189, 30},	//1175 QsciLexerPerl::foldPODBlocks() const
    {73, 1302, 16, 1, Smoke::mf_virtual|Smoke::mf_slot, 0, 31},	//1176 QsciLexerPerl::setFoldComments(bool)
    {73, 1304, 16, 1, Smoke::mf_virtual|Smoke::mf_slot, 0, 32},	//1177 QsciLexerPerl::setFoldCompact(bool)
    {73, 1153, 93, 2, Smoke::mf_protected|Smoke::mf_virtual, 189, 33},	//1178 QsciLexerPerl::readProperties(QSettings&, const QString&)
    {73, 1582, 93, 2, Smoke::mf_const|Smoke::mf_protected|Smoke::mf_virtual, 189, 34},	//1179 QsciLexerPerl::writeProperties(QSettings&, const QString&) const
    {73, 1546, 12, 1, Smoke::mf_static, 40, 35},	//1180 QsciLexerPerl::tr(const char*)
    {73, 1550, 12, 1, Smoke::mf_static, 40, 36},	//1181 QsciLexerPerl::trUtf8(const char*)
    {73, 508, 0, 0, Smoke::mf_ctor, 78, 37},	//1182 QsciLexerPerl::QsciLexerPerl()
    {73, 827, 0, 0, Smoke::mf_const, 213, 38},	//1183 QsciLexerPerl::blockEnd() const
    {73, 830, 0, 0, Smoke::mf_const, 213, 39},	//1184 QsciLexerPerl::blockStart() const
    {73, 1523, 0, 0, Smoke::mf_const|Smoke::mf_static|Smoke::mf_attribute, 199, 40},	//1185 QsciLexerPerl::staticMetaObject() const
    {73, 160, 0, 0, Smoke::mf_static|Smoke::mf_enum, 218, 41},	//1186 QsciLexerPerl::Default (enum)
    {73, 205, 0, 0, Smoke::mf_static|Smoke::mf_enum, 218, 42},	//1187 QsciLexerPerl::Error (enum)
    {73, 139, 0, 0, Smoke::mf_static|Smoke::mf_enum, 218, 43},	//1188 QsciLexerPerl::Comment (enum)
    {73, 396, 0, 0, Smoke::mf_static|Smoke::mf_enum, 218, 44},	//1189 QsciLexerPerl::POD (enum)
    {73, 378, 0, 0, Smoke::mf_static|Smoke::mf_enum, 218, 45},	//1190 QsciLexerPerl::Number (enum)
    {73, 307, 0, 0, Smoke::mf_static|Smoke::mf_enum, 218, 46},	//1191 QsciLexerPerl::Keyword (enum)
    {73, 186, 0, 0, Smoke::mf_static|Smoke::mf_enum, 218, 47},	//1192 QsciLexerPerl::DoubleQuotedString (enum)
    {73, 658, 0, 0, Smoke::mf_static|Smoke::mf_enum, 218, 48},	//1193 QsciLexerPerl::SingleQuotedString (enum)
    {73, 382, 0, 0, Smoke::mf_static|Smoke::mf_enum, 218, 49},	//1194 QsciLexerPerl::Operator (enum)
    {73, 255, 0, 0, Smoke::mf_static|Smoke::mf_enum, 218, 50},	//1195 QsciLexerPerl::Identifier (enum)
    {73, 632, 0, 0, Smoke::mf_static|Smoke::mf_enum, 218, 51},	//1196 QsciLexerPerl::Scalar (enum)
    {73, 62, 0, 0, Smoke::mf_static|Smoke::mf_enum, 218, 52},	//1197 QsciLexerPerl::Array (enum)
    {73, 235, 0, 0, Smoke::mf_static|Smoke::mf_enum, 218, 53},	//1198 QsciLexerPerl::Hash (enum)
    {73, 696, 0, 0, Smoke::mf_static|Smoke::mf_enum, 218, 54},	//1199 QsciLexerPerl::SymbolTable (enum)
    {73, 565, 0, 0, Smoke::mf_static|Smoke::mf_enum, 218, 55},	//1200 QsciLexerPerl::Regex (enum)
    {73, 688, 0, 0, Smoke::mf_static|Smoke::mf_enum, 218, 56},	//1201 QsciLexerPerl::Substitution (enum)
    {73, 85, 0, 0, Smoke::mf_static|Smoke::mf_enum, 218, 57},	//1202 QsciLexerPerl::Backticks (enum)
    {73, 158, 0, 0, Smoke::mf_static|Smoke::mf_enum, 218, 58},	//1203 QsciLexerPerl::DataSection (enum)
    {73, 239, 0, 0, Smoke::mf_static|Smoke::mf_enum, 218, 59},	//1204 QsciLexerPerl::HereDocumentDelimiter (enum)
    {73, 657, 0, 0, Smoke::mf_static|Smoke::mf_enum, 218, 60},	//1205 QsciLexerPerl::SingleQuotedHereDocument (enum)
    {73, 184, 0, 0, Smoke::mf_static|Smoke::mf_enum, 218, 61},	//1206 QsciLexerPerl::DoubleQuotedHereDocument (enum)
    {73, 83, 0, 0, Smoke::mf_static|Smoke::mf_enum, 218, 62},	//1207 QsciLexerPerl::BacktickHereDocument (enum)
    {73, 552, 0, 0, Smoke::mf_static|Smoke::mf_enum, 218, 63},	//1208 QsciLexerPerl::QuotedStringQ (enum)
    {73, 553, 0, 0, Smoke::mf_static|Smoke::mf_enum, 218, 64},	//1209 QsciLexerPerl::QuotedStringQQ (enum)
    {73, 558, 0, 0, Smoke::mf_static|Smoke::mf_enum, 218, 65},	//1210 QsciLexerPerl::QuotedStringQX (enum)
    {73, 555, 0, 0, Smoke::mf_static|Smoke::mf_enum, 218, 66},	//1211 QsciLexerPerl::QuotedStringQR (enum)
    {73, 557, 0, 0, Smoke::mf_static|Smoke::mf_enum, 218, 67},	//1212 QsciLexerPerl::QuotedStringQW (enum)
    {73, 397, 0, 0, Smoke::mf_static|Smoke::mf_enum, 218, 68},	//1213 QsciLexerPerl::PODVerbatim (enum)
    {73, 687, 0, 0, Smoke::mf_static|Smoke::mf_enum, 218, 69},	//1214 QsciLexerPerl::SubroutinePrototype (enum)
    {73, 218, 0, 0, Smoke::mf_static|Smoke::mf_enum, 218, 70},	//1215 QsciLexerPerl::FormatIdentifier (enum)
    {73, 217, 0, 0, Smoke::mf_static|Smoke::mf_enum, 218, 71},	//1216 QsciLexerPerl::FormatBody (enum)
    {73, 187, 0, 0, Smoke::mf_static|Smoke::mf_enum, 218, 72},	//1217 QsciLexerPerl::DoubleQuotedStringVar (enum)
    {73, 719, 0, 0, Smoke::mf_static|Smoke::mf_enum, 218, 73},	//1218 QsciLexerPerl::Translation (enum)
    {73, 566, 0, 0, Smoke::mf_static|Smoke::mf_enum, 218, 74},	//1219 QsciLexerPerl::RegexVar (enum)
    {73, 690, 0, 0, Smoke::mf_static|Smoke::mf_enum, 218, 75},	//1220 QsciLexerPerl::SubstitutionVar (enum)
    {73, 86, 0, 0, Smoke::mf_static|Smoke::mf_enum, 218, 76},	//1221 QsciLexerPerl::BackticksVar (enum)
    {73, 185, 0, 0, Smoke::mf_static|Smoke::mf_enum, 218, 77},	//1222 QsciLexerPerl::DoubleQuotedHereDocumentVar (enum)
    {73, 84, 0, 0, Smoke::mf_static|Smoke::mf_enum, 218, 78},	//1223 QsciLexerPerl::BacktickHereDocumentVar (enum)
    {73, 554, 0, 0, Smoke::mf_static|Smoke::mf_enum, 218, 79},	//1224 QsciLexerPerl::QuotedStringQQVar (enum)
    {73, 559, 0, 0, Smoke::mf_static|Smoke::mf_enum, 218, 80},	//1225 QsciLexerPerl::QuotedStringQXVar (enum)
    {73, 556, 0, 0, Smoke::mf_static|Smoke::mf_enum, 218, 81},	//1226 QsciLexerPerl::QuotedStringQRVar (enum)
    {73, 1618, 0, 0, Smoke::mf_dtor, 0, 82 },	//1227 QsciLexerPerl::~QsciLexerPerl()
    {74, 1105, 0, 0, Smoke::mf_const|Smoke::mf_virtual, 200, 1},	//1228 QsciLexerPostScript::metaObject() const
    {74, 1148, 12, 1, Smoke::mf_virtual, 221, 2},	//1229 QsciLexerPostScript::qt_metacast(const char*)
    {74, 1546, 42, 2, Smoke::mf_static, 40, 3},	//1230 QsciLexerPostScript::tr(const char*, const char*)
    {74, 1550, 42, 2, Smoke::mf_static, 40, 4},	//1231 QsciLexerPostScript::trUtf8(const char*, const char*)
    {74, 1546, 45, 3, Smoke::mf_static, 40, 5},	//1232 QsciLexerPostScript::tr(const char*, const char*, int)
    {74, 1550, 45, 3, Smoke::mf_static, 40, 6},	//1233 QsciLexerPostScript::trUtf8(const char*, const char*, int)
    {74, 1146, 49, 3, Smoke::mf_virtual, 215, 7},	//1234 QsciLexerPostScript::qt_metacall(QMetaObject::Call, int, void**)
    {74, 510, 74, 1, Smoke::mf_ctor, 79, 8},	//1235 QsciLexerPostScript::QsciLexerPostScript(QObject*)
    {74, 1049, 0, 0, Smoke::mf_const|Smoke::mf_virtual, 213, 9},	//1236 QsciLexerPostScript::language() const
    {74, 1054, 0, 0, Smoke::mf_const|Smoke::mf_virtual, 213, 10},	//1237 QsciLexerPostScript::lexer() const
    {74, 837, 0, 0, Smoke::mf_const|Smoke::mf_virtual, 215, 11},	//1238 QsciLexerPostScript::braceStyle() const
    {74, 890, 18, 1, Smoke::mf_const|Smoke::mf_virtual, 6, 12},	//1239 QsciLexerPostScript::defaultColor(int) const
    {74, 894, 18, 1, Smoke::mf_const|Smoke::mf_virtual, 14, 13},	//1240 QsciLexerPostScript::defaultFont(int) const
    {74, 896, 18, 1, Smoke::mf_const|Smoke::mf_virtual, 6, 14},	//1241 QsciLexerPostScript::defaultPaper(int) const
    {74, 1047, 18, 1, Smoke::mf_const|Smoke::mf_virtual, 213, 15},	//1242 QsciLexerPostScript::keywords(int) const
    {74, 900, 18, 1, Smoke::mf_const|Smoke::mf_virtual, 40, 16},	//1243 QsciLexerPostScript::description(int) const
    {74, 1163, 0, 0, Smoke::mf_virtual, 0, 17},	//1244 QsciLexerPostScript::refreshProperties()
    {74, 1545, 0, 0, Smoke::mf_const, 189, 18},	//1245 QsciLexerPostScript::tokenize() const
    {74, 1053, 0, 0, Smoke::mf_const, 215, 19},	//1246 QsciLexerPostScript::level() const
    {74, 969, 0, 0, Smoke::mf_const, 189, 20},	//1247 QsciLexerPostScript::foldCompact() const
    {74, 966, 0, 0, Smoke::mf_const, 189, 21},	//1248 QsciLexerPostScript::foldAtElse() const
    {74, 1477, 16, 1, Smoke::mf_virtual|Smoke::mf_slot, 0, 22},	//1249 QsciLexerPostScript::setTokenize(bool)
    {74, 1389, 18, 1, Smoke::mf_virtual|Smoke::mf_slot, 0, 23},	//1250 QsciLexerPostScript::setLevel(int)
    {74, 1304, 16, 1, Smoke::mf_virtual|Smoke::mf_slot, 0, 24},	//1251 QsciLexerPostScript::setFoldCompact(bool)
    {74, 1298, 16, 1, Smoke::mf_virtual|Smoke::mf_slot, 0, 25},	//1252 QsciLexerPostScript::setFoldAtElse(bool)
    {74, 1153, 93, 2, Smoke::mf_protected|Smoke::mf_virtual, 189, 26},	//1253 QsciLexerPostScript::readProperties(QSettings&, const QString&)
    {74, 1582, 93, 2, Smoke::mf_const|Smoke::mf_protected|Smoke::mf_virtual, 189, 27},	//1254 QsciLexerPostScript::writeProperties(QSettings&, const QString&) const
    {74, 1546, 12, 1, Smoke::mf_static, 40, 28},	//1255 QsciLexerPostScript::tr(const char*)
    {74, 1550, 12, 1, Smoke::mf_static, 40, 29},	//1256 QsciLexerPostScript::trUtf8(const char*)
    {74, 510, 0, 0, Smoke::mf_ctor, 79, 30},	//1257 QsciLexerPostScript::QsciLexerPostScript()
    {74, 1523, 0, 0, Smoke::mf_const|Smoke::mf_static|Smoke::mf_attribute, 199, 31},	//1258 QsciLexerPostScript::staticMetaObject() const
    {74, 160, 0, 0, Smoke::mf_static|Smoke::mf_enum, 218, 32},	//1259 QsciLexerPostScript::Default (enum)
    {74, 139, 0, 0, Smoke::mf_static|Smoke::mf_enum, 218, 33},	//1260 QsciLexerPostScript::Comment (enum)
    {74, 155, 0, 0, Smoke::mf_static|Smoke::mf_enum, 218, 34},	//1261 QsciLexerPostScript::DSCComment (enum)
    {74, 156, 0, 0, Smoke::mf_static|Smoke::mf_enum, 218, 35},	//1262 QsciLexerPostScript::DSCCommentValue (enum)
    {74, 378, 0, 0, Smoke::mf_static|Smoke::mf_enum, 218, 36},	//1263 QsciLexerPostScript::Number (enum)
    {74, 371, 0, 0, Smoke::mf_static|Smoke::mf_enum, 218, 37},	//1264 QsciLexerPostScript::Name (enum)
    {74, 307, 0, 0, Smoke::mf_static|Smoke::mf_enum, 218, 38},	//1265 QsciLexerPostScript::Keyword (enum)
    {74, 353, 0, 0, Smoke::mf_static|Smoke::mf_enum, 218, 39},	//1266 QsciLexerPostScript::Literal (enum)
    {74, 258, 0, 0, Smoke::mf_static|Smoke::mf_enum, 218, 40},	//1267 QsciLexerPostScript::ImmediateEvalLiteral (enum)
    {74, 63, 0, 0, Smoke::mf_static|Smoke::mf_enum, 218, 41},	//1268 QsciLexerPostScript::ArrayParenthesis (enum)
    {74, 173, 0, 0, Smoke::mf_static|Smoke::mf_enum, 218, 42},	//1269 QsciLexerPostScript::DictionaryParenthesis (enum)
    {74, 438, 0, 0, Smoke::mf_static|Smoke::mf_enum, 218, 43},	//1270 QsciLexerPostScript::ProcedureParenthesis (enum)
    {74, 707, 0, 0, Smoke::mf_static|Smoke::mf_enum, 218, 44},	//1271 QsciLexerPostScript::Text (enum)
    {74, 241, 0, 0, Smoke::mf_static|Smoke::mf_enum, 218, 45},	//1272 QsciLexerPostScript::HexString (enum)
    {74, 89, 0, 0, Smoke::mf_static|Smoke::mf_enum, 218, 46},	//1273 QsciLexerPostScript::Base85String (enum)
    {74, 88, 0, 0, Smoke::mf_static|Smoke::mf_enum, 218, 47},	//1274 QsciLexerPostScript::BadStringCharacter (enum)
    {74, 1619, 0, 0, Smoke::mf_dtor, 0, 48 },	//1275 QsciLexerPostScript::~QsciLexerPostScript()
    {75, 1105, 0, 0, Smoke::mf_const|Smoke::mf_virtual, 200, 1},	//1276 QsciLexerProperties::metaObject() const
    {75, 1148, 12, 1, Smoke::mf_virtual, 221, 2},	//1277 QsciLexerProperties::qt_metacast(const char*)
    {75, 1546, 42, 2, Smoke::mf_static, 40, 3},	//1278 QsciLexerProperties::tr(const char*, const char*)
    {75, 1550, 42, 2, Smoke::mf_static, 40, 4},	//1279 QsciLexerProperties::trUtf8(const char*, const char*)
    {75, 1546, 45, 3, Smoke::mf_static, 40, 5},	//1280 QsciLexerProperties::tr(const char*, const char*, int)
    {75, 1550, 45, 3, Smoke::mf_static, 40, 6},	//1281 QsciLexerProperties::trUtf8(const char*, const char*, int)
    {75, 1146, 49, 3, Smoke::mf_virtual, 215, 7},	//1282 QsciLexerProperties::qt_metacall(QMetaObject::Call, int, void**)
    {75, 512, 74, 1, Smoke::mf_ctor, 80, 8},	//1283 QsciLexerProperties::QsciLexerProperties(QObject*)
    {75, 1049, 0, 0, Smoke::mf_const|Smoke::mf_virtual, 213, 9},	//1284 QsciLexerProperties::language() const
    {75, 1054, 0, 0, Smoke::mf_const|Smoke::mf_virtual, 213, 10},	//1285 QsciLexerProperties::lexer() const
    {75, 1577, 0, 0, Smoke::mf_const|Smoke::mf_virtual, 213, 11},	//1286 QsciLexerProperties::wordCharacters() const
    {75, 890, 18, 1, Smoke::mf_const|Smoke::mf_virtual, 6, 12},	//1287 QsciLexerProperties::defaultColor(int) const
    {75, 892, 18, 1, Smoke::mf_const|Smoke::mf_virtual, 189, 13},	//1288 QsciLexerProperties::defaultEolFill(int) const
    {75, 894, 18, 1, Smoke::mf_const|Smoke::mf_virtual, 14, 14},	//1289 QsciLexerProperties::defaultFont(int) const
    {75, 896, 18, 1, Smoke::mf_const|Smoke::mf_virtual, 6, 15},	//1290 QsciLexerProperties::defaultPaper(int) const
    {75, 900, 18, 1, Smoke::mf_const|Smoke::mf_virtual, 40, 16},	//1291 QsciLexerProperties::description(int) const
    {75, 1163, 0, 0, Smoke::mf_virtual, 0, 17},	//1292 QsciLexerProperties::refreshProperties()
    {75, 969, 0, 0, Smoke::mf_const, 189, 18},	//1293 QsciLexerProperties::foldCompact() const
    {75, 1383, 16, 1, 0, 0, 19},	//1294 QsciLexerProperties::setInitialSpaces(bool)
    {75, 1022, 0, 0, Smoke::mf_const, 189, 20},	//1295 QsciLexerProperties::initialSpaces() const
    {75, 1304, 16, 1, Smoke::mf_virtual|Smoke::mf_slot, 0, 21},	//1296 QsciLexerProperties::setFoldCompact(bool)
    {75, 1153, 93, 2, Smoke::mf_protected|Smoke::mf_virtual, 189, 22},	//1297 QsciLexerProperties::readProperties(QSettings&, const QString&)
    {75, 1582, 93, 2, Smoke::mf_const|Smoke::mf_protected|Smoke::mf_virtual, 189, 23},	//1298 QsciLexerProperties::writeProperties(QSettings&, const QString&) const
    {75, 1546, 12, 1, Smoke::mf_static, 40, 24},	//1299 QsciLexerProperties::tr(const char*)
    {75, 1550, 12, 1, Smoke::mf_static, 40, 25},	//1300 QsciLexerProperties::trUtf8(const char*)
    {75, 512, 0, 0, Smoke::mf_ctor, 80, 26},	//1301 QsciLexerProperties::QsciLexerProperties()
    {75, 1523, 0, 0, Smoke::mf_const|Smoke::mf_static|Smoke::mf_attribute, 199, 27},	//1302 QsciLexerProperties::staticMetaObject() const
    {75, 160, 0, 0, Smoke::mf_static|Smoke::mf_enum, 218, 28},	//1303 QsciLexerProperties::Default (enum)
    {75, 139, 0, 0, Smoke::mf_static|Smoke::mf_enum, 218, 29},	//1304 QsciLexerProperties::Comment (enum)
    {75, 637, 0, 0, Smoke::mf_static|Smoke::mf_enum, 218, 30},	//1305 QsciLexerProperties::Section (enum)
    {75, 65, 0, 0, Smoke::mf_static|Smoke::mf_enum, 218, 31},	//1306 QsciLexerProperties::Assignment (enum)
    {75, 161, 0, 0, Smoke::mf_static|Smoke::mf_enum, 218, 32},	//1307 QsciLexerProperties::DefaultValue (enum)
    {75, 306, 0, 0, Smoke::mf_static|Smoke::mf_enum, 218, 33},	//1308 QsciLexerProperties::Key (enum)
    {75, 1620, 0, 0, Smoke::mf_dtor, 0, 34 },	//1309 QsciLexerProperties::~QsciLexerProperties()
    {76, 1105, 0, 0, Smoke::mf_const|Smoke::mf_virtual, 200, 1},	//1310 QsciLexerPython::metaObject() const
    {76, 1148, 12, 1, Smoke::mf_virtual, 221, 2},	//1311 QsciLexerPython::qt_metacast(const char*)
    {76, 1546, 42, 2, Smoke::mf_static, 40, 3},	//1312 QsciLexerPython::tr(const char*, const char*)
    {76, 1550, 42, 2, Smoke::mf_static, 40, 4},	//1313 QsciLexerPython::trUtf8(const char*, const char*)
    {76, 1546, 45, 3, Smoke::mf_static, 40, 5},	//1314 QsciLexerPython::tr(const char*, const char*, int)
    {76, 1550, 45, 3, Smoke::mf_static, 40, 6},	//1315 QsciLexerPython::trUtf8(const char*, const char*, int)
    {76, 1146, 49, 3, Smoke::mf_virtual, 215, 7},	//1316 QsciLexerPython::qt_metacall(QMetaObject::Call, int, void**)
    {76, 514, 74, 1, Smoke::mf_ctor, 81, 8},	//1317 QsciLexerPython::QsciLexerPython(QObject*)
    {76, 1049, 0, 0, Smoke::mf_const|Smoke::mf_virtual, 213, 9},	//1318 QsciLexerPython::language() const
    {76, 1054, 0, 0, Smoke::mf_const|Smoke::mf_virtual, 213, 10},	//1319 QsciLexerPython::lexer() const
    {76, 821, 0, 0, Smoke::mf_const|Smoke::mf_virtual, 41, 11},	//1320 QsciLexerPython::autoCompletionWordSeparators() const
    {76, 829, 0, 0, Smoke::mf_const|Smoke::mf_virtual, 215, 12},	//1321 QsciLexerPython::blockLookback() const
    {76, 830, 76, 1, Smoke::mf_const|Smoke::mf_virtual, 213, 13},	//1322 QsciLexerPython::blockStart(int*) const
    {76, 837, 0, 0, Smoke::mf_const|Smoke::mf_virtual, 215, 14},	//1323 QsciLexerPython::braceStyle() const
    {76, 890, 18, 1, Smoke::mf_const|Smoke::mf_virtual, 6, 15},	//1324 QsciLexerPython::defaultColor(int) const
    {76, 892, 18, 1, Smoke::mf_const|Smoke::mf_virtual, 189, 16},	//1325 QsciLexerPython::defaultEolFill(int) const
    {76, 894, 18, 1, Smoke::mf_const|Smoke::mf_virtual, 14, 17},	//1326 QsciLexerPython::defaultFont(int) const
    {76, 896, 18, 1, Smoke::mf_const|Smoke::mf_virtual, 6, 18},	//1327 QsciLexerPython::defaultPaper(int) const
    {76, 1008, 0, 0, Smoke::mf_const|Smoke::mf_virtual, 215, 19},	//1328 QsciLexerPython::indentationGuideView() const
    {76, 1047, 18, 1, Smoke::mf_const|Smoke::mf_virtual, 213, 20},	//1329 QsciLexerPython::keywords(int) const
    {76, 900, 18, 1, Smoke::mf_const|Smoke::mf_virtual, 40, 21},	//1330 QsciLexerPython::description(int) const
    {76, 1163, 0, 0, Smoke::mf_virtual, 0, 22},	//1331 QsciLexerPython::refreshProperties()
    {76, 968, 0, 0, Smoke::mf_const, 189, 23},	//1332 QsciLexerPython::foldComments() const
    {76, 1304, 16, 1, 0, 0, 24},	//1333 QsciLexerPython::setFoldCompact(bool)
    {76, 969, 0, 0, Smoke::mf_const, 189, 25},	//1334 QsciLexerPython::foldCompact() const
    {76, 977, 0, 0, Smoke::mf_const, 189, 26},	//1335 QsciLexerPython::foldQuotes() const
    {76, 1010, 0, 0, Smoke::mf_const, 82, 27},	//1336 QsciLexerPython::indentationWarning() const
    {76, 1340, 16, 1, 0, 0, 28},	//1337 QsciLexerPython::setHighlightSubidentifiers(bool)
    {76, 1001, 0, 0, Smoke::mf_const, 189, 29},	//1338 QsciLexerPython::highlightSubidentifiers() const
    {76, 1462, 16, 1, 0, 0, 30},	//1339 QsciLexerPython::setStringsOverNewlineAllowed(bool)
    {76, 1524, 0, 0, Smoke::mf_const, 189, 31},	//1340 QsciLexerPython::stringsOverNewlineAllowed() const
    {76, 1487, 16, 1, 0, 0, 32},	//1341 QsciLexerPython::setV2UnicodeAllowed(bool)
    {76, 1561, 0, 0, Smoke::mf_const, 189, 33},	//1342 QsciLexerPython::v2UnicodeAllowed() const
    {76, 1489, 16, 1, 0, 0, 34},	//1343 QsciLexerPython::setV3BinaryOctalAllowed(bool)
    {76, 1562, 0, 0, Smoke::mf_const, 189, 35},	//1344 QsciLexerPython::v3BinaryOctalAllowed() const
    {76, 1491, 16, 1, 0, 0, 36},	//1345 QsciLexerPython::setV3BytesAllowed(bool)
    {76, 1563, 0, 0, Smoke::mf_const, 189, 37},	//1346 QsciLexerPython::v3BytesAllowed() const
    {76, 1302, 16, 1, Smoke::mf_virtual|Smoke::mf_slot, 0, 38},	//1347 QsciLexerPython::setFoldComments(bool)
    {76, 1318, 16, 1, Smoke::mf_virtual|Smoke::mf_slot, 0, 39},	//1348 QsciLexerPython::setFoldQuotes(bool)
    {76, 1362, 105, 1, Smoke::mf_virtual|Smoke::mf_slot, 0, 40},	//1349 QsciLexerPython::setIndentationWarning(QsciLexerPython::IndentationWarning)
    {76, 1153, 93, 2, Smoke::mf_protected|Smoke::mf_virtual, 189, 41},	//1350 QsciLexerPython::readProperties(QSettings&, const QString&)
    {76, 1582, 93, 2, Smoke::mf_const|Smoke::mf_protected|Smoke::mf_virtual, 189, 42},	//1351 QsciLexerPython::writeProperties(QSettings&, const QString&) const
    {76, 1546, 12, 1, Smoke::mf_static, 40, 43},	//1352 QsciLexerPython::tr(const char*)
    {76, 1550, 12, 1, Smoke::mf_static, 40, 44},	//1353 QsciLexerPython::trUtf8(const char*)
    {76, 514, 0, 0, Smoke::mf_ctor, 81, 45},	//1354 QsciLexerPython::QsciLexerPython()
    {76, 830, 0, 0, Smoke::mf_const, 213, 46},	//1355 QsciLexerPython::blockStart() const
    {76, 1523, 0, 0, Smoke::mf_const|Smoke::mf_static|Smoke::mf_attribute, 199, 47},	//1356 QsciLexerPython::staticMetaObject() const
    {76, 160, 0, 0, Smoke::mf_static|Smoke::mf_enum, 218, 48},	//1357 QsciLexerPython::Default (enum)
    {76, 139, 0, 0, Smoke::mf_static|Smoke::mf_enum, 218, 49},	//1358 QsciLexerPython::Comment (enum)
    {76, 378, 0, 0, Smoke::mf_static|Smoke::mf_enum, 218, 50},	//1359 QsciLexerPython::Number (enum)
    {76, 186, 0, 0, Smoke::mf_static|Smoke::mf_enum, 218, 51},	//1360 QsciLexerPython::DoubleQuotedString (enum)
    {76, 658, 0, 0, Smoke::mf_static|Smoke::mf_enum, 218, 52},	//1361 QsciLexerPython::SingleQuotedString (enum)
    {76, 307, 0, 0, Smoke::mf_static|Smoke::mf_enum, 218, 53},	//1362 QsciLexerPython::Keyword (enum)
    {76, 722, 0, 0, Smoke::mf_static|Smoke::mf_enum, 218, 54},	//1363 QsciLexerPython::TripleSingleQuotedString (enum)
    {76, 720, 0, 0, Smoke::mf_static|Smoke::mf_enum, 218, 55},	//1364 QsciLexerPython::TripleDoubleQuotedString (enum)
    {76, 133, 0, 0, Smoke::mf_static|Smoke::mf_enum, 218, 56},	//1365 QsciLexerPython::ClassName (enum)
    {76, 223, 0, 0, Smoke::mf_static|Smoke::mf_enum, 218, 57},	//1366 QsciLexerPython::FunctionMethodName (enum)
    {76, 382, 0, 0, Smoke::mf_static|Smoke::mf_enum, 218, 58},	//1367 QsciLexerPython::Operator (enum)
    {76, 255, 0, 0, Smoke::mf_static|Smoke::mf_enum, 218, 59},	//1368 QsciLexerPython::Identifier (enum)
    {76, 140, 0, 0, Smoke::mf_static|Smoke::mf_enum, 218, 60},	//1369 QsciLexerPython::CommentBlock (enum)
    {76, 726, 0, 0, Smoke::mf_static|Smoke::mf_enum, 218, 61},	//1370 QsciLexerPython::UnclosedString (enum)
    {76, 245, 0, 0, Smoke::mf_static|Smoke::mf_enum, 218, 62},	//1371 QsciLexerPython::HighlightedIdentifier (enum)
    {76, 159, 0, 0, Smoke::mf_static|Smoke::mf_enum, 218, 63},	//1372 QsciLexerPython::Decorator (enum)
    {76, 377, 0, 0, Smoke::mf_static|Smoke::mf_enum, 82, 64},	//1373 QsciLexerPython::NoWarning (enum)
    {76, 289, 0, 0, Smoke::mf_static|Smoke::mf_enum, 82, 65},	//1374 QsciLexerPython::Inconsistent (enum)
    {76, 703, 0, 0, Smoke::mf_static|Smoke::mf_enum, 82, 66},	//1375 QsciLexerPython::TabsAfterSpaces (enum)
    {76, 662, 0, 0, Smoke::mf_static|Smoke::mf_enum, 82, 67},	//1376 QsciLexerPython::Spaces (enum)
    {76, 702, 0, 0, Smoke::mf_static|Smoke::mf_enum, 82, 68},	//1377 QsciLexerPython::Tabs (enum)
    {76, 1621, 0, 0, Smoke::mf_dtor, 0, 69 },	//1378 QsciLexerPython::~QsciLexerPython()
    {77, 1105, 0, 0, Smoke::mf_const|Smoke::mf_virtual, 200, 1},	//1379 QsciLexerRuby::metaObject() const
    {77, 1148, 12, 1, Smoke::mf_virtual, 221, 2},	//1380 QsciLexerRuby::qt_metacast(const char*)
    {77, 1546, 42, 2, Smoke::mf_static, 40, 3},	//1381 QsciLexerRuby::tr(const char*, const char*)
    {77, 1550, 42, 2, Smoke::mf_static, 40, 4},	//1382 QsciLexerRuby::trUtf8(const char*, const char*)
    {77, 1546, 45, 3, Smoke::mf_static, 40, 5},	//1383 QsciLexerRuby::tr(const char*, const char*, int)
    {77, 1550, 45, 3, Smoke::mf_static, 40, 6},	//1384 QsciLexerRuby::trUtf8(const char*, const char*, int)
    {77, 1146, 49, 3, Smoke::mf_virtual, 215, 7},	//1385 QsciLexerRuby::qt_metacall(QMetaObject::Call, int, void**)
    {77, 516, 74, 1, Smoke::mf_ctor, 83, 8},	//1386 QsciLexerRuby::QsciLexerRuby(QObject*)
    {77, 1049, 0, 0, Smoke::mf_const|Smoke::mf_virtual, 213, 9},	//1387 QsciLexerRuby::language() const
    {77, 1054, 0, 0, Smoke::mf_const|Smoke::mf_virtual, 213, 10},	//1388 QsciLexerRuby::lexer() const
    {77, 827, 76, 1, Smoke::mf_const|Smoke::mf_virtual, 213, 11},	//1389 QsciLexerRuby::blockEnd(int*) const
    {77, 830, 76, 1, Smoke::mf_const|Smoke::mf_virtual, 213, 12},	//1390 QsciLexerRuby::blockStart(int*) const
    {77, 832, 76, 1, Smoke::mf_const|Smoke::mf_virtual, 213, 13},	//1391 QsciLexerRuby::blockStartKeyword(int*) const
    {77, 837, 0, 0, Smoke::mf_const|Smoke::mf_virtual, 215, 14},	//1392 QsciLexerRuby::braceStyle() const
    {77, 890, 18, 1, Smoke::mf_const|Smoke::mf_virtual, 6, 15},	//1393 QsciLexerRuby::defaultColor(int) const
    {77, 892, 18, 1, Smoke::mf_const|Smoke::mf_virtual, 189, 16},	//1394 QsciLexerRuby::defaultEolFill(int) const
    {77, 894, 18, 1, Smoke::mf_const|Smoke::mf_virtual, 14, 17},	//1395 QsciLexerRuby::defaultFont(int) const
    {77, 896, 18, 1, Smoke::mf_const|Smoke::mf_virtual, 6, 18},	//1396 QsciLexerRuby::defaultPaper(int) const
    {77, 1047, 18, 1, Smoke::mf_const|Smoke::mf_virtual, 213, 19},	//1397 QsciLexerRuby::keywords(int) const
    {77, 900, 18, 1, Smoke::mf_const|Smoke::mf_virtual, 40, 20},	//1398 QsciLexerRuby::description(int) const
    {77, 1163, 0, 0, Smoke::mf_virtual, 0, 21},	//1399 QsciLexerRuby::refreshProperties()
    {77, 1302, 16, 1, 0, 0, 22},	//1400 QsciLexerRuby::setFoldComments(bool)
    {77, 968, 0, 0, Smoke::mf_const, 189, 23},	//1401 QsciLexerRuby::foldComments() const
    {77, 1304, 16, 1, 0, 0, 24},	//1402 QsciLexerRuby::setFoldCompact(bool)
    {77, 969, 0, 0, Smoke::mf_const, 189, 25},	//1403 QsciLexerRuby::foldCompact() const
    {77, 1153, 93, 2, Smoke::mf_protected|Smoke::mf_virtual, 189, 26},	//1404 QsciLexerRuby::readProperties(QSettings&, const QString&)
    {77, 1582, 93, 2, Smoke::mf_const|Smoke::mf_protected|Smoke::mf_virtual, 189, 27},	//1405 QsciLexerRuby::writeProperties(QSettings&, const QString&) const
    {77, 1546, 12, 1, Smoke::mf_static, 40, 28},	//1406 QsciLexerRuby::tr(const char*)
    {77, 1550, 12, 1, Smoke::mf_static, 40, 29},	//1407 QsciLexerRuby::trUtf8(const char*)
    {77, 516, 0, 0, Smoke::mf_ctor, 83, 30},	//1408 QsciLexerRuby::QsciLexerRuby()
    {77, 827, 0, 0, Smoke::mf_const, 213, 31},	//1409 QsciLexerRuby::blockEnd() const
    {77, 830, 0, 0, Smoke::mf_const, 213, 32},	//1410 QsciLexerRuby::blockStart() const
    {77, 832, 0, 0, Smoke::mf_const, 213, 33},	//1411 QsciLexerRuby::blockStartKeyword() const
    {77, 1523, 0, 0, Smoke::mf_const|Smoke::mf_static|Smoke::mf_attribute, 199, 34},	//1412 QsciLexerRuby::staticMetaObject() const
    {77, 160, 0, 0, Smoke::mf_static|Smoke::mf_enum, 218, 35},	//1413 QsciLexerRuby::Default (enum)
    {77, 205, 0, 0, Smoke::mf_static|Smoke::mf_enum, 218, 36},	//1414 QsciLexerRuby::Error (enum)
    {77, 139, 0, 0, Smoke::mf_static|Smoke::mf_enum, 218, 37},	//1415 QsciLexerRuby::Comment (enum)
    {77, 396, 0, 0, Smoke::mf_static|Smoke::mf_enum, 218, 38},	//1416 QsciLexerRuby::POD (enum)
    {77, 378, 0, 0, Smoke::mf_static|Smoke::mf_enum, 218, 39},	//1417 QsciLexerRuby::Number (enum)
    {77, 307, 0, 0, Smoke::mf_static|Smoke::mf_enum, 218, 40},	//1418 QsciLexerRuby::Keyword (enum)
    {77, 186, 0, 0, Smoke::mf_static|Smoke::mf_enum, 218, 41},	//1419 QsciLexerRuby::DoubleQuotedString (enum)
    {77, 658, 0, 0, Smoke::mf_static|Smoke::mf_enum, 218, 42},	//1420 QsciLexerRuby::SingleQuotedString (enum)
    {77, 133, 0, 0, Smoke::mf_static|Smoke::mf_enum, 218, 43},	//1421 QsciLexerRuby::ClassName (enum)
    {77, 223, 0, 0, Smoke::mf_static|Smoke::mf_enum, 218, 44},	//1422 QsciLexerRuby::FunctionMethodName (enum)
    {77, 382, 0, 0, Smoke::mf_static|Smoke::mf_enum, 218, 45},	//1423 QsciLexerRuby::Operator (enum)
    {77, 255, 0, 0, Smoke::mf_static|Smoke::mf_enum, 218, 46},	//1424 QsciLexerRuby::Identifier (enum)
    {77, 565, 0, 0, Smoke::mf_static|Smoke::mf_enum, 218, 47},	//1425 QsciLexerRuby::Regex (enum)
    {77, 224, 0, 0, Smoke::mf_static|Smoke::mf_enum, 218, 48},	//1426 QsciLexerRuby::Global (enum)
    {77, 692, 0, 0, Smoke::mf_static|Smoke::mf_enum, 218, 49},	//1427 QsciLexerRuby::Symbol (enum)
    {77, 366, 0, 0, Smoke::mf_static|Smoke::mf_enum, 218, 50},	//1428 QsciLexerRuby::ModuleName (enum)
    {77, 290, 0, 0, Smoke::mf_static|Smoke::mf_enum, 218, 51},	//1429 QsciLexerRuby::InstanceVariable (enum)
    {77, 135, 0, 0, Smoke::mf_static|Smoke::mf_enum, 218, 52},	//1430 QsciLexerRuby::ClassVariable (enum)
    {77, 85, 0, 0, Smoke::mf_static|Smoke::mf_enum, 218, 53},	//1431 QsciLexerRuby::Backticks (enum)
    {77, 158, 0, 0, Smoke::mf_static|Smoke::mf_enum, 218, 54},	//1432 QsciLexerRuby::DataSection (enum)
    {77, 239, 0, 0, Smoke::mf_static|Smoke::mf_enum, 218, 55},	//1433 QsciLexerRuby::HereDocumentDelimiter (enum)
    {77, 238, 0, 0, Smoke::mf_static|Smoke::mf_enum, 218, 56},	//1434 QsciLexerRuby::HereDocument (enum)
    {77, 414, 0, 0, Smoke::mf_static|Smoke::mf_enum, 218, 57},	//1435 QsciLexerRuby::PercentStringq (enum)
    {77, 413, 0, 0, Smoke::mf_static|Smoke::mf_enum, 218, 58},	//1436 QsciLexerRuby::PercentStringQ (enum)
    {77, 417, 0, 0, Smoke::mf_static|Smoke::mf_enum, 218, 59},	//1437 QsciLexerRuby::PercentStringx (enum)
    {77, 415, 0, 0, Smoke::mf_static|Smoke::mf_enum, 218, 60},	//1438 QsciLexerRuby::PercentStringr (enum)
    {77, 416, 0, 0, Smoke::mf_static|Smoke::mf_enum, 218, 61},	//1439 QsciLexerRuby::PercentStringw (enum)
    {77, 170, 0, 0, Smoke::mf_static|Smoke::mf_enum, 218, 62},	//1440 QsciLexerRuby::DemotedKeyword (enum)
    {77, 672, 0, 0, Smoke::mf_static|Smoke::mf_enum, 218, 63},	//1441 QsciLexerRuby::Stdin (enum)
    {77, 673, 0, 0, Smoke::mf_static|Smoke::mf_enum, 218, 64},	//1442 QsciLexerRuby::Stdout (enum)
    {77, 671, 0, 0, Smoke::mf_static|Smoke::mf_enum, 218, 65},	//1443 QsciLexerRuby::Stderr (enum)
    {77, 1622, 0, 0, Smoke::mf_dtor, 0, 66 },	//1444 QsciLexerRuby::~QsciLexerRuby()
    {78, 1105, 0, 0, Smoke::mf_const|Smoke::mf_virtual, 200, 1},	//1445 QsciLexerSQL::metaObject() const
    {78, 1148, 12, 1, Smoke::mf_virtual, 221, 2},	//1446 QsciLexerSQL::qt_metacast(const char*)
    {78, 1546, 42, 2, Smoke::mf_static, 40, 3},	//1447 QsciLexerSQL::tr(const char*, const char*)
    {78, 1550, 42, 2, Smoke::mf_static, 40, 4},	//1448 QsciLexerSQL::trUtf8(const char*, const char*)
    {78, 1546, 45, 3, Smoke::mf_static, 40, 5},	//1449 QsciLexerSQL::tr(const char*, const char*, int)
    {78, 1550, 45, 3, Smoke::mf_static, 40, 6},	//1450 QsciLexerSQL::trUtf8(const char*, const char*, int)
    {78, 1146, 49, 3, Smoke::mf_virtual, 215, 7},	//1451 QsciLexerSQL::qt_metacall(QMetaObject::Call, int, void**)
    {78, 518, 74, 1, Smoke::mf_ctor, 84, 8},	//1452 QsciLexerSQL::QsciLexerSQL(QObject*)
    {78, 1049, 0, 0, Smoke::mf_const|Smoke::mf_virtual, 213, 9},	//1453 QsciLexerSQL::language() const
    {78, 1054, 0, 0, Smoke::mf_const|Smoke::mf_virtual, 213, 10},	//1454 QsciLexerSQL::lexer() const
    {78, 837, 0, 0, Smoke::mf_const|Smoke::mf_virtual, 215, 11},	//1455 QsciLexerSQL::braceStyle() const
    {78, 890, 18, 1, Smoke::mf_const|Smoke::mf_virtual, 6, 12},	//1456 QsciLexerSQL::defaultColor(int) const
    {78, 892, 18, 1, Smoke::mf_const|Smoke::mf_virtual, 189, 13},	//1457 QsciLexerSQL::defaultEolFill(int) const
    {78, 894, 18, 1, Smoke::mf_const|Smoke::mf_virtual, 14, 14},	//1458 QsciLexerSQL::defaultFont(int) const
    {78, 896, 18, 1, Smoke::mf_const|Smoke::mf_virtual, 6, 15},	//1459 QsciLexerSQL::defaultPaper(int) const
    {78, 1047, 18, 1, Smoke::mf_const|Smoke::mf_virtual, 213, 16},	//1460 QsciLexerSQL::keywords(int) const
    {78, 900, 18, 1, Smoke::mf_const|Smoke::mf_virtual, 40, 17},	//1461 QsciLexerSQL::description(int) const
    {78, 1163, 0, 0, Smoke::mf_virtual, 0, 18},	//1462 QsciLexerSQL::refreshProperties()
    {78, 824, 0, 0, Smoke::mf_const, 189, 19},	//1463 QsciLexerSQL::backslashEscapes() const
    {78, 1273, 16, 1, 0, 0, 20},	//1464 QsciLexerSQL::setDottedWords(bool)
    {78, 907, 0, 0, Smoke::mf_const, 189, 21},	//1465 QsciLexerSQL::dottedWords() const
    {78, 1298, 16, 1, 0, 0, 22},	//1466 QsciLexerSQL::setFoldAtElse(bool)
    {78, 966, 0, 0, Smoke::mf_const, 189, 23},	//1467 QsciLexerSQL::foldAtElse() const
    {78, 968, 0, 0, Smoke::mf_const, 189, 24},	//1468 QsciLexerSQL::foldComments() const
    {78, 969, 0, 0, Smoke::mf_const, 189, 25},	//1469 QsciLexerSQL::foldCompact() const
    {78, 1310, 16, 1, 0, 0, 26},	//1470 QsciLexerSQL::setFoldOnlyBegin(bool)
    {78, 973, 0, 0, Smoke::mf_const, 189, 27},	//1471 QsciLexerSQL::foldOnlyBegin() const
    {78, 1332, 16, 1, 0, 0, 28},	//1472 QsciLexerSQL::setHashComments(bool)
    {78, 995, 0, 0, Smoke::mf_const, 189, 29},	//1473 QsciLexerSQL::hashComments() const
    {78, 1443, 16, 1, 0, 0, 30},	//1474 QsciLexerSQL::setQuotedIdentifiers(bool)
    {78, 1150, 0, 0, Smoke::mf_const, 189, 31},	//1475 QsciLexerSQL::quotedIdentifiers() const
    {78, 1222, 16, 1, Smoke::mf_virtual|Smoke::mf_slot, 0, 32},	//1476 QsciLexerSQL::setBackslashEscapes(bool)
    {78, 1302, 16, 1, Smoke::mf_virtual|Smoke::mf_slot, 0, 33},	//1477 QsciLexerSQL::setFoldComments(bool)
    {78, 1304, 16, 1, Smoke::mf_virtual|Smoke::mf_slot, 0, 34},	//1478 QsciLexerSQL::setFoldCompact(bool)
    {78, 1153, 93, 2, Smoke::mf_protected|Smoke::mf_virtual, 189, 35},	//1479 QsciLexerSQL::readProperties(QSettings&, const QString&)
    {78, 1582, 93, 2, Smoke::mf_const|Smoke::mf_protected|Smoke::mf_virtual, 189, 36},	//1480 QsciLexerSQL::writeProperties(QSettings&, const QString&) const
    {78, 1546, 12, 1, Smoke::mf_static, 40, 37},	//1481 QsciLexerSQL::tr(const char*)
    {78, 1550, 12, 1, Smoke::mf_static, 40, 38},	//1482 QsciLexerSQL::trUtf8(const char*)
    {78, 518, 0, 0, Smoke::mf_ctor, 84, 39},	//1483 QsciLexerSQL::QsciLexerSQL()
    {78, 1523, 0, 0, Smoke::mf_const|Smoke::mf_static|Smoke::mf_attribute, 199, 40},	//1484 QsciLexerSQL::staticMetaObject() const
    {78, 160, 0, 0, Smoke::mf_static|Smoke::mf_enum, 218, 41},	//1485 QsciLexerSQL::Default (enum)
    {78, 139, 0, 0, Smoke::mf_static|Smoke::mf_enum, 218, 42},	//1486 QsciLexerSQL::Comment (enum)
    {78, 145, 0, 0, Smoke::mf_static|Smoke::mf_enum, 218, 43},	//1487 QsciLexerSQL::CommentLine (enum)
    {78, 142, 0, 0, Smoke::mf_static|Smoke::mf_enum, 218, 44},	//1488 QsciLexerSQL::CommentDoc (enum)
    {78, 378, 0, 0, Smoke::mf_static|Smoke::mf_enum, 218, 45},	//1489 QsciLexerSQL::Number (enum)
    {78, 307, 0, 0, Smoke::mf_static|Smoke::mf_enum, 218, 46},	//1490 QsciLexerSQL::Keyword (enum)
    {78, 186, 0, 0, Smoke::mf_static|Smoke::mf_enum, 218, 47},	//1491 QsciLexerSQL::DoubleQuotedString (enum)
    {78, 658, 0, 0, Smoke::mf_static|Smoke::mf_enum, 218, 48},	//1492 QsciLexerSQL::SingleQuotedString (enum)
    {78, 424, 0, 0, Smoke::mf_static|Smoke::mf_enum, 218, 49},	//1493 QsciLexerSQL::PlusKeyword (enum)
    {78, 425, 0, 0, Smoke::mf_static|Smoke::mf_enum, 218, 50},	//1494 QsciLexerSQL::PlusPrompt (enum)
    {78, 382, 0, 0, Smoke::mf_static|Smoke::mf_enum, 218, 51},	//1495 QsciLexerSQL::Operator (enum)
    {78, 255, 0, 0, Smoke::mf_static|Smoke::mf_enum, 218, 52},	//1496 QsciLexerSQL::Identifier (enum)
    {78, 423, 0, 0, Smoke::mf_static|Smoke::mf_enum, 218, 53},	//1497 QsciLexerSQL::PlusComment (enum)
    {78, 147, 0, 0, Smoke::mf_static|Smoke::mf_enum, 218, 54},	//1498 QsciLexerSQL::CommentLineHash (enum)
    {78, 143, 0, 0, Smoke::mf_static|Smoke::mf_enum, 218, 55},	//1499 QsciLexerSQL::CommentDocKeyword (enum)
    {78, 144, 0, 0, Smoke::mf_static|Smoke::mf_enum, 218, 56},	//1500 QsciLexerSQL::CommentDocKeywordError (enum)
    {78, 312, 0, 0, Smoke::mf_static|Smoke::mf_enum, 218, 57},	//1501 QsciLexerSQL::KeywordSet5 (enum)
    {78, 313, 0, 0, Smoke::mf_static|Smoke::mf_enum, 218, 58},	//1502 QsciLexerSQL::KeywordSet6 (enum)
    {78, 314, 0, 0, Smoke::mf_static|Smoke::mf_enum, 218, 59},	//1503 QsciLexerSQL::KeywordSet7 (enum)
    {78, 315, 0, 0, Smoke::mf_static|Smoke::mf_enum, 218, 60},	//1504 QsciLexerSQL::KeywordSet8 (enum)
    {78, 548, 0, 0, Smoke::mf_static|Smoke::mf_enum, 218, 61},	//1505 QsciLexerSQL::QuotedIdentifier (enum)
    {78, 550, 0, 0, Smoke::mf_static|Smoke::mf_enum, 218, 62},	//1506 QsciLexerSQL::QuotedOperator (enum)
    {78, 1623, 0, 0, Smoke::mf_dtor, 0, 63 },	//1507 QsciLexerSQL::~QsciLexerSQL()
    {79, 1105, 0, 0, Smoke::mf_const|Smoke::mf_virtual, 200, 1},	//1508 QsciLexerTCL::metaObject() const
    {79, 1148, 12, 1, Smoke::mf_virtual, 221, 2},	//1509 QsciLexerTCL::qt_metacast(const char*)
    {79, 1546, 42, 2, Smoke::mf_static, 40, 3},	//1510 QsciLexerTCL::tr(const char*, const char*)
    {79, 1550, 42, 2, Smoke::mf_static, 40, 4},	//1511 QsciLexerTCL::trUtf8(const char*, const char*)
    {79, 1546, 45, 3, Smoke::mf_static, 40, 5},	//1512 QsciLexerTCL::tr(const char*, const char*, int)
    {79, 1550, 45, 3, Smoke::mf_static, 40, 6},	//1513 QsciLexerTCL::trUtf8(const char*, const char*, int)
    {79, 1146, 49, 3, Smoke::mf_virtual, 215, 7},	//1514 QsciLexerTCL::qt_metacall(QMetaObject::Call, int, void**)
    {79, 520, 74, 1, Smoke::mf_ctor, 85, 8},	//1515 QsciLexerTCL::QsciLexerTCL(QObject*)
    {79, 1049, 0, 0, Smoke::mf_const|Smoke::mf_virtual, 213, 9},	//1516 QsciLexerTCL::language() const
    {79, 1054, 0, 0, Smoke::mf_const|Smoke::mf_virtual, 213, 10},	//1517 QsciLexerTCL::lexer() const
    {79, 837, 0, 0, Smoke::mf_const|Smoke::mf_virtual, 215, 11},	//1518 QsciLexerTCL::braceStyle() const
    {79, 890, 18, 1, Smoke::mf_const|Smoke::mf_virtual, 6, 12},	//1519 QsciLexerTCL::defaultColor(int) const
    {79, 892, 18, 1, Smoke::mf_const|Smoke::mf_virtual, 189, 13},	//1520 QsciLexerTCL::defaultEolFill(int) const
    {79, 894, 18, 1, Smoke::mf_const|Smoke::mf_virtual, 14, 14},	//1521 QsciLexerTCL::defaultFont(int) const
    {79, 896, 18, 1, Smoke::mf_const|Smoke::mf_virtual, 6, 15},	//1522 QsciLexerTCL::defaultPaper(int) const
    {79, 1047, 18, 1, Smoke::mf_const|Smoke::mf_virtual, 213, 16},	//1523 QsciLexerTCL::keywords(int) const
    {79, 900, 18, 1, Smoke::mf_const|Smoke::mf_virtual, 40, 17},	//1524 QsciLexerTCL::description(int) const
    {79, 1163, 0, 0, Smoke::mf_virtual, 0, 18},	//1525 QsciLexerTCL::refreshProperties()
    {79, 1302, 16, 1, 0, 0, 19},	//1526 QsciLexerTCL::setFoldComments(bool)
    {79, 968, 0, 0, Smoke::mf_const, 189, 20},	//1527 QsciLexerTCL::foldComments() const
    {79, 1153, 93, 2, Smoke::mf_protected|Smoke::mf_virtual, 189, 21},	//1528 QsciLexerTCL::readProperties(QSettings&, const QString&)
    {79, 1582, 93, 2, Smoke::mf_const|Smoke::mf_protected|Smoke::mf_virtual, 189, 22},	//1529 QsciLexerTCL::writeProperties(QSettings&, const QString&) const
    {79, 1546, 12, 1, Smoke::mf_static, 40, 23},	//1530 QsciLexerTCL::tr(const char*)
    {79, 1550, 12, 1, Smoke::mf_static, 40, 24},	//1531 QsciLexerTCL::trUtf8(const char*)
    {79, 520, 0, 0, Smoke::mf_ctor, 85, 25},	//1532 QsciLexerTCL::QsciLexerTCL()
    {79, 1523, 0, 0, Smoke::mf_const|Smoke::mf_static|Smoke::mf_attribute, 199, 26},	//1533 QsciLexerTCL::staticMetaObject() const
    {79, 160, 0, 0, Smoke::mf_static|Smoke::mf_enum, 218, 27},	//1534 QsciLexerTCL::Default (enum)
    {79, 139, 0, 0, Smoke::mf_static|Smoke::mf_enum, 218, 28},	//1535 QsciLexerTCL::Comment (enum)
    {79, 145, 0, 0, Smoke::mf_static|Smoke::mf_enum, 218, 29},	//1536 QsciLexerTCL::CommentLine (enum)
    {79, 378, 0, 0, Smoke::mf_static|Smoke::mf_enum, 218, 30},	//1537 QsciLexerTCL::Number (enum)
    {79, 549, 0, 0, Smoke::mf_static|Smoke::mf_enum, 218, 31},	//1538 QsciLexerTCL::QuotedKeyword (enum)
    {79, 551, 0, 0, Smoke::mf_static|Smoke::mf_enum, 218, 32},	//1539 QsciLexerTCL::QuotedString (enum)
    {79, 382, 0, 0, Smoke::mf_static|Smoke::mf_enum, 218, 33},	//1540 QsciLexerTCL::Operator (enum)
    {79, 255, 0, 0, Smoke::mf_static|Smoke::mf_enum, 218, 34},	//1541 QsciLexerTCL::Identifier (enum)
    {79, 688, 0, 0, Smoke::mf_static|Smoke::mf_enum, 218, 35},	//1542 QsciLexerTCL::Substitution (enum)
    {79, 689, 0, 0, Smoke::mf_static|Smoke::mf_enum, 218, 36},	//1543 QsciLexerTCL::SubstitutionBrace (enum)
    {79, 365, 0, 0, Smoke::mf_static|Smoke::mf_enum, 218, 37},	//1544 QsciLexerTCL::Modifier (enum)
    {79, 208, 0, 0, Smoke::mf_static|Smoke::mf_enum, 218, 38},	//1545 QsciLexerTCL::ExpandKeyword (enum)
    {79, 698, 0, 0, Smoke::mf_static|Smoke::mf_enum, 218, 39},	//1546 QsciLexerTCL::TCLKeyword (enum)
    {79, 717, 0, 0, Smoke::mf_static|Smoke::mf_enum, 218, 40},	//1547 QsciLexerTCL::TkKeyword (enum)
    {79, 254, 0, 0, Smoke::mf_static|Smoke::mf_enum, 218, 41},	//1548 QsciLexerTCL::ITCLKeyword (enum)
    {79, 716, 0, 0, Smoke::mf_static|Smoke::mf_enum, 218, 42},	//1549 QsciLexerTCL::TkCommand (enum)
    {79, 313, 0, 0, Smoke::mf_static|Smoke::mf_enum, 218, 43},	//1550 QsciLexerTCL::KeywordSet6 (enum)
    {79, 314, 0, 0, Smoke::mf_static|Smoke::mf_enum, 218, 44},	//1551 QsciLexerTCL::KeywordSet7 (enum)
    {79, 315, 0, 0, Smoke::mf_static|Smoke::mf_enum, 218, 45},	//1552 QsciLexerTCL::KeywordSet8 (enum)
    {79, 316, 0, 0, Smoke::mf_static|Smoke::mf_enum, 218, 46},	//1553 QsciLexerTCL::KeywordSet9 (enum)
    {79, 141, 0, 0, Smoke::mf_static|Smoke::mf_enum, 218, 47},	//1554 QsciLexerTCL::CommentBox (enum)
    {79, 140, 0, 0, Smoke::mf_static|Smoke::mf_enum, 218, 48},	//1555 QsciLexerTCL::CommentBlock (enum)
    {79, 1624, 0, 0, Smoke::mf_dtor, 0, 49 },	//1556 QsciLexerTCL::~QsciLexerTCL()
    {80, 1105, 0, 0, Smoke::mf_const|Smoke::mf_virtual, 200, 1},	//1557 QsciLexerTeX::metaObject() const
    {80, 1148, 12, 1, Smoke::mf_virtual, 221, 2},	//1558 QsciLexerTeX::qt_metacast(const char*)
    {80, 1546, 42, 2, Smoke::mf_static, 40, 3},	//1559 QsciLexerTeX::tr(const char*, const char*)
    {80, 1550, 42, 2, Smoke::mf_static, 40, 4},	//1560 QsciLexerTeX::trUtf8(const char*, const char*)
    {80, 1546, 45, 3, Smoke::mf_static, 40, 5},	//1561 QsciLexerTeX::tr(const char*, const char*, int)
    {80, 1550, 45, 3, Smoke::mf_static, 40, 6},	//1562 QsciLexerTeX::trUtf8(const char*, const char*, int)
    {80, 1146, 49, 3, Smoke::mf_virtual, 215, 7},	//1563 QsciLexerTeX::qt_metacall(QMetaObject::Call, int, void**)
    {80, 522, 74, 1, Smoke::mf_ctor, 86, 8},	//1564 QsciLexerTeX::QsciLexerTeX(QObject*)
    {80, 1049, 0, 0, Smoke::mf_const|Smoke::mf_virtual, 213, 9},	//1565 QsciLexerTeX::language() const
    {80, 1054, 0, 0, Smoke::mf_const|Smoke::mf_virtual, 213, 10},	//1566 QsciLexerTeX::lexer() const
    {80, 1577, 0, 0, Smoke::mf_const|Smoke::mf_virtual, 213, 11},	//1567 QsciLexerTeX::wordCharacters() const
    {80, 890, 18, 1, Smoke::mf_const|Smoke::mf_virtual, 6, 12},	//1568 QsciLexerTeX::defaultColor(int) const
    {80, 1047, 18, 1, Smoke::mf_const|Smoke::mf_virtual, 213, 13},	//1569 QsciLexerTeX::keywords(int) const
    {80, 900, 18, 1, Smoke::mf_const|Smoke::mf_virtual, 40, 14},	//1570 QsciLexerTeX::description(int) const
    {80, 1163, 0, 0, Smoke::mf_virtual, 0, 15},	//1571 QsciLexerTeX::refreshProperties()
    {80, 1302, 16, 1, 0, 0, 16},	//1572 QsciLexerTeX::setFoldComments(bool)
    {80, 968, 0, 0, Smoke::mf_const, 189, 17},	//1573 QsciLexerTeX::foldComments() const
    {80, 1304, 16, 1, 0, 0, 18},	//1574 QsciLexerTeX::setFoldCompact(bool)
    {80, 969, 0, 0, Smoke::mf_const, 189, 19},	//1575 QsciLexerTeX::foldCompact() const
    {80, 1439, 16, 1, 0, 0, 20},	//1576 QsciLexerTeX::setProcessComments(bool)
    {80, 1142, 0, 0, Smoke::mf_const, 189, 21},	//1577 QsciLexerTeX::processComments() const
    {80, 1441, 16, 1, 0, 0, 22},	//1578 QsciLexerTeX::setProcessIf(bool)
    {80, 1143, 0, 0, Smoke::mf_const, 189, 23},	//1579 QsciLexerTeX::processIf() const
    {80, 1153, 93, 2, Smoke::mf_protected|Smoke::mf_virtual, 189, 24},	//1580 QsciLexerTeX::readProperties(QSettings&, const QString&)
    {80, 1582, 93, 2, Smoke::mf_const|Smoke::mf_protected|Smoke::mf_virtual, 189, 25},	//1581 QsciLexerTeX::writeProperties(QSettings&, const QString&) const
    {80, 1546, 12, 1, Smoke::mf_static, 40, 26},	//1582 QsciLexerTeX::tr(const char*)
    {80, 1550, 12, 1, Smoke::mf_static, 40, 27},	//1583 QsciLexerTeX::trUtf8(const char*)
    {80, 522, 0, 0, Smoke::mf_ctor, 86, 28},	//1584 QsciLexerTeX::QsciLexerTeX()
    {80, 1523, 0, 0, Smoke::mf_const|Smoke::mf_static|Smoke::mf_attribute, 199, 29},	//1585 QsciLexerTeX::staticMetaObject() const
    {80, 160, 0, 0, Smoke::mf_static|Smoke::mf_enum, 218, 30},	//1586 QsciLexerTeX::Default (enum)
    {80, 663, 0, 0, Smoke::mf_static|Smoke::mf_enum, 218, 31},	//1587 QsciLexerTeX::Special (enum)
    {80, 227, 0, 0, Smoke::mf_static|Smoke::mf_enum, 218, 32},	//1588 QsciLexerTeX::Group (enum)
    {80, 692, 0, 0, Smoke::mf_static|Smoke::mf_enum, 218, 33},	//1589 QsciLexerTeX::Symbol (enum)
    {80, 138, 0, 0, Smoke::mf_static|Smoke::mf_enum, 218, 34},	//1590 QsciLexerTeX::Command (enum)
    {80, 707, 0, 0, Smoke::mf_static|Smoke::mf_enum, 218, 35},	//1591 QsciLexerTeX::Text (enum)
    {80, 1625, 0, 0, Smoke::mf_dtor, 0, 36 },	//1592 QsciLexerTeX::~QsciLexerTeX()
    {81, 1105, 0, 0, Smoke::mf_const|Smoke::mf_virtual, 200, 1},	//1593 QsciLexerVHDL::metaObject() const
    {81, 1148, 12, 1, Smoke::mf_virtual, 221, 2},	//1594 QsciLexerVHDL::qt_metacast(const char*)
    {81, 1546, 42, 2, Smoke::mf_static, 40, 3},	//1595 QsciLexerVHDL::tr(const char*, const char*)
    {81, 1550, 42, 2, Smoke::mf_static, 40, 4},	//1596 QsciLexerVHDL::trUtf8(const char*, const char*)
    {81, 1546, 45, 3, Smoke::mf_static, 40, 5},	//1597 QsciLexerVHDL::tr(const char*, const char*, int)
    {81, 1550, 45, 3, Smoke::mf_static, 40, 6},	//1598 QsciLexerVHDL::trUtf8(const char*, const char*, int)
    {81, 1146, 49, 3, Smoke::mf_virtual, 215, 7},	//1599 QsciLexerVHDL::qt_metacall(QMetaObject::Call, int, void**)
    {81, 524, 74, 1, Smoke::mf_ctor, 87, 8},	//1600 QsciLexerVHDL::QsciLexerVHDL(QObject*)
    {81, 1049, 0, 0, Smoke::mf_const|Smoke::mf_virtual, 213, 9},	//1601 QsciLexerVHDL::language() const
    {81, 1054, 0, 0, Smoke::mf_const|Smoke::mf_virtual, 213, 10},	//1602 QsciLexerVHDL::lexer() const
    {81, 837, 0, 0, Smoke::mf_const|Smoke::mf_virtual, 215, 11},	//1603 QsciLexerVHDL::braceStyle() const
    {81, 890, 18, 1, Smoke::mf_const|Smoke::mf_virtual, 6, 12},	//1604 QsciLexerVHDL::defaultColor(int) const
    {81, 892, 18, 1, Smoke::mf_const|Smoke::mf_virtual, 189, 13},	//1605 QsciLexerVHDL::defaultEolFill(int) const
    {81, 894, 18, 1, Smoke::mf_const|Smoke::mf_virtual, 14, 14},	//1606 QsciLexerVHDL::defaultFont(int) const
    {81, 896, 18, 1, Smoke::mf_const|Smoke::mf_virtual, 6, 15},	//1607 QsciLexerVHDL::defaultPaper(int) const
    {81, 1047, 18, 1, Smoke::mf_const|Smoke::mf_virtual, 213, 16},	//1608 QsciLexerVHDL::keywords(int) const
    {81, 900, 18, 1, Smoke::mf_const|Smoke::mf_virtual, 40, 17},	//1609 QsciLexerVHDL::description(int) const
    {81, 1163, 0, 0, Smoke::mf_virtual, 0, 18},	//1610 QsciLexerVHDL::refreshProperties()
    {81, 968, 0, 0, Smoke::mf_const, 189, 19},	//1611 QsciLexerVHDL::foldComments() const
    {81, 969, 0, 0, Smoke::mf_const, 189, 20},	//1612 QsciLexerVHDL::foldCompact() const
    {81, 966, 0, 0, Smoke::mf_const, 189, 21},	//1613 QsciLexerVHDL::foldAtElse() const
    {81, 965, 0, 0, Smoke::mf_const, 189, 22},	//1614 QsciLexerVHDL::foldAtBegin() const
    {81, 967, 0, 0, Smoke::mf_const, 189, 23},	//1615 QsciLexerVHDL::foldAtParenthesis() const
    {81, 1302, 16, 1, Smoke::mf_virtual|Smoke::mf_slot, 0, 24},	//1616 QsciLexerVHDL::setFoldComments(bool)
    {81, 1304, 16, 1, Smoke::mf_virtual|Smoke::mf_slot, 0, 25},	//1617 QsciLexerVHDL::setFoldCompact(bool)
    {81, 1298, 16, 1, Smoke::mf_virtual|Smoke::mf_slot, 0, 26},	//1618 QsciLexerVHDL::setFoldAtElse(bool)
    {81, 1296, 16, 1, Smoke::mf_virtual|Smoke::mf_slot, 0, 27},	//1619 QsciLexerVHDL::setFoldAtBegin(bool)
    {81, 1300, 16, 1, Smoke::mf_virtual|Smoke::mf_slot, 0, 28},	//1620 QsciLexerVHDL::setFoldAtParenthesis(bool)
    {81, 1153, 93, 2, Smoke::mf_protected|Smoke::mf_virtual, 189, 29},	//1621 QsciLexerVHDL::readProperties(QSettings&, const QString&)
    {81, 1582, 93, 2, Smoke::mf_const|Smoke::mf_protected|Smoke::mf_virtual, 189, 30},	//1622 QsciLexerVHDL::writeProperties(QSettings&, const QString&) const
    {81, 1546, 12, 1, Smoke::mf_static, 40, 31},	//1623 QsciLexerVHDL::tr(const char*)
    {81, 1550, 12, 1, Smoke::mf_static, 40, 32},	//1624 QsciLexerVHDL::trUtf8(const char*)
    {81, 524, 0, 0, Smoke::mf_ctor, 87, 33},	//1625 QsciLexerVHDL::QsciLexerVHDL()
    {81, 1523, 0, 0, Smoke::mf_const|Smoke::mf_static|Smoke::mf_attribute, 199, 34},	//1626 QsciLexerVHDL::staticMetaObject() const
    {81, 160, 0, 0, Smoke::mf_static|Smoke::mf_enum, 218, 35},	//1627 QsciLexerVHDL::Default (enum)
    {81, 139, 0, 0, Smoke::mf_static|Smoke::mf_enum, 218, 36},	//1628 QsciLexerVHDL::Comment (enum)
    {81, 145, 0, 0, Smoke::mf_static|Smoke::mf_enum, 218, 37},	//1629 QsciLexerVHDL::CommentLine (enum)
    {81, 378, 0, 0, Smoke::mf_static|Smoke::mf_enum, 218, 38},	//1630 QsciLexerVHDL::Number (enum)
    {81, 677, 0, 0, Smoke::mf_static|Smoke::mf_enum, 218, 39},	//1631 QsciLexerVHDL::String (enum)
    {81, 382, 0, 0, Smoke::mf_static|Smoke::mf_enum, 218, 40},	//1632 QsciLexerVHDL::Operator (enum)
    {81, 255, 0, 0, Smoke::mf_static|Smoke::mf_enum, 218, 41},	//1633 QsciLexerVHDL::Identifier (enum)
    {81, 726, 0, 0, Smoke::mf_static|Smoke::mf_enum, 218, 42},	//1634 QsciLexerVHDL::UnclosedString (enum)
    {81, 307, 0, 0, Smoke::mf_static|Smoke::mf_enum, 218, 43},	//1635 QsciLexerVHDL::Keyword (enum)
    {81, 668, 0, 0, Smoke::mf_static|Smoke::mf_enum, 218, 44},	//1636 QsciLexerVHDL::StandardOperator (enum)
    {81, 67, 0, 0, Smoke::mf_static|Smoke::mf_enum, 218, 45},	//1637 QsciLexerVHDL::Attribute (enum)
    {81, 667, 0, 0, Smoke::mf_static|Smoke::mf_enum, 218, 46},	//1638 QsciLexerVHDL::StandardFunction (enum)
    {81, 669, 0, 0, Smoke::mf_static|Smoke::mf_enum, 218, 47},	//1639 QsciLexerVHDL::StandardPackage (enum)
    {81, 670, 0, 0, Smoke::mf_static|Smoke::mf_enum, 218, 48},	//1640 QsciLexerVHDL::StandardType (enum)
    {81, 314, 0, 0, Smoke::mf_static|Smoke::mf_enum, 218, 49},	//1641 QsciLexerVHDL::KeywordSet7 (enum)
    {81, 140, 0, 0, Smoke::mf_static|Smoke::mf_enum, 218, 50},	//1642 QsciLexerVHDL::CommentBlock (enum)
    {81, 1626, 0, 0, Smoke::mf_dtor, 0, 51 },	//1643 QsciLexerVHDL::~QsciLexerVHDL()
    {82, 1105, 0, 0, Smoke::mf_const|Smoke::mf_virtual, 200, 1},	//1644 QsciLexerXML::metaObject() const
    {82, 1148, 12, 1, Smoke::mf_virtual, 221, 2},	//1645 QsciLexerXML::qt_metacast(const char*)
    {82, 1546, 42, 2, Smoke::mf_static, 40, 3},	//1646 QsciLexerXML::tr(const char*, const char*)
    {82, 1550, 42, 2, Smoke::mf_static, 40, 4},	//1647 QsciLexerXML::trUtf8(const char*, const char*)
    {82, 1546, 45, 3, Smoke::mf_static, 40, 5},	//1648 QsciLexerXML::tr(const char*, const char*, int)
    {82, 1550, 45, 3, Smoke::mf_static, 40, 6},	//1649 QsciLexerXML::trUtf8(const char*, const char*, int)
    {82, 1146, 49, 3, Smoke::mf_virtual, 215, 7},	//1650 QsciLexerXML::qt_metacall(QMetaObject::Call, int, void**)
    {82, 526, 74, 1, Smoke::mf_ctor, 88, 8},	//1651 QsciLexerXML::QsciLexerXML(QObject*)
    {82, 1049, 0, 0, Smoke::mf_const|Smoke::mf_virtual, 213, 9},	//1652 QsciLexerXML::language() const
    {82, 1054, 0, 0, Smoke::mf_const|Smoke::mf_virtual, 213, 10},	//1653 QsciLexerXML::lexer() const
    {82, 890, 18, 1, Smoke::mf_const|Smoke::mf_virtual, 6, 11},	//1654 QsciLexerXML::defaultColor(int) const
    {82, 892, 18, 1, Smoke::mf_const|Smoke::mf_virtual, 189, 12},	//1655 QsciLexerXML::defaultEolFill(int) const
    {82, 894, 18, 1, Smoke::mf_const|Smoke::mf_virtual, 14, 13},	//1656 QsciLexerXML::defaultFont(int) const
    {82, 896, 18, 1, Smoke::mf_const|Smoke::mf_virtual, 6, 14},	//1657 QsciLexerXML::defaultPaper(int) const
    {82, 1047, 18, 1, Smoke::mf_const|Smoke::mf_virtual, 213, 15},	//1658 QsciLexerXML::keywords(int) const
    {82, 1163, 0, 0, Smoke::mf_virtual, 0, 16},	//1659 QsciLexerXML::refreshProperties()
    {82, 1449, 16, 1, 0, 0, 17},	//1660 QsciLexerXML::setScriptsStyled(bool)
    {82, 1185, 0, 0, Smoke::mf_const, 189, 18},	//1661 QsciLexerXML::scriptsStyled() const
    {82, 1153, 93, 2, Smoke::mf_protected|Smoke::mf_virtual, 189, 19},	//1662 QsciLexerXML::readProperties(QSettings&, const QString&)
    {82, 1582, 93, 2, Smoke::mf_const|Smoke::mf_protected|Smoke::mf_virtual, 189, 20},	//1663 QsciLexerXML::writeProperties(QSettings&, const QString&) const
    {82, 1546, 12, 1, Smoke::mf_static, 40, 21},	//1664 QsciLexerXML::tr(const char*)
    {82, 1550, 12, 1, Smoke::mf_static, 40, 22},	//1665 QsciLexerXML::trUtf8(const char*)
    {82, 526, 0, 0, Smoke::mf_ctor, 88, 23},	//1666 QsciLexerXML::QsciLexerXML()
    {82, 1523, 0, 0, Smoke::mf_const|Smoke::mf_static|Smoke::mf_attribute, 199, 24},	//1667 QsciLexerXML::staticMetaObject() const
    {82, 1627, 0, 0, Smoke::mf_dtor, 0, 25 },	//1668 QsciLexerXML::~QsciLexerXML()
    {83, 1105, 0, 0, Smoke::mf_const|Smoke::mf_virtual, 200, 1},	//1669 QsciLexerYAML::metaObject() const
    {83, 1148, 12, 1, Smoke::mf_virtual, 221, 2},	//1670 QsciLexerYAML::qt_metacast(const char*)
    {83, 1546, 42, 2, Smoke::mf_static, 40, 3},	//1671 QsciLexerYAML::tr(const char*, const char*)
    {83, 1550, 42, 2, Smoke::mf_static, 40, 4},	//1672 QsciLexerYAML::trUtf8(const char*, const char*)
    {83, 1546, 45, 3, Smoke::mf_static, 40, 5},	//1673 QsciLexerYAML::tr(const char*, const char*, int)
    {83, 1550, 45, 3, Smoke::mf_static, 40, 6},	//1674 QsciLexerYAML::trUtf8(const char*, const char*, int)
    {83, 1146, 49, 3, Smoke::mf_virtual, 215, 7},	//1675 QsciLexerYAML::qt_metacall(QMetaObject::Call, int, void**)
    {83, 528, 74, 1, Smoke::mf_ctor, 89, 8},	//1676 QsciLexerYAML::QsciLexerYAML(QObject*)
    {83, 1049, 0, 0, Smoke::mf_const|Smoke::mf_virtual, 213, 9},	//1677 QsciLexerYAML::language() const
    {83, 1054, 0, 0, Smoke::mf_const|Smoke::mf_virtual, 213, 10},	//1678 QsciLexerYAML::lexer() const
    {83, 890, 18, 1, Smoke::mf_const|Smoke::mf_virtual, 6, 11},	//1679 QsciLexerYAML::defaultColor(int) const
    {83, 892, 18, 1, Smoke::mf_const|Smoke::mf_virtual, 189, 12},	//1680 QsciLexerYAML::defaultEolFill(int) const
    {83, 894, 18, 1, Smoke::mf_const|Smoke::mf_virtual, 14, 13},	//1681 QsciLexerYAML::defaultFont(int) const
    {83, 896, 18, 1, Smoke::mf_const|Smoke::mf_virtual, 6, 14},	//1682 QsciLexerYAML::defaultPaper(int) const
    {83, 1047, 18, 1, Smoke::mf_const|Smoke::mf_virtual, 213, 15},	//1683 QsciLexerYAML::keywords(int) const
    {83, 900, 18, 1, Smoke::mf_const|Smoke::mf_virtual, 40, 16},	//1684 QsciLexerYAML::description(int) const
    {83, 1163, 0, 0, Smoke::mf_virtual, 0, 17},	//1685 QsciLexerYAML::refreshProperties()
    {83, 968, 0, 0, Smoke::mf_const, 189, 18},	//1686 QsciLexerYAML::foldComments() const
    {83, 1302, 16, 1, Smoke::mf_virtual|Smoke::mf_slot, 0, 19},	//1687 QsciLexerYAML::setFoldComments(bool)
    {83, 1153, 93, 2, Smoke::mf_protected|Smoke::mf_virtual, 189, 20},	//1688 QsciLexerYAML::readProperties(QSettings&, const QString&)
    {83, 1582, 93, 2, Smoke::mf_const|Smoke::mf_protected|Smoke::mf_virtual, 189, 21},	//1689 QsciLexerYAML::writeProperties(QSettings&, const QString&) const
    {83, 1546, 12, 1, Smoke::mf_static, 40, 22},	//1690 QsciLexerYAML::tr(const char*)
    {83, 1550, 12, 1, Smoke::mf_static, 40, 23},	//1691 QsciLexerYAML::trUtf8(const char*)
    {83, 528, 0, 0, Smoke::mf_ctor, 89, 24},	//1692 QsciLexerYAML::QsciLexerYAML()
    {83, 1523, 0, 0, Smoke::mf_const|Smoke::mf_static|Smoke::mf_attribute, 199, 25},	//1693 QsciLexerYAML::staticMetaObject() const
    {83, 160, 0, 0, Smoke::mf_static|Smoke::mf_enum, 218, 26},	//1694 QsciLexerYAML::Default (enum)
    {83, 139, 0, 0, Smoke::mf_static|Smoke::mf_enum, 218, 27},	//1695 QsciLexerYAML::Comment (enum)
    {83, 255, 0, 0, Smoke::mf_static|Smoke::mf_enum, 218, 28},	//1696 QsciLexerYAML::Identifier (enum)
    {83, 307, 0, 0, Smoke::mf_static|Smoke::mf_enum, 218, 29},	//1697 QsciLexerYAML::Keyword (enum)
    {83, 378, 0, 0, Smoke::mf_static|Smoke::mf_enum, 218, 30},	//1698 QsciLexerYAML::Number (enum)
    {83, 564, 0, 0, Smoke::mf_static|Smoke::mf_enum, 218, 31},	//1699 QsciLexerYAML::Reference (enum)
    {83, 176, 0, 0, Smoke::mf_static|Smoke::mf_enum, 218, 32},	//1700 QsciLexerYAML::DocumentDelimiter (enum)
    {83, 708, 0, 0, Smoke::mf_static|Smoke::mf_enum, 218, 33},	//1701 QsciLexerYAML::TextBlockMarker (enum)
    {83, 697, 0, 0, Smoke::mf_static|Smoke::mf_enum, 218, 34},	//1702 QsciLexerYAML::SyntaxErrorMarker (enum)
    {83, 382, 0, 0, Smoke::mf_static|Smoke::mf_enum, 218, 35},	//1703 QsciLexerYAML::Operator (enum)
    {83, 1628, 0, 0, Smoke::mf_dtor, 0, 36 },	//1704 QsciLexerYAML::~QsciLexerYAML()
    {84, 1105, 0, 0, Smoke::mf_const|Smoke::mf_virtual, 200, 1},	//1705 QsciMacro::metaObject() const
    {84, 1148, 12, 1, Smoke::mf_virtual, 221, 2},	//1706 QsciMacro::qt_metacast(const char*)
    {84, 1546, 42, 2, Smoke::mf_static, 40, 3},	//1707 QsciMacro::tr(const char*, const char*)
    {84, 1550, 42, 2, Smoke::mf_static, 40, 4},	//1708 QsciMacro::trUtf8(const char*, const char*)
    {84, 1546, 45, 3, Smoke::mf_static, 40, 5},	//1709 QsciMacro::tr(const char*, const char*, int)
    {84, 1550, 45, 3, Smoke::mf_static, 40, 6},	//1710 QsciMacro::trUtf8(const char*, const char*, int)
    {84, 1146, 49, 3, Smoke::mf_virtual, 215, 7},	//1711 QsciMacro::qt_metacall(QMetaObject::Call, int, void**)
    {84, 530, 82, 1, Smoke::mf_ctor, 90, 8},	//1712 QsciMacro::QsciMacro(QsciScintilla*)
    {84, 530, 107, 2, Smoke::mf_ctor, 90, 9},	//1713 QsciMacro::QsciMacro(const QString&, QsciScintilla*)
    {84, 856, 0, 0, 0, 0, 10},	//1714 QsciMacro::clear()
    {84, 1064, 55, 1, 0, 189, 11},	//1715 QsciMacro::load(const QString&)
    {84, 1182, 0, 0, Smoke::mf_const, 40, 12},	//1716 QsciMacro::save() const
    {84, 1133, 0, 0, Smoke::mf_virtual|Smoke::mf_slot, 0, 13},	//1717 QsciMacro::play()
    {84, 1519, 0, 0, Smoke::mf_virtual|Smoke::mf_slot, 0, 14},	//1718 QsciMacro::startRecording()
    {84, 921, 0, 0, Smoke::mf_virtual|Smoke::mf_slot, 0, 15},	//1719 QsciMacro::endRecording()
    {84, 1546, 12, 1, Smoke::mf_static, 40, 16},	//1720 QsciMacro::tr(const char*)
    {84, 1550, 12, 1, Smoke::mf_static, 40, 17},	//1721 QsciMacro::trUtf8(const char*)
    {84, 1523, 0, 0, Smoke::mf_const|Smoke::mf_static|Smoke::mf_attribute, 199, 18},	//1722 QsciMacro::staticMetaObject() const
    {84, 1629, 0, 0, Smoke::mf_dtor, 0, 19 },	//1723 QsciMacro::~QsciMacro()
    {85, 533, 110, 1, Smoke::mf_ctor, 91, 1},	//1724 QsciPrinter::QsciPrinter(QPrinter::PrinterMode)
    {85, 986, 112, 4, Smoke::mf_virtual, 0, 2},	//1725 QsciPrinter::formatPage(QPainter&, bool, QRect&, int)
    {85, 1068, 0, 0, Smoke::mf_const, 215, 3},	//1726 QsciPrinter::magnification() const
    {85, 1393, 18, 1, Smoke::mf_virtual, 0, 4},	//1727 QsciPrinter::setMagnification(int)
    {85, 1138, 117, 3, Smoke::mf_virtual, 215, 5},	//1728 QsciPrinter::printRange(QsciScintillaBase*, int, int)
    {85, 1579, 0, 0, Smoke::mf_const, 108, 6},	//1729 QsciPrinter::wrapMode() const
    {85, 1507, 121, 1, Smoke::mf_virtual, 0, 7},	//1730 QsciPrinter::setWrapMode(QsciScintilla::WrapMode)
    {85, 533, 0, 0, Smoke::mf_ctor, 91, 8},	//1731 QsciPrinter::QsciPrinter()
    {85, 1138, 123, 1, 0, 215, 9},	//1732 QsciPrinter::printRange(QsciScintillaBase*)
    {85, 1138, 125, 2, 0, 215, 10},	//1733 QsciPrinter::printRange(QsciScintillaBase*, int)
    {85, 1630, 0, 0, Smoke::mf_dtor, 0, 11 },	//1734 QsciPrinter::~QsciPrinter()
    {86, 1105, 0, 0, Smoke::mf_const|Smoke::mf_virtual, 200, 1},	//1735 QsciScintilla::metaObject() const
    {86, 1148, 12, 1, Smoke::mf_virtual, 221, 2},	//1736 QsciScintilla::qt_metacast(const char*)
    {86, 1546, 42, 2, Smoke::mf_static, 40, 3},	//1737 QsciScintilla::tr(const char*, const char*)
    {86, 1550, 42, 2, Smoke::mf_static, 40, 4},	//1738 QsciScintilla::trUtf8(const char*, const char*)
    {86, 1546, 45, 3, Smoke::mf_static, 40, 5},	//1739 QsciScintilla::tr(const char*, const char*, int)
    {86, 1550, 45, 3, Smoke::mf_static, 40, 6},	//1740 QsciScintilla::trUtf8(const char*, const char*, int)
    {86, 1146, 49, 3, Smoke::mf_virtual, 215, 7},	//1741 QsciScintilla::qt_metacall(QMetaObject::Call, int, void**)
    {86, 535, 128, 1, Smoke::mf_ctor, 92, 8},	//1742 QsciScintilla::QsciScintilla(QWidget*)
    {86, 798, 130, 3, Smoke::mf_virtual, 41, 9},	//1743 QsciScintilla::apiContext(int, int&, int&)
    {86, 790, 134, 3, 0, 0, 10},	//1744 QsciScintilla::annotate(int, const QString&, int)
    {86, 790, 138, 3, 0, 0, 11},	//1745 QsciScintilla::annotate(int, const QString&, const QsciStyle&)
    {86, 790, 142, 2, 0, 0, 12},	//1746 QsciScintilla::annotate(int, const QsciStyledText&)
    {86, 790, 145, 2, 0, 0, 13},	//1747 QsciScintilla::annotate(int, const QList<QsciStyledText>&)
    {86, 795, 18, 1, Smoke::mf_const, 40, 14},	//1748 QsciScintilla::annotation(int) const
    {86, 797, 0, 0, Smoke::mf_const, 93, 15},	//1749 QsciScintilla::annotationDisplay() const
    {86, 858, 18, 1, 0, 0, 16},	//1750 QsciScintilla::clearAnnotations(int)
    {86, 811, 0, 0, Smoke::mf_const, 189, 17},	//1751 QsciScintilla::autoCompletionCaseSensitivity() const
    {86, 813, 0, 0, Smoke::mf_const, 189, 18},	//1752 QsciScintilla::autoCompletionFillupsEnabled() const
    {86, 814, 0, 0, Smoke::mf_const, 189, 19},	//1753 QsciScintilla::autoCompletionReplaceWord() const
    {86, 817, 0, 0, Smoke::mf_const, 189, 20},	//1754 QsciScintilla::autoCompletionShowSingle() const
    {86, 818, 0, 0, Smoke::mf_const, 94, 21},	//1755 QsciScintilla::autoCompletionSource() const
    {86, 819, 0, 0, Smoke::mf_const, 215, 22},	//1756 QsciScintilla::autoCompletionThreshold() const
    {86, 820, 0, 0, Smoke::mf_const, 95, 23},	//1757 QsciScintilla::autoCompletionUseSingle() const
    {86, 822, 0, 0, Smoke::mf_const, 189, 24},	//1758 QsciScintilla::autoIndent() const
    {86, 825, 0, 0, Smoke::mf_const, 189, 25},	//1759 QsciScintilla::backspaceUnindents() const
    {86, 826, 0, 0, 0, 0, 26},	//1760 QsciScintilla::beginUndoAction()
    {86, 836, 0, 0, Smoke::mf_const, 96, 27},	//1761 QsciScintilla::braceMatching() const
    {86, 843, 0, 0, Smoke::mf_const, 97, 28},	//1762 QsciScintilla::callTipsPosition() const
    {86, 844, 0, 0, Smoke::mf_const, 98, 29},	//1763 QsciScintilla::callTipsStyle() const
    {86, 845, 0, 0, Smoke::mf_const, 215, 30},	//1764 QsciScintilla::callTipsVisible() const
    {86, 848, 0, 0, 0, 0, 31},	//1765 QsciScintilla::cancelList()
    {86, 850, 0, 0, Smoke::mf_const, 189, 32},	//1766 QsciScintilla::caseSensitive() const
    {86, 860, 0, 0, 0, 0, 33},	//1767 QsciScintilla::clearFolds()
    {86, 861, 148, 5, 0, 0, 34},	//1768 QsciScintilla::clearIndicatorRange(int, int, int, int, int)
    {86, 866, 0, 0, 0, 0, 35},	//1769 QsciScintilla::clearRegisteredImages()
    {86, 868, 0, 0, Smoke::mf_const, 6, 36},	//1770 QsciScintilla::color() const
    {86, 879, 0, 0, Smoke::mf_const, 20, 37},	//1771 QsciScintilla::contractedFolds() const
    {86, 880, 154, 1, 0, 0, 38},	//1772 QsciScintilla::convertEols(QsciScintilla::EolMode)
    {86, 885, 0, 0, 0, 22, 39},	//1773 QsciScintilla::createStandardContextMenu()
    {86, 905, 0, 0, Smoke::mf_const, 55, 40},	//1774 QsciScintilla::document() const
    {86, 922, 0, 0, 0, 0, 41},	//1775 QsciScintilla::endUndoAction()
    {86, 916, 0, 0, Smoke::mf_const, 6, 42},	//1776 QsciScintilla::edgeColor() const
    {86, 917, 0, 0, Smoke::mf_const, 215, 43},	//1777 QsciScintilla::edgeColumn() const
    {86, 918, 0, 0, Smoke::mf_const, 99, 44},	//1778 QsciScintilla::edgeMode() const
    {86, 1327, 40, 1, 0, 0, 45},	//1779 QsciScintilla::setFont(const QFont&)
    {86, 931, 0, 0, Smoke::mf_const, 100, 46},	//1780 QsciScintilla::eolMode() const
    {86, 932, 0, 0, Smoke::mf_const, 189, 47},	//1781 QsciScintilla::eolVisibility() const
    {86, 937, 0, 0, Smoke::mf_const, 215, 48},	//1782 QsciScintilla::extraAscent() const
    {86, 938, 0, 0, Smoke::mf_const, 215, 49},	//1783 QsciScintilla::extraDescent() const
    {86, 939, 148, 5, 0, 0, 50},	//1784 QsciScintilla::fillIndicatorRange(int, int, int, int, int)
    {86, 943, 156, 10, Smoke::mf_virtual, 189, 51},	//1785 QsciScintilla::findFirst(const QString&, bool, bool, bool, bool, bool, int, int, bool, bool)
    {86, 950, 167, 7, Smoke::mf_virtual, 189, 52},	//1786 QsciScintilla::findFirstInSelection(const QString&, bool, bool, bool, bool, bool, bool)
    {86, 955, 0, 0, Smoke::mf_virtual, 189, 53},	//1787 QsciScintilla::findNext()
    {86, 956, 0, 0, Smoke::mf_const, 215, 54},	//1788 QsciScintilla::firstVisibleLine() const
    {86, 980, 0, 0, Smoke::mf_const, 101, 55},	//1789 QsciScintilla::folding() const
    {86, 990, 175, 2, Smoke::mf_const, 0, 56},	//1790 QsciScintilla::getCursorPosition(int*, int*) const
    {86, 992, 178, 4, Smoke::mf_const, 0, 57},	//1791 QsciScintilla::getSelection(int*, int*, int*, int*) const
    {86, 994, 0, 0, Smoke::mf_const, 189, 58},	//1792 QsciScintilla::hasSelectedText() const
    {86, 1006, 18, 1, Smoke::mf_const, 215, 59},	//1793 QsciScintilla::indentation(int) const
    {86, 1009, 0, 0, Smoke::mf_const, 189, 60},	//1794 QsciScintilla::indentationGuides() const
    {86, 1012, 0, 0, Smoke::mf_const, 189, 61},	//1795 QsciScintilla::indentationsUseTabs() const
    {86, 1011, 0, 0, Smoke::mf_const, 215, 62},	//1796 QsciScintilla::indentationWidth() const
    {86, 1015, 183, 2, 0, 215, 63},	//1797 QsciScintilla::indicatorDefine(QsciScintilla::IndicatorStyle, int)
    {86, 1018, 18, 1, Smoke::mf_const, 189, 64},	//1798 QsciScintilla::indicatorDrawUnder(int) const
    {86, 1032, 0, 0, Smoke::mf_const, 189, 65},	//1799 QsciScintilla::isCallTipActive() const
    {86, 1033, 0, 0, Smoke::mf_const, 189, 66},	//1800 QsciScintilla::isListActive() const
    {86, 1034, 0, 0, Smoke::mf_const, 189, 67},	//1801 QsciScintilla::isModified() const
    {86, 1037, 0, 0, Smoke::mf_const, 189, 68},	//1802 QsciScintilla::isReadOnly() const
    {86, 1038, 0, 0, Smoke::mf_const, 189, 69},	//1803 QsciScintilla::isRedoAvailable() const
    {86, 1039, 0, 0, Smoke::mf_const, 189, 70},	//1804 QsciScintilla::isUndoAvailable() const
    {86, 1040, 0, 0, Smoke::mf_const, 189, 71},	//1805 QsciScintilla::isUtf8() const
    {86, 1041, 186, 1, Smoke::mf_const, 189, 72},	//1806 QsciScintilla::isWordCharacter(char) const
    {86, 1056, 188, 1, Smoke::mf_const, 215, 73},	//1807 QsciScintilla::lineAt(const QPoint&) const
    {86, 1058, 190, 3, Smoke::mf_const, 0, 74},	//1808 QsciScintilla::lineIndexFromPosition(int, int*, int*) const
    {86, 1060, 18, 1, Smoke::mf_const, 215, 75},	//1809 QsciScintilla::lineLength(int) const
    {86, 1062, 0, 0, Smoke::mf_const, 215, 76},	//1810 QsciScintilla::lines() const
    {86, 1052, 0, 0, Smoke::mf_const, 215, 77},	//1811 QsciScintilla::length() const
    {86, 1054, 0, 0, Smoke::mf_const, 58, 78},	//1812 QsciScintilla::lexer() const
    {86, 1072, 18, 1, Smoke::mf_const, 189, 79},	//1813 QsciScintilla::marginLineNumbers(int) const
    {86, 1074, 18, 1, Smoke::mf_const, 215, 80},	//1814 QsciScintilla::marginMarkerMask(int) const
    {86, 1076, 0, 0, Smoke::mf_const, 215, 81},	//1815 QsciScintilla::marginOptions() const
    {86, 1077, 18, 1, Smoke::mf_const, 189, 82},	//1816 QsciScintilla::marginSensitivity(int) const
    {86, 1079, 18, 1, Smoke::mf_const, 104, 83},	//1817 QsciScintilla::marginType(int) const
    {86, 1081, 18, 1, Smoke::mf_const, 215, 84},	//1818 QsciScintilla::marginWidth(int) const
    {86, 1085, 194, 2, 0, 215, 85},	//1819 QsciScintilla::markerDefine(QsciScintilla::MarkerSymbol, int)
    {86, 1085, 197, 2, 0, 215, 86},	//1820 QsciScintilla::markerDefine(char, int)
    {86, 1085, 200, 2, 0, 215, 87},	//1821 QsciScintilla::markerDefine(const QPixmap&, int)
    {86, 1085, 203, 2, 0, 215, 88},	//1822 QsciScintilla::markerDefine(const QImage&, int)
    {86, 1083, 99, 2, 0, 215, 89},	//1823 QsciScintilla::markerAdd(int, int)
    {86, 1103, 18, 1, Smoke::mf_const, 219, 90},	//1824 QsciScintilla::markersAtLine(int) const
    {86, 1090, 99, 2, 0, 0, 91},	//1825 QsciScintilla::markerDelete(int, int)
    {86, 1093, 18, 1, 0, 0, 92},	//1826 QsciScintilla::markerDeleteAll(int)
    {86, 1095, 18, 1, 0, 0, 93},	//1827 QsciScintilla::markerDeleteHandle(int)
    {86, 1101, 18, 1, Smoke::mf_const, 215, 94},	//1828 QsciScintilla::markerLine(int) const
    {86, 1097, 206, 2, Smoke::mf_const, 215, 95},	//1829 QsciScintilla::markerFindNext(int, unsigned int) const
    {86, 1099, 206, 2, Smoke::mf_const, 215, 96},	//1830 QsciScintilla::markerFindPrevious(int, unsigned int) const
    {86, 1123, 0, 0, Smoke::mf_const, 189, 97},	//1831 QsciScintilla::overwriteMode() const
    {86, 1128, 0, 0, Smoke::mf_const, 6, 98},	//1832 QsciScintilla::paper() const
    {86, 1135, 99, 2, Smoke::mf_const, 215, 99},	//1833 QsciScintilla::positionFromLineIndex(int, int) const
    {86, 1151, 209, 1, 0, 189, 100},	//1834 QsciScintilla::read(QIODevice*)
    {86, 1158, 99, 2, Smoke::mf_virtual, 0, 101},	//1835 QsciScintilla::recolor(int, int)
    {86, 1164, 211, 2, 0, 0, 102},	//1836 QsciScintilla::registerImage(int, const QPixmap&)
    {86, 1164, 214, 2, 0, 0, 103},	//1837 QsciScintilla::registerImage(int, const QImage&)
    {86, 1169, 55, 1, Smoke::mf_virtual, 0, 104},	//1838 QsciScintilla::replace(const QString&)
    {86, 1173, 0, 0, 0, 0, 105},	//1839 QsciScintilla::resetFoldMarginColors()
    {86, 1174, 0, 0, 0, 0, 106},	//1840 QsciScintilla::resetHotspotBackgroundColor()
    {86, 1175, 0, 0, 0, 0, 107},	//1841 QsciScintilla::resetHotspotForegroundColor()
    {86, 1308, 217, 2, 0, 0, 108},	//1842 QsciScintilla::setFoldMarginColors(const QColor&, const QColor&)
    {86, 1198, 220, 1, 0, 0, 109},	//1843 QsciScintilla::setAnnotationDisplay(QsciScintilla::AnnotationDisplay)
    {86, 1204, 16, 1, 0, 0, 110},	//1844 QsciScintilla::setAutoCompletionFillupsEnabled(bool)
    {86, 1202, 12, 1, 0, 0, 111},	//1845 QsciScintilla::setAutoCompletionFillups(const char*)
    {86, 1216, 222, 1, 0, 0, 112},	//1846 QsciScintilla::setAutoCompletionWordSeparators(const QStringList&)
    {86, 1228, 80, 1, 0, 0, 113},	//1847 QsciScintilla::setCallTipsBackgroundColor(const QColor&)
    {86, 1230, 80, 1, 0, 0, 114},	//1848 QsciScintilla::setCallTipsForegroundColor(const QColor&)
    {86, 1232, 80, 1, 0, 0, 115},	//1849 QsciScintilla::setCallTipsHighlightColor(const QColor&)
    {86, 1234, 224, 1, 0, 0, 116},	//1850 QsciScintilla::setCallTipsPosition(QsciScintilla::CallTipsPosition)
    {86, 1236, 226, 1, 0, 0, 117},	//1851 QsciScintilla::setCallTipsStyle(QsciScintilla::CallTipsStyle)
    {86, 1238, 18, 1, 0, 0, 118},	//1852 QsciScintilla::setCallTipsVisible(int)
    {86, 1255, 228, 1, 0, 0, 119},	//1853 QsciScintilla::setContractedFolds(const QList<int>&)
    {86, 1269, 72, 1, 0, 0, 120},	//1854 QsciScintilla::setDocument(const QsciDocument&)
    {86, 1275, 80, 1, 0, 0, 121},	//1855 QsciScintilla::setEdgeColor(const QColor&)
    {86, 1277, 18, 1, 0, 0, 122},	//1856 QsciScintilla::setEdgeColumn(int)
    {86, 1279, 230, 1, 0, 0, 123},	//1857 QsciScintilla::setEdgeMode(QsciScintilla::EdgeMode)
    {86, 1294, 18, 1, 0, 0, 124},	//1858 QsciScintilla::setFirstVisibleLine(int)
    {86, 1368, 87, 2, 0, 0, 125},	//1859 QsciScintilla::setIndicatorDrawUnder(bool, int)
    {86, 1371, 84, 2, 0, 0, 126},	//1860 QsciScintilla::setIndicatorForegroundColor(const QColor&, int)
    {86, 1374, 84, 2, 0, 0, 127},	//1861 QsciScintilla::setIndicatorHoverForegroundColor(const QColor&, int)
    {86, 1377, 183, 2, 0, 0, 128},	//1862 QsciScintilla::setIndicatorHoverStyle(QsciScintilla::IndicatorStyle, int)
    {86, 1380, 84, 2, 0, 0, 129},	//1863 QsciScintilla::setIndicatorOutlineColor(const QColor&, int)
    {86, 1401, 18, 1, 0, 0, 130},	//1864 QsciScintilla::setMarginOptions(int)
    {86, 1405, 134, 3, 0, 0, 131},	//1865 QsciScintilla::setMarginText(int, const QString&, int)
    {86, 1405, 138, 3, 0, 0, 132},	//1866 QsciScintilla::setMarginText(int, const QString&, const QsciStyle&)
    {86, 1405, 142, 2, 0, 0, 133},	//1867 QsciScintilla::setMarginText(int, const QsciStyledText&)
    {86, 1405, 145, 2, 0, 0, 134},	//1868 QsciScintilla::setMarginText(int, const QList<QsciStyledText>&)
    {86, 1410, 232, 2, 0, 0, 135},	//1869 QsciScintilla::setMarginType(int, QsciScintilla::MarginType)
    {86, 864, 18, 1, 0, 0, 136},	//1870 QsciScintilla::clearMarginText(int)
    {86, 1420, 84, 2, 0, 0, 137},	//1871 QsciScintilla::setMarkerBackgroundColor(const QColor&, int)
    {86, 1423, 84, 2, 0, 0, 138},	//1872 QsciScintilla::setMarkerForegroundColor(const QColor&, int)
    {86, 1426, 80, 1, 0, 0, 139},	//1873 QsciScintilla::setMatchedBraceBackgroundColor(const QColor&)
    {86, 1428, 80, 1, 0, 0, 140},	//1874 QsciScintilla::setMatchedBraceForegroundColor(const QColor&)
    {86, 1430, 18, 1, 0, 0, 141},	//1875 QsciScintilla::setMatchedBraceIndicator(int)
    {86, 1176, 0, 0, 0, 0, 142},	//1876 QsciScintilla::resetMatchedBraceIndicator()
    {86, 1479, 80, 1, 0, 0, 143},	//1877 QsciScintilla::setUnmatchedBraceBackgroundColor(const QColor&)
    {86, 1481, 80, 1, 0, 0, 144},	//1878 QsciScintilla::setUnmatchedBraceForegroundColor(const QColor&)
    {86, 1483, 18, 1, 0, 0, 145},	//1879 QsciScintilla::setUnmatchedBraceIndicator(int)
    {86, 1179, 0, 0, 0, 0, 146},	//1880 QsciScintilla::resetUnmatchedBraceIndicator()
    {86, 1509, 235, 3, 0, 0, 147},	//1881 QsciScintilla::setWrapVisualFlags(QsciScintilla::WrapVisualFlag, QsciScintilla::WrapVisualFlag, int)
    {86, 1191, 0, 0, Smoke::mf_const, 40, 148},	//1882 QsciScintilla::selectedText() const
    {86, 1193, 0, 0, Smoke::mf_const, 189, 149},	//1883 QsciScintilla::selectionToEol() const
    {86, 1346, 80, 1, 0, 0, 150},	//1884 QsciScintilla::setHotspotBackgroundColor(const QColor&)
    {86, 1348, 80, 1, 0, 0, 151},	//1885 QsciScintilla::setHotspotForegroundColor(const QColor&)
    {86, 1350, 16, 1, 0, 0, 152},	//1886 QsciScintilla::setHotspotUnderline(bool)
    {86, 1352, 16, 1, 0, 0, 153},	//1887 QsciScintilla::setHotspotWrap(bool)
    {86, 1458, 16, 1, 0, 0, 154},	//1888 QsciScintilla::setSelectionToEol(bool)
    {86, 1290, 18, 1, 0, 0, 155},	//1889 QsciScintilla::setExtraAscent(int)
    {86, 1292, 18, 1, 0, 0, 156},	//1890 QsciScintilla::setExtraDescent(int)
    {86, 1434, 16, 1, 0, 0, 157},	//1891 QsciScintilla::setOverwriteMode(bool)
    {86, 1497, 80, 1, 0, 0, 158},	//1892 QsciScintilla::setWhitespaceBackgroundColor(const QColor&)
    {86, 1499, 80, 1, 0, 0, 159},	//1893 QsciScintilla::setWhitespaceForegroundColor(const QColor&)
    {86, 1501, 18, 1, 0, 0, 160},	//1894 QsciScintilla::setWhitespaceSize(int)
    {86, 1505, 239, 1, 0, 0, 161},	//1895 QsciScintilla::setWrapIndentMode(QsciScintilla::WrapIndentMode)
    {86, 1514, 241, 2, 0, 0, 162},	//1896 QsciScintilla::showUserList(int, const QStringList&)
    {86, 1518, 0, 0, Smoke::mf_const, 54, 163},	//1897 QsciScintilla::standardCommands() const
    {86, 1531, 0, 0, Smoke::mf_const, 189, 164},	//1898 QsciScintilla::tabIndents() const
    {86, 1532, 0, 0, Smoke::mf_const, 215, 165},	//1899 QsciScintilla::tabWidth() const
    {86, 1534, 0, 0, Smoke::mf_const, 40, 166},	//1900 QsciScintilla::text() const
    {86, 1534, 18, 1, Smoke::mf_const, 40, 167},	//1901 QsciScintilla::text(int) const
    {86, 1540, 18, 1, Smoke::mf_const, 215, 168},	//1902 QsciScintilla::textHeight(int) const
    {86, 1570, 0, 0, Smoke::mf_const, 215, 169},	//1903 QsciScintilla::whitespaceSize() const
    {86, 1571, 0, 0, Smoke::mf_const, 106, 170},	//1904 QsciScintilla::whitespaceVisibility() const
    {86, 1573, 99, 2, Smoke::mf_const, 40, 171},	//1905 QsciScintilla::wordAtLineIndex(int, int) const
    {86, 1575, 188, 1, Smoke::mf_const, 40, 172},	//1906 QsciScintilla::wordAtPoint(const QPoint&) const
    {86, 1577, 0, 0, Smoke::mf_const, 213, 173},	//1907 QsciScintilla::wordCharacters() const
    {86, 1579, 0, 0, Smoke::mf_const, 108, 174},	//1908 QsciScintilla::wrapMode() const
    {86, 1578, 0, 0, Smoke::mf_const, 107, 175},	//1909 QsciScintilla::wrapIndentMode() const
    {86, 1580, 209, 1, Smoke::mf_const, 189, 176},	//1910 QsciScintilla::write(QIODevice*) const
    {86, 804, 55, 1, Smoke::mf_virtual|Smoke::mf_slot, 0, 177},	//1911 QsciScintilla::append(const QString&)
    {86, 809, 0, 0, Smoke::mf_virtual|Smoke::mf_slot, 0, 178},	//1912 QsciScintilla::autoCompleteFromAll()
    {86, 808, 0, 0, Smoke::mf_virtual|Smoke::mf_slot, 0, 179},	//1913 QsciScintilla::autoCompleteFromAPIs()
    {86, 810, 0, 0, Smoke::mf_virtual|Smoke::mf_slot, 0, 180},	//1914 QsciScintilla::autoCompleteFromDocument()
    {86, 840, 0, 0, Smoke::mf_virtual|Smoke::mf_slot, 0, 181},	//1915 QsciScintilla::callTip()
    {86, 856, 0, 0, Smoke::mf_virtual|Smoke::mf_slot, 0, 182},	//1916 QsciScintilla::clear()
    {86, 882, 0, 0, Smoke::mf_virtual|Smoke::mf_slot, 0, 183},	//1917 QsciScintilla::copy()
    {86, 889, 0, 0, Smoke::mf_virtual|Smoke::mf_slot, 0, 184},	//1918 QsciScintilla::cut()
    {86, 923, 0, 0, Smoke::mf_virtual|Smoke::mf_slot, 0, 185},	//1919 QsciScintilla::ensureCursorVisible()
    {86, 924, 18, 1, Smoke::mf_virtual|Smoke::mf_slot, 0, 186},	//1920 QsciScintilla::ensureLineVisible(int)
    {86, 963, 16, 1, Smoke::mf_virtual|Smoke::mf_slot, 0, 187},	//1921 QsciScintilla::foldAll(bool)
    {86, 971, 18, 1, Smoke::mf_virtual|Smoke::mf_slot, 0, 188},	//1922 QsciScintilla::foldLine(int)
    {86, 1004, 18, 1, Smoke::mf_virtual|Smoke::mf_slot, 0, 189},	//1923 QsciScintilla::indent(int)
    {86, 1027, 55, 1, Smoke::mf_virtual|Smoke::mf_slot, 0, 190},	//1924 QsciScintilla::insert(const QString&)
    {86, 1029, 244, 3, Smoke::mf_virtual|Smoke::mf_slot, 0, 191},	//1925 QsciScintilla::insertAt(const QString&, int, int)
    {86, 1120, 0, 0, Smoke::mf_virtual|Smoke::mf_slot, 0, 192},	//1926 QsciScintilla::moveToMatchingBrace()
    {86, 1132, 0, 0, Smoke::mf_virtual|Smoke::mf_slot, 0, 193},	//1927 QsciScintilla::paste()
    {86, 1161, 0, 0, Smoke::mf_virtual|Smoke::mf_slot, 0, 194},	//1928 QsciScintilla::redo()
    {86, 1168, 0, 0, Smoke::mf_virtual|Smoke::mf_slot, 0, 195},	//1929 QsciScintilla::removeSelectedText()
    {86, 1171, 55, 1, Smoke::mf_virtual|Smoke::mf_slot, 0, 196},	//1930 QsciScintilla::replaceSelectedText(const QString&)
    {86, 1177, 0, 0, Smoke::mf_virtual|Smoke::mf_slot, 0, 197},	//1931 QsciScintilla::resetSelectionBackgroundColor()
    {86, 1178, 0, 0, Smoke::mf_virtual|Smoke::mf_slot, 0, 198},	//1932 QsciScintilla::resetSelectionForegroundColor()
    {86, 1188, 16, 1, Smoke::mf_virtual|Smoke::mf_slot, 0, 199},	//1933 QsciScintilla::selectAll(bool)
    {86, 1190, 0, 0, Smoke::mf_virtual|Smoke::mf_slot, 0, 200},	//1934 QsciScintilla::selectToMatchingBrace()
    {86, 1200, 16, 1, Smoke::mf_virtual|Smoke::mf_slot, 0, 201},	//1935 QsciScintilla::setAutoCompletionCaseSensitivity(bool)
    {86, 1206, 16, 1, Smoke::mf_virtual|Smoke::mf_slot, 0, 202},	//1936 QsciScintilla::setAutoCompletionReplaceWord(bool)
    {86, 1208, 16, 1, Smoke::mf_virtual|Smoke::mf_slot, 0, 203},	//1937 QsciScintilla::setAutoCompletionShowSingle(bool)
    {86, 1210, 248, 1, Smoke::mf_virtual|Smoke::mf_slot, 0, 204},	//1938 QsciScintilla::setAutoCompletionSource(QsciScintilla::AutoCompletionSource)
    {86, 1212, 18, 1, Smoke::mf_virtual|Smoke::mf_slot, 0, 205},	//1939 QsciScintilla::setAutoCompletionThreshold(int)
    {86, 1214, 250, 1, Smoke::mf_virtual|Smoke::mf_slot, 0, 206},	//1940 QsciScintilla::setAutoCompletionUseSingle(QsciScintilla::AutoCompletionUseSingle)
    {86, 1218, 16, 1, Smoke::mf_virtual|Smoke::mf_slot, 0, 207},	//1941 QsciScintilla::setAutoIndent(bool)
    {86, 1226, 252, 1, Smoke::mf_virtual|Smoke::mf_slot, 0, 208},	//1942 QsciScintilla::setBraceMatching(QsciScintilla::BraceMatch)
    {86, 1224, 16, 1, Smoke::mf_virtual|Smoke::mf_slot, 0, 209},	//1943 QsciScintilla::setBackspaceUnindents(bool)
    {86, 1240, 80, 1, Smoke::mf_virtual|Smoke::mf_slot, 0, 210},	//1944 QsciScintilla::setCaretForegroundColor(const QColor&)
    {86, 1242, 80, 1, Smoke::mf_virtual|Smoke::mf_slot, 0, 211},	//1945 QsciScintilla::setCaretLineBackgroundColor(const QColor&)
    {86, 1244, 16, 1, Smoke::mf_virtual|Smoke::mf_slot, 0, 212},	//1946 QsciScintilla::setCaretLineVisible(bool)
    {86, 1246, 18, 1, Smoke::mf_virtual|Smoke::mf_slot, 0, 213},	//1947 QsciScintilla::setCaretWidth(int)
    {86, 1252, 80, 1, Smoke::mf_virtual|Smoke::mf_slot, 0, 214},	//1948 QsciScintilla::setColor(const QColor&)
    {86, 1257, 99, 2, Smoke::mf_virtual|Smoke::mf_slot, 0, 215},	//1949 QsciScintilla::setCursorPosition(int, int)
    {86, 1286, 154, 1, Smoke::mf_virtual|Smoke::mf_slot, 0, 216},	//1950 QsciScintilla::setEolMode(QsciScintilla::EolMode)
    {86, 1288, 16, 1, Smoke::mf_virtual|Smoke::mf_slot, 0, 217},	//1951 QsciScintilla::setEolVisibility(bool)
    {86, 1324, 254, 2, Smoke::mf_virtual|Smoke::mf_slot, 0, 218},	//1952 QsciScintilla::setFolding(QsciScintilla::FoldStyle, int)
    {86, 1354, 99, 2, Smoke::mf_virtual|Smoke::mf_slot, 0, 219},	//1953 QsciScintilla::setIndentation(int, int)
    {86, 1356, 16, 1, Smoke::mf_virtual|Smoke::mf_slot, 0, 220},	//1954 QsciScintilla::setIndentationGuides(bool)
    {86, 1358, 80, 1, Smoke::mf_virtual|Smoke::mf_slot, 0, 221},	//1955 QsciScintilla::setIndentationGuidesBackgroundColor(const QColor&)
    {86, 1360, 80, 1, Smoke::mf_virtual|Smoke::mf_slot, 0, 222},	//1956 QsciScintilla::setIndentationGuidesForegroundColor(const QColor&)
    {86, 1366, 16, 1, Smoke::mf_virtual|Smoke::mf_slot, 0, 223},	//1957 QsciScintilla::setIndentationsUseTabs(bool)
    {86, 1364, 18, 1, Smoke::mf_virtual|Smoke::mf_slot, 0, 224},	//1958 QsciScintilla::setIndentationWidth(int)
    {86, 1391, 53, 1, Smoke::mf_virtual|Smoke::mf_slot, 0, 225},	//1959 QsciScintilla::setLexer(QsciLexer*)
    {86, 1414, 80, 1, Smoke::mf_virtual|Smoke::mf_slot, 0, 226},	//1960 QsciScintilla::setMarginsBackgroundColor(const QColor&)
    {86, 1416, 40, 1, Smoke::mf_virtual|Smoke::mf_slot, 0, 227},	//1961 QsciScintilla::setMarginsFont(const QFont&)
    {86, 1418, 80, 1, Smoke::mf_virtual|Smoke::mf_slot, 0, 228},	//1962 QsciScintilla::setMarginsForegroundColor(const QColor&)
    {86, 1397, 257, 2, Smoke::mf_virtual|Smoke::mf_slot, 0, 229},	//1963 QsciScintilla::setMarginLineNumbers(int, bool)
    {86, 1399, 99, 2, Smoke::mf_virtual|Smoke::mf_slot, 0, 230},	//1964 QsciScintilla::setMarginMarkerMask(int, int)
    {86, 1403, 257, 2, Smoke::mf_virtual|Smoke::mf_slot, 0, 231},	//1965 QsciScintilla::setMarginSensitivity(int, bool)
    {86, 1412, 99, 2, Smoke::mf_virtual|Smoke::mf_slot, 0, 232},	//1966 QsciScintilla::setMarginWidth(int, int)
    {86, 1412, 260, 2, Smoke::mf_virtual|Smoke::mf_slot, 0, 233},	//1967 QsciScintilla::setMarginWidth(int, const QString&)
    {86, 1432, 16, 1, Smoke::mf_virtual|Smoke::mf_slot, 0, 234},	//1968 QsciScintilla::setModified(bool)
    {86, 1436, 80, 1, Smoke::mf_virtual|Smoke::mf_slot, 0, 235},	//1969 QsciScintilla::setPaper(const QColor&)
    {86, 1445, 16, 1, Smoke::mf_virtual|Smoke::mf_slot, 0, 236},	//1970 QsciScintilla::setReadOnly(bool)
    {86, 1452, 263, 4, Smoke::mf_virtual|Smoke::mf_slot, 0, 237},	//1971 QsciScintilla::setSelection(int, int, int, int)
    {86, 1454, 80, 1, Smoke::mf_virtual|Smoke::mf_slot, 0, 238},	//1972 QsciScintilla::setSelectionBackgroundColor(const QColor&)
    {86, 1456, 80, 1, Smoke::mf_virtual|Smoke::mf_slot, 0, 239},	//1973 QsciScintilla::setSelectionForegroundColor(const QColor&)
    {86, 1469, 16, 1, Smoke::mf_virtual|Smoke::mf_slot, 0, 240},	//1974 QsciScintilla::setTabIndents(bool)
    {86, 1471, 18, 1, Smoke::mf_virtual|Smoke::mf_slot, 0, 241},	//1975 QsciScintilla::setTabWidth(int)
    {86, 1473, 55, 1, Smoke::mf_virtual|Smoke::mf_slot, 0, 242},	//1976 QsciScintilla::setText(const QString&)
    {86, 1485, 16, 1, Smoke::mf_virtual|Smoke::mf_slot, 0, 243},	//1977 QsciScintilla::setUtf8(bool)
    {86, 1503, 268, 1, Smoke::mf_virtual|Smoke::mf_slot, 0, 244},	//1978 QsciScintilla::setWhitespaceVisibility(QsciScintilla::WhitespaceVisibility)
    {86, 1507, 121, 1, Smoke::mf_virtual|Smoke::mf_slot, 0, 245},	//1979 QsciScintilla::setWrapMode(QsciScintilla::WrapMode)
    {86, 1554, 0, 0, Smoke::mf_virtual|Smoke::mf_slot, 0, 246},	//1980 QsciScintilla::undo()
    {86, 1555, 18, 1, Smoke::mf_virtual|Smoke::mf_slot, 0, 247},	//1981 QsciScintilla::unindent(int)
    {86, 1588, 18, 1, Smoke::mf_virtual|Smoke::mf_slot, 0, 248},	//1982 QsciScintilla::zoomIn(int)
    {86, 1588, 0, 0, Smoke::mf_virtual|Smoke::mf_slot, 0, 249},	//1983 QsciScintilla::zoomIn()
    {86, 1590, 18, 1, Smoke::mf_virtual|Smoke::mf_slot, 0, 250},	//1984 QsciScintilla::zoomOut(int)
    {86, 1590, 0, 0, Smoke::mf_virtual|Smoke::mf_slot, 0, 251},	//1985 QsciScintilla::zoomOut()
    {86, 1592, 18, 1, Smoke::mf_virtual|Smoke::mf_slot, 0, 252},	//1986 QsciScintilla::zoomTo(int)
    {86, 886, 99, 2, Smoke::mf_protected|Smoke::mf_signal, 0, 253},	//1987 QsciScintilla::cursorPositionChanged(int, int)
    {86, 883, 16, 1, Smoke::mf_protected|Smoke::mf_signal, 0, 254},	//1988 QsciScintilla::copyAvailable(bool)
    {86, 1013, 270, 3, Smoke::mf_protected|Smoke::mf_signal, 0, 255},	//1989 QsciScintilla::indicatorClicked(int, int, Qt::KeyboardModifiers)
    {86, 1020, 270, 3, Smoke::mf_protected|Smoke::mf_signal, 0, 256},	//1990 QsciScintilla::indicatorReleased(int, int, Qt::KeyboardModifiers)
    {86, 1063, 0, 0, Smoke::mf_protected|Smoke::mf_signal, 0, 257},	//1991 QsciScintilla::linesChanged()
    {86, 1070, 270, 3, Smoke::mf_protected|Smoke::mf_signal, 0, 258},	//1992 QsciScintilla::marginClicked(int, int, Qt::KeyboardModifiers)
    {86, 1108, 0, 0, Smoke::mf_protected|Smoke::mf_signal, 0, 259},	//1993 QsciScintilla::modificationAttempted()
    {86, 1109, 16, 1, Smoke::mf_protected|Smoke::mf_signal, 0, 260},	//1994 QsciScintilla::modificationChanged(bool)
    {86, 1192, 0, 0, Smoke::mf_protected|Smoke::mf_signal, 0, 261},	//1995 QsciScintilla::selectionChanged()
    {86, 1539, 0, 0, Smoke::mf_protected|Smoke::mf_signal, 0, 262},	//1996 QsciScintilla::textChanged()
    {86, 1559, 260, 2, Smoke::mf_protected|Smoke::mf_signal, 0, 263},	//1997 QsciScintilla::userListActivated(int, const QString&)
    {86, 933, 1, 1, Smoke::mf_protected|Smoke::mf_virtual, 189, 264},	//1998 QsciScintilla::event(QEvent*)
    {86, 852, 1, 1, Smoke::mf_protected|Smoke::mf_virtual, 0, 265},	//1999 QsciScintilla::changeEvent(QEvent*)
    {86, 877, 274, 1, Smoke::mf_protected|Smoke::mf_virtual, 0, 266},	//2000 QsciScintilla::contextMenuEvent(QContextMenuEvent*)
    {86, 1546, 12, 1, Smoke::mf_static, 40, 267},	//2001 QsciScintilla::tr(const char*)
    {86, 1550, 12, 1, Smoke::mf_static, 40, 268},	//2002 QsciScintilla::trUtf8(const char*)
    {86, 535, 0, 0, Smoke::mf_ctor, 92, 269},	//2003 QsciScintilla::QsciScintilla()
    {86, 858, 0, 0, 0, 0, 270},	//2004 QsciScintilla::clearAnnotations()
    {86, 943, 276, 5, 0, 189, 271},	//2005 QsciScintilla::findFirst(const QString&, bool, bool, bool, bool)
    {86, 943, 282, 6, 0, 189, 272},	//2006 QsciScintilla::findFirst(const QString&, bool, bool, bool, bool, bool)
    {86, 943, 289, 7, 0, 189, 273},	//2007 QsciScintilla::findFirst(const QString&, bool, bool, bool, bool, bool, int)
    {86, 943, 297, 8, 0, 189, 274},	//2008 QsciScintilla::findFirst(const QString&, bool, bool, bool, bool, bool, int, int)
    {86, 943, 306, 9, 0, 189, 275},	//2009 QsciScintilla::findFirst(const QString&, bool, bool, bool, bool, bool, int, int, bool)
    {86, 950, 316, 4, 0, 189, 276},	//2010 QsciScintilla::findFirstInSelection(const QString&, bool, bool, bool)
    {86, 950, 276, 5, 0, 189, 277},	//2011 QsciScintilla::findFirstInSelection(const QString&, bool, bool, bool, bool)
    {86, 950, 282, 6, 0, 189, 278},	//2012 QsciScintilla::findFirstInSelection(const QString&, bool, bool, bool, bool, bool)
    {86, 1015, 321, 1, 0, 215, 279},	//2013 QsciScintilla::indicatorDefine(QsciScintilla::IndicatorStyle)
    {86, 1085, 323, 1, 0, 215, 280},	//2014 QsciScintilla::markerDefine(QsciScintilla::MarkerSymbol)
    {86, 1085, 186, 1, 0, 215, 281},	//2015 QsciScintilla::markerDefine(char)
    {86, 1085, 325, 1, 0, 215, 282},	//2016 QsciScintilla::markerDefine(const QPixmap&)
    {86, 1085, 327, 1, 0, 215, 283},	//2017 QsciScintilla::markerDefine(const QImage&)
    {86, 1090, 18, 1, 0, 0, 284},	//2018 QsciScintilla::markerDelete(int)
    {86, 1093, 0, 0, 0, 0, 285},	//2019 QsciScintilla::markerDeleteAll()
    {86, 1158, 0, 0, 0, 0, 286},	//2020 QsciScintilla::recolor()
    {86, 1158, 18, 1, 0, 0, 287},	//2021 QsciScintilla::recolor(int)
    {86, 1368, 16, 1, 0, 0, 288},	//2022 QsciScintilla::setIndicatorDrawUnder(bool)
    {86, 1371, 80, 1, 0, 0, 289},	//2023 QsciScintilla::setIndicatorForegroundColor(const QColor&)
    {86, 1374, 80, 1, 0, 0, 290},	//2024 QsciScintilla::setIndicatorHoverForegroundColor(const QColor&)
    {86, 1377, 321, 1, 0, 0, 291},	//2025 QsciScintilla::setIndicatorHoverStyle(QsciScintilla::IndicatorStyle)
    {86, 1380, 80, 1, 0, 0, 292},	//2026 QsciScintilla::setIndicatorOutlineColor(const QColor&)
    {86, 864, 0, 0, 0, 0, 293},	//2027 QsciScintilla::clearMarginText()
    {86, 1420, 80, 1, 0, 0, 294},	//2028 QsciScintilla::setMarkerBackgroundColor(const QColor&)
    {86, 1423, 80, 1, 0, 0, 295},	//2029 QsciScintilla::setMarkerForegroundColor(const QColor&)
    {86, 1509, 329, 1, 0, 0, 296},	//2030 QsciScintilla::setWrapVisualFlags(QsciScintilla::WrapVisualFlag)
    {86, 1509, 331, 2, 0, 0, 297},	//2031 QsciScintilla::setWrapVisualFlags(QsciScintilla::WrapVisualFlag, QsciScintilla::WrapVisualFlag)
    {86, 963, 0, 0, Smoke::mf_slot, 0, 298},	//2032 QsciScintilla::foldAll()
    {86, 1188, 0, 0, Smoke::mf_slot, 0, 299},	//2033 QsciScintilla::selectAll()
    {86, 1324, 334, 1, Smoke::mf_slot, 0, 300},	//2034 QsciScintilla::setFolding(QsciScintilla::FoldStyle)
    {86, 1391, 0, 0, Smoke::mf_slot, 0, 301},	//2035 QsciScintilla::setLexer()
    {86, 1523, 0, 0, Smoke::mf_const|Smoke::mf_static|Smoke::mf_attribute, 199, 302},	//2036 QsciScintilla::staticMetaObject() const
    {86, 363, 0, 0, Smoke::mf_static|Smoke::mf_enum, 218, 303},	//2037 QsciScintilla::MoNone (enum)
    {86, 364, 0, 0, Smoke::mf_static|Smoke::mf_enum, 218, 304},	//2038 QsciScintilla::MoSublineSelect (enum)
    {86, 59, 0, 0, Smoke::mf_static|Smoke::mf_enum, 93, 305},	//2039 QsciScintilla::AnnotationHidden (enum)
    {86, 61, 0, 0, Smoke::mf_static|Smoke::mf_enum, 93, 306},	//2040 QsciScintilla::AnnotationStandard (enum)
    {86, 58, 0, 0, Smoke::mf_static|Smoke::mf_enum, 93, 307},	//2041 QsciScintilla::AnnotationBoxed (enum)
    {86, 60, 0, 0, Smoke::mf_static|Smoke::mf_enum, 93, 308},	//2042 QsciScintilla::AnnotationIndented (enum)
    {86, 56, 0, 0, Smoke::mf_static|Smoke::mf_enum, 95, 309},	//2043 QsciScintilla::AcusNever (enum)
    {86, 55, 0, 0, Smoke::mf_static|Smoke::mf_enum, 95, 310},	//2044 QsciScintilla::AcusExplicit (enum)
    {86, 54, 0, 0, Smoke::mf_static|Smoke::mf_enum, 95, 311},	//2045 QsciScintilla::AcusAlways (enum)
    {86, 52, 0, 0, Smoke::mf_static|Smoke::mf_enum, 94, 312},	//2046 QsciScintilla::AcsNone (enum)
    {86, 50, 0, 0, Smoke::mf_static|Smoke::mf_enum, 94, 313},	//2047 QsciScintilla::AcsAll (enum)
    {86, 51, 0, 0, Smoke::mf_static|Smoke::mf_enum, 94, 314},	//2048 QsciScintilla::AcsDocument (enum)
    {86, 49, 0, 0, Smoke::mf_static|Smoke::mf_enum, 94, 315},	//2049 QsciScintilla::AcsAPIs (enum)
    {86, 374, 0, 0, Smoke::mf_static|Smoke::mf_enum, 96, 316},	//2050 QsciScintilla::NoBraceMatch (enum)
    {86, 675, 0, 0, Smoke::mf_static|Smoke::mf_enum, 96, 317},	//2051 QsciScintilla::StrictBraceMatch (enum)
    {86, 659, 0, 0, Smoke::mf_static|Smoke::mf_enum, 96, 318},	//2052 QsciScintilla::SloppyBraceMatch (enum)
    {86, 111, 0, 0, Smoke::mf_static|Smoke::mf_enum, 97, 319},	//2053 QsciScintilla::CallTipsBelowText (enum)
    {86, 110, 0, 0, Smoke::mf_static|Smoke::mf_enum, 97, 320},	//2054 QsciScintilla::CallTipsAboveText (enum)
    {86, 115, 0, 0, Smoke::mf_static|Smoke::mf_enum, 98, 321},	//2055 QsciScintilla::CallTipsNone (enum)
    {86, 114, 0, 0, Smoke::mf_static|Smoke::mf_enum, 98, 322},	//2056 QsciScintilla::CallTipsNoContext (enum)
    {86, 113, 0, 0, Smoke::mf_static|Smoke::mf_enum, 98, 323},	//2057 QsciScintilla::CallTipsNoAutoCompletionContext (enum)
    {86, 112, 0, 0, Smoke::mf_static|Smoke::mf_enum, 98, 324},	//2058 QsciScintilla::CallTipsContext (enum)
    {86, 197, 0, 0, Smoke::mf_static|Smoke::mf_enum, 99, 325},	//2059 QsciScintilla::EdgeNone (enum)
    {86, 196, 0, 0, Smoke::mf_static|Smoke::mf_enum, 99, 326},	//2060 QsciScintilla::EdgeLine (enum)
    {86, 195, 0, 0, Smoke::mf_static|Smoke::mf_enum, 99, 327},	//2061 QsciScintilla::EdgeBackground (enum)
    {86, 204, 0, 0, Smoke::mf_static|Smoke::mf_enum, 100, 328},	//2062 QsciScintilla::EolWindows (enum)
    {86, 203, 0, 0, Smoke::mf_static|Smoke::mf_enum, 100, 329},	//2063 QsciScintilla::EolUnix (enum)
    {86, 202, 0, 0, Smoke::mf_static|Smoke::mf_enum, 100, 330},	//2064 QsciScintilla::EolMac (enum)
    {86, 375, 0, 0, Smoke::mf_static|Smoke::mf_enum, 101, 331},	//2065 QsciScintilla::NoFoldStyle (enum)
    {86, 420, 0, 0, Smoke::mf_static|Smoke::mf_enum, 101, 332},	//2066 QsciScintilla::PlainFoldStyle (enum)
    {86, 127, 0, 0, Smoke::mf_static|Smoke::mf_enum, 101, 333},	//2067 QsciScintilla::CircledFoldStyle (enum)
    {86, 99, 0, 0, Smoke::mf_static|Smoke::mf_enum, 101, 334},	//2068 QsciScintilla::BoxedFoldStyle (enum)
    {86, 132, 0, 0, Smoke::mf_static|Smoke::mf_enum, 101, 335},	//2069 QsciScintilla::CircledTreeFoldStyle (enum)
    {86, 104, 0, 0, Smoke::mf_static|Smoke::mf_enum, 101, 336},	//2070 QsciScintilla::BoxedTreeFoldStyle (enum)
    {86, 421, 0, 0, Smoke::mf_static|Smoke::mf_enum, 103, 337},	//2071 QsciScintilla::PlainIndicator (enum)
    {86, 664, 0, 0, Smoke::mf_static|Smoke::mf_enum, 103, 338},	//2072 QsciScintilla::SquiggleIndicator (enum)
    {86, 699, 0, 0, Smoke::mf_static|Smoke::mf_enum, 103, 339},	//2073 QsciScintilla::TTIndicator (enum)
    {86, 172, 0, 0, Smoke::mf_static|Smoke::mf_enum, 103, 340},	//2074 QsciScintilla::DiagonalIndicator (enum)
    {86, 676, 0, 0, Smoke::mf_static|Smoke::mf_enum, 103, 341},	//2075 QsciScintilla::StrikeIndicator (enum)
    {86, 242, 0, 0, Smoke::mf_static|Smoke::mf_enum, 103, 342},	//2076 QsciScintilla::HiddenIndicator (enum)
    {86, 98, 0, 0, Smoke::mf_static|Smoke::mf_enum, 103, 343},	//2077 QsciScintilla::BoxIndicator (enum)
    {86, 569, 0, 0, Smoke::mf_static|Smoke::mf_enum, 103, 344},	//2078 QsciScintilla::RoundBoxIndicator (enum)
    {86, 674, 0, 0, Smoke::mf_static|Smoke::mf_enum, 103, 345},	//2079 QsciScintilla::StraightBoxIndicator (enum)
    {86, 220, 0, 0, Smoke::mf_static|Smoke::mf_enum, 103, 346},	//2080 QsciScintilla::FullBoxIndicator (enum)
    {86, 157, 0, 0, Smoke::mf_static|Smoke::mf_enum, 103, 347},	//2081 QsciScintilla::DashesIndicator (enum)
    {86, 182, 0, 0, Smoke::mf_static|Smoke::mf_enum, 103, 348},	//2082 QsciScintilla::DotsIndicator (enum)
    {86, 665, 0, 0, Smoke::mf_static|Smoke::mf_enum, 103, 349},	//2083 QsciScintilla::SquiggleLowIndicator (enum)
    {86, 181, 0, 0, Smoke::mf_static|Smoke::mf_enum, 103, 350},	//2084 QsciScintilla::DotBoxIndicator (enum)
    {86, 666, 0, 0, Smoke::mf_static|Smoke::mf_enum, 103, 351},	//2085 QsciScintilla::SquigglePixmapIndicator (enum)
    {86, 712, 0, 0, Smoke::mf_static|Smoke::mf_enum, 103, 352},	//2086 QsciScintilla::ThickCompositionIndicator (enum)
    {86, 713, 0, 0, Smoke::mf_static|Smoke::mf_enum, 103, 353},	//2087 QsciScintilla::ThinCompositionIndicator (enum)
    {86, 709, 0, 0, Smoke::mf_static|Smoke::mf_enum, 103, 354},	//2088 QsciScintilla::TextColorIndicator (enum)
    {86, 363, 0, 0, Smoke::mf_static|Smoke::mf_enum, 218, 355},	//2089 QsciScintilla::MoNone (enum)
    {86, 364, 0, 0, Smoke::mf_static|Smoke::mf_enum, 218, 356},	//2090 QsciScintilla::MoSublineSelect (enum)
    {86, 693, 0, 0, Smoke::mf_static|Smoke::mf_enum, 104, 357},	//2091 QsciScintilla::SymbolMargin (enum)
    {86, 695, 0, 0, Smoke::mf_static|Smoke::mf_enum, 104, 358},	//2092 QsciScintilla::SymbolMarginDefaultForegroundColor (enum)
    {86, 694, 0, 0, Smoke::mf_static|Smoke::mf_enum, 104, 359},	//2093 QsciScintilla::SymbolMarginDefaultBackgroundColor (enum)
    {86, 379, 0, 0, Smoke::mf_static|Smoke::mf_enum, 104, 360},	//2094 QsciScintilla::NumberMargin (enum)
    {86, 710, 0, 0, Smoke::mf_static|Smoke::mf_enum, 104, 361},	//2095 QsciScintilla::TextMargin (enum)
    {86, 711, 0, 0, Smoke::mf_static|Smoke::mf_enum, 104, 362},	//2096 QsciScintilla::TextMarginRightJustified (enum)
    {86, 126, 0, 0, Smoke::mf_static|Smoke::mf_enum, 105, 363},	//2097 QsciScintilla::Circle (enum)
    {86, 562, 0, 0, Smoke::mf_static|Smoke::mf_enum, 105, 364},	//2098 QsciScintilla::Rectangle (enum)
    {86, 568, 0, 0, Smoke::mf_static|Smoke::mf_enum, 105, 365},	//2099 QsciScintilla::RightTriangle (enum)
    {86, 661, 0, 0, Smoke::mf_static|Smoke::mf_enum, 105, 366},	//2100 QsciScintilla::SmallRectangle (enum)
    {86, 567, 0, 0, Smoke::mf_static|Smoke::mf_enum, 105, 367},	//2101 QsciScintilla::RightArrow (enum)
    {86, 292, 0, 0, Smoke::mf_static|Smoke::mf_enum, 105, 368},	//2102 QsciScintilla::Invisible (enum)
    {86, 188, 0, 0, Smoke::mf_static|Smoke::mf_enum, 105, 369},	//2103 QsciScintilla::DownTriangle (enum)
    {86, 362, 0, 0, Smoke::mf_static|Smoke::mf_enum, 105, 370},	//2104 QsciScintilla::Minus (enum)
    {86, 422, 0, 0, Smoke::mf_static|Smoke::mf_enum, 105, 371},	//2105 QsciScintilla::Plus (enum)
    {86, 753, 0, 0, Smoke::mf_static|Smoke::mf_enum, 105, 372},	//2106 QsciScintilla::VerticalLine (enum)
    {86, 96, 0, 0, Smoke::mf_static|Smoke::mf_enum, 105, 373},	//2107 QsciScintilla::BottomLeftCorner (enum)
    {86, 325, 0, 0, Smoke::mf_static|Smoke::mf_enum, 105, 374},	//2108 QsciScintilla::LeftSideSplitter (enum)
    {86, 102, 0, 0, Smoke::mf_static|Smoke::mf_enum, 105, 375},	//2109 QsciScintilla::BoxedPlus (enum)
    {86, 103, 0, 0, Smoke::mf_static|Smoke::mf_enum, 105, 376},	//2110 QsciScintilla::BoxedPlusConnected (enum)
    {86, 100, 0, 0, Smoke::mf_static|Smoke::mf_enum, 105, 377},	//2111 QsciScintilla::BoxedMinus (enum)
    {86, 101, 0, 0, Smoke::mf_static|Smoke::mf_enum, 105, 378},	//2112 QsciScintilla::BoxedMinusConnected (enum)
    {86, 570, 0, 0, Smoke::mf_static|Smoke::mf_enum, 105, 379},	//2113 QsciScintilla::RoundedBottomLeftCorner (enum)
    {86, 324, 0, 0, Smoke::mf_static|Smoke::mf_enum, 105, 380},	//2114 QsciScintilla::LeftSideRoundedSplitter (enum)
    {86, 130, 0, 0, Smoke::mf_static|Smoke::mf_enum, 105, 381},	//2115 QsciScintilla::CircledPlus (enum)
    {86, 131, 0, 0, Smoke::mf_static|Smoke::mf_enum, 105, 382},	//2116 QsciScintilla::CircledPlusConnected (enum)
    {86, 128, 0, 0, Smoke::mf_static|Smoke::mf_enum, 105, 383},	//2117 QsciScintilla::CircledMinus (enum)
    {86, 129, 0, 0, Smoke::mf_static|Smoke::mf_enum, 105, 384},	//2118 QsciScintilla::CircledMinusConnected (enum)
    {86, 80, 0, 0, Smoke::mf_static|Smoke::mf_enum, 105, 385},	//2119 QsciScintilla::Background (enum)
    {86, 714, 0, 0, Smoke::mf_static|Smoke::mf_enum, 105, 386},	//2120 QsciScintilla::ThreeDots (enum)
    {86, 715, 0, 0, Smoke::mf_static|Smoke::mf_enum, 105, 387},	//2121 QsciScintilla::ThreeRightArrows (enum)
    {86, 221, 0, 0, Smoke::mf_static|Smoke::mf_enum, 105, 388},	//2122 QsciScintilla::FullRectangle (enum)
    {86, 323, 0, 0, Smoke::mf_static|Smoke::mf_enum, 105, 389},	//2123 QsciScintilla::LeftRectangle (enum)
    {86, 727, 0, 0, Smoke::mf_static|Smoke::mf_enum, 105, 390},	//2124 QsciScintilla::Underline (enum)
    {86, 95, 0, 0, Smoke::mf_static|Smoke::mf_enum, 105, 391},	//2125 QsciScintilla::Bookmark (enum)
    {86, 778, 0, 0, Smoke::mf_static|Smoke::mf_enum, 106, 392},	//2126 QsciScintilla::WsInvisible (enum)
    {86, 779, 0, 0, Smoke::mf_static|Smoke::mf_enum, 106, 393},	//2127 QsciScintilla::WsVisible (enum)
    {86, 780, 0, 0, Smoke::mf_static|Smoke::mf_enum, 106, 394},	//2128 QsciScintilla::WsVisibleAfterIndent (enum)
    {86, 775, 0, 0, Smoke::mf_static|Smoke::mf_enum, 108, 395},	//2129 QsciScintilla::WrapNone (enum)
    {86, 777, 0, 0, Smoke::mf_static|Smoke::mf_enum, 108, 396},	//2130 QsciScintilla::WrapWord (enum)
    {86, 767, 0, 0, Smoke::mf_static|Smoke::mf_enum, 108, 397},	//2131 QsciScintilla::WrapCharacter (enum)
    {86, 776, 0, 0, Smoke::mf_static|Smoke::mf_enum, 108, 398},	//2132 QsciScintilla::WrapWhitespace (enum)
    {86, 771, 0, 0, Smoke::mf_static|Smoke::mf_enum, 109, 399},	//2133 QsciScintilla::WrapFlagNone (enum)
    {86, 769, 0, 0, Smoke::mf_static|Smoke::mf_enum, 109, 400},	//2134 QsciScintilla::WrapFlagByText (enum)
    {86, 768, 0, 0, Smoke::mf_static|Smoke::mf_enum, 109, 401},	//2135 QsciScintilla::WrapFlagByBorder (enum)
    {86, 770, 0, 0, Smoke::mf_static|Smoke::mf_enum, 109, 402},	//2136 QsciScintilla::WrapFlagInMargin (enum)
    {86, 772, 0, 0, Smoke::mf_static|Smoke::mf_enum, 107, 403},	//2137 QsciScintilla::WrapIndentFixed (enum)
    {86, 774, 0, 0, Smoke::mf_static|Smoke::mf_enum, 107, 404},	//2138 QsciScintilla::WrapIndentSame (enum)
    {86, 773, 0, 0, Smoke::mf_static|Smoke::mf_enum, 107, 405},	//2139 QsciScintilla::WrapIndentIndented (enum)
    {86, 1631, 0, 0, Smoke::mf_dtor, 0, 406 },	//2140 QsciScintilla::~QsciScintilla()
    {87, 1105, 0, 0, Smoke::mf_const|Smoke::mf_virtual, 200, 1},	//2141 QsciScintillaBase::metaObject() const
    {87, 1148, 12, 1, Smoke::mf_virtual, 221, 2},	//2142 QsciScintillaBase::qt_metacast(const char*)
    {87, 1546, 42, 2, Smoke::mf_static, 40, 3},	//2143 QsciScintillaBase::tr(const char*, const char*)
    {87, 1550, 42, 2, Smoke::mf_static, 40, 4},	//2144 QsciScintillaBase::trUtf8(const char*, const char*)
    {87, 1546, 45, 3, Smoke::mf_static, 40, 5},	//2145 QsciScintillaBase::tr(const char*, const char*, int)
    {87, 1550, 45, 3, Smoke::mf_static, 40, 6},	//2146 QsciScintillaBase::trUtf8(const char*, const char*, int)
    {87, 1146, 49, 3, Smoke::mf_virtual, 215, 7},	//2147 QsciScintillaBase::qt_metacall(QMetaObject::Call, int, void**)
    {87, 537, 128, 1, Smoke::mf_ctor, 110, 8},	//2148 QsciScintillaBase::QsciScintillaBase(QWidget*)
    {87, 1134, 0, 0, Smoke::mf_static, 110, 9},	//2149 QsciScintillaBase::pool()
    {87, 645, 336, 3, Smoke::mf_const, 218, 10},	//2150 QsciScintillaBase::SendScintilla(unsigned int, unsigned long, long) const
    {87, 645, 340, 3, Smoke::mf_const, 218, 11},	//2151 QsciScintillaBase::SendScintilla(unsigned int, unsigned long, void*) const
    {87, 645, 344, 3, Smoke::mf_const, 218, 12},	//2152 QsciScintillaBase::SendScintilla(unsigned int, unsigned long, const char*) const
    {87, 645, 348, 2, Smoke::mf_const, 218, 13},	//2153 QsciScintillaBase::SendScintilla(unsigned int, const char*) const
    {87, 645, 351, 3, Smoke::mf_const, 218, 14},	//2154 QsciScintillaBase::SendScintilla(unsigned int, const char*, const char*) const
    {87, 645, 355, 2, Smoke::mf_const, 218, 15},	//2155 QsciScintillaBase::SendScintilla(unsigned int, long) const
    {87, 645, 358, 2, Smoke::mf_const, 218, 16},	//2156 QsciScintillaBase::SendScintilla(unsigned int, int) const
    {87, 645, 361, 4, Smoke::mf_const, 218, 17},	//2157 QsciScintillaBase::SendScintilla(unsigned int, long, long, char*) const
    {87, 645, 366, 3, Smoke::mf_const, 218, 18},	//2158 QsciScintillaBase::SendScintilla(unsigned int, unsigned long, const QColor&) const
    {87, 645, 370, 2, Smoke::mf_const, 218, 19},	//2159 QsciScintillaBase::SendScintilla(unsigned int, const QColor&) const
    {87, 645, 373, 6, Smoke::mf_const, 218, 20},	//2160 QsciScintillaBase::SendScintilla(unsigned int, unsigned long, QPainter*, const QRect&, long, long) const
    {87, 645, 380, 3, Smoke::mf_const, 218, 21},	//2161 QsciScintillaBase::SendScintilla(unsigned int, unsigned long, const QPixmap&) const
    {87, 645, 384, 3, Smoke::mf_const, 218, 22},	//2162 QsciScintillaBase::SendScintilla(unsigned int, unsigned long, const QImage&) const
    {87, 653, 388, 1, Smoke::mf_const, 221, 23},	//2163 QsciScintillaBase::SendScintillaPtrResult(unsigned int) const
    {87, 873, 390, 2, Smoke::mf_static, 215, 24},	//2164 QsciScintillaBase::commandKey(int, int&)
    {87, 454, 16, 1, Smoke::mf_protected|Smoke::mf_signal, 0, 25},	//2165 QsciScintillaBase::QSCN_SELCHANGED(bool)
    {87, 572, 0, 0, Smoke::mf_protected|Smoke::mf_signal, 0, 26},	//2166 QsciScintillaBase::SCN_AUTOCCANCELLED()
    {87, 573, 0, 0, Smoke::mf_protected|Smoke::mf_signal, 0, 27},	//2167 QsciScintillaBase::SCN_AUTOCCHARDELETED()
    {87, 574, 393, 2, Smoke::mf_protected|Smoke::mf_signal, 0, 28},	//2168 QsciScintillaBase::SCN_AUTOCSELECTION(const char*, int)
    {87, 571, 0, 0, Smoke::mf_protected|Smoke::mf_signal, 0, 29},	//2169 QsciScintillaBase::SCEN_CHANGE()
    {87, 576, 18, 1, Smoke::mf_protected|Smoke::mf_signal, 0, 30},	//2170 QsciScintillaBase::SCN_CALLTIPCLICK(int)
    {87, 578, 18, 1, Smoke::mf_protected|Smoke::mf_signal, 0, 31},	//2171 QsciScintillaBase::SCN_CHARADDED(int)
    {87, 580, 396, 3, Smoke::mf_protected|Smoke::mf_signal, 0, 32},	//2172 QsciScintillaBase::SCN_DOUBLECLICK(int, int, int)
    {87, 582, 396, 3, Smoke::mf_protected|Smoke::mf_signal, 0, 33},	//2173 QsciScintillaBase::SCN_DWELLEND(int, int, int)
    {87, 584, 396, 3, Smoke::mf_protected|Smoke::mf_signal, 0, 34},	//2174 QsciScintillaBase::SCN_DWELLSTART(int, int, int)
    {87, 586, 0, 0, Smoke::mf_protected|Smoke::mf_signal, 0, 35},	//2175 QsciScintillaBase::SCN_FOCUSIN()
    {87, 587, 0, 0, Smoke::mf_protected|Smoke::mf_signal, 0, 36},	//2176 QsciScintillaBase::SCN_FOCUSOUT()
    {87, 588, 99, 2, Smoke::mf_protected|Smoke::mf_signal, 0, 37},	//2177 QsciScintillaBase::SCN_HOTSPOTCLICK(int, int)
    {87, 590, 99, 2, Smoke::mf_protected|Smoke::mf_signal, 0, 38},	//2178 QsciScintillaBase::SCN_HOTSPOTDOUBLECLICK(int, int)
    {87, 592, 99, 2, Smoke::mf_protected|Smoke::mf_signal, 0, 39},	//2179 QsciScintillaBase::SCN_HOTSPOTRELEASECLICK(int, int)
    {87, 594, 99, 2, Smoke::mf_protected|Smoke::mf_signal, 0, 40},	//2180 QsciScintillaBase::SCN_INDICATORCLICK(int, int)
    {87, 596, 99, 2, Smoke::mf_protected|Smoke::mf_signal, 0, 41},	//2181 QsciScintillaBase::SCN_INDICATORRELEASE(int, int)
    {87, 598, 340, 3, Smoke::mf_protected|Smoke::mf_signal, 0, 42},	//2182 QsciScintillaBase::SCN_MACRORECORD(unsigned int, unsigned long, void*)
    {87, 600, 396, 3, Smoke::mf_protected|Smoke::mf_signal, 0, 43},	//2183 QsciScintillaBase::SCN_MARGINCLICK(int, int, int)
    {87, 602, 400, 10, Smoke::mf_protected|Smoke::mf_signal, 0, 44},	//2184 QsciScintillaBase::SCN_MODIFIED(int, int, const char*, int, int, int, int, int, int, int)
    {87, 604, 0, 0, Smoke::mf_protected|Smoke::mf_signal, 0, 45},	//2185 QsciScintillaBase::SCN_MODIFYATTEMPTRO()
    {87, 605, 99, 2, Smoke::mf_protected|Smoke::mf_signal, 0, 46},	//2186 QsciScintillaBase::SCN_NEEDSHOWN(int, int)
    {87, 607, 0, 0, Smoke::mf_protected|Smoke::mf_signal, 0, 47},	//2187 QsciScintillaBase::SCN_PAINTED()
    {87, 608, 0, 0, Smoke::mf_protected|Smoke::mf_signal, 0, 48},	//2188 QsciScintillaBase::SCN_SAVEPOINTLEFT()
    {87, 609, 0, 0, Smoke::mf_protected|Smoke::mf_signal, 0, 49},	//2189 QsciScintillaBase::SCN_SAVEPOINTREACHED()
    {87, 610, 18, 1, Smoke::mf_protected|Smoke::mf_signal, 0, 50},	//2190 QsciScintillaBase::SCN_STYLENEEDED(int)
    {87, 612, 18, 1, Smoke::mf_protected|Smoke::mf_signal, 0, 51},	//2191 QsciScintillaBase::SCN_UPDATEUI(int)
    {87, 614, 393, 2, Smoke::mf_protected|Smoke::mf_signal, 0, 52},	//2192 QsciScintillaBase::SCN_USERLISTSELECTION(const char*, int)
    {87, 616, 0, 0, Smoke::mf_protected|Smoke::mf_signal, 0, 53},	//2193 QsciScintillaBase::SCN_ZOOM()
    {87, 846, 411, 1, Smoke::mf_const|Smoke::mf_protected|Smoke::mf_virtual, 189, 54},	//2194 QsciScintillaBase::canInsertFromMimeData(const QMimeData*) const
    {87, 988, 413, 2, Smoke::mf_const|Smoke::mf_protected|Smoke::mf_virtual, 3, 55},	//2195 QsciScintillaBase::fromMimeData(const QMimeData*, bool&) const
    {87, 1543, 416, 2, Smoke::mf_const|Smoke::mf_protected|Smoke::mf_virtual, 24, 56},	//2196 QsciScintillaBase::toMimeData(const QByteArray&, bool) const
    {87, 877, 274, 1, Smoke::mf_protected|Smoke::mf_virtual, 0, 57},	//2197 QsciScintillaBase::contextMenuEvent(QContextMenuEvent*)
    {87, 908, 419, 1, Smoke::mf_protected|Smoke::mf_virtual, 0, 58},	//2198 QsciScintillaBase::dragEnterEvent(QDragEnterEvent*)
    {87, 910, 421, 1, Smoke::mf_protected|Smoke::mf_virtual, 0, 59},	//2199 QsciScintillaBase::dragLeaveEvent(QDragLeaveEvent*)
    {87, 912, 423, 1, Smoke::mf_protected|Smoke::mf_virtual, 0, 60},	//2200 QsciScintillaBase::dragMoveEvent(QDragMoveEvent*)
    {87, 914, 425, 1, Smoke::mf_protected|Smoke::mf_virtual, 0, 61},	//2201 QsciScintillaBase::dropEvent(QDropEvent*)
    {87, 957, 427, 1, Smoke::mf_protected|Smoke::mf_virtual, 0, 62},	//2202 QsciScintillaBase::focusInEvent(QFocusEvent*)
    {87, 961, 427, 1, Smoke::mf_protected|Smoke::mf_virtual, 0, 63},	//2203 QsciScintillaBase::focusOutEvent(QFocusEvent*)
    {87, 959, 16, 1, Smoke::mf_protected|Smoke::mf_virtual, 189, 64},	//2204 QsciScintillaBase::focusNextPrevChild(bool)
    {87, 1044, 20, 1, Smoke::mf_protected|Smoke::mf_virtual, 0, 65},	//2205 QsciScintillaBase::keyPressEvent(QKeyEvent*)
    {87, 1023, 429, 1, Smoke::mf_protected|Smoke::mf_virtual, 0, 66},	//2206 QsciScintillaBase::inputMethodEvent(QInputMethodEvent*)
    {87, 1025, 431, 1, Smoke::mf_const|Smoke::mf_protected|Smoke::mf_virtual, 47, 67},	//2207 QsciScintillaBase::inputMethodQuery(Qt::InputMethodQuery) const
    {87, 1111, 433, 1, Smoke::mf_protected|Smoke::mf_virtual, 0, 68},	//2208 QsciScintillaBase::mouseDoubleClickEvent(QMouseEvent*)
    {87, 1113, 433, 1, Smoke::mf_protected|Smoke::mf_virtual, 0, 69},	//2209 QsciScintillaBase::mouseMoveEvent(QMouseEvent*)
    {87, 1115, 433, 1, Smoke::mf_protected|Smoke::mf_virtual, 0, 70},	//2210 QsciScintillaBase::mousePressEvent(QMouseEvent*)
    {87, 1117, 433, 1, Smoke::mf_protected|Smoke::mf_virtual, 0, 71},	//2211 QsciScintillaBase::mouseReleaseEvent(QMouseEvent*)
    {87, 1125, 435, 1, Smoke::mf_protected|Smoke::mf_virtual, 0, 72},	//2212 QsciScintillaBase::paintEvent(QPaintEvent*)
    {87, 1180, 437, 1, Smoke::mf_protected|Smoke::mf_virtual, 0, 73},	//2213 QsciScintillaBase::resizeEvent(QResizeEvent*)
    {87, 1186, 99, 2, Smoke::mf_protected|Smoke::mf_virtual, 0, 74},	//2214 QsciScintillaBase::scrollContentsBy(int, int)
    {87, 1451, 0, 0, Smoke::mf_protected, 0, 75},	//2215 QsciScintillaBase::setScrollBars()
    {87, 1536, 55, 1, Smoke::mf_const|Smoke::mf_protected, 3, 76},	//2216 QsciScintillaBase::textAsBytes(const QString&) const
    {87, 838, 12, 1, Smoke::mf_const|Smoke::mf_protected, 40, 77},	//2217 QsciScintillaBase::bytesAsText(const char*) const
    {87, 1546, 12, 1, Smoke::mf_static, 40, 78},	//2218 QsciScintillaBase::tr(const char*)
    {87, 1550, 12, 1, Smoke::mf_static, 40, 79},	//2219 QsciScintillaBase::trUtf8(const char*)
    {87, 537, 0, 0, Smoke::mf_ctor, 110, 80},	//2220 QsciScintillaBase::QsciScintillaBase()
    {87, 645, 388, 1, Smoke::mf_const, 218, 81},	//2221 QsciScintillaBase::SendScintilla(unsigned int) const
    {87, 645, 439, 2, Smoke::mf_const, 218, 82},	//2222 QsciScintillaBase::SendScintilla(unsigned int, unsigned long) const
    {87, 1523, 0, 0, Smoke::mf_const|Smoke::mf_static|Smoke::mf_attribute, 199, 83},	//2223 QsciScintillaBase::staticMetaObject() const
    {87, 620, 0, 0, Smoke::mf_static|Smoke::mf_enum, 218, 84},	//2224 QsciScintillaBase::SC_ORDER_PRESORTED (enum)
    {87, 619, 0, 0, Smoke::mf_static|Smoke::mf_enum, 218, 85},	//2225 QsciScintillaBase::SC_ORDER_PERFORMSORT (enum)
    {87, 618, 0, 0, Smoke::mf_static|Smoke::mf_enum, 218, 86},	//2226 QsciScintillaBase::SC_ORDER_CUSTOM (enum)
    {87, 620, 0, 0, Smoke::mf_static|Smoke::mf_enum, 218, 87},	//2227 QsciScintillaBase::SC_ORDER_PRESORTED (enum)
    {87, 619, 0, 0, Smoke::mf_static|Smoke::mf_enum, 218, 88},	//2228 QsciScintillaBase::SC_ORDER_PERFORMSORT (enum)
    {87, 618, 0, 0, Smoke::mf_static|Smoke::mf_enum, 218, 89},	//2229 QsciScintillaBase::SC_ORDER_CUSTOM (enum)
    {87, 620, 0, 0, Smoke::mf_static|Smoke::mf_enum, 218, 90},	//2230 QsciScintillaBase::SC_ORDER_PRESORTED (enum)
    {87, 619, 0, 0, Smoke::mf_static|Smoke::mf_enum, 218, 91},	//2231 QsciScintillaBase::SC_ORDER_PERFORMSORT (enum)
    {87, 618, 0, 0, Smoke::mf_static|Smoke::mf_enum, 218, 92},	//2232 QsciScintillaBase::SC_ORDER_CUSTOM (enum)
    {87, 620, 0, 0, Smoke::mf_static|Smoke::mf_enum, 218, 93},	//2233 QsciScintillaBase::SC_ORDER_PRESORTED (enum)
    {87, 619, 0, 0, Smoke::mf_static|Smoke::mf_enum, 218, 94},	//2234 QsciScintillaBase::SC_ORDER_PERFORMSORT (enum)
    {87, 618, 0, 0, Smoke::mf_static|Smoke::mf_enum, 218, 95},	//2235 QsciScintillaBase::SC_ORDER_CUSTOM (enum)
    {87, 620, 0, 0, Smoke::mf_static|Smoke::mf_enum, 218, 96},	//2236 QsciScintillaBase::SC_ORDER_PRESORTED (enum)
    {87, 619, 0, 0, Smoke::mf_static|Smoke::mf_enum, 218, 97},	//2237 QsciScintillaBase::SC_ORDER_PERFORMSORT (enum)
    {87, 618, 0, 0, Smoke::mf_static|Smoke::mf_enum, 218, 98},	//2238 QsciScintillaBase::SC_ORDER_CUSTOM (enum)
    {87, 620, 0, 0, Smoke::mf_static|Smoke::mf_enum, 218, 99},	//2239 QsciScintillaBase::SC_ORDER_PRESORTED (enum)
    {87, 619, 0, 0, Smoke::mf_static|Smoke::mf_enum, 218, 100},	//2240 QsciScintillaBase::SC_ORDER_PERFORMSORT (enum)
    {87, 618, 0, 0, Smoke::mf_static|Smoke::mf_enum, 218, 101},	//2241 QsciScintillaBase::SC_ORDER_CUSTOM (enum)
    {87, 620, 0, 0, Smoke::mf_static|Smoke::mf_enum, 218, 102},	//2242 QsciScintillaBase::SC_ORDER_PRESORTED (enum)
    {87, 619, 0, 0, Smoke::mf_static|Smoke::mf_enum, 218, 103},	//2243 QsciScintillaBase::SC_ORDER_PERFORMSORT (enum)
    {87, 618, 0, 0, Smoke::mf_static|Smoke::mf_enum, 218, 104},	//2244 QsciScintillaBase::SC_ORDER_CUSTOM (enum)
    {87, 620, 0, 0, Smoke::mf_static|Smoke::mf_enum, 218, 105},	//2245 QsciScintillaBase::SC_ORDER_PRESORTED (enum)
    {87, 619, 0, 0, Smoke::mf_static|Smoke::mf_enum, 218, 106},	//2246 QsciScintillaBase::SC_ORDER_PERFORMSORT (enum)
    {87, 618, 0, 0, Smoke::mf_static|Smoke::mf_enum, 218, 107},	//2247 QsciScintillaBase::SC_ORDER_CUSTOM (enum)
    {87, 620, 0, 0, Smoke::mf_static|Smoke::mf_enum, 218, 108},	//2248 QsciScintillaBase::SC_ORDER_PRESORTED (enum)
    {87, 619, 0, 0, Smoke::mf_static|Smoke::mf_enum, 218, 109},	//2249 QsciScintillaBase::SC_ORDER_PERFORMSORT (enum)
    {87, 618, 0, 0, Smoke::mf_static|Smoke::mf_enum, 218, 110},	//2250 QsciScintillaBase::SC_ORDER_CUSTOM (enum)
    {87, 620, 0, 0, Smoke::mf_static|Smoke::mf_enum, 218, 111},	//2251 QsciScintillaBase::SC_ORDER_PRESORTED (enum)
    {87, 619, 0, 0, Smoke::mf_static|Smoke::mf_enum, 218, 112},	//2252 QsciScintillaBase::SC_ORDER_PERFORMSORT (enum)
    {87, 618, 0, 0, Smoke::mf_static|Smoke::mf_enum, 218, 113},	//2253 QsciScintillaBase::SC_ORDER_CUSTOM (enum)
    {87, 620, 0, 0, Smoke::mf_static|Smoke::mf_enum, 218, 114},	//2254 QsciScintillaBase::SC_ORDER_PRESORTED (enum)
    {87, 619, 0, 0, Smoke::mf_static|Smoke::mf_enum, 218, 115},	//2255 QsciScintillaBase::SC_ORDER_PERFORMSORT (enum)
    {87, 618, 0, 0, Smoke::mf_static|Smoke::mf_enum, 218, 116},	//2256 QsciScintillaBase::SC_ORDER_CUSTOM (enum)
    {87, 620, 0, 0, Smoke::mf_static|Smoke::mf_enum, 218, 117},	//2257 QsciScintillaBase::SC_ORDER_PRESORTED (enum)
    {87, 619, 0, 0, Smoke::mf_static|Smoke::mf_enum, 218, 118},	//2258 QsciScintillaBase::SC_ORDER_PERFORMSORT (enum)
    {87, 618, 0, 0, Smoke::mf_static|Smoke::mf_enum, 218, 119},	//2259 QsciScintillaBase::SC_ORDER_CUSTOM (enum)
    {87, 620, 0, 0, Smoke::mf_static|Smoke::mf_enum, 218, 120},	//2260 QsciScintillaBase::SC_ORDER_PRESORTED (enum)
    {87, 619, 0, 0, Smoke::mf_static|Smoke::mf_enum, 218, 121},	//2261 QsciScintillaBase::SC_ORDER_PERFORMSORT (enum)
    {87, 618, 0, 0, Smoke::mf_static|Smoke::mf_enum, 218, 122},	//2262 QsciScintillaBase::SC_ORDER_CUSTOM (enum)
    {87, 620, 0, 0, Smoke::mf_static|Smoke::mf_enum, 218, 123},	//2263 QsciScintillaBase::SC_ORDER_PRESORTED (enum)
    {87, 619, 0, 0, Smoke::mf_static|Smoke::mf_enum, 218, 124},	//2264 QsciScintillaBase::SC_ORDER_PERFORMSORT (enum)
    {87, 618, 0, 0, Smoke::mf_static|Smoke::mf_enum, 218, 125},	//2265 QsciScintillaBase::SC_ORDER_CUSTOM (enum)
    {87, 620, 0, 0, Smoke::mf_static|Smoke::mf_enum, 218, 126},	//2266 QsciScintillaBase::SC_ORDER_PRESORTED (enum)
    {87, 619, 0, 0, Smoke::mf_static|Smoke::mf_enum, 218, 127},	//2267 QsciScintillaBase::SC_ORDER_PERFORMSORT (enum)
    {87, 618, 0, 0, Smoke::mf_static|Smoke::mf_enum, 218, 128},	//2268 QsciScintillaBase::SC_ORDER_CUSTOM (enum)
    {87, 620, 0, 0, Smoke::mf_static|Smoke::mf_enum, 218, 129},	//2269 QsciScintillaBase::SC_ORDER_PRESORTED (enum)
    {87, 619, 0, 0, Smoke::mf_static|Smoke::mf_enum, 218, 130},	//2270 QsciScintillaBase::SC_ORDER_PERFORMSORT (enum)
    {87, 618, 0, 0, Smoke::mf_static|Smoke::mf_enum, 218, 131},	//2271 QsciScintillaBase::SC_ORDER_CUSTOM (enum)
    {87, 620, 0, 0, Smoke::mf_static|Smoke::mf_enum, 218, 132},	//2272 QsciScintillaBase::SC_ORDER_PRESORTED (enum)
    {87, 619, 0, 0, Smoke::mf_static|Smoke::mf_enum, 218, 133},	//2273 QsciScintillaBase::SC_ORDER_PERFORMSORT (enum)
    {87, 618, 0, 0, Smoke::mf_static|Smoke::mf_enum, 218, 134},	//2274 QsciScintillaBase::SC_ORDER_CUSTOM (enum)
    {87, 620, 0, 0, Smoke::mf_static|Smoke::mf_enum, 218, 135},	//2275 QsciScintillaBase::SC_ORDER_PRESORTED (enum)
    {87, 619, 0, 0, Smoke::mf_static|Smoke::mf_enum, 218, 136},	//2276 QsciScintillaBase::SC_ORDER_PERFORMSORT (enum)
    {87, 618, 0, 0, Smoke::mf_static|Smoke::mf_enum, 218, 137},	//2277 QsciScintillaBase::SC_ORDER_CUSTOM (enum)
    {87, 620, 0, 0, Smoke::mf_static|Smoke::mf_enum, 218, 138},	//2278 QsciScintillaBase::SC_ORDER_PRESORTED (enum)
    {87, 619, 0, 0, Smoke::mf_static|Smoke::mf_enum, 218, 139},	//2279 QsciScintillaBase::SC_ORDER_PERFORMSORT (enum)
    {87, 618, 0, 0, Smoke::mf_static|Smoke::mf_enum, 218, 140},	//2280 QsciScintillaBase::SC_ORDER_CUSTOM (enum)
    {87, 620, 0, 0, Smoke::mf_static|Smoke::mf_enum, 218, 141},	//2281 QsciScintillaBase::SC_ORDER_PRESORTED (enum)
    {87, 619, 0, 0, Smoke::mf_static|Smoke::mf_enum, 218, 142},	//2282 QsciScintillaBase::SC_ORDER_PERFORMSORT (enum)
    {87, 618, 0, 0, Smoke::mf_static|Smoke::mf_enum, 218, 143},	//2283 QsciScintillaBase::SC_ORDER_CUSTOM (enum)
    {87, 620, 0, 0, Smoke::mf_static|Smoke::mf_enum, 218, 144},	//2284 QsciScintillaBase::SC_ORDER_PRESORTED (enum)
    {87, 619, 0, 0, Smoke::mf_static|Smoke::mf_enum, 218, 145},	//2285 QsciScintillaBase::SC_ORDER_PERFORMSORT (enum)
    {87, 618, 0, 0, Smoke::mf_static|Smoke::mf_enum, 218, 146},	//2286 QsciScintillaBase::SC_ORDER_CUSTOM (enum)
    {87, 620, 0, 0, Smoke::mf_static|Smoke::mf_enum, 218, 147},	//2287 QsciScintillaBase::SC_ORDER_PRESORTED (enum)
    {87, 619, 0, 0, Smoke::mf_static|Smoke::mf_enum, 218, 148},	//2288 QsciScintillaBase::SC_ORDER_PERFORMSORT (enum)
    {87, 618, 0, 0, Smoke::mf_static|Smoke::mf_enum, 218, 149},	//2289 QsciScintillaBase::SC_ORDER_CUSTOM (enum)
    {87, 620, 0, 0, Smoke::mf_static|Smoke::mf_enum, 218, 150},	//2290 QsciScintillaBase::SC_ORDER_PRESORTED (enum)
    {87, 619, 0, 0, Smoke::mf_static|Smoke::mf_enum, 218, 151},	//2291 QsciScintillaBase::SC_ORDER_PERFORMSORT (enum)
    {87, 618, 0, 0, Smoke::mf_static|Smoke::mf_enum, 218, 152},	//2292 QsciScintillaBase::SC_ORDER_CUSTOM (enum)
    {87, 620, 0, 0, Smoke::mf_static|Smoke::mf_enum, 218, 153},	//2293 QsciScintillaBase::SC_ORDER_PRESORTED (enum)
    {87, 619, 0, 0, Smoke::mf_static|Smoke::mf_enum, 218, 154},	//2294 QsciScintillaBase::SC_ORDER_PERFORMSORT (enum)
    {87, 618, 0, 0, Smoke::mf_static|Smoke::mf_enum, 218, 155},	//2295 QsciScintillaBase::SC_ORDER_CUSTOM (enum)
    {87, 620, 0, 0, Smoke::mf_static|Smoke::mf_enum, 218, 156},	//2296 QsciScintillaBase::SC_ORDER_PRESORTED (enum)
    {87, 619, 0, 0, Smoke::mf_static|Smoke::mf_enum, 218, 157},	//2297 QsciScintillaBase::SC_ORDER_PERFORMSORT (enum)
    {87, 618, 0, 0, Smoke::mf_static|Smoke::mf_enum, 218, 158},	//2298 QsciScintillaBase::SC_ORDER_CUSTOM (enum)
    {87, 620, 0, 0, Smoke::mf_static|Smoke::mf_enum, 218, 159},	//2299 QsciScintillaBase::SC_ORDER_PRESORTED (enum)
    {87, 619, 0, 0, Smoke::mf_static|Smoke::mf_enum, 218, 160},	//2300 QsciScintillaBase::SC_ORDER_PERFORMSORT (enum)
    {87, 618, 0, 0, Smoke::mf_static|Smoke::mf_enum, 218, 161},	//2301 QsciScintillaBase::SC_ORDER_CUSTOM (enum)
    {87, 620, 0, 0, Smoke::mf_static|Smoke::mf_enum, 218, 162},	//2302 QsciScintillaBase::SC_ORDER_PRESORTED (enum)
    {87, 619, 0, 0, Smoke::mf_static|Smoke::mf_enum, 218, 163},	//2303 QsciScintillaBase::SC_ORDER_PERFORMSORT (enum)
    {87, 618, 0, 0, Smoke::mf_static|Smoke::mf_enum, 218, 164},	//2304 QsciScintillaBase::SC_ORDER_CUSTOM (enum)
    {87, 620, 0, 0, Smoke::mf_static|Smoke::mf_enum, 218, 165},	//2305 QsciScintillaBase::SC_ORDER_PRESORTED (enum)
    {87, 619, 0, 0, Smoke::mf_static|Smoke::mf_enum, 218, 166},	//2306 QsciScintillaBase::SC_ORDER_PERFORMSORT (enum)
    {87, 618, 0, 0, Smoke::mf_static|Smoke::mf_enum, 218, 167},	//2307 QsciScintillaBase::SC_ORDER_CUSTOM (enum)
    {87, 620, 0, 0, Smoke::mf_static|Smoke::mf_enum, 218, 168},	//2308 QsciScintillaBase::SC_ORDER_PRESORTED (enum)
    {87, 619, 0, 0, Smoke::mf_static|Smoke::mf_enum, 218, 169},	//2309 QsciScintillaBase::SC_ORDER_PERFORMSORT (enum)
    {87, 618, 0, 0, Smoke::mf_static|Smoke::mf_enum, 218, 170},	//2310 QsciScintillaBase::SC_ORDER_CUSTOM (enum)
    {87, 620, 0, 0, Smoke::mf_static|Smoke::mf_enum, 218, 171},	//2311 QsciScintillaBase::SC_ORDER_PRESORTED (enum)
    {87, 619, 0, 0, Smoke::mf_static|Smoke::mf_enum, 218, 172},	//2312 QsciScintillaBase::SC_ORDER_PERFORMSORT (enum)
    {87, 618, 0, 0, Smoke::mf_static|Smoke::mf_enum, 218, 173},	//2313 QsciScintillaBase::SC_ORDER_CUSTOM (enum)
    {87, 620, 0, 0, Smoke::mf_static|Smoke::mf_enum, 218, 174},	//2314 QsciScintillaBase::SC_ORDER_PRESORTED (enum)
    {87, 619, 0, 0, Smoke::mf_static|Smoke::mf_enum, 218, 175},	//2315 QsciScintillaBase::SC_ORDER_PERFORMSORT (enum)
    {87, 618, 0, 0, Smoke::mf_static|Smoke::mf_enum, 218, 176},	//2316 QsciScintillaBase::SC_ORDER_CUSTOM (enum)
    {87, 620, 0, 0, Smoke::mf_static|Smoke::mf_enum, 218, 177},	//2317 QsciScintillaBase::SC_ORDER_PRESORTED (enum)
    {87, 619, 0, 0, Smoke::mf_static|Smoke::mf_enum, 218, 178},	//2318 QsciScintillaBase::SC_ORDER_PERFORMSORT (enum)
    {87, 618, 0, 0, Smoke::mf_static|Smoke::mf_enum, 218, 179},	//2319 QsciScintillaBase::SC_ORDER_CUSTOM (enum)
    {87, 620, 0, 0, Smoke::mf_static|Smoke::mf_enum, 218, 180},	//2320 QsciScintillaBase::SC_ORDER_PRESORTED (enum)
    {87, 619, 0, 0, Smoke::mf_static|Smoke::mf_enum, 218, 181},	//2321 QsciScintillaBase::SC_ORDER_PERFORMSORT (enum)
    {87, 618, 0, 0, Smoke::mf_static|Smoke::mf_enum, 218, 182},	//2322 QsciScintillaBase::SC_ORDER_CUSTOM (enum)
    {87, 620, 0, 0, Smoke::mf_static|Smoke::mf_enum, 218, 183},	//2323 QsciScintillaBase::SC_ORDER_PRESORTED (enum)
    {87, 619, 0, 0, Smoke::mf_static|Smoke::mf_enum, 218, 184},	//2324 QsciScintillaBase::SC_ORDER_PERFORMSORT (enum)
    {87, 618, 0, 0, Smoke::mf_static|Smoke::mf_enum, 218, 185},	//2325 QsciScintillaBase::SC_ORDER_CUSTOM (enum)
    {87, 620, 0, 0, Smoke::mf_static|Smoke::mf_enum, 218, 186},	//2326 QsciScintillaBase::SC_ORDER_PRESORTED (enum)
    {87, 619, 0, 0, Smoke::mf_static|Smoke::mf_enum, 218, 187},	//2327 QsciScintillaBase::SC_ORDER_PERFORMSORT (enum)
    {87, 618, 0, 0, Smoke::mf_static|Smoke::mf_enum, 218, 188},	//2328 QsciScintillaBase::SC_ORDER_CUSTOM (enum)
    {87, 620, 0, 0, Smoke::mf_static|Smoke::mf_enum, 218, 189},	//2329 QsciScintillaBase::SC_ORDER_PRESORTED (enum)
    {87, 619, 0, 0, Smoke::mf_static|Smoke::mf_enum, 218, 190},	//2330 QsciScintillaBase::SC_ORDER_PERFORMSORT (enum)
    {87, 618, 0, 0, Smoke::mf_static|Smoke::mf_enum, 218, 191},	//2331 QsciScintillaBase::SC_ORDER_CUSTOM (enum)
    {87, 620, 0, 0, Smoke::mf_static|Smoke::mf_enum, 218, 192},	//2332 QsciScintillaBase::SC_ORDER_PRESORTED (enum)
    {87, 619, 0, 0, Smoke::mf_static|Smoke::mf_enum, 218, 193},	//2333 QsciScintillaBase::SC_ORDER_PERFORMSORT (enum)
    {87, 618, 0, 0, Smoke::mf_static|Smoke::mf_enum, 218, 194},	//2334 QsciScintillaBase::SC_ORDER_CUSTOM (enum)
    {87, 620, 0, 0, Smoke::mf_static|Smoke::mf_enum, 218, 195},	//2335 QsciScintillaBase::SC_ORDER_PRESORTED (enum)
    {87, 619, 0, 0, Smoke::mf_static|Smoke::mf_enum, 218, 196},	//2336 QsciScintillaBase::SC_ORDER_PERFORMSORT (enum)
    {87, 618, 0, 0, Smoke::mf_static|Smoke::mf_enum, 218, 197},	//2337 QsciScintillaBase::SC_ORDER_CUSTOM (enum)
    {87, 620, 0, 0, Smoke::mf_static|Smoke::mf_enum, 218, 198},	//2338 QsciScintillaBase::SC_ORDER_PRESORTED (enum)
    {87, 619, 0, 0, Smoke::mf_static|Smoke::mf_enum, 218, 199},	//2339 QsciScintillaBase::SC_ORDER_PERFORMSORT (enum)
    {87, 618, 0, 0, Smoke::mf_static|Smoke::mf_enum, 218, 200},	//2340 QsciScintillaBase::SC_ORDER_CUSTOM (enum)
    {87, 620, 0, 0, Smoke::mf_static|Smoke::mf_enum, 218, 201},	//2341 QsciScintillaBase::SC_ORDER_PRESORTED (enum)
    {87, 619, 0, 0, Smoke::mf_static|Smoke::mf_enum, 218, 202},	//2342 QsciScintillaBase::SC_ORDER_PERFORMSORT (enum)
    {87, 618, 0, 0, Smoke::mf_static|Smoke::mf_enum, 218, 203},	//2343 QsciScintillaBase::SC_ORDER_CUSTOM (enum)
    {87, 620, 0, 0, Smoke::mf_static|Smoke::mf_enum, 218, 204},	//2344 QsciScintillaBase::SC_ORDER_PRESORTED (enum)
    {87, 619, 0, 0, Smoke::mf_static|Smoke::mf_enum, 218, 205},	//2345 QsciScintillaBase::SC_ORDER_PERFORMSORT (enum)
    {87, 618, 0, 0, Smoke::mf_static|Smoke::mf_enum, 218, 206},	//2346 QsciScintillaBase::SC_ORDER_CUSTOM (enum)
    {87, 620, 0, 0, Smoke::mf_static|Smoke::mf_enum, 218, 207},	//2347 QsciScintillaBase::SC_ORDER_PRESORTED (enum)
    {87, 619, 0, 0, Smoke::mf_static|Smoke::mf_enum, 218, 208},	//2348 QsciScintillaBase::SC_ORDER_PERFORMSORT (enum)
    {87, 618, 0, 0, Smoke::mf_static|Smoke::mf_enum, 218, 209},	//2349 QsciScintillaBase::SC_ORDER_CUSTOM (enum)
    {87, 620, 0, 0, Smoke::mf_static|Smoke::mf_enum, 218, 210},	//2350 QsciScintillaBase::SC_ORDER_PRESORTED (enum)
    {87, 619, 0, 0, Smoke::mf_static|Smoke::mf_enum, 218, 211},	//2351 QsciScintillaBase::SC_ORDER_PERFORMSORT (enum)
    {87, 618, 0, 0, Smoke::mf_static|Smoke::mf_enum, 218, 212},	//2352 QsciScintillaBase::SC_ORDER_CUSTOM (enum)
    {87, 620, 0, 0, Smoke::mf_static|Smoke::mf_enum, 218, 213},	//2353 QsciScintillaBase::SC_ORDER_PRESORTED (enum)
    {87, 619, 0, 0, Smoke::mf_static|Smoke::mf_enum, 218, 214},	//2354 QsciScintillaBase::SC_ORDER_PERFORMSORT (enum)
    {87, 618, 0, 0, Smoke::mf_static|Smoke::mf_enum, 218, 215},	//2355 QsciScintillaBase::SC_ORDER_CUSTOM (enum)
    {87, 620, 0, 0, Smoke::mf_static|Smoke::mf_enum, 218, 216},	//2356 QsciScintillaBase::SC_ORDER_PRESORTED (enum)
    {87, 619, 0, 0, Smoke::mf_static|Smoke::mf_enum, 218, 217},	//2357 QsciScintillaBase::SC_ORDER_PERFORMSORT (enum)
    {87, 618, 0, 0, Smoke::mf_static|Smoke::mf_enum, 218, 218},	//2358 QsciScintillaBase::SC_ORDER_CUSTOM (enum)
    {87, 620, 0, 0, Smoke::mf_static|Smoke::mf_enum, 218, 219},	//2359 QsciScintillaBase::SC_ORDER_PRESORTED (enum)
    {87, 619, 0, 0, Smoke::mf_static|Smoke::mf_enum, 218, 220},	//2360 QsciScintillaBase::SC_ORDER_PERFORMSORT (enum)
    {87, 618, 0, 0, Smoke::mf_static|Smoke::mf_enum, 218, 221},	//2361 QsciScintillaBase::SC_ORDER_CUSTOM (enum)
    {87, 620, 0, 0, Smoke::mf_static|Smoke::mf_enum, 218, 222},	//2362 QsciScintillaBase::SC_ORDER_PRESORTED (enum)
    {87, 619, 0, 0, Smoke::mf_static|Smoke::mf_enum, 218, 223},	//2363 QsciScintillaBase::SC_ORDER_PERFORMSORT (enum)
    {87, 618, 0, 0, Smoke::mf_static|Smoke::mf_enum, 218, 224},	//2364 QsciScintillaBase::SC_ORDER_CUSTOM (enum)
    {87, 620, 0, 0, Smoke::mf_static|Smoke::mf_enum, 218, 225},	//2365 QsciScintillaBase::SC_ORDER_PRESORTED (enum)
    {87, 619, 0, 0, Smoke::mf_static|Smoke::mf_enum, 218, 226},	//2366 QsciScintillaBase::SC_ORDER_PERFORMSORT (enum)
    {87, 618, 0, 0, Smoke::mf_static|Smoke::mf_enum, 218, 227},	//2367 QsciScintillaBase::SC_ORDER_CUSTOM (enum)
    {87, 620, 0, 0, Smoke::mf_static|Smoke::mf_enum, 218, 228},	//2368 QsciScintillaBase::SC_ORDER_PRESORTED (enum)
    {87, 619, 0, 0, Smoke::mf_static|Smoke::mf_enum, 218, 229},	//2369 QsciScintillaBase::SC_ORDER_PERFORMSORT (enum)
    {87, 618, 0, 0, Smoke::mf_static|Smoke::mf_enum, 218, 230},	//2370 QsciScintillaBase::SC_ORDER_CUSTOM (enum)
    {87, 620, 0, 0, Smoke::mf_static|Smoke::mf_enum, 218, 231},	//2371 QsciScintillaBase::SC_ORDER_PRESORTED (enum)
    {87, 619, 0, 0, Smoke::mf_static|Smoke::mf_enum, 218, 232},	//2372 QsciScintillaBase::SC_ORDER_PERFORMSORT (enum)
    {87, 618, 0, 0, Smoke::mf_static|Smoke::mf_enum, 218, 233},	//2373 QsciScintillaBase::SC_ORDER_CUSTOM (enum)
    {87, 620, 0, 0, Smoke::mf_static|Smoke::mf_enum, 218, 234},	//2374 QsciScintillaBase::SC_ORDER_PRESORTED (enum)
    {87, 619, 0, 0, Smoke::mf_static|Smoke::mf_enum, 218, 235},	//2375 QsciScintillaBase::SC_ORDER_PERFORMSORT (enum)
    {87, 618, 0, 0, Smoke::mf_static|Smoke::mf_enum, 218, 236},	//2376 QsciScintillaBase::SC_ORDER_CUSTOM (enum)
    {87, 620, 0, 0, Smoke::mf_static|Smoke::mf_enum, 218, 237},	//2377 QsciScintillaBase::SC_ORDER_PRESORTED (enum)
    {87, 619, 0, 0, Smoke::mf_static|Smoke::mf_enum, 218, 238},	//2378 QsciScintillaBase::SC_ORDER_PERFORMSORT (enum)
    {87, 618, 0, 0, Smoke::mf_static|Smoke::mf_enum, 218, 239},	//2379 QsciScintillaBase::SC_ORDER_CUSTOM (enum)
    {87, 620, 0, 0, Smoke::mf_static|Smoke::mf_enum, 218, 240},	//2380 QsciScintillaBase::SC_ORDER_PRESORTED (enum)
    {87, 619, 0, 0, Smoke::mf_static|Smoke::mf_enum, 218, 241},	//2381 QsciScintillaBase::SC_ORDER_PERFORMSORT (enum)
    {87, 618, 0, 0, Smoke::mf_static|Smoke::mf_enum, 218, 242},	//2382 QsciScintillaBase::SC_ORDER_CUSTOM (enum)
    {87, 620, 0, 0, Smoke::mf_static|Smoke::mf_enum, 218, 243},	//2383 QsciScintillaBase::SC_ORDER_PRESORTED (enum)
    {87, 619, 0, 0, Smoke::mf_static|Smoke::mf_enum, 218, 244},	//2384 QsciScintillaBase::SC_ORDER_PERFORMSORT (enum)
    {87, 618, 0, 0, Smoke::mf_static|Smoke::mf_enum, 218, 245},	//2385 QsciScintillaBase::SC_ORDER_CUSTOM (enum)
    {87, 1632, 0, 0, Smoke::mf_dtor, 0, 246 },	//2386 QsciScintillaBase::~QsciScintillaBase()
    {88, 539, 18, 1, Smoke::mf_ctor, 111, 1},	//2387 QsciStyle::QsciStyle(int)
    {88, 539, 442, 6, Smoke::mf_ctor, 111, 2},	//2388 QsciStyle::QsciStyle(int, const QString&, const QColor&, const QColor&, const QFont&, bool)
    {88, 806, 123, 1, Smoke::mf_const, 0, 3},	//2389 QsciStyle::apply(QsciScintillaBase*) const
    {88, 1525, 0, 0, Smoke::mf_const, 215, 4},	//2390 QsciStyle::style() const
    {88, 1265, 55, 1, 0, 0, 5},	//2391 QsciStyle::setDescription(const QString&)
    {88, 900, 0, 0, Smoke::mf_const, 40, 6},	//2392 QsciStyle::description() const
    {88, 1252, 80, 1, 0, 0, 7},	//2393 QsciStyle::setColor(const QColor&)
    {88, 868, 0, 0, Smoke::mf_const, 6, 8},	//2394 QsciStyle::color() const
    {88, 1436, 80, 1, 0, 0, 9},	//2395 QsciStyle::setPaper(const QColor&)
    {88, 1128, 0, 0, Smoke::mf_const, 6, 10},	//2396 QsciStyle::paper() const
    {88, 1327, 40, 1, 0, 0, 11},	//2397 QsciStyle::setFont(const QFont&)
    {88, 981, 0, 0, Smoke::mf_const, 14, 12},	//2398 QsciStyle::font() const
    {88, 1283, 16, 1, 0, 0, 13},	//2399 QsciStyle::setEolFill(bool)
    {88, 927, 0, 0, Smoke::mf_const, 189, 14},	//2400 QsciStyle::eolFill() const
    {88, 1475, 449, 1, 0, 0, 15},	//2401 QsciStyle::setTextCase(QsciStyle::TextCase)
    {88, 1538, 0, 0, Smoke::mf_const, 112, 16},	//2402 QsciStyle::textCase() const
    {88, 1495, 16, 1, 0, 0, 17},	//2403 QsciStyle::setVisible(bool)
    {88, 1568, 0, 0, Smoke::mf_const, 189, 18},	//2404 QsciStyle::visible() const
    {88, 1250, 16, 1, 0, 0, 19},	//2405 QsciStyle::setChangeable(bool)
    {88, 854, 0, 0, Smoke::mf_const, 189, 20},	//2406 QsciStyle::changeable() const
    {88, 1344, 16, 1, 0, 0, 21},	//2407 QsciStyle::setHotspot(bool)
    {88, 1003, 0, 0, Smoke::mf_const, 189, 22},	//2408 QsciStyle::hotspot() const
    {88, 1162, 0, 0, 0, 0, 23},	//2409 QsciStyle::refresh()
    {88, 539, 451, 1, Smoke::mf_ctor|Smoke::mf_copyctor, 111, 24},	//2410 QsciStyle::QsciStyle(const QsciStyle&)
    {88, 539, 0, 0, Smoke::mf_ctor, 111, 25},	//2411 QsciStyle::QsciStyle()
    {88, 539, 453, 5, Smoke::mf_ctor, 111, 26},	//2412 QsciStyle::QsciStyle(int, const QString&, const QColor&, const QColor&, const QFont&)
    {88, 383, 0, 0, Smoke::mf_static|Smoke::mf_enum, 112, 27},	//2413 QsciStyle::OriginalCase (enum)
    {88, 733, 0, 0, Smoke::mf_static|Smoke::mf_enum, 112, 28},	//2414 QsciStyle::UpperCase (enum)
    {88, 356, 0, 0, Smoke::mf_static|Smoke::mf_enum, 112, 29},	//2415 QsciStyle::LowerCase (enum)
    {88, 1633, 0, 0, Smoke::mf_dtor, 0, 30 },	//2416 QsciStyle::~QsciStyle()
    {89, 544, 459, 2, Smoke::mf_ctor, 114, 1},	//2417 QsciStyledText::QsciStyledText(const QString&, int)
    {89, 544, 462, 2, Smoke::mf_ctor, 114, 2},	//2418 QsciStyledText::QsciStyledText(const QString&, const QsciStyle&)
    {89, 806, 123, 1, Smoke::mf_const, 0, 3},	//2419 QsciStyledText::apply(QsciScintillaBase*) const
    {89, 1534, 0, 0, Smoke::mf_const, 207, 4},	//2420 QsciStyledText::text() const
    {89, 1525, 0, 0, Smoke::mf_const, 215, 5},	//2421 QsciStyledText::style() const
    {89, 544, 465, 1, Smoke::mf_ctor|Smoke::mf_copyctor, 114, 6},	//2422 QsciStyledText::QsciStyledText(const QsciStyledText&)
    {89, 1634, 0, 0, Smoke::mf_dtor, 0, 7 },	//2423 QsciStyledText::~QsciStyledText()
};

static Smoke::Index ambiguousMethodList[] = {
    0,
    2089,  // QsciScintilla::MoNone
    2089,  // QsciScintilla::MoNone
    0,
    2090,  // QsciScintilla::MoSublineSelect
    2090,  // QsciScintilla::MoSublineSelect
    0,
    2016,  // QsciScintilla::markerDefine(const QPixmap&)
    2017,  // QsciScintilla::markerDefine(const QImage&)
    0,
    1821,  // QsciScintilla::markerDefine(const QPixmap&, int)
    1822,  // QsciScintilla::markerDefine(const QImage&, int)
    0,
    2014,  // QsciScintilla::markerDefine(QsciScintilla::MarkerSymbol)
    2015,  // QsciScintilla::markerDefine(char)
    0,
    1819,  // QsciScintilla::markerDefine(QsciScintilla::MarkerSymbol, int)
    1820,  // QsciScintilla::markerDefine(char, int)
    0,
    1836,  // QsciScintilla::registerImage(int, const QPixmap&)
    1837,  // QsciScintilla::registerImage(int, const QImage&)
    0,
    1966,  // QsciScintilla::setMarginWidth(int, int)
    1967,  // QsciScintilla::setMarginWidth(int, const QString&)
    0,
    2385,  // QsciScintillaBase::SC_ORDER_CUSTOM
    2385,  // QsciScintillaBase::SC_ORDER_CUSTOM
    2385,  // QsciScintillaBase::SC_ORDER_CUSTOM
    2385,  // QsciScintillaBase::SC_ORDER_CUSTOM
    2385,  // QsciScintillaBase::SC_ORDER_CUSTOM
    2385,  // QsciScintillaBase::SC_ORDER_CUSTOM
    2385,  // QsciScintillaBase::SC_ORDER_CUSTOM
    2385,  // QsciScintillaBase::SC_ORDER_CUSTOM
    2385,  // QsciScintillaBase::SC_ORDER_CUSTOM
    2385,  // QsciScintillaBase::SC_ORDER_CUSTOM
    2385,  // QsciScintillaBase::SC_ORDER_CUSTOM
    2385,  // QsciScintillaBase::SC_ORDER_CUSTOM
    2385,  // QsciScintillaBase::SC_ORDER_CUSTOM
    2385,  // QsciScintillaBase::SC_ORDER_CUSTOM
    2385,  // QsciScintillaBase::SC_ORDER_CUSTOM
    2385,  // QsciScintillaBase::SC_ORDER_CUSTOM
    2385,  // QsciScintillaBase::SC_ORDER_CUSTOM
    2385,  // QsciScintillaBase::SC_ORDER_CUSTOM
    2385,  // QsciScintillaBase::SC_ORDER_CUSTOM
    2385,  // QsciScintillaBase::SC_ORDER_CUSTOM
    2385,  // QsciScintillaBase::SC_ORDER_CUSTOM
    2385,  // QsciScintillaBase::SC_ORDER_CUSTOM
    2385,  // QsciScintillaBase::SC_ORDER_CUSTOM
    2385,  // QsciScintillaBase::SC_ORDER_CUSTOM
    2385,  // QsciScintillaBase::SC_ORDER_CUSTOM
    2385,  // QsciScintillaBase::SC_ORDER_CUSTOM
    2385,  // QsciScintillaBase::SC_ORDER_CUSTOM
    2385,  // QsciScintillaBase::SC_ORDER_CUSTOM
    2385,  // QsciScintillaBase::SC_ORDER_CUSTOM
    2385,  // QsciScintillaBase::SC_ORDER_CUSTOM
    2385,  // QsciScintillaBase::SC_ORDER_CUSTOM
    2385,  // QsciScintillaBase::SC_ORDER_CUSTOM
    2385,  // QsciScintillaBase::SC_ORDER_CUSTOM
    2385,  // QsciScintillaBase::SC_ORDER_CUSTOM
    2385,  // QsciScintillaBase::SC_ORDER_CUSTOM
    2385,  // QsciScintillaBase::SC_ORDER_CUSTOM
    2385,  // QsciScintillaBase::SC_ORDER_CUSTOM
    2385,  // QsciScintillaBase::SC_ORDER_CUSTOM
    2385,  // QsciScintillaBase::SC_ORDER_CUSTOM
    2385,  // QsciScintillaBase::SC_ORDER_CUSTOM
    2385,  // QsciScintillaBase::SC_ORDER_CUSTOM
    2385,  // QsciScintillaBase::SC_ORDER_CUSTOM
    2385,  // QsciScintillaBase::SC_ORDER_CUSTOM
    2385,  // QsciScintillaBase::SC_ORDER_CUSTOM
    2385,  // QsciScintillaBase::SC_ORDER_CUSTOM
    2385,  // QsciScintillaBase::SC_ORDER_CUSTOM
    2385,  // QsciScintillaBase::SC_ORDER_CUSTOM
    2385,  // QsciScintillaBase::SC_ORDER_CUSTOM
    2385,  // QsciScintillaBase::SC_ORDER_CUSTOM
    2385,  // QsciScintillaBase::SC_ORDER_CUSTOM
    2385,  // QsciScintillaBase::SC_ORDER_CUSTOM
    2385,  // QsciScintillaBase::SC_ORDER_CUSTOM
    2385,  // QsciScintillaBase::SC_ORDER_CUSTOM
    2385,  // QsciScintillaBase::SC_ORDER_CUSTOM
    0,
    2384,  // QsciScintillaBase::SC_ORDER_PERFORMSORT
    2384,  // QsciScintillaBase::SC_ORDER_PERFORMSORT
    2384,  // QsciScintillaBase::SC_ORDER_PERFORMSORT
    2384,  // QsciScintillaBase::SC_ORDER_PERFORMSORT
    2384,  // QsciScintillaBase::SC_ORDER_PERFORMSORT
    2384,  // QsciScintillaBase::SC_ORDER_PERFORMSORT
    2384,  // QsciScintillaBase::SC_ORDER_PERFORMSORT
    2384,  // QsciScintillaBase::SC_ORDER_PERFORMSORT
    2384,  // QsciScintillaBase::SC_ORDER_PERFORMSORT
    2384,  // QsciScintillaBase::SC_ORDER_PERFORMSORT
    2384,  // QsciScintillaBase::SC_ORDER_PERFORMSORT
    2384,  // QsciScintillaBase::SC_ORDER_PERFORMSORT
    2384,  // QsciScintillaBase::SC_ORDER_PERFORMSORT
    2384,  // QsciScintillaBase::SC_ORDER_PERFORMSORT
    2384,  // QsciScintillaBase::SC_ORDER_PERFORMSORT
    2384,  // QsciScintillaBase::SC_ORDER_PERFORMSORT
    2384,  // QsciScintillaBase::SC_ORDER_PERFORMSORT
    2384,  // QsciScintillaBase::SC_ORDER_PERFORMSORT
    2384,  // QsciScintillaBase::SC_ORDER_PERFORMSORT
    2384,  // QsciScintillaBase::SC_ORDER_PERFORMSORT
    2384,  // QsciScintillaBase::SC_ORDER_PERFORMSORT
    2384,  // QsciScintillaBase::SC_ORDER_PERFORMSORT
    2384,  // QsciScintillaBase::SC_ORDER_PERFORMSORT
    2384,  // QsciScintillaBase::SC_ORDER_PERFORMSORT
    2384,  // QsciScintillaBase::SC_ORDER_PERFORMSORT
    2384,  // QsciScintillaBase::SC_ORDER_PERFORMSORT
    2384,  // QsciScintillaBase::SC_ORDER_PERFORMSORT
    2384,  // QsciScintillaBase::SC_ORDER_PERFORMSORT
    2384,  // QsciScintillaBase::SC_ORDER_PERFORMSORT
    2384,  // QsciScintillaBase::SC_ORDER_PERFORMSORT
    2384,  // QsciScintillaBase::SC_ORDER_PERFORMSORT
    2384,  // QsciScintillaBase::SC_ORDER_PERFORMSORT
    2384,  // QsciScintillaBase::SC_ORDER_PERFORMSORT
    2384,  // QsciScintillaBase::SC_ORDER_PERFORMSORT
    2384,  // QsciScintillaBase::SC_ORDER_PERFORMSORT
    2384,  // QsciScintillaBase::SC_ORDER_PERFORMSORT
    2384,  // QsciScintillaBase::SC_ORDER_PERFORMSORT
    2384,  // QsciScintillaBase::SC_ORDER_PERFORMSORT
    2384,  // QsciScintillaBase::SC_ORDER_PERFORMSORT
    2384,  // QsciScintillaBase::SC_ORDER_PERFORMSORT
    2384,  // QsciScintillaBase::SC_ORDER_PERFORMSORT
    2384,  // QsciScintillaBase::SC_ORDER_PERFORMSORT
    2384,  // QsciScintillaBase::SC_ORDER_PERFORMSORT
    2384,  // QsciScintillaBase::SC_ORDER_PERFORMSORT
    2384,  // QsciScintillaBase::SC_ORDER_PERFORMSORT
    2384,  // QsciScintillaBase::SC_ORDER_PERFORMSORT
    2384,  // QsciScintillaBase::SC_ORDER_PERFORMSORT
    2384,  // QsciScintillaBase::SC_ORDER_PERFORMSORT
    2384,  // QsciScintillaBase::SC_ORDER_PERFORMSORT
    2384,  // QsciScintillaBase::SC_ORDER_PERFORMSORT
    2384,  // QsciScintillaBase::SC_ORDER_PERFORMSORT
    2384,  // QsciScintillaBase::SC_ORDER_PERFORMSORT
    2384,  // QsciScintillaBase::SC_ORDER_PERFORMSORT
    2384,  // QsciScintillaBase::SC_ORDER_PERFORMSORT
    0,
    2383,  // QsciScintillaBase::SC_ORDER_PRESORTED
    2383,  // QsciScintillaBase::SC_ORDER_PRESORTED
    2383,  // QsciScintillaBase::SC_ORDER_PRESORTED
    2383,  // QsciScintillaBase::SC_ORDER_PRESORTED
    2383,  // QsciScintillaBase::SC_ORDER_PRESORTED
    2383,  // QsciScintillaBase::SC_ORDER_PRESORTED
    2383,  // QsciScintillaBase::SC_ORDER_PRESORTED
    2383,  // QsciScintillaBase::SC_ORDER_PRESORTED
    2383,  // QsciScintillaBase::SC_ORDER_PRESORTED
    2383,  // QsciScintillaBase::SC_ORDER_PRESORTED
    2383,  // QsciScintillaBase::SC_ORDER_PRESORTED
    2383,  // QsciScintillaBase::SC_ORDER_PRESORTED
    2383,  // QsciScintillaBase::SC_ORDER_PRESORTED
    2383,  // QsciScintillaBase::SC_ORDER_PRESORTED
    2383,  // QsciScintillaBase::SC_ORDER_PRESORTED
    2383,  // QsciScintillaBase::SC_ORDER_PRESORTED
    2383,  // QsciScintillaBase::SC_ORDER_PRESORTED
    2383,  // QsciScintillaBase::SC_ORDER_PRESORTED
    2383,  // QsciScintillaBase::SC_ORDER_PRESORTED
    2383,  // QsciScintillaBase::SC_ORDER_PRESORTED
    2383,  // QsciScintillaBase::SC_ORDER_PRESORTED
    2383,  // QsciScintillaBase::SC_ORDER_PRESORTED
    2383,  // QsciScintillaBase::SC_ORDER_PRESORTED
    2383,  // QsciScintillaBase::SC_ORDER_PRESORTED
    2383,  // QsciScintillaBase::SC_ORDER_PRESORTED
    2383,  // QsciScintillaBase::SC_ORDER_PRESORTED
    2383,  // QsciScintillaBase::SC_ORDER_PRESORTED
    2383,  // QsciScintillaBase::SC_ORDER_PRESORTED
    2383,  // QsciScintillaBase::SC_ORDER_PRESORTED
    2383,  // QsciScintillaBase::SC_ORDER_PRESORTED
    2383,  // QsciScintillaBase::SC_ORDER_PRESORTED
    2383,  // QsciScintillaBase::SC_ORDER_PRESORTED
    2383,  // QsciScintillaBase::SC_ORDER_PRESORTED
    2383,  // QsciScintillaBase::SC_ORDER_PRESORTED
    2383,  // QsciScintillaBase::SC_ORDER_PRESORTED
    2383,  // QsciScintillaBase::SC_ORDER_PRESORTED
    2383,  // QsciScintillaBase::SC_ORDER_PRESORTED
    2383,  // QsciScintillaBase::SC_ORDER_PRESORTED
    2383,  // QsciScintillaBase::SC_ORDER_PRESORTED
    2383,  // QsciScintillaBase::SC_ORDER_PRESORTED
    2383,  // QsciScintillaBase::SC_ORDER_PRESORTED
    2383,  // QsciScintillaBase::SC_ORDER_PRESORTED
    2383,  // QsciScintillaBase::SC_ORDER_PRESORTED
    2383,  // QsciScintillaBase::SC_ORDER_PRESORTED
    2383,  // QsciScintillaBase::SC_ORDER_PRESORTED
    2383,  // QsciScintillaBase::SC_ORDER_PRESORTED
    2383,  // QsciScintillaBase::SC_ORDER_PRESORTED
    2383,  // QsciScintillaBase::SC_ORDER_PRESORTED
    2383,  // QsciScintillaBase::SC_ORDER_PRESORTED
    2383,  // QsciScintillaBase::SC_ORDER_PRESORTED
    2383,  // QsciScintillaBase::SC_ORDER_PRESORTED
    2383,  // QsciScintillaBase::SC_ORDER_PRESORTED
    2383,  // QsciScintillaBase::SC_ORDER_PRESORTED
    2383,  // QsciScintillaBase::SC_ORDER_PRESORTED
    0,
    2153,  // QsciScintillaBase::SendScintilla(unsigned int, const char*) const
    2155,  // QsciScintillaBase::SendScintilla(unsigned int, long) const
    2156,  // QsciScintillaBase::SendScintilla(unsigned int, int) const
    2222,  // QsciScintillaBase::SendScintilla(unsigned int, unsigned long) const
    0,
    2158,  // QsciScintillaBase::SendScintilla(unsigned int, unsigned long, const QColor&) const
    2161,  // QsciScintillaBase::SendScintilla(unsigned int, unsigned long, const QPixmap&) const
    2162,  // QsciScintillaBase::SendScintilla(unsigned int, unsigned long, const QImage&) const
    0,
    2150,  // QsciScintillaBase::SendScintilla(unsigned int, unsigned long, long) const
    2151,  // QsciScintillaBase::SendScintilla(unsigned int, unsigned long, void*) const
    2152,  // QsciScintillaBase::SendScintilla(unsigned int, unsigned long, const char*) const
    2154,  // QsciScintillaBase::SendScintilla(unsigned int, const char*, const char*) const
    0,
};

// Class ID, munged name ID (index into methodNames), method def (see methods) if >0 or number of overloads if <0
static Smoke::MethodMap methodMaps[] = {
    {0, 0, 0},	//0 (no method)
    {17, 456, 7},	// QGlobalSpace::Q_COMPLEX_TYPE
    {17, 457, 11},	// QGlobalSpace::Q_DUMMY_TYPE
    {17, 458, 10},	// QGlobalSpace::Q_MOVABLE_TYPE
    {17, 459, 8},	// QGlobalSpace::Q_PRIMITIVE_TYPE
    {17, 460, 9},	// QGlobalSpace::Q_STATIC_TYPE
    {48, 462, 53},	// QsciAPIs::QsciAPIs#
    {48, 788, 54},	// QsciAPIs::add$
    {48, 800, 69},	// QsciAPIs::apiPreparationCancelled
    {48, 801, 71},	// QsciAPIs::apiPreparationFinished
    {48, 802, 70},	// QsciAPIs::apiPreparationStarted
    {48, 816, 65},	// QsciAPIs::autoCompletionSelected$
    {48, 842, 66},	// QsciAPIs::callTips?$$?
    {48, 849, 59},	// QsciAPIs::cancelPreparation
    {48, 856, 55},	// QsciAPIs::clear
    {48, 898, 60},	// QsciAPIs::defaultPreparedName
    {48, 934, 67},	// QsciAPIs::event#
    {48, 1031, 68},	// QsciAPIs::installedAPIFiles
    {48, 1035, 74},	// QsciAPIs::isPrepared
    {48, 1036, 61},	// QsciAPIs::isPrepared$
    {48, 1065, 56},	// QsciAPIs::load$
    {48, 1066, 75},	// QsciAPIs::loadPrepared
    {48, 1067, 62},	// QsciAPIs::loadPrepared$
    {48, 1105, 46},	// QsciAPIs::metaObject
    {48, 1137, 58},	// QsciAPIs::prepare
    {48, 1147, 52},	// QsciAPIs::qt_metacall$$?
    {48, 1149, 47},	// QsciAPIs::qt_metacast$
    {48, 1167, 57},	// QsciAPIs::remove$
    {48, 1183, 76},	// QsciAPIs::savePrepared
    {48, 1184, 63},	// QsciAPIs::savePrepared$
    {48, 1523, 77},	// QsciAPIs::staticMetaObject
    {48, 1547, 72},	// QsciAPIs::tr$
    {48, 1548, 48},	// QsciAPIs::tr$$
    {48, 1549, 50},	// QsciAPIs::tr$$$
    {48, 1551, 73},	// QsciAPIs::trUtf8$
    {48, 1552, 49},	// QsciAPIs::trUtf8$$
    {48, 1553, 51},	// QsciAPIs::trUtf8$$$
    {48, 1558, 64},	// QsciAPIs::updateAutoCompletionList??
    {48, 1594, 78},	// QsciAPIs::~QsciAPIs
    {49, 464, 86},	// QsciAbstractAPIs::QsciAbstractAPIs#
    {49, 816, 89},	// QsciAbstractAPIs::autoCompletionSelected$
    {49, 842, 90},	// QsciAbstractAPIs::callTips?$$?
    {49, 1054, 87},	// QsciAbstractAPIs::lexer
    {49, 1105, 79},	// QsciAbstractAPIs::metaObject
    {49, 1147, 85},	// QsciAbstractAPIs::qt_metacall$$?
    {49, 1149, 80},	// QsciAbstractAPIs::qt_metacast$
    {49, 1523, 93},	// QsciAbstractAPIs::staticMetaObject
    {49, 1547, 91},	// QsciAbstractAPIs::tr$
    {49, 1548, 81},	// QsciAbstractAPIs::tr$$
    {49, 1549, 83},	// QsciAbstractAPIs::tr$$$
    {49, 1551, 92},	// QsciAbstractAPIs::trUtf8$
    {49, 1552, 82},	// QsciAbstractAPIs::trUtf8$$
    {49, 1553, 84},	// QsciAbstractAPIs::trUtf8$$$
    {49, 1558, 88},	// QsciAbstractAPIs::updateAutoCompletionList??
    {49, 1595, 94},	// QsciAbstractAPIs::~QsciAbstractAPIs
    {50, 82, 195},	// QsciCommand::Backtab
    {50, 116, 196},	// QsciCommand::Cancel
    {50, 118, 118},	// QsciCommand::CharLeft
    {50, 119, 119},	// QsciCommand::CharLeftExtend
    {50, 120, 120},	// QsciCommand::CharLeftRectExtend
    {50, 121, 121},	// QsciCommand::CharRight
    {50, 122, 122},	// QsciCommand::CharRightExtend
    {50, 123, 123},	// QsciCommand::CharRightRectExtend
    {50, 162, 169},	// QsciCommand::Delete
    {50, 163, 170},	// QsciCommand::DeleteBack
    {50, 164, 171},	// QsciCommand::DeleteBackNotLine
    {50, 165, 175},	// QsciCommand::DeleteLineLeft
    {50, 166, 176},	// QsciCommand::DeleteLineRight
    {50, 167, 172},	// QsciCommand::DeleteWordLeft
    {50, 168, 173},	// QsciCommand::DeleteWordRight
    {50, 169, 174},	// QsciCommand::DeleteWordRightEnd
    {50, 177, 157},	// QsciCommand::DocumentEnd
    {50, 178, 158},	// QsciCommand::DocumentEndExtend
    {50, 179, 155},	// QsciCommand::DocumentStart
    {50, 180, 156},	// QsciCommand::DocumentStartExtend
    {50, 198, 191},	// QsciCommand::EditToggleOvertype
    {50, 219, 193},	// QsciCommand::Formfeed
    {50, 246, 136},	// QsciCommand::Home
    {50, 247, 139},	// QsciCommand::HomeDisplay
    {50, 248, 140},	// QsciCommand::HomeDisplayExtend
    {50, 249, 137},	// QsciCommand::HomeExtend
    {50, 250, 138},	// QsciCommand::HomeRectExtend
    {50, 251, 141},	// QsciCommand::HomeWrap
    {50, 252, 142},	// QsciCommand::HomeWrapExtend
    {50, 332, 179},	// QsciCommand::LineCopy
    {50, 333, 178},	// QsciCommand::LineCut
    {50, 334, 177},	// QsciCommand::LineDelete
    {50, 335, 103},	// QsciCommand::LineDown
    {50, 336, 104},	// QsciCommand::LineDownExtend
    {50, 337, 105},	// QsciCommand::LineDownRectExtend
    {50, 338, 181},	// QsciCommand::LineDuplicate
    {50, 339, 148},	// QsciCommand::LineEnd
    {50, 340, 151},	// QsciCommand::LineEndDisplay
    {50, 341, 152},	// QsciCommand::LineEndDisplayExtend
    {50, 342, 149},	// QsciCommand::LineEndExtend
    {50, 343, 150},	// QsciCommand::LineEndRectExtend
    {50, 344, 153},	// QsciCommand::LineEndWrap
    {50, 345, 154},	// QsciCommand::LineEndWrapExtend
    {50, 347, 106},	// QsciCommand::LineScrollDown
    {50, 348, 110},	// QsciCommand::LineScrollUp
    {50, 349, 180},	// QsciCommand::LineTranspose
    {50, 350, 107},	// QsciCommand::LineUp
    {50, 351, 108},	// QsciCommand::LineUpExtend
    {50, 352, 109},	// QsciCommand::LineUpRectExtend
    {50, 367, 184},	// QsciCommand::MoveSelectedLinesDown
    {50, 368, 183},	// QsciCommand::MoveSelectedLinesUp
    {50, 373, 192},	// QsciCommand::Newline
    {50, 398, 162},	// QsciCommand::PageDown
    {50, 399, 163},	// QsciCommand::PageDownExtend
    {50, 400, 164},	// QsciCommand::PageDownRectExtend
    {50, 402, 159},	// QsciCommand::PageUp
    {50, 403, 160},	// QsciCommand::PageUpExtend
    {50, 404, 161},	// QsciCommand::PageUpRectExtend
    {50, 406, 114},	// QsciCommand::ParaDown
    {50, 407, 115},	// QsciCommand::ParaDownExtend
    {50, 408, 116},	// QsciCommand::ParaUp
    {50, 409, 117},	// QsciCommand::ParaUpExtend
    {50, 411, 190},	// QsciCommand::Paste
    {50, 563, 198},	// QsciCommand::Redo
    {50, 635, 112},	// QsciCommand::ScrollToEnd
    {50, 636, 111},	// QsciCommand::ScrollToStart
    {50, 638, 182},	// QsciCommand::SelectAll
    {50, 640, 189},	// QsciCommand::SelectionCopy
    {50, 641, 188},	// QsciCommand::SelectionCut
    {50, 642, 185},	// QsciCommand::SelectionDuplicate
    {50, 643, 186},	// QsciCommand::SelectionLowerCase
    {50, 644, 187},	// QsciCommand::SelectionUpperCase
    {50, 682, 167},	// QsciCommand::StutteredPageDown
    {50, 683, 168},	// QsciCommand::StutteredPageDownExtend
    {50, 684, 165},	// QsciCommand::StutteredPageUp
    {50, 685, 166},	// QsciCommand::StutteredPageUpExtend
    {50, 700, 194},	// QsciCommand::Tab
    {50, 728, 197},	// QsciCommand::Undo
    {50, 743, 143},	// QsciCommand::VCHome
    {50, 744, 144},	// QsciCommand::VCHomeExtend
    {50, 745, 145},	// QsciCommand::VCHomeRectExtend
    {50, 746, 146},	// QsciCommand::VCHomeWrap
    {50, 747, 147},	// QsciCommand::VCHomeWrapExtend
    {50, 752, 113},	// QsciCommand::VerticalCentreCaret
    {50, 755, 124},	// QsciCommand::WordLeft
    {50, 756, 128},	// QsciCommand::WordLeftEnd
    {50, 757, 129},	// QsciCommand::WordLeftEndExtend
    {50, 758, 125},	// QsciCommand::WordLeftExtend
    {50, 759, 132},	// QsciCommand::WordPartLeft
    {50, 760, 133},	// QsciCommand::WordPartLeftExtend
    {50, 761, 134},	// QsciCommand::WordPartRight
    {50, 762, 135},	// QsciCommand::WordPartRightExtend
    {50, 763, 126},	// QsciCommand::WordRight
    {50, 764, 130},	// QsciCommand::WordRightEnd
    {50, 765, 131},	// QsciCommand::WordRightEndExtend
    {50, 766, 127},	// QsciCommand::WordRightExtend
    {50, 784, 199},	// QsciCommand::ZoomIn
    {50, 785, 200},	// QsciCommand::ZoomOut
    {50, 789, 100},	// QsciCommand::alternateKey
    {50, 872, 95},	// QsciCommand::command
    {50, 900, 102},	// QsciCommand::description
    {50, 936, 96},	// QsciCommand::execute
    {50, 1043, 99},	// QsciCommand::key
    {50, 1197, 98},	// QsciCommand::setAlternateKey$
    {50, 1386, 97},	// QsciCommand::setKey$
    {50, 1565, 101},	// QsciCommand::validKey$
    {50, 1596, 201},	// QsciCommand::~QsciCommand
    {51, 835, 207},	// QsciCommandSet::boundTo$
    {51, 857, 206},	// QsciCommandSet::clearAlternateKeys
    {51, 863, 205},	// QsciCommandSet::clearKeys
    {51, 875, 204},	// QsciCommandSet::commands
    {51, 942, 208},	// QsciCommandSet::find$
    {51, 1156, 209},	// QsciCommandSet::readSettings#
    {51, 1157, 202},	// QsciCommandSet::readSettings#$
    {51, 1585, 210},	// QsciCommandSet::writeSettings#
    {51, 1586, 203},	// QsciCommandSet::writeSettings#$
    {52, 465, 211},	// QsciDocument::QsciDocument
    {52, 466, 212},	// QsciDocument::QsciDocument#
    {52, 1122, 213},	// QsciDocument::operator=#
    {52, 1597, 214},	// QsciDocument::~QsciDocument
    {53, 467, 276},	// QsciLexer::QsciLexer
    {53, 468, 222},	// QsciLexer::QsciLexer#
    {53, 803, 226},	// QsciLexer::apis
    {53, 812, 227},	// QsciLexer::autoCompletionFillups
    {53, 821, 228},	// QsciLexer::autoCompletionWordSeparators
    {53, 823, 229},	// QsciLexer::autoIndentStyle
    {53, 827, 277},	// QsciLexer::blockEnd
    {53, 828, 230},	// QsciLexer::blockEnd$
    {53, 829, 231},	// QsciLexer::blockLookback
    {53, 830, 278},	// QsciLexer::blockStart
    {53, 831, 232},	// QsciLexer::blockStart$
    {53, 832, 279},	// QsciLexer::blockStartKeyword
    {53, 833, 233},	// QsciLexer::blockStartKeyword$
    {53, 837, 234},	// QsciLexer::braceStyle
    {53, 850, 235},	// QsciLexer::caseSensitive
    {53, 869, 236},	// QsciLexer::color$
    {53, 871, 267},	// QsciLexer::colorChanged#$
    {53, 890, 244},	// QsciLexer::defaultColor
    {53, 891, 245},	// QsciLexer::defaultColor$
    {53, 893, 246},	// QsciLexer::defaultEolFill$
    {53, 894, 247},	// QsciLexer::defaultFont
    {53, 895, 248},	// QsciLexer::defaultFont$
    {53, 896, 249},	// QsciLexer::defaultPaper
    {53, 897, 250},	// QsciLexer::defaultPaper$
    {53, 899, 241},	// QsciLexer::defaultStyle
    {53, 901, 242},	// QsciLexer::description$
    {53, 919, 251},	// QsciLexer::editor
    {53, 928, 237},	// QsciLexer::eolFill$
    {53, 930, 268},	// QsciLexer::eolFillChanged$$
    {53, 982, 238},	// QsciLexer::font$
    {53, 985, 269},	// QsciLexer::fontChanged#$
    {53, 1008, 239},	// QsciLexer::indentationGuideView
    {53, 1048, 240},	// QsciLexer::keywords$
    {53, 1049, 223},	// QsciLexer::language
    {53, 1054, 224},	// QsciLexer::lexer
    {53, 1055, 225},	// QsciLexer::lexerId
    {53, 1105, 215},	// QsciLexer::metaObject
    {53, 1129, 243},	// QsciLexer::paper$
    {53, 1131, 270},	// QsciLexer::paperChanged#$
    {53, 1145, 271},	// QsciLexer::propertyChanged$$
    {53, 1147, 221},	// QsciLexer::qt_metacall$$?
    {53, 1149, 216},	// QsciLexer::qt_metacast$
    {53, 1154, 272},	// QsciLexer::readProperties#$
    {53, 1156, 280},	// QsciLexer::readSettings#
    {53, 1157, 257},	// QsciLexer::readSettings#$
    {53, 1163, 258},	// QsciLexer::refreshProperties
    {53, 1195, 252},	// QsciLexer::setAPIs#
    {53, 1221, 262},	// QsciLexer::setAutoIndentStyle$
    {53, 1253, 282},	// QsciLexer::setColor#
    {53, 1254, 263},	// QsciLexer::setColor#$
    {53, 1260, 253},	// QsciLexer::setDefaultColor#
    {53, 1262, 254},	// QsciLexer::setDefaultFont#
    {53, 1264, 255},	// QsciLexer::setDefaultPaper#
    {53, 1282, 256},	// QsciLexer::setEditor#
    {53, 1284, 283},	// QsciLexer::setEolFill$
    {53, 1285, 264},	// QsciLexer::setEolFill$$
    {53, 1328, 284},	// QsciLexer::setFont#
    {53, 1329, 265},	// QsciLexer::setFont#$
    {53, 1437, 285},	// QsciLexer::setPaper#
    {53, 1438, 266},	// QsciLexer::setPaper#$
    {53, 1523, 286},	// QsciLexer::staticMetaObject
    {53, 1526, 259},	// QsciLexer::styleBitsNeeded
    {53, 1547, 274},	// QsciLexer::tr$
    {53, 1548, 217},	// QsciLexer::tr$$
    {53, 1549, 219},	// QsciLexer::tr$$$
    {53, 1551, 275},	// QsciLexer::trUtf8$
    {53, 1552, 218},	// QsciLexer::trUtf8$$
    {53, 1553, 220},	// QsciLexer::trUtf8$$$
    {53, 1577, 260},	// QsciLexer::wordCharacters
    {53, 1583, 273},	// QsciLexer::writeProperties#$
    {53, 1585, 281},	// QsciLexer::writeSettings#
    {53, 1586, 261},	// QsciLexer::writeSettings#$
    {53, 1598, 287},	// QsciLexer::~QsciLexer
    {54, 85, 328},	// QsciLexerBash::Backticks
    {54, 139, 319},	// QsciLexerBash::Comment
    {54, 160, 317},	// QsciLexerBash::Default
    {54, 186, 322},	// QsciLexerBash::DoubleQuotedString
    {54, 205, 318},	// QsciLexerBash::Error
    {54, 239, 329},	// QsciLexerBash::HereDocumentDelimiter
    {54, 255, 325},	// QsciLexerBash::Identifier
    {54, 307, 321},	// QsciLexerBash::Keyword
    {54, 378, 320},	// QsciLexerBash::Number
    {54, 382, 324},	// QsciLexerBash::Operator
    {54, 410, 327},	// QsciLexerBash::ParameterExpansion
    {54, 469, 315},	// QsciLexerBash::QsciLexerBash
    {54, 470, 295},	// QsciLexerBash::QsciLexerBash#
    {54, 632, 326},	// QsciLexerBash::Scalar
    {54, 657, 330},	// QsciLexerBash::SingleQuotedHereDocument
    {54, 658, 323},	// QsciLexerBash::SingleQuotedString
    {54, 837, 298},	// QsciLexerBash::braceStyle
    {54, 891, 300},	// QsciLexerBash::defaultColor$
    {54, 893, 301},	// QsciLexerBash::defaultEolFill$
    {54, 895, 302},	// QsciLexerBash::defaultFont$
    {54, 897, 303},	// QsciLexerBash::defaultPaper$
    {54, 901, 305},	// QsciLexerBash::description$
    {54, 968, 307},	// QsciLexerBash::foldComments
    {54, 969, 308},	// QsciLexerBash::foldCompact
    {54, 1048, 304},	// QsciLexerBash::keywords$
    {54, 1049, 296},	// QsciLexerBash::language
    {54, 1054, 297},	// QsciLexerBash::lexer
    {54, 1105, 288},	// QsciLexerBash::metaObject
    {54, 1147, 294},	// QsciLexerBash::qt_metacall$$?
    {54, 1149, 289},	// QsciLexerBash::qt_metacast$
    {54, 1154, 311},	// QsciLexerBash::readProperties#$
    {54, 1163, 306},	// QsciLexerBash::refreshProperties
    {54, 1303, 309},	// QsciLexerBash::setFoldComments$
    {54, 1305, 310},	// QsciLexerBash::setFoldCompact$
    {54, 1523, 316},	// QsciLexerBash::staticMetaObject
    {54, 1547, 313},	// QsciLexerBash::tr$
    {54, 1548, 290},	// QsciLexerBash::tr$$
    {54, 1549, 292},	// QsciLexerBash::tr$$$
    {54, 1551, 314},	// QsciLexerBash::trUtf8$
    {54, 1552, 291},	// QsciLexerBash::trUtf8$$
    {54, 1553, 293},	// QsciLexerBash::trUtf8$$$
    {54, 1577, 299},	// QsciLexerBash::wordCharacters
    {54, 1583, 312},	// QsciLexerBash::writeProperties#$
    {54, 1599, 331},	// QsciLexerBash::~QsciLexerBash
    {55, 139, 355},	// QsciLexerBatch::Comment
    {55, 160, 354},	// QsciLexerBatch::Default
    {55, 213, 359},	// QsciLexerBatch::ExternalCommand
    {55, 243, 358},	// QsciLexerBatch::HideCommandChar
    {55, 307, 356},	// QsciLexerBatch::Keyword
    {55, 317, 357},	// QsciLexerBatch::Label
    {55, 382, 361},	// QsciLexerBatch::Operator
    {55, 471, 352},	// QsciLexerBatch::QsciLexerBatch
    {55, 472, 339},	// QsciLexerBatch::QsciLexerBatch#
    {55, 750, 360},	// QsciLexerBatch::Variable
    {55, 850, 343},	// QsciLexerBatch::caseSensitive
    {55, 891, 344},	// QsciLexerBatch::defaultColor$
    {55, 893, 345},	// QsciLexerBatch::defaultEolFill$
    {55, 895, 346},	// QsciLexerBatch::defaultFont$
    {55, 897, 347},	// QsciLexerBatch::defaultPaper$
    {55, 901, 349},	// QsciLexerBatch::description$
    {55, 1048, 348},	// QsciLexerBatch::keywords$
    {55, 1049, 340},	// QsciLexerBatch::language
    {55, 1054, 341},	// QsciLexerBatch::lexer
    {55, 1105, 332},	// QsciLexerBatch::metaObject
    {55, 1147, 338},	// QsciLexerBatch::qt_metacall$$?
    {55, 1149, 333},	// QsciLexerBatch::qt_metacast$
    {55, 1523, 353},	// QsciLexerBatch::staticMetaObject
    {55, 1547, 350},	// QsciLexerBatch::tr$
    {55, 1548, 334},	// QsciLexerBatch::tr$$
    {55, 1549, 336},	// QsciLexerBatch::tr$$$
    {55, 1551, 351},	// QsciLexerBatch::trUtf8$
    {55, 1552, 335},	// QsciLexerBatch::trUtf8$$
    {55, 1553, 337},	// QsciLexerBatch::trUtf8$$$
    {55, 1577, 342},	// QsciLexerBatch::wordCharacters
    {55, 1600, 362},	// QsciLexerBatch::~QsciLexerBatch
    {56, 91, 397},	// QsciLexerCMake::BlockForeach
    {56, 92, 398},	// QsciLexerCMake::BlockIf
    {56, 93, 399},	// QsciLexerCMake::BlockMacro
    {56, 94, 396},	// QsciLexerCMake::BlockWhile
    {56, 139, 388},	// QsciLexerCMake::Comment
    {56, 160, 387},	// QsciLexerCMake::Default
    {56, 222, 392},	// QsciLexerCMake::Function
    {56, 311, 395},	// QsciLexerCMake::KeywordSet3
    {56, 317, 394},	// QsciLexerCMake::Label
    {56, 378, 401},	// QsciLexerCMake::Number
    {56, 473, 385},	// QsciLexerCMake::QsciLexerCMake
    {56, 474, 370},	// QsciLexerCMake::QsciLexerCMake#
    {56, 677, 389},	// QsciLexerCMake::String
    {56, 678, 390},	// QsciLexerCMake::StringLeftQuote
    {56, 679, 391},	// QsciLexerCMake::StringRightQuote
    {56, 681, 400},	// QsciLexerCMake::StringVariable
    {56, 750, 393},	// QsciLexerCMake::Variable
    {56, 891, 373},	// QsciLexerCMake::defaultColor$
    {56, 895, 374},	// QsciLexerCMake::defaultFont$
    {56, 897, 375},	// QsciLexerCMake::defaultPaper$
    {56, 901, 377},	// QsciLexerCMake::description$
    {56, 966, 379},	// QsciLexerCMake::foldAtElse
    {56, 1048, 376},	// QsciLexerCMake::keywords$
    {56, 1049, 371},	// QsciLexerCMake::language
    {56, 1054, 372},	// QsciLexerCMake::lexer
    {56, 1105, 363},	// QsciLexerCMake::metaObject
    {56, 1147, 369},	// QsciLexerCMake::qt_metacall$$?
    {56, 1149, 364},	// QsciLexerCMake::qt_metacast$
    {56, 1154, 381},	// QsciLexerCMake::readProperties#$
    {56, 1163, 378},	// QsciLexerCMake::refreshProperties
    {56, 1299, 380},	// QsciLexerCMake::setFoldAtElse$
    {56, 1523, 386},	// QsciLexerCMake::staticMetaObject
    {56, 1547, 383},	// QsciLexerCMake::tr$
    {56, 1548, 365},	// QsciLexerCMake::tr$$
    {56, 1549, 367},	// QsciLexerCMake::tr$$$
    {56, 1551, 384},	// QsciLexerCMake::trUtf8$
    {56, 1552, 366},	// QsciLexerCMake::trUtf8$$
    {56, 1553, 368},	// QsciLexerCMake::trUtf8$$$
    {56, 1583, 382},	// QsciLexerCMake::writeProperties#$
    {56, 1601, 402},	// QsciLexerCMake::~QsciLexerCMake
    {57, 139, 460},	// QsciLexerCPP::Comment
    {57, 142, 464},	// QsciLexerCPP::CommentDoc
    {57, 143, 492},	// QsciLexerCPP::CommentDocKeyword
    {57, 144, 494},	// QsciLexerCPP::CommentDocKeywordError
    {57, 145, 462},	// QsciLexerCPP::CommentLine
    {57, 146, 488},	// QsciLexerCPP::CommentLineDoc
    {57, 160, 458},	// QsciLexerCPP::Default
    {57, 186, 470},	// QsciLexerCPP::DoubleQuotedString
    {57, 206, 512},	// QsciLexerCPP::EscapeSequence
    {57, 225, 496},	// QsciLexerCPP::GlobalClass
    {57, 236, 502},	// QsciLexerCPP::HashQuotedString
    {57, 255, 480},	// QsciLexerCPP::Identifier
    {57, 260, 461},	// QsciLexerCPP::InactiveComment
    {57, 261, 465},	// QsciLexerCPP::InactiveCommentDoc
    {57, 262, 493},	// QsciLexerCPP::InactiveCommentDocKeyword
    {57, 263, 495},	// QsciLexerCPP::InactiveCommentDocKeywordError
    {57, 264, 463},	// QsciLexerCPP::InactiveCommentLine
    {57, 265, 489},	// QsciLexerCPP::InactiveCommentLineDoc
    {57, 266, 459},	// QsciLexerCPP::InactiveDefault
    {57, 267, 471},	// QsciLexerCPP::InactiveDoubleQuotedString
    {57, 268, 513},	// QsciLexerCPP::InactiveEscapeSequence
    {57, 269, 497},	// QsciLexerCPP::InactiveGlobalClass
    {57, 270, 503},	// QsciLexerCPP::InactiveHashQuotedString
    {57, 271, 481},	// QsciLexerCPP::InactiveIdentifier
    {57, 272, 469},	// QsciLexerCPP::InactiveKeyword
    {57, 273, 491},	// QsciLexerCPP::InactiveKeywordSet2
    {57, 274, 467},	// QsciLexerCPP::InactiveNumber
    {57, 275, 479},	// QsciLexerCPP::InactiveOperator
    {57, 276, 477},	// QsciLexerCPP::InactivePreProcessor
    {57, 277, 505},	// QsciLexerCPP::InactivePreProcessorComment
    {57, 278, 507},	// QsciLexerCPP::InactivePreProcessorCommentLineDoc
    {57, 279, 499},	// QsciLexerCPP::InactiveRawString
    {57, 280, 487},	// QsciLexerCPP::InactiveRegex
    {57, 281, 473},	// QsciLexerCPP::InactiveSingleQuotedString
    {57, 282, 511},	// QsciLexerCPP::InactiveTaskMarker
    {57, 283, 501},	// QsciLexerCPP::InactiveTripleQuotedVerbatimString
    {57, 284, 475},	// QsciLexerCPP::InactiveUUID
    {57, 285, 483},	// QsciLexerCPP::InactiveUnclosedString
    {57, 286, 509},	// QsciLexerCPP::InactiveUserLiteral
    {57, 287, 485},	// QsciLexerCPP::InactiveVerbatimString
    {57, 307, 468},	// QsciLexerCPP::Keyword
    {57, 310, 490},	// QsciLexerCPP::KeywordSet2
    {57, 378, 466},	// QsciLexerCPP::Number
    {57, 382, 478},	// QsciLexerCPP::Operator
    {57, 430, 476},	// QsciLexerCPP::PreProcessor
    {57, 431, 504},	// QsciLexerCPP::PreProcessorComment
    {57, 432, 506},	// QsciLexerCPP::PreProcessorCommentLineDoc
    {57, 475, 452},	// QsciLexerCPP::QsciLexerCPP
    {57, 476, 453},	// QsciLexerCPP::QsciLexerCPP#
    {57, 477, 410},	// QsciLexerCPP::QsciLexerCPP#$
    {57, 561, 498},	// QsciLexerCPP::RawString
    {57, 565, 486},	// QsciLexerCPP::Regex
    {57, 658, 472},	// QsciLexerCPP::SingleQuotedString
    {57, 706, 510},	// QsciLexerCPP::TaskMarker
    {57, 721, 500},	// QsciLexerCPP::TripleQuotedVerbatimString
    {57, 725, 474},	// QsciLexerCPP::UUID
    {57, 726, 482},	// QsciLexerCPP::UnclosedString
    {57, 734, 508},	// QsciLexerCPP::UserLiteral
    {57, 751, 484},	// QsciLexerCPP::VerbatimString
    {57, 821, 413},	// QsciLexerCPP::autoCompletionWordSeparators
    {57, 827, 454},	// QsciLexerCPP::blockEnd
    {57, 828, 414},	// QsciLexerCPP::blockEnd$
    {57, 830, 455},	// QsciLexerCPP::blockStart
    {57, 831, 415},	// QsciLexerCPP::blockStart$
    {57, 832, 456},	// QsciLexerCPP::blockStartKeyword
    {57, 833, 416},	// QsciLexerCPP::blockStartKeyword$
    {57, 837, 417},	// QsciLexerCPP::braceStyle
    {57, 891, 419},	// QsciLexerCPP::defaultColor$
    {57, 893, 420},	// QsciLexerCPP::defaultEolFill$
    {57, 895, 421},	// QsciLexerCPP::defaultFont$
    {57, 897, 422},	// QsciLexerCPP::defaultPaper$
    {57, 901, 424},	// QsciLexerCPP::description$
    {57, 906, 432},	// QsciLexerCPP::dollarsAllowed
    {57, 966, 426},	// QsciLexerCPP::foldAtElse
    {57, 968, 427},	// QsciLexerCPP::foldComments
    {57, 969, 428},	// QsciLexerCPP::foldCompact
    {57, 976, 429},	// QsciLexerCPP::foldPreprocessor
    {57, 998, 438},	// QsciLexerCPP::highlightBackQuotedStrings
    {57, 999, 440},	// QsciLexerCPP::highlightEscapeSequences
    {57, 1000, 436},	// QsciLexerCPP::highlightHashQuotedStrings
    {57, 1002, 434},	// QsciLexerCPP::highlightTripleQuotedStrings
    {57, 1048, 423},	// QsciLexerCPP::keywords$
    {57, 1049, 411},	// QsciLexerCPP::language
    {57, 1054, 412},	// QsciLexerCPP::lexer
    {57, 1105, 403},	// QsciLexerCPP::metaObject
    {57, 1147, 409},	// QsciLexerCPP::qt_metacall$$?
    {57, 1149, 404},	// QsciLexerCPP::qt_metacast$
    {57, 1154, 448},	// QsciLexerCPP::readProperties#$
    {57, 1163, 425},	// QsciLexerCPP::refreshProperties
    {57, 1272, 431},	// QsciLexerCPP::setDollarsAllowed$
    {57, 1299, 443},	// QsciLexerCPP::setFoldAtElse$
    {57, 1303, 444},	// QsciLexerCPP::setFoldComments$
    {57, 1305, 445},	// QsciLexerCPP::setFoldCompact$
    {57, 1317, 446},	// QsciLexerCPP::setFoldPreprocessor$
    {57, 1335, 437},	// QsciLexerCPP::setHighlightBackQuotedStrings$
    {57, 1337, 439},	// QsciLexerCPP::setHighlightEscapeSequences$
    {57, 1339, 435},	// QsciLexerCPP::setHighlightHashQuotedStrings$
    {57, 1343, 433},	// QsciLexerCPP::setHighlightTripleQuotedStrings$
    {57, 1465, 447},	// QsciLexerCPP::setStylePreprocessor$
    {57, 1494, 441},	// QsciLexerCPP::setVerbatimStringEscapeSequencesAllowed$
    {57, 1523, 457},	// QsciLexerCPP::staticMetaObject
    {57, 1528, 430},	// QsciLexerCPP::stylePreprocessor
    {57, 1547, 450},	// QsciLexerCPP::tr$
    {57, 1548, 405},	// QsciLexerCPP::tr$$
    {57, 1549, 407},	// QsciLexerCPP::tr$$$
    {57, 1551, 451},	// QsciLexerCPP::trUtf8$
    {57, 1552, 406},	// QsciLexerCPP::trUtf8$$
    {57, 1553, 408},	// QsciLexerCPP::trUtf8$$$
    {57, 1566, 442},	// QsciLexerCPP::verbatimStringEscapeSequencesAllowed
    {57, 1577, 418},	// QsciLexerCPP::wordCharacters
    {57, 1583, 449},	// QsciLexerCPP::writeProperties#$
    {57, 1602, 514},	// QsciLexerCPP::~QsciLexerCPP
    {58, 66, 563},	// QsciLexerCSS::AtRule
    {58, 67, 567},	// QsciLexerCSS::Attribute
    {58, 107, 557},	// QsciLexerCSS::CSS1Property
    {58, 108, 566},	// QsciLexerCSS::CSS2Property
    {58, 109, 568},	// QsciLexerCSS::CSS3Property
    {58, 134, 553},	// QsciLexerCSS::ClassSelector
    {58, 139, 560},	// QsciLexerCSS::Comment
    {58, 160, 551},	// QsciLexerCSS::Default
    {58, 186, 564},	// QsciLexerCSS::DoubleQuotedString
    {58, 209, 570},	// QsciLexerCSS::ExtendedCSSProperty
    {58, 211, 571},	// QsciLexerCSS::ExtendedPseudoClass
    {58, 212, 572},	// QsciLexerCSS::ExtendedPseudoElement
    {58, 229, 536},	// QsciLexerCSS::HSSLanguage
    {58, 253, 561},	// QsciLexerCSS::IDSelector
    {58, 259, 562},	// QsciLexerCSS::Important
    {58, 327, 538},	// QsciLexerCSS::LessLanguage
    {58, 359, 573},	// QsciLexerCSS::MediaRule
    {58, 382, 556},	// QsciLexerCSS::Operator
    {58, 439, 554},	// QsciLexerCSS::PseudoClass
    {58, 440, 569},	// QsciLexerCSS::PseudoElement
    {58, 478, 547},	// QsciLexerCSS::QsciLexerCSS
    {58, 479, 522},	// QsciLexerCSS::QsciLexerCSS#
    {58, 617, 540},	// QsciLexerCSS::SCSSLanguage
    {58, 658, 565},	// QsciLexerCSS::SingleQuotedString
    {58, 704, 552},	// QsciLexerCSS::Tag
    {58, 730, 558},	// QsciLexerCSS::UnknownProperty
    {58, 731, 555},	// QsciLexerCSS::UnknownPseudoClass
    {58, 749, 559},	// QsciLexerCSS::Value
    {58, 750, 574},	// QsciLexerCSS::Variable
    {58, 827, 548},	// QsciLexerCSS::blockEnd
    {58, 828, 525},	// QsciLexerCSS::blockEnd$
    {58, 830, 549},	// QsciLexerCSS::blockStart
    {58, 831, 526},	// QsciLexerCSS::blockStart$
    {58, 891, 528},	// QsciLexerCSS::defaultColor$
    {58, 895, 529},	// QsciLexerCSS::defaultFont$
    {58, 901, 531},	// QsciLexerCSS::description$
    {58, 968, 533},	// QsciLexerCSS::foldComments
    {58, 969, 534},	// QsciLexerCSS::foldCompact
    {58, 1048, 530},	// QsciLexerCSS::keywords$
    {58, 1049, 523},	// QsciLexerCSS::language
    {58, 1054, 524},	// QsciLexerCSS::lexer
    {58, 1105, 515},	// QsciLexerCSS::metaObject
    {58, 1147, 521},	// QsciLexerCSS::qt_metacall$$?
    {58, 1149, 516},	// QsciLexerCSS::qt_metacast$
    {58, 1154, 543},	// QsciLexerCSS::readProperties#$
    {58, 1163, 532},	// QsciLexerCSS::refreshProperties
    {58, 1303, 541},	// QsciLexerCSS::setFoldComments$
    {58, 1305, 542},	// QsciLexerCSS::setFoldCompact$
    {58, 1331, 535},	// QsciLexerCSS::setHSSLanguage$
    {58, 1388, 537},	// QsciLexerCSS::setLessLanguage$
    {58, 1448, 539},	// QsciLexerCSS::setSCSSLanguage$
    {58, 1523, 550},	// QsciLexerCSS::staticMetaObject
    {58, 1547, 545},	// QsciLexerCSS::tr$
    {58, 1548, 517},	// QsciLexerCSS::tr$$
    {58, 1549, 519},	// QsciLexerCSS::tr$$$
    {58, 1551, 546},	// QsciLexerCSS::trUtf8$
    {58, 1552, 518},	// QsciLexerCSS::trUtf8$$
    {58, 1553, 520},	// QsciLexerCSS::trUtf8$$$
    {58, 1577, 527},	// QsciLexerCSS::wordCharacters
    {58, 1583, 544},	// QsciLexerCSS::writeProperties#$
    {58, 1603, 575},	// QsciLexerCSS::~QsciLexerCSS
    {59, 480, 593},	// QsciLexerCSharp::QsciLexerCSharp
    {59, 481, 583},	// QsciLexerCSharp::QsciLexerCSharp#
    {59, 891, 585},	// QsciLexerCSharp::defaultColor$
    {59, 893, 586},	// QsciLexerCSharp::defaultEolFill$
    {59, 895, 587},	// QsciLexerCSharp::defaultFont$
    {59, 897, 588},	// QsciLexerCSharp::defaultPaper$
    {59, 901, 590},	// QsciLexerCSharp::description$
    {59, 1048, 589},	// QsciLexerCSharp::keywords$
    {59, 1049, 584},	// QsciLexerCSharp::language
    {59, 1105, 576},	// QsciLexerCSharp::metaObject
    {59, 1147, 582},	// QsciLexerCSharp::qt_metacall$$?
    {59, 1149, 577},	// QsciLexerCSharp::qt_metacast$
    {59, 1523, 594},	// QsciLexerCSharp::staticMetaObject
    {59, 1547, 591},	// QsciLexerCSharp::tr$
    {59, 1548, 578},	// QsciLexerCSharp::tr$$
    {59, 1549, 580},	// QsciLexerCSharp::tr$$$
    {59, 1551, 592},	// QsciLexerCSharp::trUtf8$
    {59, 1552, 579},	// QsciLexerCSharp::trUtf8$$
    {59, 1553, 581},	// QsciLexerCSharp::trUtf8$$$
    {59, 1604, 595},	// QsciLexerCSharp::~QsciLexerCSharp
    {60, 482, 612},	// QsciLexerCustom::QsciLexerCustom
    {60, 483, 603},	// QsciLexerCustom::QsciLexerCustom#
    {60, 1105, 596},	// QsciLexerCustom::metaObject
    {60, 1147, 602},	// QsciLexerCustom::qt_metacall$$?
    {60, 1149, 597},	// QsciLexerCustom::qt_metacast$
    {60, 1282, 608},	// QsciLexerCustom::setEditor#
    {60, 1467, 605},	// QsciLexerCustom::setStyling$#
    {60, 1468, 604},	// QsciLexerCustom::setStyling$$
    {60, 1521, 613},	// QsciLexerCustom::startStyling$
    {60, 1522, 606},	// QsciLexerCustom::startStyling$$
    {60, 1523, 614},	// QsciLexerCustom::staticMetaObject
    {60, 1526, 609},	// QsciLexerCustom::styleBitsNeeded
    {60, 1530, 607},	// QsciLexerCustom::styleText$$
    {60, 1547, 610},	// QsciLexerCustom::tr$
    {60, 1548, 598},	// QsciLexerCustom::tr$$
    {60, 1549, 600},	// QsciLexerCustom::tr$$$
    {60, 1551, 611},	// QsciLexerCustom::trUtf8$
    {60, 1552, 599},	// QsciLexerCustom::trUtf8$$
    {60, 1553, 601},	// QsciLexerCustom::trUtf8$$$
    {60, 1605, 615},	// QsciLexerCustom::~QsciLexerCustom
    {61, 81, 672},	// QsciLexerD::BackquoteString
    {61, 124, 666},	// QsciLexerD::Character
    {61, 139, 655},	// QsciLexerD::Comment
    {61, 142, 657},	// QsciLexerD::CommentDoc
    {61, 143, 670},	// QsciLexerD::CommentDocKeyword
    {61, 144, 671},	// QsciLexerD::CommentDocKeywordError
    {61, 145, 656},	// QsciLexerD::CommentLine
    {61, 146, 669},	// QsciLexerD::CommentLineDoc
    {61, 148, 658},	// QsciLexerD::CommentNested
    {61, 160, 654},	// QsciLexerD::Default
    {61, 255, 668},	// QsciLexerD::Identifier
    {61, 307, 660},	// QsciLexerD::Keyword
    {61, 308, 662},	// QsciLexerD::KeywordDoc
    {61, 309, 661},	// QsciLexerD::KeywordSecondary
    {61, 312, 674},	// QsciLexerD::KeywordSet5
    {61, 313, 675},	// QsciLexerD::KeywordSet6
    {61, 314, 676},	// QsciLexerD::KeywordSet7
    {61, 378, 659},	// QsciLexerD::Number
    {61, 382, 667},	// QsciLexerD::Operator
    {61, 484, 649},	// QsciLexerD::QsciLexerD
    {61, 485, 623},	// QsciLexerD::QsciLexerD#
    {61, 561, 673},	// QsciLexerD::RawString
    {61, 677, 664},	// QsciLexerD::String
    {61, 723, 663},	// QsciLexerD::Typedefs
    {61, 726, 665},	// QsciLexerD::UnclosedString
    {61, 821, 626},	// QsciLexerD::autoCompletionWordSeparators
    {61, 827, 650},	// QsciLexerD::blockEnd
    {61, 828, 627},	// QsciLexerD::blockEnd$
    {61, 830, 651},	// QsciLexerD::blockStart
    {61, 831, 628},	// QsciLexerD::blockStart$
    {61, 832, 652},	// QsciLexerD::blockStartKeyword
    {61, 833, 629},	// QsciLexerD::blockStartKeyword$
    {61, 837, 630},	// QsciLexerD::braceStyle
    {61, 891, 632},	// QsciLexerD::defaultColor$
    {61, 893, 633},	// QsciLexerD::defaultEolFill$
    {61, 895, 634},	// QsciLexerD::defaultFont$
    {61, 897, 635},	// QsciLexerD::defaultPaper$
    {61, 901, 637},	// QsciLexerD::description$
    {61, 966, 639},	// QsciLexerD::foldAtElse
    {61, 968, 640},	// QsciLexerD::foldComments
    {61, 969, 641},	// QsciLexerD::foldCompact
    {61, 1048, 636},	// QsciLexerD::keywords$
    {61, 1049, 624},	// QsciLexerD::language
    {61, 1054, 625},	// QsciLexerD::lexer
    {61, 1105, 616},	// QsciLexerD::metaObject
    {61, 1147, 622},	// QsciLexerD::qt_metacall$$?
    {61, 1149, 617},	// QsciLexerD::qt_metacast$
    {61, 1154, 645},	// QsciLexerD::readProperties#$
    {61, 1163, 638},	// QsciLexerD::refreshProperties
    {61, 1299, 642},	// QsciLexerD::setFoldAtElse$
    {61, 1303, 643},	// QsciLexerD::setFoldComments$
    {61, 1305, 644},	// QsciLexerD::setFoldCompact$
    {61, 1523, 653},	// QsciLexerD::staticMetaObject
    {61, 1547, 647},	// QsciLexerD::tr$
    {61, 1548, 618},	// QsciLexerD::tr$$
    {61, 1549, 620},	// QsciLexerD::tr$$$
    {61, 1551, 648},	// QsciLexerD::trUtf8$
    {61, 1552, 619},	// QsciLexerD::trUtf8$$
    {61, 1553, 621},	// QsciLexerD::trUtf8$$$
    {61, 1577, 631},	// QsciLexerD::wordCharacters
    {61, 1583, 646},	// QsciLexerD::writeProperties#$
    {61, 1606, 677},	// QsciLexerD::~QsciLexerD
    {62, 138, 697},	// QsciLexerDiff::Command
    {62, 139, 696},	// QsciLexerDiff::Comment
    {62, 160, 695},	// QsciLexerDiff::Default
    {62, 237, 698},	// QsciLexerDiff::Header
    {62, 329, 701},	// QsciLexerDiff::LineAdded
    {62, 330, 702},	// QsciLexerDiff::LineChanged
    {62, 346, 700},	// QsciLexerDiff::LineRemoved
    {62, 428, 699},	// QsciLexerDiff::Position
    {62, 486, 693},	// QsciLexerDiff::QsciLexerDiff
    {62, 487, 685},	// QsciLexerDiff::QsciLexerDiff#
    {62, 891, 689},	// QsciLexerDiff::defaultColor$
    {62, 901, 690},	// QsciLexerDiff::description$
    {62, 1049, 686},	// QsciLexerDiff::language
    {62, 1054, 687},	// QsciLexerDiff::lexer
    {62, 1105, 678},	// QsciLexerDiff::metaObject
    {62, 1147, 684},	// QsciLexerDiff::qt_metacall$$?
    {62, 1149, 679},	// QsciLexerDiff::qt_metacast$
    {62, 1523, 694},	// QsciLexerDiff::staticMetaObject
    {62, 1547, 691},	// QsciLexerDiff::tr$
    {62, 1548, 680},	// QsciLexerDiff::tr$$
    {62, 1549, 682},	// QsciLexerDiff::tr$$$
    {62, 1551, 692},	// QsciLexerDiff::trUtf8$
    {62, 1552, 681},	// QsciLexerDiff::trUtf8$$
    {62, 1553, 683},	// QsciLexerDiff::trUtf8$$$
    {62, 1577, 688},	// QsciLexerDiff::wordCharacters
    {62, 1607, 703},	// QsciLexerDiff::~QsciLexerDiff
    {63, 488, 717},	// QsciLexerFortran::QsciLexerFortran
    {63, 489, 711},	// QsciLexerFortran::QsciLexerFortran#
    {63, 1048, 714},	// QsciLexerFortran::keywords$
    {63, 1049, 712},	// QsciLexerFortran::language
    {63, 1054, 713},	// QsciLexerFortran::lexer
    {63, 1105, 704},	// QsciLexerFortran::metaObject
    {63, 1147, 710},	// QsciLexerFortran::qt_metacall$$?
    {63, 1149, 705},	// QsciLexerFortran::qt_metacast$
    {63, 1523, 718},	// QsciLexerFortran::staticMetaObject
    {63, 1547, 715},	// QsciLexerFortran::tr$
    {63, 1548, 706},	// QsciLexerFortran::tr$$
    {63, 1549, 708},	// QsciLexerFortran::tr$$$
    {63, 1551, 716},	// QsciLexerFortran::trUtf8$
    {63, 1552, 707},	// QsciLexerFortran::trUtf8$$
    {63, 1553, 709},	// QsciLexerFortran::trUtf8$$$
    {63, 1608, 719},	// QsciLexerFortran::~QsciLexerFortran
    {64, 139, 747},	// QsciLexerFortran77::Comment
    {64, 150, 760},	// QsciLexerFortran77::Continuation
    {64, 160, 746},	// QsciLexerFortran77::Default
    {64, 183, 758},	// QsciLexerFortran77::DottedOperator
    {64, 186, 750},	// QsciLexerFortran77::DoubleQuotedString
    {64, 210, 756},	// QsciLexerFortran77::ExtendedFunction
    {64, 255, 753},	// QsciLexerFortran77::Identifier
    {64, 291, 755},	// QsciLexerFortran77::IntrinsicFunction
    {64, 307, 754},	// QsciLexerFortran77::Keyword
    {64, 317, 759},	// QsciLexerFortran77::Label
    {64, 378, 748},	// QsciLexerFortran77::Number
    {64, 382, 752},	// QsciLexerFortran77::Operator
    {64, 430, 757},	// QsciLexerFortran77::PreProcessor
    {64, 490, 744},	// QsciLexerFortran77::QsciLexerFortran77
    {64, 491, 727},	// QsciLexerFortran77::QsciLexerFortran77#
    {64, 658, 749},	// QsciLexerFortran77::SingleQuotedString
    {64, 726, 751},	// QsciLexerFortran77::UnclosedString
    {64, 837, 730},	// QsciLexerFortran77::braceStyle
    {64, 891, 731},	// QsciLexerFortran77::defaultColor$
    {64, 893, 732},	// QsciLexerFortran77::defaultEolFill$
    {64, 895, 733},	// QsciLexerFortran77::defaultFont$
    {64, 897, 734},	// QsciLexerFortran77::defaultPaper$
    {64, 901, 736},	// QsciLexerFortran77::description$
    {64, 969, 738},	// QsciLexerFortran77::foldCompact
    {64, 1048, 735},	// QsciLexerFortran77::keywords$
    {64, 1049, 728},	// QsciLexerFortran77::language
    {64, 1054, 729},	// QsciLexerFortran77::lexer
    {64, 1105, 720},	// QsciLexerFortran77::metaObject
    {64, 1147, 726},	// QsciLexerFortran77::qt_metacall$$?
    {64, 1149, 721},	// QsciLexerFortran77::qt_metacast$
    {64, 1154, 740},	// QsciLexerFortran77::readProperties#$
    {64, 1163, 737},	// QsciLexerFortran77::refreshProperties
    {64, 1305, 739},	// QsciLexerFortran77::setFoldCompact$
    {64, 1523, 745},	// QsciLexerFortran77::staticMetaObject
    {64, 1547, 742},	// QsciLexerFortran77::tr$
    {64, 1548, 722},	// QsciLexerFortran77::tr$$
    {64, 1549, 724},	// QsciLexerFortran77::tr$$$
    {64, 1551, 743},	// QsciLexerFortran77::trUtf8$
    {64, 1552, 723},	// QsciLexerFortran77::trUtf8$$
    {64, 1553, 725},	// QsciLexerFortran77::trUtf8$$$
    {64, 1583, 741},	// QsciLexerFortran77::writeProperties#$
    {64, 1609, 761},	// QsciLexerFortran77::~QsciLexerFortran77
    {65, 11, 816},	// QsciLexerHTML::ASPAtStart
    {65, 12, 848},	// QsciLexerHTML::ASPJavaScriptComment
    {65, 13, 850},	// QsciLexerHTML::ASPJavaScriptCommentDoc
    {65, 14, 849},	// QsciLexerHTML::ASPJavaScriptCommentLine
    {65, 15, 847},	// QsciLexerHTML::ASPJavaScriptDefault
    {65, 16, 854},	// QsciLexerHTML::ASPJavaScriptDoubleQuotedString
    {65, 17, 853},	// QsciLexerHTML::ASPJavaScriptKeyword
    {65, 18, 851},	// QsciLexerHTML::ASPJavaScriptNumber
    {65, 19, 858},	// QsciLexerHTML::ASPJavaScriptRegex
    {65, 20, 855},	// QsciLexerHTML::ASPJavaScriptSingleQuotedString
    {65, 21, 846},	// QsciLexerHTML::ASPJavaScriptStart
    {65, 22, 856},	// QsciLexerHTML::ASPJavaScriptSymbol
    {65, 23, 857},	// QsciLexerHTML::ASPJavaScriptUnclosedString
    {65, 24, 852},	// QsciLexerHTML::ASPJavaScriptWord
    {65, 25, 897},	// QsciLexerHTML::ASPPythonClassName
    {65, 26, 890},	// QsciLexerHTML::ASPPythonComment
    {65, 27, 889},	// QsciLexerHTML::ASPPythonDefault
    {65, 28, 892},	// QsciLexerHTML::ASPPythonDoubleQuotedString
    {65, 29, 898},	// QsciLexerHTML::ASPPythonFunctionMethodName
    {65, 30, 900},	// QsciLexerHTML::ASPPythonIdentifier
    {65, 31, 894},	// QsciLexerHTML::ASPPythonKeyword
    {65, 32, 891},	// QsciLexerHTML::ASPPythonNumber
    {65, 33, 899},	// QsciLexerHTML::ASPPythonOperator
    {65, 34, 893},	// QsciLexerHTML::ASPPythonSingleQuotedString
    {65, 35, 888},	// QsciLexerHTML::ASPPythonStart
    {65, 36, 896},	// QsciLexerHTML::ASPPythonTripleDoubleQuotedString
    {65, 37, 895},	// QsciLexerHTML::ASPPythonTripleSingleQuotedString
    {65, 38, 817},	// QsciLexerHTML::ASPStart
    {65, 39, 869},	// QsciLexerHTML::ASPVBScriptComment
    {65, 40, 868},	// QsciLexerHTML::ASPVBScriptDefault
    {65, 41, 873},	// QsciLexerHTML::ASPVBScriptIdentifier
    {65, 42, 871},	// QsciLexerHTML::ASPVBScriptKeyword
    {65, 43, 870},	// QsciLexerHTML::ASPVBScriptNumber
    {65, 44, 867},	// QsciLexerHTML::ASPVBScriptStart
    {65, 45, 872},	// QsciLexerHTML::ASPVBScriptString
    {65, 46, 874},	// QsciLexerHTML::ASPVBScriptUnclosedString
    {65, 47, 821},	// QsciLexerHTML::ASPXCComment
    {65, 67, 804},	// QsciLexerHTML::Attribute
    {65, 106, 818},	// QsciLexerHTML::CDATA
    {65, 160, 801},	// QsciLexerHTML::Default
    {65, 199, 811},	// QsciLexerHTML::Entity
    {65, 230, 810},	// QsciLexerHTML::HTMLComment
    {65, 231, 807},	// QsciLexerHTML::HTMLDoubleQuotedString
    {65, 232, 806},	// QsciLexerHTML::HTMLNumber
    {65, 233, 808},	// QsciLexerHTML::HTMLSingleQuotedString
    {65, 234, 820},	// QsciLexerHTML::HTMLValue
    {65, 293, 835},	// QsciLexerHTML::JavaScriptComment
    {65, 294, 837},	// QsciLexerHTML::JavaScriptCommentDoc
    {65, 295, 836},	// QsciLexerHTML::JavaScriptCommentLine
    {65, 296, 834},	// QsciLexerHTML::JavaScriptDefault
    {65, 297, 841},	// QsciLexerHTML::JavaScriptDoubleQuotedString
    {65, 298, 840},	// QsciLexerHTML::JavaScriptKeyword
    {65, 299, 838},	// QsciLexerHTML::JavaScriptNumber
    {65, 300, 845},	// QsciLexerHTML::JavaScriptRegex
    {65, 301, 842},	// QsciLexerHTML::JavaScriptSingleQuotedString
    {65, 302, 833},	// QsciLexerHTML::JavaScriptStart
    {65, 303, 843},	// QsciLexerHTML::JavaScriptSymbol
    {65, 304, 844},	// QsciLexerHTML::JavaScriptUnclosedString
    {65, 305, 839},	// QsciLexerHTML::JavaScriptWord
    {65, 384, 809},	// QsciLexerHTML::OtherInTag
    {65, 385, 907},	// QsciLexerHTML::PHPComment
    {65, 386, 908},	// QsciLexerHTML::PHPCommentLine
    {65, 387, 901},	// QsciLexerHTML::PHPDefault
    {65, 388, 902},	// QsciLexerHTML::PHPDoubleQuotedString
    {65, 389, 909},	// QsciLexerHTML::PHPDoubleQuotedVariable
    {65, 390, 904},	// QsciLexerHTML::PHPKeyword
    {65, 391, 905},	// QsciLexerHTML::PHPNumber
    {65, 392, 910},	// QsciLexerHTML::PHPOperator
    {65, 393, 903},	// QsciLexerHTML::PHPSingleQuotedString
    {65, 394, 819},	// QsciLexerHTML::PHPStart
    {65, 395, 906},	// QsciLexerHTML::PHPVariable
    {65, 441, 884},	// QsciLexerHTML::PythonClassName
    {65, 442, 877},	// QsciLexerHTML::PythonComment
    {65, 443, 876},	// QsciLexerHTML::PythonDefault
    {65, 444, 879},	// QsciLexerHTML::PythonDoubleQuotedString
    {65, 445, 885},	// QsciLexerHTML::PythonFunctionMethodName
    {65, 446, 887},	// QsciLexerHTML::PythonIdentifier
    {65, 447, 881},	// QsciLexerHTML::PythonKeyword
    {65, 448, 878},	// QsciLexerHTML::PythonNumber
    {65, 449, 886},	// QsciLexerHTML::PythonOperator
    {65, 450, 880},	// QsciLexerHTML::PythonSingleQuotedString
    {65, 451, 875},	// QsciLexerHTML::PythonStart
    {65, 452, 883},	// QsciLexerHTML::PythonTripleDoubleQuotedString
    {65, 453, 882},	// QsciLexerHTML::PythonTripleSingleQuotedString
    {65, 492, 799},	// QsciLexerHTML::QsciLexerHTML
    {65, 493, 769},	// QsciLexerHTML::QsciLexerHTML#
    {65, 621, 832},	// QsciLexerHTML::SGMLBlockDefault
    {65, 622, 823},	// QsciLexerHTML::SGMLCommand
    {65, 623, 830},	// QsciLexerHTML::SGMLComment
    {65, 624, 822},	// QsciLexerHTML::SGMLDefault
    {65, 625, 825},	// QsciLexerHTML::SGMLDoubleQuotedString
    {65, 626, 829},	// QsciLexerHTML::SGMLEntity
    {65, 627, 827},	// QsciLexerHTML::SGMLError
    {65, 628, 824},	// QsciLexerHTML::SGMLParameter
    {65, 629, 831},	// QsciLexerHTML::SGMLParameterComment
    {65, 630, 826},	// QsciLexerHTML::SGMLSingleQuotedString
    {65, 631, 828},	// QsciLexerHTML::SGMLSpecial
    {65, 634, 815},	// QsciLexerHTML::Script
    {65, 704, 802},	// QsciLexerHTML::Tag
    {65, 729, 805},	// QsciLexerHTML::UnknownAttribute
    {65, 732, 803},	// QsciLexerHTML::UnknownTag
    {65, 735, 861},	// QsciLexerHTML::VBScriptComment
    {65, 736, 860},	// QsciLexerHTML::VBScriptDefault
    {65, 737, 865},	// QsciLexerHTML::VBScriptIdentifier
    {65, 738, 863},	// QsciLexerHTML::VBScriptKeyword
    {65, 739, 862},	// QsciLexerHTML::VBScriptNumber
    {65, 740, 859},	// QsciLexerHTML::VBScriptStart
    {65, 741, 864},	// QsciLexerHTML::VBScriptString
    {65, 742, 866},	// QsciLexerHTML::VBScriptUnclosedString
    {65, 781, 814},	// QsciLexerHTML::XMLEnd
    {65, 782, 813},	// QsciLexerHTML::XMLStart
    {65, 783, 812},	// QsciLexerHTML::XMLTagEnd
    {65, 812, 772},	// QsciLexerHTML::autoCompletionFillups
    {65, 851, 781},	// QsciLexerHTML::caseSensitiveTags
    {65, 891, 774},	// QsciLexerHTML::defaultColor$
    {65, 893, 775},	// QsciLexerHTML::defaultEolFill$
    {65, 895, 776},	// QsciLexerHTML::defaultFont$
    {65, 897, 777},	// QsciLexerHTML::defaultPaper$
    {65, 901, 779},	// QsciLexerHTML::description$
    {65, 904, 783},	// QsciLexerHTML::djangoTemplates
    {65, 969, 784},	// QsciLexerHTML::foldCompact
    {65, 976, 785},	// QsciLexerHTML::foldPreprocessor
    {65, 978, 787},	// QsciLexerHTML::foldScriptComments
    {65, 979, 789},	// QsciLexerHTML::foldScriptHeredocs
    {65, 1048, 778},	// QsciLexerHTML::keywords$
    {65, 1049, 770},	// QsciLexerHTML::language
    {65, 1054, 771},	// QsciLexerHTML::lexer
    {65, 1069, 791},	// QsciLexerHTML::makoTemplates
    {65, 1105, 762},	// QsciLexerHTML::metaObject
    {65, 1147, 768},	// QsciLexerHTML::qt_metacall$$?
    {65, 1149, 763},	// QsciLexerHTML::qt_metacast$
    {65, 1154, 795},	// QsciLexerHTML::readProperties#$
    {65, 1163, 780},	// QsciLexerHTML::refreshProperties
    {65, 1249, 794},	// QsciLexerHTML::setCaseSensitiveTags$
    {65, 1268, 782},	// QsciLexerHTML::setDjangoTemplates$
    {65, 1305, 792},	// QsciLexerHTML::setFoldCompact$
    {65, 1317, 793},	// QsciLexerHTML::setFoldPreprocessor$
    {65, 1321, 786},	// QsciLexerHTML::setFoldScriptComments$
    {65, 1323, 788},	// QsciLexerHTML::setFoldScriptHeredocs$
    {65, 1396, 790},	// QsciLexerHTML::setMakoTemplates$
    {65, 1523, 800},	// QsciLexerHTML::staticMetaObject
    {65, 1547, 797},	// QsciLexerHTML::tr$
    {65, 1548, 764},	// QsciLexerHTML::tr$$
    {65, 1549, 766},	// QsciLexerHTML::tr$$$
    {65, 1551, 798},	// QsciLexerHTML::trUtf8$
    {65, 1552, 765},	// QsciLexerHTML::trUtf8$$
    {65, 1553, 767},	// QsciLexerHTML::trUtf8$$$
    {65, 1577, 773},	// QsciLexerHTML::wordCharacters
    {65, 1583, 796},	// QsciLexerHTML::writeProperties#$
    {65, 1610, 911},	// QsciLexerHTML::~QsciLexerHTML
    {66, 494, 926},	// QsciLexerIDL::QsciLexerIDL
    {66, 495, 919},	// QsciLexerIDL::QsciLexerIDL#
    {66, 891, 921},	// QsciLexerIDL::defaultColor$
    {66, 901, 923},	// QsciLexerIDL::description$
    {66, 1048, 922},	// QsciLexerIDL::keywords$
    {66, 1049, 920},	// QsciLexerIDL::language
    {66, 1105, 912},	// QsciLexerIDL::metaObject
    {66, 1147, 918},	// QsciLexerIDL::qt_metacall$$?
    {66, 1149, 913},	// QsciLexerIDL::qt_metacast$
    {66, 1523, 927},	// QsciLexerIDL::staticMetaObject
    {66, 1547, 924},	// QsciLexerIDL::tr$
    {66, 1548, 914},	// QsciLexerIDL::tr$$
    {66, 1549, 916},	// QsciLexerIDL::tr$$$
    {66, 1551, 925},	// QsciLexerIDL::trUtf8$
    {66, 1552, 915},	// QsciLexerIDL::trUtf8$$
    {66, 1553, 917},	// QsciLexerIDL::trUtf8$$$
    {66, 1611, 928},	// QsciLexerIDL::~QsciLexerIDL
    {67, 496, 941},	// QsciLexerJava::QsciLexerJava
    {67, 497, 936},	// QsciLexerJava::QsciLexerJava#
    {67, 1048, 938},	// QsciLexerJava::keywords$
    {67, 1049, 937},	// QsciLexerJava::language
    {67, 1105, 929},	// QsciLexerJava::metaObject
    {67, 1147, 935},	// QsciLexerJava::qt_metacall$$?
    {67, 1149, 930},	// QsciLexerJava::qt_metacast$
    {67, 1523, 942},	// QsciLexerJava::staticMetaObject
    {67, 1547, 939},	// QsciLexerJava::tr$
    {67, 1548, 931},	// QsciLexerJava::tr$$
    {67, 1549, 933},	// QsciLexerJava::tr$$$
    {67, 1551, 940},	// QsciLexerJava::trUtf8$
    {67, 1552, 932},	// QsciLexerJava::trUtf8$$
    {67, 1553, 934},	// QsciLexerJava::trUtf8$$$
    {67, 1612, 943},	// QsciLexerJava::~QsciLexerJava
    {68, 498, 961},	// QsciLexerJavaScript::QsciLexerJavaScript
    {68, 499, 951},	// QsciLexerJavaScript::QsciLexerJavaScript#
    {68, 891, 953},	// QsciLexerJavaScript::defaultColor$
    {68, 893, 954},	// QsciLexerJavaScript::defaultEolFill$
    {68, 895, 955},	// QsciLexerJavaScript::defaultFont$
    {68, 897, 956},	// QsciLexerJavaScript::defaultPaper$
    {68, 901, 958},	// QsciLexerJavaScript::description$
    {68, 1048, 957},	// QsciLexerJavaScript::keywords$
    {68, 1049, 952},	// QsciLexerJavaScript::language
    {68, 1105, 944},	// QsciLexerJavaScript::metaObject
    {68, 1147, 950},	// QsciLexerJavaScript::qt_metacall$$?
    {68, 1149, 945},	// QsciLexerJavaScript::qt_metacast$
    {68, 1523, 962},	// QsciLexerJavaScript::staticMetaObject
    {68, 1547, 959},	// QsciLexerJavaScript::tr$
    {68, 1548, 946},	// QsciLexerJavaScript::tr$$
    {68, 1549, 948},	// QsciLexerJavaScript::tr$$$
    {68, 1551, 960},	// QsciLexerJavaScript::trUtf8$
    {68, 1552, 947},	// QsciLexerJavaScript::trUtf8$$
    {68, 1553, 949},	// QsciLexerJavaScript::trUtf8$$$
    {68, 1613, 963},	// QsciLexerJavaScript::~QsciLexerJavaScript
    {69, 90, 1005},	// QsciLexerLua::BasicFunctions
    {69, 124, 999},	// QsciLexerLua::Character
    {69, 139, 994},	// QsciLexerLua::Comment
    {69, 151, 1007},	// QsciLexerLua::CoroutinesIOSystemFacilities
    {69, 160, 993},	// QsciLexerLua::Default
    {69, 255, 1003},	// QsciLexerLua::Identifier
    {69, 307, 997},	// QsciLexerLua::Keyword
    {69, 312, 1008},	// QsciLexerLua::KeywordSet5
    {69, 313, 1009},	// QsciLexerLua::KeywordSet6
    {69, 314, 1010},	// QsciLexerLua::KeywordSet7
    {69, 315, 1011},	// QsciLexerLua::KeywordSet8
    {69, 317, 1012},	// QsciLexerLua::Label
    {69, 331, 995},	// QsciLexerLua::LineComment
    {69, 354, 1000},	// QsciLexerLua::LiteralString
    {69, 378, 996},	// QsciLexerLua::Number
    {69, 382, 1002},	// QsciLexerLua::Operator
    {69, 436, 1001},	// QsciLexerLua::Preprocessor
    {69, 500, 990},	// QsciLexerLua::QsciLexerLua
    {69, 501, 971},	// QsciLexerLua::QsciLexerLua#
    {69, 677, 998},	// QsciLexerLua::String
    {69, 680, 1006},	// QsciLexerLua::StringTableMathsFunctions
    {69, 726, 1004},	// QsciLexerLua::UnclosedString
    {69, 821, 974},	// QsciLexerLua::autoCompletionWordSeparators
    {69, 830, 991},	// QsciLexerLua::blockStart
    {69, 831, 975},	// QsciLexerLua::blockStart$
    {69, 837, 976},	// QsciLexerLua::braceStyle
    {69, 891, 977},	// QsciLexerLua::defaultColor$
    {69, 893, 978},	// QsciLexerLua::defaultEolFill$
    {69, 895, 979},	// QsciLexerLua::defaultFont$
    {69, 897, 980},	// QsciLexerLua::defaultPaper$
    {69, 901, 982},	// QsciLexerLua::description$
    {69, 969, 984},	// QsciLexerLua::foldCompact
    {69, 1048, 981},	// QsciLexerLua::keywords$
    {69, 1049, 972},	// QsciLexerLua::language
    {69, 1054, 973},	// QsciLexerLua::lexer
    {69, 1105, 964},	// QsciLexerLua::metaObject
    {69, 1147, 970},	// QsciLexerLua::qt_metacall$$?
    {69, 1149, 965},	// QsciLexerLua::qt_metacast$
    {69, 1154, 986},	// QsciLexerLua::readProperties#$
    {69, 1163, 983},	// QsciLexerLua::refreshProperties
    {69, 1305, 985},	// QsciLexerLua::setFoldCompact$
    {69, 1523, 992},	// QsciLexerLua::staticMetaObject
    {69, 1547, 988},	// QsciLexerLua::tr$
    {69, 1548, 966},	// QsciLexerLua::tr$$
    {69, 1549, 968},	// QsciLexerLua::tr$$$
    {69, 1551, 989},	// QsciLexerLua::trUtf8$
    {69, 1552, 967},	// QsciLexerLua::trUtf8$$
    {69, 1553, 969},	// QsciLexerLua::trUtf8$$$
    {69, 1583, 987},	// QsciLexerLua::writeProperties#$
    {69, 1614, 1013},	// QsciLexerLua::~QsciLexerLua
    {70, 139, 1035},	// QsciLexerMakefile::Comment
    {70, 160, 1034},	// QsciLexerMakefile::Default
    {70, 205, 1040},	// QsciLexerMakefile::Error
    {70, 382, 1038},	// QsciLexerMakefile::Operator
    {70, 436, 1036},	// QsciLexerMakefile::Preprocessor
    {70, 502, 1032},	// QsciLexerMakefile::QsciLexerMakefile
    {70, 503, 1021},	// QsciLexerMakefile::QsciLexerMakefile#
    {70, 705, 1039},	// QsciLexerMakefile::Target
    {70, 750, 1037},	// QsciLexerMakefile::Variable
    {70, 891, 1025},	// QsciLexerMakefile::defaultColor$
    {70, 893, 1026},	// QsciLexerMakefile::defaultEolFill$
    {70, 895, 1027},	// QsciLexerMakefile::defaultFont$
    {70, 897, 1028},	// QsciLexerMakefile::defaultPaper$
    {70, 901, 1029},	// QsciLexerMakefile::description$
    {70, 1049, 1022},	// QsciLexerMakefile::language
    {70, 1054, 1023},	// QsciLexerMakefile::lexer
    {70, 1105, 1014},	// QsciLexerMakefile::metaObject
    {70, 1147, 1020},	// QsciLexerMakefile::qt_metacall$$?
    {70, 1149, 1015},	// QsciLexerMakefile::qt_metacast$
    {70, 1523, 1033},	// QsciLexerMakefile::staticMetaObject
    {70, 1547, 1030},	// QsciLexerMakefile::tr$
    {70, 1548, 1016},	// QsciLexerMakefile::tr$$
    {70, 1549, 1018},	// QsciLexerMakefile::tr$$$
    {70, 1551, 1031},	// QsciLexerMakefile::trUtf8$
    {70, 1552, 1017},	// QsciLexerMakefile::trUtf8$$
    {70, 1553, 1019},	// QsciLexerMakefile::trUtf8$$$
    {70, 1577, 1024},	// QsciLexerMakefile::wordCharacters
    {70, 1615, 1041},	// QsciLexerMakefile::~QsciLexerMakefile
    {71, 87, 1082},	// QsciLexerPOV::BadDirective
    {71, 139, 1074},	// QsciLexerPOV::Comment
    {71, 145, 1075},	// QsciLexerPOV::CommentLine
    {71, 160, 1073},	// QsciLexerPOV::Default
    {71, 175, 1081},	// QsciLexerPOV::Directive
    {71, 255, 1078},	// QsciLexerPOV::Identifier
    {71, 313, 1087},	// QsciLexerPOV::KeywordSet6
    {71, 314, 1088},	// QsciLexerPOV::KeywordSet7
    {71, 315, 1089},	// QsciLexerPOV::KeywordSet8
    {71, 378, 1076},	// QsciLexerPOV::Number
    {71, 380, 1083},	// QsciLexerPOV::ObjectsCSGAppearance
    {71, 382, 1077},	// QsciLexerPOV::Operator
    {71, 434, 1086},	// QsciLexerPOV::PredefinedFunctions
    {71, 435, 1085},	// QsciLexerPOV::PredefinedIdentifiers
    {71, 504, 1071},	// QsciLexerPOV::QsciLexerPOV
    {71, 505, 1049},	// QsciLexerPOV::QsciLexerPOV#
    {71, 677, 1079},	// QsciLexerPOV::String
    {71, 724, 1084},	// QsciLexerPOV::TypesModifiersItems
    {71, 726, 1080},	// QsciLexerPOV::UnclosedString
    {71, 837, 1052},	// QsciLexerPOV::braceStyle
    {71, 891, 1054},	// QsciLexerPOV::defaultColor$
    {71, 893, 1055},	// QsciLexerPOV::defaultEolFill$
    {71, 895, 1056},	// QsciLexerPOV::defaultFont$
    {71, 897, 1057},	// QsciLexerPOV::defaultPaper$
    {71, 901, 1059},	// QsciLexerPOV::description$
    {71, 968, 1061},	// QsciLexerPOV::foldComments
    {71, 969, 1062},	// QsciLexerPOV::foldCompact
    {71, 970, 1063},	// QsciLexerPOV::foldDirectives
    {71, 1048, 1058},	// QsciLexerPOV::keywords$
    {71, 1049, 1050},	// QsciLexerPOV::language
    {71, 1054, 1051},	// QsciLexerPOV::lexer
    {71, 1105, 1042},	// QsciLexerPOV::metaObject
    {71, 1147, 1048},	// QsciLexerPOV::qt_metacall$$?
    {71, 1149, 1043},	// QsciLexerPOV::qt_metacast$
    {71, 1154, 1067},	// QsciLexerPOV::readProperties#$
    {71, 1163, 1060},	// QsciLexerPOV::refreshProperties
    {71, 1303, 1064},	// QsciLexerPOV::setFoldComments$
    {71, 1305, 1065},	// QsciLexerPOV::setFoldCompact$
    {71, 1307, 1066},	// QsciLexerPOV::setFoldDirectives$
    {71, 1523, 1072},	// QsciLexerPOV::staticMetaObject
    {71, 1547, 1069},	// QsciLexerPOV::tr$
    {71, 1548, 1044},	// QsciLexerPOV::tr$$
    {71, 1549, 1046},	// QsciLexerPOV::tr$$$
    {71, 1551, 1070},	// QsciLexerPOV::trUtf8$
    {71, 1552, 1045},	// QsciLexerPOV::trUtf8$$
    {71, 1553, 1047},	// QsciLexerPOV::trUtf8$$$
    {71, 1577, 1053},	// QsciLexerPOV::wordCharacters
    {71, 1583, 1068},	// QsciLexerPOV::writeProperties#$
    {71, 1616, 1090},	// QsciLexerPOV::~QsciLexerPOV
    {72, 64, 1144},	// QsciLexerPascal::Asm
    {72, 124, 1142},	// QsciLexerPascal::Character
    {72, 139, 1132},	// QsciLexerPascal::Comment
    {72, 145, 1134},	// QsciLexerPascal::CommentLine
    {72, 149, 1133},	// QsciLexerPascal::CommentParenthesis
    {72, 160, 1130},	// QsciLexerPascal::Default
    {72, 240, 1138},	// QsciLexerPascal::HexNumber
    {72, 255, 1131},	// QsciLexerPascal::Identifier
    {72, 307, 1139},	// QsciLexerPascal::Keyword
    {72, 378, 1137},	// QsciLexerPascal::Number
    {72, 382, 1143},	// QsciLexerPascal::Operator
    {72, 430, 1135},	// QsciLexerPascal::PreProcessor
    {72, 433, 1136},	// QsciLexerPascal::PreProcessorParenthesis
    {72, 506, 1125},	// QsciLexerPascal::QsciLexerPascal
    {72, 507, 1098},	// QsciLexerPascal::QsciLexerPascal#
    {72, 658, 1140},	// QsciLexerPascal::SingleQuotedString
    {72, 726, 1141},	// QsciLexerPascal::UnclosedString
    {72, 821, 1101},	// QsciLexerPascal::autoCompletionWordSeparators
    {72, 827, 1126},	// QsciLexerPascal::blockEnd
    {72, 828, 1102},	// QsciLexerPascal::blockEnd$
    {72, 830, 1127},	// QsciLexerPascal::blockStart
    {72, 831, 1103},	// QsciLexerPascal::blockStart$
    {72, 832, 1128},	// QsciLexerPascal::blockStartKeyword
    {72, 833, 1104},	// QsciLexerPascal::blockStartKeyword$
    {72, 837, 1105},	// QsciLexerPascal::braceStyle
    {72, 891, 1106},	// QsciLexerPascal::defaultColor$
    {72, 893, 1107},	// QsciLexerPascal::defaultEolFill$
    {72, 895, 1108},	// QsciLexerPascal::defaultFont$
    {72, 897, 1109},	// QsciLexerPascal::defaultPaper$
    {72, 901, 1111},	// QsciLexerPascal::description$
    {72, 968, 1113},	// QsciLexerPascal::foldComments
    {72, 969, 1114},	// QsciLexerPascal::foldCompact
    {72, 976, 1115},	// QsciLexerPascal::foldPreprocessor
    {72, 1048, 1110},	// QsciLexerPascal::keywords$
    {72, 1049, 1099},	// QsciLexerPascal::language
    {72, 1054, 1100},	// QsciLexerPascal::lexer
    {72, 1105, 1091},	// QsciLexerPascal::metaObject
    {72, 1147, 1097},	// QsciLexerPascal::qt_metacall$$?
    {72, 1149, 1092},	// QsciLexerPascal::qt_metacast$
    {72, 1154, 1121},	// QsciLexerPascal::readProperties#$
    {72, 1163, 1112},	// QsciLexerPascal::refreshProperties
    {72, 1303, 1118},	// QsciLexerPascal::setFoldComments$
    {72, 1305, 1119},	// QsciLexerPascal::setFoldCompact$
    {72, 1317, 1120},	// QsciLexerPascal::setFoldPreprocessor$
    {72, 1461, 1116},	// QsciLexerPascal::setSmartHighlighting$
    {72, 1517, 1117},	// QsciLexerPascal::smartHighlighting
    {72, 1523, 1129},	// QsciLexerPascal::staticMetaObject
    {72, 1547, 1123},	// QsciLexerPascal::tr$
    {72, 1548, 1093},	// QsciLexerPascal::tr$$
    {72, 1549, 1095},	// QsciLexerPascal::tr$$$
    {72, 1551, 1124},	// QsciLexerPascal::trUtf8$
    {72, 1552, 1094},	// QsciLexerPascal::trUtf8$$
    {72, 1553, 1096},	// QsciLexerPascal::trUtf8$$$
    {72, 1583, 1122},	// QsciLexerPascal::writeProperties#$
    {72, 1617, 1145},	// QsciLexerPascal::~QsciLexerPascal
    {73, 62, 1197},	// QsciLexerPerl::Array
    {73, 83, 1207},	// QsciLexerPerl::BacktickHereDocument
    {73, 84, 1223},	// QsciLexerPerl::BacktickHereDocumentVar
    {73, 85, 1202},	// QsciLexerPerl::Backticks
    {73, 86, 1221},	// QsciLexerPerl::BackticksVar
    {73, 139, 1188},	// QsciLexerPerl::Comment
    {73, 158, 1203},	// QsciLexerPerl::DataSection
    {73, 160, 1186},	// QsciLexerPerl::Default
    {73, 184, 1206},	// QsciLexerPerl::DoubleQuotedHereDocument
    {73, 185, 1222},	// QsciLexerPerl::DoubleQuotedHereDocumentVar
    {73, 186, 1192},	// QsciLexerPerl::DoubleQuotedString
    {73, 187, 1217},	// QsciLexerPerl::DoubleQuotedStringVar
    {73, 205, 1187},	// QsciLexerPerl::Error
    {73, 217, 1216},	// QsciLexerPerl::FormatBody
    {73, 218, 1215},	// QsciLexerPerl::FormatIdentifier
    {73, 235, 1198},	// QsciLexerPerl::Hash
    {73, 239, 1204},	// QsciLexerPerl::HereDocumentDelimiter
    {73, 255, 1195},	// QsciLexerPerl::Identifier
    {73, 307, 1191},	// QsciLexerPerl::Keyword
    {73, 378, 1190},	// QsciLexerPerl::Number
    {73, 382, 1194},	// QsciLexerPerl::Operator
    {73, 396, 1189},	// QsciLexerPerl::POD
    {73, 397, 1213},	// QsciLexerPerl::PODVerbatim
    {73, 508, 1182},	// QsciLexerPerl::QsciLexerPerl
    {73, 509, 1153},	// QsciLexerPerl::QsciLexerPerl#
    {73, 552, 1208},	// QsciLexerPerl::QuotedStringQ
    {73, 553, 1209},	// QsciLexerPerl::QuotedStringQQ
    {73, 554, 1224},	// QsciLexerPerl::QuotedStringQQVar
    {73, 555, 1211},	// QsciLexerPerl::QuotedStringQR
    {73, 556, 1226},	// QsciLexerPerl::QuotedStringQRVar
    {73, 557, 1212},	// QsciLexerPerl::QuotedStringQW
    {73, 558, 1210},	// QsciLexerPerl::QuotedStringQX
    {73, 559, 1225},	// QsciLexerPerl::QuotedStringQXVar
    {73, 565, 1200},	// QsciLexerPerl::Regex
    {73, 566, 1219},	// QsciLexerPerl::RegexVar
    {73, 632, 1196},	// QsciLexerPerl::Scalar
    {73, 657, 1205},	// QsciLexerPerl::SingleQuotedHereDocument
    {73, 658, 1193},	// QsciLexerPerl::SingleQuotedString
    {73, 687, 1214},	// QsciLexerPerl::SubroutinePrototype
    {73, 688, 1201},	// QsciLexerPerl::Substitution
    {73, 690, 1220},	// QsciLexerPerl::SubstitutionVar
    {73, 696, 1199},	// QsciLexerPerl::SymbolTable
    {73, 719, 1218},	// QsciLexerPerl::Translation
    {73, 821, 1156},	// QsciLexerPerl::autoCompletionWordSeparators
    {73, 827, 1183},	// QsciLexerPerl::blockEnd
    {73, 828, 1157},	// QsciLexerPerl::blockEnd$
    {73, 830, 1184},	// QsciLexerPerl::blockStart
    {73, 831, 1158},	// QsciLexerPerl::blockStart$
    {73, 837, 1159},	// QsciLexerPerl::braceStyle
    {73, 891, 1161},	// QsciLexerPerl::defaultColor$
    {73, 893, 1162},	// QsciLexerPerl::defaultEolFill$
    {73, 895, 1163},	// QsciLexerPerl::defaultFont$
    {73, 897, 1164},	// QsciLexerPerl::defaultPaper$
    {73, 901, 1166},	// QsciLexerPerl::description$
    {73, 966, 1169},	// QsciLexerPerl::foldAtElse
    {73, 968, 1170},	// QsciLexerPerl::foldComments
    {73, 969, 1171},	// QsciLexerPerl::foldCompact
    {73, 974, 1175},	// QsciLexerPerl::foldPODBlocks
    {73, 975, 1173},	// QsciLexerPerl::foldPackages
    {73, 1048, 1165},	// QsciLexerPerl::keywords$
    {73, 1049, 1154},	// QsciLexerPerl::language
    {73, 1054, 1155},	// QsciLexerPerl::lexer
    {73, 1105, 1146},	// QsciLexerPerl::metaObject
    {73, 1147, 1152},	// QsciLexerPerl::qt_metacall$$?
    {73, 1149, 1147},	// QsciLexerPerl::qt_metacast$
    {73, 1154, 1178},	// QsciLexerPerl::readProperties#$
    {73, 1163, 1167},	// QsciLexerPerl::refreshProperties
    {73, 1299, 1168},	// QsciLexerPerl::setFoldAtElse$
    {73, 1303, 1176},	// QsciLexerPerl::setFoldComments$
    {73, 1305, 1177},	// QsciLexerPerl::setFoldCompact$
    {73, 1313, 1174},	// QsciLexerPerl::setFoldPODBlocks$
    {73, 1315, 1172},	// QsciLexerPerl::setFoldPackages$
    {73, 1523, 1185},	// QsciLexerPerl::staticMetaObject
    {73, 1547, 1180},	// QsciLexerPerl::tr$
    {73, 1548, 1148},	// QsciLexerPerl::tr$$
    {73, 1549, 1150},	// QsciLexerPerl::tr$$$
    {73, 1551, 1181},	// QsciLexerPerl::trUtf8$
    {73, 1552, 1149},	// QsciLexerPerl::trUtf8$$
    {73, 1553, 1151},	// QsciLexerPerl::trUtf8$$$
    {73, 1577, 1160},	// QsciLexerPerl::wordCharacters
    {73, 1583, 1179},	// QsciLexerPerl::writeProperties#$
    {73, 1618, 1227},	// QsciLexerPerl::~QsciLexerPerl
    {74, 63, 1268},	// QsciLexerPostScript::ArrayParenthesis
    {74, 88, 1274},	// QsciLexerPostScript::BadStringCharacter
    {74, 89, 1273},	// QsciLexerPostScript::Base85String
    {74, 139, 1260},	// QsciLexerPostScript::Comment
    {74, 155, 1261},	// QsciLexerPostScript::DSCComment
    {74, 156, 1262},	// QsciLexerPostScript::DSCCommentValue
    {74, 160, 1259},	// QsciLexerPostScript::Default
    {74, 173, 1269},	// QsciLexerPostScript::DictionaryParenthesis
    {74, 241, 1272},	// QsciLexerPostScript::HexString
    {74, 258, 1267},	// QsciLexerPostScript::ImmediateEvalLiteral
    {74, 307, 1265},	// QsciLexerPostScript::Keyword
    {74, 353, 1266},	// QsciLexerPostScript::Literal
    {74, 371, 1264},	// QsciLexerPostScript::Name
    {74, 378, 1263},	// QsciLexerPostScript::Number
    {74, 438, 1270},	// QsciLexerPostScript::ProcedureParenthesis
    {74, 510, 1257},	// QsciLexerPostScript::QsciLexerPostScript
    {74, 511, 1235},	// QsciLexerPostScript::QsciLexerPostScript#
    {74, 707, 1271},	// QsciLexerPostScript::Text
    {74, 837, 1238},	// QsciLexerPostScript::braceStyle
    {74, 891, 1239},	// QsciLexerPostScript::defaultColor$
    {74, 895, 1240},	// QsciLexerPostScript::defaultFont$
    {74, 897, 1241},	// QsciLexerPostScript::defaultPaper$
    {74, 901, 1243},	// QsciLexerPostScript::description$
    {74, 966, 1248},	// QsciLexerPostScript::foldAtElse
    {74, 969, 1247},	// QsciLexerPostScript::foldCompact
    {74, 1048, 1242},	// QsciLexerPostScript::keywords$
    {74, 1049, 1236},	// QsciLexerPostScript::language
    {74, 1053, 1246},	// QsciLexerPostScript::level
    {74, 1054, 1237},	// QsciLexerPostScript::lexer
    {74, 1105, 1228},	// QsciLexerPostScript::metaObject
    {74, 1147, 1234},	// QsciLexerPostScript::qt_metacall$$?
    {74, 1149, 1229},	// QsciLexerPostScript::qt_metacast$
    {74, 1154, 1253},	// QsciLexerPostScript::readProperties#$
    {74, 1163, 1244},	// QsciLexerPostScript::refreshProperties
    {74, 1299, 1252},	// QsciLexerPostScript::setFoldAtElse$
    {74, 1305, 1251},	// QsciLexerPostScript::setFoldCompact$
    {74, 1390, 1250},	// QsciLexerPostScript::setLevel$
    {74, 1478, 1249},	// QsciLexerPostScript::setTokenize$
    {74, 1523, 1258},	// QsciLexerPostScript::staticMetaObject
    {74, 1545, 1245},	// QsciLexerPostScript::tokenize
    {74, 1547, 1255},	// QsciLexerPostScript::tr$
    {74, 1548, 1230},	// QsciLexerPostScript::tr$$
    {74, 1549, 1232},	// QsciLexerPostScript::tr$$$
    {74, 1551, 1256},	// QsciLexerPostScript::trUtf8$
    {74, 1552, 1231},	// QsciLexerPostScript::trUtf8$$
    {74, 1553, 1233},	// QsciLexerPostScript::trUtf8$$$
    {74, 1583, 1254},	// QsciLexerPostScript::writeProperties#$
    {74, 1619, 1275},	// QsciLexerPostScript::~QsciLexerPostScript
    {75, 65, 1306},	// QsciLexerProperties::Assignment
    {75, 139, 1304},	// QsciLexerProperties::Comment
    {75, 160, 1303},	// QsciLexerProperties::Default
    {75, 161, 1307},	// QsciLexerProperties::DefaultValue
    {75, 306, 1308},	// QsciLexerProperties::Key
    {75, 512, 1301},	// QsciLexerProperties::QsciLexerProperties
    {75, 513, 1283},	// QsciLexerProperties::QsciLexerProperties#
    {75, 637, 1305},	// QsciLexerProperties::Section
    {75, 891, 1287},	// QsciLexerProperties::defaultColor$
    {75, 893, 1288},	// QsciLexerProperties::defaultEolFill$
    {75, 895, 1289},	// QsciLexerProperties::defaultFont$
    {75, 897, 1290},	// QsciLexerProperties::defaultPaper$
    {75, 901, 1291},	// QsciLexerProperties::description$
    {75, 969, 1293},	// QsciLexerProperties::foldCompact
    {75, 1022, 1295},	// QsciLexerProperties::initialSpaces
    {75, 1049, 1284},	// QsciLexerProperties::language
    {75, 1054, 1285},	// QsciLexerProperties::lexer
    {75, 1105, 1276},	// QsciLexerProperties::metaObject
    {75, 1147, 1282},	// QsciLexerProperties::qt_metacall$$?
    {75, 1149, 1277},	// QsciLexerProperties::qt_metacast$
    {75, 1154, 1297},	// QsciLexerProperties::readProperties#$
    {75, 1163, 1292},	// QsciLexerProperties::refreshProperties
    {75, 1305, 1296},	// QsciLexerProperties::setFoldCompact$
    {75, 1384, 1294},	// QsciLexerProperties::setInitialSpaces$
    {75, 1523, 1302},	// QsciLexerProperties::staticMetaObject
    {75, 1547, 1299},	// QsciLexerProperties::tr$
    {75, 1548, 1278},	// QsciLexerProperties::tr$$
    {75, 1549, 1280},	// QsciLexerProperties::tr$$$
    {75, 1551, 1300},	// QsciLexerProperties::trUtf8$
    {75, 1552, 1279},	// QsciLexerProperties::trUtf8$$
    {75, 1553, 1281},	// QsciLexerProperties::trUtf8$$$
    {75, 1577, 1286},	// QsciLexerProperties::wordCharacters
    {75, 1583, 1298},	// QsciLexerProperties::writeProperties#$
    {75, 1620, 1309},	// QsciLexerProperties::~QsciLexerProperties
    {76, 133, 1365},	// QsciLexerPython::ClassName
    {76, 139, 1358},	// QsciLexerPython::Comment
    {76, 140, 1369},	// QsciLexerPython::CommentBlock
    {76, 159, 1372},	// QsciLexerPython::Decorator
    {76, 160, 1357},	// QsciLexerPython::Default
    {76, 186, 1360},	// QsciLexerPython::DoubleQuotedString
    {76, 223, 1366},	// QsciLexerPython::FunctionMethodName
    {76, 245, 1371},	// QsciLexerPython::HighlightedIdentifier
    {76, 255, 1368},	// QsciLexerPython::Identifier
    {76, 289, 1374},	// QsciLexerPython::Inconsistent
    {76, 307, 1362},	// QsciLexerPython::Keyword
    {76, 377, 1373},	// QsciLexerPython::NoWarning
    {76, 378, 1359},	// QsciLexerPython::Number
    {76, 382, 1367},	// QsciLexerPython::Operator
    {76, 514, 1354},	// QsciLexerPython::QsciLexerPython
    {76, 515, 1317},	// QsciLexerPython::QsciLexerPython#
    {76, 658, 1361},	// QsciLexerPython::SingleQuotedString
    {76, 662, 1376},	// QsciLexerPython::Spaces
    {76, 702, 1377},	// QsciLexerPython::Tabs
    {76, 703, 1375},	// QsciLexerPython::TabsAfterSpaces
    {76, 720, 1364},	// QsciLexerPython::TripleDoubleQuotedString
    {76, 722, 1363},	// QsciLexerPython::TripleSingleQuotedString
    {76, 726, 1370},	// QsciLexerPython::UnclosedString
    {76, 821, 1320},	// QsciLexerPython::autoCompletionWordSeparators
    {76, 829, 1321},	// QsciLexerPython::blockLookback
    {76, 830, 1355},	// QsciLexerPython::blockStart
    {76, 831, 1322},	// QsciLexerPython::blockStart$
    {76, 837, 1323},	// QsciLexerPython::braceStyle
    {76, 891, 1324},	// QsciLexerPython::defaultColor$
    {76, 893, 1325},	// QsciLexerPython::defaultEolFill$
    {76, 895, 1326},	// QsciLexerPython::defaultFont$
    {76, 897, 1327},	// QsciLexerPython::defaultPaper$
    {76, 901, 1330},	// QsciLexerPython::description$
    {76, 968, 1332},	// QsciLexerPython::foldComments
    {76, 969, 1334},	// QsciLexerPython::foldCompact
    {76, 977, 1335},	// QsciLexerPython::foldQuotes
    {76, 1001, 1338},	// QsciLexerPython::highlightSubidentifiers
    {76, 1008, 1328},	// QsciLexerPython::indentationGuideView
    {76, 1010, 1336},	// QsciLexerPython::indentationWarning
    {76, 1048, 1329},	// QsciLexerPython::keywords$
    {76, 1049, 1318},	// QsciLexerPython::language
    {76, 1054, 1319},	// QsciLexerPython::lexer
    {76, 1105, 1310},	// QsciLexerPython::metaObject
    {76, 1147, 1316},	// QsciLexerPython::qt_metacall$$?
    {76, 1149, 1311},	// QsciLexerPython::qt_metacast$
    {76, 1154, 1350},	// QsciLexerPython::readProperties#$
    {76, 1163, 1331},	// QsciLexerPython::refreshProperties
    {76, 1303, 1347},	// QsciLexerPython::setFoldComments$
    {76, 1305, 1333},	// QsciLexerPython::setFoldCompact$
    {76, 1319, 1348},	// QsciLexerPython::setFoldQuotes$
    {76, 1341, 1337},	// QsciLexerPython::setHighlightSubidentifiers$
    {76, 1363, 1349},	// QsciLexerPython::setIndentationWarning$
    {76, 1463, 1339},	// QsciLexerPython::setStringsOverNewlineAllowed$
    {76, 1488, 1341},	// QsciLexerPython::setV2UnicodeAllowed$
    {76, 1490, 1343},	// QsciLexerPython::setV3BinaryOctalAllowed$
    {76, 1492, 1345},	// QsciLexerPython::setV3BytesAllowed$
    {76, 1523, 1356},	// QsciLexerPython::staticMetaObject
    {76, 1524, 1340},	// QsciLexerPython::stringsOverNewlineAllowed
    {76, 1547, 1352},	// QsciLexerPython::tr$
    {76, 1548, 1312},	// QsciLexerPython::tr$$
    {76, 1549, 1314},	// QsciLexerPython::tr$$$
    {76, 1551, 1353},	// QsciLexerPython::trUtf8$
    {76, 1552, 1313},	// QsciLexerPython::trUtf8$$
    {76, 1553, 1315},	// QsciLexerPython::trUtf8$$$
    {76, 1561, 1342},	// QsciLexerPython::v2UnicodeAllowed
    {76, 1562, 1344},	// QsciLexerPython::v3BinaryOctalAllowed
    {76, 1563, 1346},	// QsciLexerPython::v3BytesAllowed
    {76, 1583, 1351},	// QsciLexerPython::writeProperties#$
    {76, 1621, 1378},	// QsciLexerPython::~QsciLexerPython
    {77, 85, 1431},	// QsciLexerRuby::Backticks
    {77, 133, 1421},	// QsciLexerRuby::ClassName
    {77, 135, 1430},	// QsciLexerRuby::ClassVariable
    {77, 139, 1415},	// QsciLexerRuby::Comment
    {77, 158, 1432},	// QsciLexerRuby::DataSection
    {77, 160, 1413},	// QsciLexerRuby::Default
    {77, 170, 1440},	// QsciLexerRuby::DemotedKeyword
    {77, 186, 1419},	// QsciLexerRuby::DoubleQuotedString
    {77, 205, 1414},	// QsciLexerRuby::Error
    {77, 223, 1422},	// QsciLexerRuby::FunctionMethodName
    {77, 224, 1426},	// QsciLexerRuby::Global
    {77, 238, 1434},	// QsciLexerRuby::HereDocument
    {77, 239, 1433},	// QsciLexerRuby::HereDocumentDelimiter
    {77, 255, 1424},	// QsciLexerRuby::Identifier
    {77, 290, 1429},	// QsciLexerRuby::InstanceVariable
    {77, 307, 1418},	// QsciLexerRuby::Keyword
    {77, 366, 1428},	// QsciLexerRuby::ModuleName
    {77, 378, 1417},	// QsciLexerRuby::Number
    {77, 382, 1423},	// QsciLexerRuby::Operator
    {77, 396, 1416},	// QsciLexerRuby::POD
    {77, 413, 1436},	// QsciLexerRuby::PercentStringQ
    {77, 414, 1435},	// QsciLexerRuby::PercentStringq
    {77, 415, 1438},	// QsciLexerRuby::PercentStringr
    {77, 416, 1439},	// QsciLexerRuby::PercentStringw
    {77, 417, 1437},	// QsciLexerRuby::PercentStringx
    {77, 516, 1408},	// QsciLexerRuby::QsciLexerRuby
    {77, 517, 1386},	// QsciLexerRuby::QsciLexerRuby#
    {77, 565, 1425},	// QsciLexerRuby::Regex
    {77, 658, 1420},	// QsciLexerRuby::SingleQuotedString
    {77, 671, 1443},	// QsciLexerRuby::Stderr
    {77, 672, 1441},	// QsciLexerRuby::Stdin
    {77, 673, 1442},	// QsciLexerRuby::Stdout
    {77, 692, 1427},	// QsciLexerRuby::Symbol
    {77, 827, 1409},	// QsciLexerRuby::blockEnd
    {77, 828, 1389},	// QsciLexerRuby::blockEnd$
    {77, 830, 1410},	// QsciLexerRuby::blockStart
    {77, 831, 1390},	// QsciLexerRuby::blockStart$
    {77, 832, 1411},	// QsciLexerRuby::blockStartKeyword
    {77, 833, 1391},	// QsciLexerRuby::blockStartKeyword$
    {77, 837, 1392},	// QsciLexerRuby::braceStyle
    {77, 891, 1393},	// QsciLexerRuby::defaultColor$
    {77, 893, 1394},	// QsciLexerRuby::defaultEolFill$
    {77, 895, 1395},	// QsciLexerRuby::defaultFont$
    {77, 897, 1396},	// QsciLexerRuby::defaultPaper$
    {77, 901, 1398},	// QsciLexerRuby::description$
    {77, 968, 1401},	// QsciLexerRuby::foldComments
    {77, 969, 1403},	// QsciLexerRuby::foldCompact
    {77, 1048, 1397},	// QsciLexerRuby::keywords$
    {77, 1049, 1387},	// QsciLexerRuby::language
    {77, 1054, 1388},	// QsciLexerRuby::lexer
    {77, 1105, 1379},	// QsciLexerRuby::metaObject
    {77, 1147, 1385},	// QsciLexerRuby::qt_metacall$$?
    {77, 1149, 1380},	// QsciLexerRuby::qt_metacast$
    {77, 1154, 1404},	// QsciLexerRuby::readProperties#$
    {77, 1163, 1399},	// QsciLexerRuby::refreshProperties
    {77, 1303, 1400},	// QsciLexerRuby::setFoldComments$
    {77, 1305, 1402},	// QsciLexerRuby::setFoldCompact$
    {77, 1523, 1412},	// QsciLexerRuby::staticMetaObject
    {77, 1547, 1406},	// QsciLexerRuby::tr$
    {77, 1548, 1381},	// QsciLexerRuby::tr$$
    {77, 1549, 1383},	// QsciLexerRuby::tr$$$
    {77, 1551, 1407},	// QsciLexerRuby::trUtf8$
    {77, 1552, 1382},	// QsciLexerRuby::trUtf8$$
    {77, 1553, 1384},	// QsciLexerRuby::trUtf8$$$
    {77, 1583, 1405},	// QsciLexerRuby::writeProperties#$
    {77, 1622, 1444},	// QsciLexerRuby::~QsciLexerRuby
    {78, 139, 1486},	// QsciLexerSQL::Comment
    {78, 142, 1488},	// QsciLexerSQL::CommentDoc
    {78, 143, 1499},	// QsciLexerSQL::CommentDocKeyword
    {78, 144, 1500},	// QsciLexerSQL::CommentDocKeywordError
    {78, 145, 1487},	// QsciLexerSQL::CommentLine
    {78, 147, 1498},	// QsciLexerSQL::CommentLineHash
    {78, 160, 1485},	// QsciLexerSQL::Default
    {78, 186, 1491},	// QsciLexerSQL::DoubleQuotedString
    {78, 255, 1496},	// QsciLexerSQL::Identifier
    {78, 307, 1490},	// QsciLexerSQL::Keyword
    {78, 312, 1501},	// QsciLexerSQL::KeywordSet5
    {78, 313, 1502},	// QsciLexerSQL::KeywordSet6
    {78, 314, 1503},	// QsciLexerSQL::KeywordSet7
    {78, 315, 1504},	// QsciLexerSQL::KeywordSet8
    {78, 378, 1489},	// QsciLexerSQL::Number
    {78, 382, 1495},	// QsciLexerSQL::Operator
    {78, 423, 1497},	// QsciLexerSQL::PlusComment
    {78, 424, 1493},	// QsciLexerSQL::PlusKeyword
    {78, 425, 1494},	// QsciLexerSQL::PlusPrompt
    {78, 518, 1483},	// QsciLexerSQL::QsciLexerSQL
    {78, 519, 1452},	// QsciLexerSQL::QsciLexerSQL#
    {78, 548, 1505},	// QsciLexerSQL::QuotedIdentifier
    {78, 550, 1506},	// QsciLexerSQL::QuotedOperator
    {78, 658, 1492},	// QsciLexerSQL::SingleQuotedString
    {78, 824, 1463},	// QsciLexerSQL::backslashEscapes
    {78, 837, 1455},	// QsciLexerSQL::braceStyle
    {78, 891, 1456},	// QsciLexerSQL::defaultColor$
    {78, 893, 1457},	// QsciLexerSQL::defaultEolFill$
    {78, 895, 1458},	// QsciLexerSQL::defaultFont$
    {78, 897, 1459},	// QsciLexerSQL::defaultPaper$
    {78, 901, 1461},	// QsciLexerSQL::description$
    {78, 907, 1465},	// QsciLexerSQL::dottedWords
    {78, 966, 1467},	// QsciLexerSQL::foldAtElse
    {78, 968, 1468},	// QsciLexerSQL::foldComments
    {78, 969, 1469},	// QsciLexerSQL::foldCompact
    {78, 973, 1471},	// QsciLexerSQL::foldOnlyBegin
    {78, 995, 1473},	// QsciLexerSQL::hashComments
    {78, 1048, 1460},	// QsciLexerSQL::keywords$
    {78, 1049, 1453},	// QsciLexerSQL::language
    {78, 1054, 1454},	// QsciLexerSQL::lexer
    {78, 1105, 1445},	// QsciLexerSQL::metaObject
    {78, 1147, 1451},	// QsciLexerSQL::qt_metacall$$?
    {78, 1149, 1446},	// QsciLexerSQL::qt_metacast$
    {78, 1150, 1475},	// QsciLexerSQL::quotedIdentifiers
    {78, 1154, 1479},	// QsciLexerSQL::readProperties#$
    {78, 1163, 1462},	// QsciLexerSQL::refreshProperties
    {78, 1223, 1476},	// QsciLexerSQL::setBackslashEscapes$
    {78, 1274, 1464},	// QsciLexerSQL::setDottedWords$
    {78, 1299, 1466},	// QsciLexerSQL::setFoldAtElse$
    {78, 1303, 1477},	// QsciLexerSQL::setFoldComments$
    {78, 1305, 1478},	// QsciLexerSQL::setFoldCompact$
    {78, 1311, 1470},	// QsciLexerSQL::setFoldOnlyBegin$
    {78, 1333, 1472},	// QsciLexerSQL::setHashComments$
    {78, 1444, 1474},	// QsciLexerSQL::setQuotedIdentifiers$
    {78, 1523, 1484},	// QsciLexerSQL::staticMetaObject
    {78, 1547, 1481},	// QsciLexerSQL::tr$
    {78, 1548, 1447},	// QsciLexerSQL::tr$$
    {78, 1549, 1449},	// QsciLexerSQL::tr$$$
    {78, 1551, 1482},	// QsciLexerSQL::trUtf8$
    {78, 1552, 1448},	// QsciLexerSQL::trUtf8$$
    {78, 1553, 1450},	// QsciLexerSQL::trUtf8$$$
    {78, 1583, 1480},	// QsciLexerSQL::writeProperties#$
    {78, 1623, 1507},	// QsciLexerSQL::~QsciLexerSQL
    {79, 139, 1535},	// QsciLexerTCL::Comment
    {79, 140, 1555},	// QsciLexerTCL::CommentBlock
    {79, 141, 1554},	// QsciLexerTCL::CommentBox
    {79, 145, 1536},	// QsciLexerTCL::CommentLine
    {79, 160, 1534},	// QsciLexerTCL::Default
    {79, 208, 1545},	// QsciLexerTCL::ExpandKeyword
    {79, 254, 1548},	// QsciLexerTCL::ITCLKeyword
    {79, 255, 1541},	// QsciLexerTCL::Identifier
    {79, 313, 1550},	// QsciLexerTCL::KeywordSet6
    {79, 314, 1551},	// QsciLexerTCL::KeywordSet7
    {79, 315, 1552},	// QsciLexerTCL::KeywordSet8
    {79, 316, 1553},	// QsciLexerTCL::KeywordSet9
    {79, 365, 1544},	// QsciLexerTCL::Modifier
    {79, 378, 1537},	// QsciLexerTCL::Number
    {79, 382, 1540},	// QsciLexerTCL::Operator
    {79, 520, 1532},	// QsciLexerTCL::QsciLexerTCL
    {79, 521, 1515},	// QsciLexerTCL::QsciLexerTCL#
    {79, 549, 1538},	// QsciLexerTCL::QuotedKeyword
    {79, 551, 1539},	// QsciLexerTCL::QuotedString
    {79, 688, 1542},	// QsciLexerTCL::Substitution
    {79, 689, 1543},	// QsciLexerTCL::SubstitutionBrace
    {79, 698, 1546},	// QsciLexerTCL::TCLKeyword
    {79, 716, 1549},	// QsciLexerTCL::TkCommand
    {79, 717, 1547},	// QsciLexerTCL::TkKeyword
    {79, 837, 1518},	// QsciLexerTCL::braceStyle
    {79, 891, 1519},	// QsciLexerTCL::defaultColor$
    {79, 893, 1520},	// QsciLexerTCL::defaultEolFill$
    {79, 895, 1521},	// QsciLexerTCL::defaultFont$
    {79, 897, 1522},	// QsciLexerTCL::defaultPaper$
    {79, 901, 1524},	// QsciLexerTCL::description$
    {79, 968, 1527},	// QsciLexerTCL::foldComments
    {79, 1048, 1523},	// QsciLexerTCL::keywords$
    {79, 1049, 1516},	// QsciLexerTCL::language
    {79, 1054, 1517},	// QsciLexerTCL::lexer
    {79, 1105, 1508},	// QsciLexerTCL::metaObject
    {79, 1147, 1514},	// QsciLexerTCL::qt_metacall$$?
    {79, 1149, 1509},	// QsciLexerTCL::qt_metacast$
    {79, 1154, 1528},	// QsciLexerTCL::readProperties#$
    {79, 1163, 1525},	// QsciLexerTCL::refreshProperties
    {79, 1303, 1526},	// QsciLexerTCL::setFoldComments$
    {79, 1523, 1533},	// QsciLexerTCL::staticMetaObject
    {79, 1547, 1530},	// QsciLexerTCL::tr$
    {79, 1548, 1510},	// QsciLexerTCL::tr$$
    {79, 1549, 1512},	// QsciLexerTCL::tr$$$
    {79, 1551, 1531},	// QsciLexerTCL::trUtf8$
    {79, 1552, 1511},	// QsciLexerTCL::trUtf8$$
    {79, 1553, 1513},	// QsciLexerTCL::trUtf8$$$
    {79, 1583, 1529},	// QsciLexerTCL::writeProperties#$
    {79, 1624, 1556},	// QsciLexerTCL::~QsciLexerTCL
    {80, 138, 1590},	// QsciLexerTeX::Command
    {80, 160, 1586},	// QsciLexerTeX::Default
    {80, 227, 1588},	// QsciLexerTeX::Group
    {80, 522, 1584},	// QsciLexerTeX::QsciLexerTeX
    {80, 523, 1564},	// QsciLexerTeX::QsciLexerTeX#
    {80, 663, 1587},	// QsciLexerTeX::Special
    {80, 692, 1589},	// QsciLexerTeX::Symbol
    {80, 707, 1591},	// QsciLexerTeX::Text
    {80, 891, 1568},	// QsciLexerTeX::defaultColor$
    {80, 901, 1570},	// QsciLexerTeX::description$
    {80, 968, 1573},	// QsciLexerTeX::foldComments
    {80, 969, 1575},	// QsciLexerTeX::foldCompact
    {80, 1048, 1569},	// QsciLexerTeX::keywords$
    {80, 1049, 1565},	// QsciLexerTeX::language
    {80, 1054, 1566},	// QsciLexerTeX::lexer
    {80, 1105, 1557},	// QsciLexerTeX::metaObject
    {80, 1142, 1577},	// QsciLexerTeX::processComments
    {80, 1143, 1579},	// QsciLexerTeX::processIf
    {80, 1147, 1563},	// QsciLexerTeX::qt_metacall$$?
    {80, 1149, 1558},	// QsciLexerTeX::qt_metacast$
    {80, 1154, 1580},	// QsciLexerTeX::readProperties#$
    {80, 1163, 1571},	// QsciLexerTeX::refreshProperties
    {80, 1303, 1572},	// QsciLexerTeX::setFoldComments$
    {80, 1305, 1574},	// QsciLexerTeX::setFoldCompact$
    {80, 1440, 1576},	// QsciLexerTeX::setProcessComments$
    {80, 1442, 1578},	// QsciLexerTeX::setProcessIf$
    {80, 1523, 1585},	// QsciLexerTeX::staticMetaObject
    {80, 1547, 1582},	// QsciLexerTeX::tr$
    {80, 1548, 1559},	// QsciLexerTeX::tr$$
    {80, 1549, 1561},	// QsciLexerTeX::tr$$$
    {80, 1551, 1583},	// QsciLexerTeX::trUtf8$
    {80, 1552, 1560},	// QsciLexerTeX::trUtf8$$
    {80, 1553, 1562},	// QsciLexerTeX::trUtf8$$$
    {80, 1577, 1567},	// QsciLexerTeX::wordCharacters
    {80, 1583, 1581},	// QsciLexerTeX::writeProperties#$
    {80, 1625, 1592},	// QsciLexerTeX::~QsciLexerTeX
    {81, 67, 1637},	// QsciLexerVHDL::Attribute
    {81, 139, 1628},	// QsciLexerVHDL::Comment
    {81, 140, 1642},	// QsciLexerVHDL::CommentBlock
    {81, 145, 1629},	// QsciLexerVHDL::CommentLine
    {81, 160, 1627},	// QsciLexerVHDL::Default
    {81, 255, 1633},	// QsciLexerVHDL::Identifier
    {81, 307, 1635},	// QsciLexerVHDL::Keyword
    {81, 314, 1641},	// QsciLexerVHDL::KeywordSet7
    {81, 378, 1630},	// QsciLexerVHDL::Number
    {81, 382, 1632},	// QsciLexerVHDL::Operator
    {81, 524, 1625},	// QsciLexerVHDL::QsciLexerVHDL
    {81, 525, 1600},	// QsciLexerVHDL::QsciLexerVHDL#
    {81, 667, 1638},	// QsciLexerVHDL::StandardFunction
    {81, 668, 1636},	// QsciLexerVHDL::StandardOperator
    {81, 669, 1639},	// QsciLexerVHDL::StandardPackage
    {81, 670, 1640},	// QsciLexerVHDL::StandardType
    {81, 677, 1631},	// QsciLexerVHDL::String
    {81, 726, 1634},	// QsciLexerVHDL::UnclosedString
    {81, 837, 1603},	// QsciLexerVHDL::braceStyle
    {81, 891, 1604},	// QsciLexerVHDL::defaultColor$
    {81, 893, 1605},	// QsciLexerVHDL::defaultEolFill$
    {81, 895, 1606},	// QsciLexerVHDL::defaultFont$
    {81, 897, 1607},	// QsciLexerVHDL::defaultPaper$
    {81, 901, 1609},	// QsciLexerVHDL::description$
    {81, 965, 1614},	// QsciLexerVHDL::foldAtBegin
    {81, 966, 1613},	// QsciLexerVHDL::foldAtElse
    {81, 967, 1615},	// QsciLexerVHDL::foldAtParenthesis
    {81, 968, 1611},	// QsciLexerVHDL::foldComments
    {81, 969, 1612},	// QsciLexerVHDL::foldCompact
    {81, 1048, 1608},	// QsciLexerVHDL::keywords$
    {81, 1049, 1601},	// QsciLexerVHDL::language
    {81, 1054, 1602},	// QsciLexerVHDL::lexer
    {81, 1105, 1593},	// QsciLexerVHDL::metaObject
    {81, 1147, 1599},	// QsciLexerVHDL::qt_metacall$$?
    {81, 1149, 1594},	// QsciLexerVHDL::qt_metacast$
    {81, 1154, 1621},	// QsciLexerVHDL::readProperties#$
    {81, 1163, 1610},	// QsciLexerVHDL::refreshProperties
    {81, 1297, 1619},	// QsciLexerVHDL::setFoldAtBegin$
    {81, 1299, 1618},	// QsciLexerVHDL::setFoldAtElse$
    {81, 1301, 1620},	// QsciLexerVHDL::setFoldAtParenthesis$
    {81, 1303, 1616},	// QsciLexerVHDL::setFoldComments$
    {81, 1305, 1617},	// QsciLexerVHDL::setFoldCompact$
    {81, 1523, 1626},	// QsciLexerVHDL::staticMetaObject
    {81, 1547, 1623},	// QsciLexerVHDL::tr$
    {81, 1548, 1595},	// QsciLexerVHDL::tr$$
    {81, 1549, 1597},	// QsciLexerVHDL::tr$$$
    {81, 1551, 1624},	// QsciLexerVHDL::trUtf8$
    {81, 1552, 1596},	// QsciLexerVHDL::trUtf8$$
    {81, 1553, 1598},	// QsciLexerVHDL::trUtf8$$$
    {81, 1583, 1622},	// QsciLexerVHDL::writeProperties#$
    {81, 1626, 1643},	// QsciLexerVHDL::~QsciLexerVHDL
    {82, 526, 1666},	// QsciLexerXML::QsciLexerXML
    {82, 527, 1651},	// QsciLexerXML::QsciLexerXML#
    {82, 891, 1654},	// QsciLexerXML::defaultColor$
    {82, 893, 1655},	// QsciLexerXML::defaultEolFill$
    {82, 895, 1656},	// QsciLexerXML::defaultFont$
    {82, 897, 1657},	// QsciLexerXML::defaultPaper$
    {82, 1048, 1658},	// QsciLexerXML::keywords$
    {82, 1049, 1652},	// QsciLexerXML::language
    {82, 1054, 1653},	// QsciLexerXML::lexer
    {82, 1105, 1644},	// QsciLexerXML::metaObject
    {82, 1147, 1650},	// QsciLexerXML::qt_metacall$$?
    {82, 1149, 1645},	// QsciLexerXML::qt_metacast$
    {82, 1154, 1662},	// QsciLexerXML::readProperties#$
    {82, 1163, 1659},	// QsciLexerXML::refreshProperties
    {82, 1185, 1661},	// QsciLexerXML::scriptsStyled
    {82, 1450, 1660},	// QsciLexerXML::setScriptsStyled$
    {82, 1523, 1667},	// QsciLexerXML::staticMetaObject
    {82, 1547, 1664},	// QsciLexerXML::tr$
    {82, 1548, 1646},	// QsciLexerXML::tr$$
    {82, 1549, 1648},	// QsciLexerXML::tr$$$
    {82, 1551, 1665},	// QsciLexerXML::trUtf8$
    {82, 1552, 1647},	// QsciLexerXML::trUtf8$$
    {82, 1553, 1649},	// QsciLexerXML::trUtf8$$$
    {82, 1583, 1663},	// QsciLexerXML::writeProperties#$
    {82, 1627, 1668},	// QsciLexerXML::~QsciLexerXML
    {83, 139, 1695},	// QsciLexerYAML::Comment
    {83, 160, 1694},	// QsciLexerYAML::Default
    {83, 176, 1700},	// QsciLexerYAML::DocumentDelimiter
    {83, 255, 1696},	// QsciLexerYAML::Identifier
    {83, 307, 1697},	// QsciLexerYAML::Keyword
    {83, 378, 1698},	// QsciLexerYAML::Number
    {83, 382, 1703},	// QsciLexerYAML::Operator
    {83, 528, 1692},	// QsciLexerYAML::QsciLexerYAML
    {83, 529, 1676},	// QsciLexerYAML::QsciLexerYAML#
    {83, 564, 1699},	// QsciLexerYAML::Reference
    {83, 697, 1702},	// QsciLexerYAML::SyntaxErrorMarker
    {83, 708, 1701},	// QsciLexerYAML::TextBlockMarker
    {83, 891, 1679},	// QsciLexerYAML::defaultColor$
    {83, 893, 1680},	// QsciLexerYAML::defaultEolFill$
    {83, 895, 1681},	// QsciLexerYAML::defaultFont$
    {83, 897, 1682},	// QsciLexerYAML::defaultPaper$
    {83, 901, 1684},	// QsciLexerYAML::description$
    {83, 968, 1686},	// QsciLexerYAML::foldComments
    {83, 1048, 1683},	// QsciLexerYAML::keywords$
    {83, 1049, 1677},	// QsciLexerYAML::language
    {83, 1054, 1678},	// QsciLexerYAML::lexer
    {83, 1105, 1669},	// QsciLexerYAML::metaObject
    {83, 1147, 1675},	// QsciLexerYAML::qt_metacall$$?
    {83, 1149, 1670},	// QsciLexerYAML::qt_metacast$
    {83, 1154, 1688},	// QsciLexerYAML::readProperties#$
    {83, 1163, 1685},	// QsciLexerYAML::refreshProperties
    {83, 1303, 1687},	// QsciLexerYAML::setFoldComments$
    {83, 1523, 1693},	// QsciLexerYAML::staticMetaObject
    {83, 1547, 1690},	// QsciLexerYAML::tr$
    {83, 1548, 1671},	// QsciLexerYAML::tr$$
    {83, 1549, 1673},	// QsciLexerYAML::tr$$$
    {83, 1551, 1691},	// QsciLexerYAML::trUtf8$
    {83, 1552, 1672},	// QsciLexerYAML::trUtf8$$
    {83, 1553, 1674},	// QsciLexerYAML::trUtf8$$$
    {83, 1583, 1689},	// QsciLexerYAML::writeProperties#$
    {83, 1628, 1704},	// QsciLexerYAML::~QsciLexerYAML
    {84, 531, 1712},	// QsciMacro::QsciMacro#
    {84, 532, 1713},	// QsciMacro::QsciMacro$#
    {84, 856, 1714},	// QsciMacro::clear
    {84, 921, 1719},	// QsciMacro::endRecording
    {84, 1065, 1715},	// QsciMacro::load$
    {84, 1105, 1705},	// QsciMacro::metaObject
    {84, 1133, 1717},	// QsciMacro::play
    {84, 1147, 1711},	// QsciMacro::qt_metacall$$?
    {84, 1149, 1706},	// QsciMacro::qt_metacast$
    {84, 1182, 1716},	// QsciMacro::save
    {84, 1519, 1718},	// QsciMacro::startRecording
    {84, 1523, 1722},	// QsciMacro::staticMetaObject
    {84, 1547, 1720},	// QsciMacro::tr$
    {84, 1548, 1707},	// QsciMacro::tr$$
    {84, 1549, 1709},	// QsciMacro::tr$$$
    {84, 1551, 1721},	// QsciMacro::trUtf8$
    {84, 1552, 1708},	// QsciMacro::trUtf8$$
    {84, 1553, 1710},	// QsciMacro::trUtf8$$$
    {84, 1629, 1723},	// QsciMacro::~QsciMacro
    {85, 533, 1731},	// QsciPrinter::QsciPrinter
    {85, 534, 1724},	// QsciPrinter::QsciPrinter$
    {85, 987, 1725},	// QsciPrinter::formatPage#$#$
    {85, 1068, 1726},	// QsciPrinter::magnification
    {85, 1139, 1732},	// QsciPrinter::printRange#
    {85, 1140, 1733},	// QsciPrinter::printRange#$
    {85, 1141, 1728},	// QsciPrinter::printRange#$$
    {85, 1394, 1727},	// QsciPrinter::setMagnification$
    {85, 1508, 1730},	// QsciPrinter::setWrapMode$
    {85, 1579, 1729},	// QsciPrinter::wrapMode
    {85, 1630, 1734},	// QsciPrinter::~QsciPrinter
    {86, 49, 2049},	// QsciScintilla::AcsAPIs
    {86, 50, 2047},	// QsciScintilla::AcsAll
    {86, 51, 2048},	// QsciScintilla::AcsDocument
    {86, 52, 2046},	// QsciScintilla::AcsNone
    {86, 54, 2045},	// QsciScintilla::AcusAlways
    {86, 55, 2044},	// QsciScintilla::AcusExplicit
    {86, 56, 2043},	// QsciScintilla::AcusNever
    {86, 58, 2041},	// QsciScintilla::AnnotationBoxed
    {86, 59, 2039},	// QsciScintilla::AnnotationHidden
    {86, 60, 2042},	// QsciScintilla::AnnotationIndented
    {86, 61, 2040},	// QsciScintilla::AnnotationStandard
    {86, 80, 2119},	// QsciScintilla::Background
    {86, 95, 2125},	// QsciScintilla::Bookmark
    {86, 96, 2107},	// QsciScintilla::BottomLeftCorner
    {86, 98, 2077},	// QsciScintilla::BoxIndicator
    {86, 99, 2068},	// QsciScintilla::BoxedFoldStyle
    {86, 100, 2111},	// QsciScintilla::BoxedMinus
    {86, 101, 2112},	// QsciScintilla::BoxedMinusConnected
    {86, 102, 2109},	// QsciScintilla::BoxedPlus
    {86, 103, 2110},	// QsciScintilla::BoxedPlusConnected
    {86, 104, 2070},	// QsciScintilla::BoxedTreeFoldStyle
    {86, 110, 2054},	// QsciScintilla::CallTipsAboveText
    {86, 111, 2053},	// QsciScintilla::CallTipsBelowText
    {86, 112, 2058},	// QsciScintilla::CallTipsContext
    {86, 113, 2057},	// QsciScintilla::CallTipsNoAutoCompletionContext
    {86, 114, 2056},	// QsciScintilla::CallTipsNoContext
    {86, 115, 2055},	// QsciScintilla::CallTipsNone
    {86, 126, 2097},	// QsciScintilla::Circle
    {86, 127, 2067},	// QsciScintilla::CircledFoldStyle
    {86, 128, 2117},	// QsciScintilla::CircledMinus
    {86, 129, 2118},	// QsciScintilla::CircledMinusConnected
    {86, 130, 2115},	// QsciScintilla::CircledPlus
    {86, 131, 2116},	// QsciScintilla::CircledPlusConnected
    {86, 132, 2069},	// QsciScintilla::CircledTreeFoldStyle
    {86, 157, 2081},	// QsciScintilla::DashesIndicator
    {86, 172, 2074},	// QsciScintilla::DiagonalIndicator
    {86, 181, 2084},	// QsciScintilla::DotBoxIndicator
    {86, 182, 2082},	// QsciScintilla::DotsIndicator
    {86, 188, 2103},	// QsciScintilla::DownTriangle
    {86, 195, 2061},	// QsciScintilla::EdgeBackground
    {86, 196, 2060},	// QsciScintilla::EdgeLine
    {86, 197, 2059},	// QsciScintilla::EdgeNone
    {86, 202, 2064},	// QsciScintilla::EolMac
    {86, 203, 2063},	// QsciScintilla::EolUnix
    {86, 204, 2062},	// QsciScintilla::EolWindows
    {86, 220, 2080},	// QsciScintilla::FullBoxIndicator
    {86, 221, 2122},	// QsciScintilla::FullRectangle
    {86, 242, 2076},	// QsciScintilla::HiddenIndicator
    {86, 292, 2102},	// QsciScintilla::Invisible
    {86, 323, 2123},	// QsciScintilla::LeftRectangle
    {86, 324, 2114},	// QsciScintilla::LeftSideRoundedSplitter
    {86, 325, 2108},	// QsciScintilla::LeftSideSplitter
    {86, 362, 2104},	// QsciScintilla::Minus
    {86, 363, -1},	// QsciScintilla::MoNone
    {86, 364, -4},	// QsciScintilla::MoSublineSelect
    {86, 374, 2050},	// QsciScintilla::NoBraceMatch
    {86, 375, 2065},	// QsciScintilla::NoFoldStyle
    {86, 379, 2094},	// QsciScintilla::NumberMargin
    {86, 420, 2066},	// QsciScintilla::PlainFoldStyle
    {86, 421, 2071},	// QsciScintilla::PlainIndicator
    {86, 422, 2105},	// QsciScintilla::Plus
    {86, 535, 2003},	// QsciScintilla::QsciScintilla
    {86, 536, 1742},	// QsciScintilla::QsciScintilla#
    {86, 562, 2098},	// QsciScintilla::Rectangle
    {86, 567, 2101},	// QsciScintilla::RightArrow
    {86, 568, 2099},	// QsciScintilla::RightTriangle
    {86, 569, 2078},	// QsciScintilla::RoundBoxIndicator
    {86, 570, 2113},	// QsciScintilla::RoundedBottomLeftCorner
    {86, 659, 2052},	// QsciScintilla::SloppyBraceMatch
    {86, 661, 2100},	// QsciScintilla::SmallRectangle
    {86, 664, 2072},	// QsciScintilla::SquiggleIndicator
    {86, 665, 2083},	// QsciScintilla::SquiggleLowIndicator
    {86, 666, 2085},	// QsciScintilla::SquigglePixmapIndicator
    {86, 674, 2079},	// QsciScintilla::StraightBoxIndicator
    {86, 675, 2051},	// QsciScintilla::StrictBraceMatch
    {86, 676, 2075},	// QsciScintilla::StrikeIndicator
    {86, 693, 2091},	// QsciScintilla::SymbolMargin
    {86, 694, 2093},	// QsciScintilla::SymbolMarginDefaultBackgroundColor
    {86, 695, 2092},	// QsciScintilla::SymbolMarginDefaultForegroundColor
    {86, 699, 2073},	// QsciScintilla::TTIndicator
    {86, 709, 2088},	// QsciScintilla::TextColorIndicator
    {86, 710, 2095},	// QsciScintilla::TextMargin
    {86, 711, 2096},	// QsciScintilla::TextMarginRightJustified
    {86, 712, 2086},	// QsciScintilla::ThickCompositionIndicator
    {86, 713, 2087},	// QsciScintilla::ThinCompositionIndicator
    {86, 714, 2120},	// QsciScintilla::ThreeDots
    {86, 715, 2121},	// QsciScintilla::ThreeRightArrows
    {86, 727, 2124},	// QsciScintilla::Underline
    {86, 753, 2106},	// QsciScintilla::VerticalLine
    {86, 767, 2131},	// QsciScintilla::WrapCharacter
    {86, 768, 2135},	// QsciScintilla::WrapFlagByBorder
    {86, 769, 2134},	// QsciScintilla::WrapFlagByText
    {86, 770, 2136},	// QsciScintilla::WrapFlagInMargin
    {86, 771, 2133},	// QsciScintilla::WrapFlagNone
    {86, 772, 2137},	// QsciScintilla::WrapIndentFixed
    {86, 773, 2139},	// QsciScintilla::WrapIndentIndented
    {86, 774, 2138},	// QsciScintilla::WrapIndentSame
    {86, 775, 2129},	// QsciScintilla::WrapNone
    {86, 776, 2132},	// QsciScintilla::WrapWhitespace
    {86, 777, 2130},	// QsciScintilla::WrapWord
    {86, 778, 2126},	// QsciScintilla::WsInvisible
    {86, 779, 2127},	// QsciScintilla::WsVisible
    {86, 780, 2128},	// QsciScintilla::WsVisibleAfterIndent
    {86, 791, 1746},	// QsciScintilla::annotate$#
    {86, 792, 1745},	// QsciScintilla::annotate$$#
    {86, 793, 1744},	// QsciScintilla::annotate$$$
    {86, 794, 1747},	// QsciScintilla::annotate$?
    {86, 796, 1748},	// QsciScintilla::annotation$
    {86, 797, 1749},	// QsciScintilla::annotationDisplay
    {86, 799, 1743},	// QsciScintilla::apiContext$$$
    {86, 805, 1911},	// QsciScintilla::append$
    {86, 808, 1913},	// QsciScintilla::autoCompleteFromAPIs
    {86, 809, 1912},	// QsciScintilla::autoCompleteFromAll
    {86, 810, 1914},	// QsciScintilla::autoCompleteFromDocument
    {86, 811, 1751},	// QsciScintilla::autoCompletionCaseSensitivity
    {86, 813, 1752},	// QsciScintilla::autoCompletionFillupsEnabled
    {86, 814, 1753},	// QsciScintilla::autoCompletionReplaceWord
    {86, 817, 1754},	// QsciScintilla::autoCompletionShowSingle
    {86, 818, 1755},	// QsciScintilla::autoCompletionSource
    {86, 819, 1756},	// QsciScintilla::autoCompletionThreshold
    {86, 820, 1757},	// QsciScintilla::autoCompletionUseSingle
    {86, 822, 1758},	// QsciScintilla::autoIndent
    {86, 825, 1759},	// QsciScintilla::backspaceUnindents
    {86, 826, 1760},	// QsciScintilla::beginUndoAction
    {86, 836, 1761},	// QsciScintilla::braceMatching
    {86, 840, 1915},	// QsciScintilla::callTip
    {86, 843, 1762},	// QsciScintilla::callTipsPosition
    {86, 844, 1763},	// QsciScintilla::callTipsStyle
    {86, 845, 1764},	// QsciScintilla::callTipsVisible
    {86, 848, 1765},	// QsciScintilla::cancelList
    {86, 850, 1766},	// QsciScintilla::caseSensitive
    {86, 853, 1999},	// QsciScintilla::changeEvent#
    {86, 856, 1916},	// QsciScintilla::clear
    {86, 858, 2004},	// QsciScintilla::clearAnnotations
    {86, 859, 1750},	// QsciScintilla::clearAnnotations$
    {86, 860, 1767},	// QsciScintilla::clearFolds
    {86, 862, 1768},	// QsciScintilla::clearIndicatorRange$$$$$
    {86, 864, 2027},	// QsciScintilla::clearMarginText
    {86, 865, 1870},	// QsciScintilla::clearMarginText$
    {86, 866, 1769},	// QsciScintilla::clearRegisteredImages
    {86, 868, 1770},	// QsciScintilla::color
    {86, 878, 2000},	// QsciScintilla::contextMenuEvent#
    {86, 879, 1771},	// QsciScintilla::contractedFolds
    {86, 881, 1772},	// QsciScintilla::convertEols$
    {86, 882, 1917},	// QsciScintilla::copy
    {86, 884, 1988},	// QsciScintilla::copyAvailable$
    {86, 885, 1773},	// QsciScintilla::createStandardContextMenu
    {86, 887, 1987},	// QsciScintilla::cursorPositionChanged$$
    {86, 889, 1918},	// QsciScintilla::cut
    {86, 905, 1774},	// QsciScintilla::document
    {86, 916, 1776},	// QsciScintilla::edgeColor
    {86, 917, 1777},	// QsciScintilla::edgeColumn
    {86, 918, 1778},	// QsciScintilla::edgeMode
    {86, 922, 1775},	// QsciScintilla::endUndoAction
    {86, 923, 1919},	// QsciScintilla::ensureCursorVisible
    {86, 925, 1920},	// QsciScintilla::ensureLineVisible$
    {86, 931, 1780},	// QsciScintilla::eolMode
    {86, 932, 1781},	// QsciScintilla::eolVisibility
    {86, 934, 1998},	// QsciScintilla::event#
    {86, 937, 1782},	// QsciScintilla::extraAscent
    {86, 938, 1783},	// QsciScintilla::extraDescent
    {86, 940, 1784},	// QsciScintilla::fillIndicatorRange$$$$$
    {86, 944, 2005},	// QsciScintilla::findFirst$$$$$
    {86, 945, 2006},	// QsciScintilla::findFirst$$$$$$
    {86, 946, 2007},	// QsciScintilla::findFirst$$$$$$$
    {86, 947, 2008},	// QsciScintilla::findFirst$$$$$$$$
    {86, 948, 2009},	// QsciScintilla::findFirst$$$$$$$$$
    {86, 949, 1785},	// QsciScintilla::findFirst$$$$$$$$$$
    {86, 951, 2010},	// QsciScintilla::findFirstInSelection$$$$
    {86, 952, 2011},	// QsciScintilla::findFirstInSelection$$$$$
    {86, 953, 2012},	// QsciScintilla::findFirstInSelection$$$$$$
    {86, 954, 1786},	// QsciScintilla::findFirstInSelection$$$$$$$
    {86, 955, 1787},	// QsciScintilla::findNext
    {86, 956, 1788},	// QsciScintilla::firstVisibleLine
    {86, 963, 2032},	// QsciScintilla::foldAll
    {86, 964, 1921},	// QsciScintilla::foldAll$
    {86, 972, 1922},	// QsciScintilla::foldLine$
    {86, 980, 1789},	// QsciScintilla::folding
    {86, 991, 1790},	// QsciScintilla::getCursorPosition$$
    {86, 993, 1791},	// QsciScintilla::getSelection$$$$
    {86, 994, 1792},	// QsciScintilla::hasSelectedText
    {86, 1005, 1923},	// QsciScintilla::indent$
    {86, 1007, 1793},	// QsciScintilla::indentation$
    {86, 1009, 1794},	// QsciScintilla::indentationGuides
    {86, 1011, 1796},	// QsciScintilla::indentationWidth
    {86, 1012, 1795},	// QsciScintilla::indentationsUseTabs
    {86, 1014, 1989},	// QsciScintilla::indicatorClicked$$$
    {86, 1016, 2013},	// QsciScintilla::indicatorDefine$
    {86, 1017, 1797},	// QsciScintilla::indicatorDefine$$
    {86, 1019, 1798},	// QsciScintilla::indicatorDrawUnder$
    {86, 1021, 1990},	// QsciScintilla::indicatorReleased$$$
    {86, 1028, 1924},	// QsciScintilla::insert$
    {86, 1030, 1925},	// QsciScintilla::insertAt$$$
    {86, 1032, 1799},	// QsciScintilla::isCallTipActive
    {86, 1033, 1800},	// QsciScintilla::isListActive
    {86, 1034, 1801},	// QsciScintilla::isModified
    {86, 1037, 1802},	// QsciScintilla::isReadOnly
    {86, 1038, 1803},	// QsciScintilla::isRedoAvailable
    {86, 1039, 1804},	// QsciScintilla::isUndoAvailable
    {86, 1040, 1805},	// QsciScintilla::isUtf8
    {86, 1042, 1806},	// QsciScintilla::isWordCharacter$
    {86, 1052, 1811},	// QsciScintilla::length
    {86, 1054, 1812},	// QsciScintilla::lexer
    {86, 1057, 1807},	// QsciScintilla::lineAt#
    {86, 1059, 1808},	// QsciScintilla::lineIndexFromPosition$$$
    {86, 1061, 1809},	// QsciScintilla::lineLength$
    {86, 1062, 1810},	// QsciScintilla::lines
    {86, 1063, 1991},	// QsciScintilla::linesChanged
    {86, 1071, 1992},	// QsciScintilla::marginClicked$$$
    {86, 1073, 1813},	// QsciScintilla::marginLineNumbers$
    {86, 1075, 1814},	// QsciScintilla::marginMarkerMask$
    {86, 1076, 1815},	// QsciScintilla::marginOptions
    {86, 1078, 1816},	// QsciScintilla::marginSensitivity$
    {86, 1080, 1817},	// QsciScintilla::marginType$
    {86, 1082, 1818},	// QsciScintilla::marginWidth$
    {86, 1084, 1823},	// QsciScintilla::markerAdd$$
    {86, 1086, -7},	// QsciScintilla::markerDefine#
    {86, 1087, -10},	// QsciScintilla::markerDefine#$
    {86, 1088, -13},	// QsciScintilla::markerDefine$
    {86, 1089, -16},	// QsciScintilla::markerDefine$$
    {86, 1091, 2018},	// QsciScintilla::markerDelete$
    {86, 1092, 1825},	// QsciScintilla::markerDelete$$
    {86, 1093, 2019},	// QsciScintilla::markerDeleteAll
    {86, 1094, 1826},	// QsciScintilla::markerDeleteAll$
    {86, 1096, 1827},	// QsciScintilla::markerDeleteHandle$
    {86, 1098, 1829},	// QsciScintilla::markerFindNext$$
    {86, 1100, 1830},	// QsciScintilla::markerFindPrevious$$
    {86, 1102, 1828},	// QsciScintilla::markerLine$
    {86, 1104, 1824},	// QsciScintilla::markersAtLine$
    {86, 1105, 1735},	// QsciScintilla::metaObject
    {86, 1108, 1993},	// QsciScintilla::modificationAttempted
    {86, 1110, 1994},	// QsciScintilla::modificationChanged$
    {86, 1120, 1926},	// QsciScintilla::moveToMatchingBrace
    {86, 1123, 1831},	// QsciScintilla::overwriteMode
    {86, 1128, 1832},	// QsciScintilla::paper
    {86, 1132, 1927},	// QsciScintilla::paste
    {86, 1136, 1833},	// QsciScintilla::positionFromLineIndex$$
    {86, 1147, 1741},	// QsciScintilla::qt_metacall$$?
    {86, 1149, 1736},	// QsciScintilla::qt_metacast$
    {86, 1152, 1834},	// QsciScintilla::read#
    {86, 1158, 2020},	// QsciScintilla::recolor
    {86, 1159, 2021},	// QsciScintilla::recolor$
    {86, 1160, 1835},	// QsciScintilla::recolor$$
    {86, 1161, 1928},	// QsciScintilla::redo
    {86, 1165, -19},	// QsciScintilla::registerImage$#
    {86, 1168, 1929},	// QsciScintilla::removeSelectedText
    {86, 1170, 1838},	// QsciScintilla::replace$
    {86, 1172, 1930},	// QsciScintilla::replaceSelectedText$
    {86, 1173, 1839},	// QsciScintilla::resetFoldMarginColors
    {86, 1174, 1840},	// QsciScintilla::resetHotspotBackgroundColor
    {86, 1175, 1841},	// QsciScintilla::resetHotspotForegroundColor
    {86, 1176, 1876},	// QsciScintilla::resetMatchedBraceIndicator
    {86, 1177, 1931},	// QsciScintilla::resetSelectionBackgroundColor
    {86, 1178, 1932},	// QsciScintilla::resetSelectionForegroundColor
    {86, 1179, 1880},	// QsciScintilla::resetUnmatchedBraceIndicator
    {86, 1188, 2033},	// QsciScintilla::selectAll
    {86, 1189, 1933},	// QsciScintilla::selectAll$
    {86, 1190, 1934},	// QsciScintilla::selectToMatchingBrace
    {86, 1191, 1882},	// QsciScintilla::selectedText
    {86, 1192, 1995},	// QsciScintilla::selectionChanged
    {86, 1193, 1883},	// QsciScintilla::selectionToEol
    {86, 1199, 1843},	// QsciScintilla::setAnnotationDisplay$
    {86, 1201, 1935},	// QsciScintilla::setAutoCompletionCaseSensitivity$
    {86, 1203, 1845},	// QsciScintilla::setAutoCompletionFillups$
    {86, 1205, 1844},	// QsciScintilla::setAutoCompletionFillupsEnabled$
    {86, 1207, 1936},	// QsciScintilla::setAutoCompletionReplaceWord$
    {86, 1209, 1937},	// QsciScintilla::setAutoCompletionShowSingle$
    {86, 1211, 1938},	// QsciScintilla::setAutoCompletionSource$
    {86, 1213, 1939},	// QsciScintilla::setAutoCompletionThreshold$
    {86, 1215, 1940},	// QsciScintilla::setAutoCompletionUseSingle$
    {86, 1217, 1846},	// QsciScintilla::setAutoCompletionWordSeparators?
    {86, 1219, 1941},	// QsciScintilla::setAutoIndent$
    {86, 1225, 1943},	// QsciScintilla::setBackspaceUnindents$
    {86, 1227, 1942},	// QsciScintilla::setBraceMatching$
    {86, 1229, 1847},	// QsciScintilla::setCallTipsBackgroundColor#
    {86, 1231, 1848},	// QsciScintilla::setCallTipsForegroundColor#
    {86, 1233, 1849},	// QsciScintilla::setCallTipsHighlightColor#
    {86, 1235, 1850},	// QsciScintilla::setCallTipsPosition$
    {86, 1237, 1851},	// QsciScintilla::setCallTipsStyle$
    {86, 1239, 1852},	// QsciScintilla::setCallTipsVisible$
    {86, 1241, 1944},	// QsciScintilla::setCaretForegroundColor#
    {86, 1243, 1945},	// QsciScintilla::setCaretLineBackgroundColor#
    {86, 1245, 1946},	// QsciScintilla::setCaretLineVisible$
    {86, 1247, 1947},	// QsciScintilla::setCaretWidth$
    {86, 1253, 1948},	// QsciScintilla::setColor#
    {86, 1256, 1853},	// QsciScintilla::setContractedFolds?
    {86, 1258, 1949},	// QsciScintilla::setCursorPosition$$
    {86, 1270, 1854},	// QsciScintilla::setDocument#
    {86, 1276, 1855},	// QsciScintilla::setEdgeColor#
    {86, 1278, 1856},	// QsciScintilla::setEdgeColumn$
    {86, 1280, 1857},	// QsciScintilla::setEdgeMode$
    {86, 1287, 1950},	// QsciScintilla::setEolMode$
    {86, 1289, 1951},	// QsciScintilla::setEolVisibility$
    {86, 1291, 1889},	// QsciScintilla::setExtraAscent$
    {86, 1293, 1890},	// QsciScintilla::setExtraDescent$
    {86, 1295, 1858},	// QsciScintilla::setFirstVisibleLine$
    {86, 1309, 1842},	// QsciScintilla::setFoldMarginColors##
    {86, 1325, 2034},	// QsciScintilla::setFolding$
    {86, 1326, 1952},	// QsciScintilla::setFolding$$
    {86, 1328, 1779},	// QsciScintilla::setFont#
    {86, 1347, 1884},	// QsciScintilla::setHotspotBackgroundColor#
    {86, 1349, 1885},	// QsciScintilla::setHotspotForegroundColor#
    {86, 1351, 1886},	// QsciScintilla::setHotspotUnderline$
    {86, 1353, 1887},	// QsciScintilla::setHotspotWrap$
    {86, 1355, 1953},	// QsciScintilla::setIndentation$$
    {86, 1357, 1954},	// QsciScintilla::setIndentationGuides$
    {86, 1359, 1955},	// QsciScintilla::setIndentationGuidesBackgroundColor#
    {86, 1361, 1956},	// QsciScintilla::setIndentationGuidesForegroundColor#
    {86, 1365, 1958},	// QsciScintilla::setIndentationWidth$
    {86, 1367, 1957},	// QsciScintilla::setIndentationsUseTabs$
    {86, 1369, 2022},	// QsciScintilla::setIndicatorDrawUnder$
    {86, 1370, 1859},	// QsciScintilla::setIndicatorDrawUnder$$
    {86, 1372, 2023},	// QsciScintilla::setIndicatorForegroundColor#
    {86, 1373, 1860},	// QsciScintilla::setIndicatorForegroundColor#$
    {86, 1375, 2024},	// QsciScintilla::setIndicatorHoverForegroundColor#
    {86, 1376, 1861},	// QsciScintilla::setIndicatorHoverForegroundColor#$
    {86, 1378, 2025},	// QsciScintilla::setIndicatorHoverStyle$
    {86, 1379, 1862},	// QsciScintilla::setIndicatorHoverStyle$$
    {86, 1381, 2026},	// QsciScintilla::setIndicatorOutlineColor#
    {86, 1382, 1863},	// QsciScintilla::setIndicatorOutlineColor#$
    {86, 1391, 2035},	// QsciScintilla::setLexer
    {86, 1392, 1959},	// QsciScintilla::setLexer#
    {86, 1398, 1963},	// QsciScintilla::setMarginLineNumbers$$
    {86, 1400, 1964},	// QsciScintilla::setMarginMarkerMask$$
    {86, 1402, 1864},	// QsciScintilla::setMarginOptions$
    {86, 1404, 1965},	// QsciScintilla::setMarginSensitivity$$
    {86, 1406, 1867},	// QsciScintilla::setMarginText$#
    {86, 1407, 1866},	// QsciScintilla::setMarginText$$#
    {86, 1408, 1865},	// QsciScintilla::setMarginText$$$
    {86, 1409, 1868},	// QsciScintilla::setMarginText$?
    {86, 1411, 1869},	// QsciScintilla::setMarginType$$
    {86, 1413, -22},	// QsciScintilla::setMarginWidth$$
    {86, 1415, 1960},	// QsciScintilla::setMarginsBackgroundColor#
    {86, 1417, 1961},	// QsciScintilla::setMarginsFont#
    {86, 1419, 1962},	// QsciScintilla::setMarginsForegroundColor#
    {86, 1421, 2028},	// QsciScintilla::setMarkerBackgroundColor#
    {86, 1422, 1871},	// QsciScintilla::setMarkerBackgroundColor#$
    {86, 1424, 2029},	// QsciScintilla::setMarkerForegroundColor#
    {86, 1425, 1872},	// QsciScintilla::setMarkerForegroundColor#$
    {86, 1427, 1873},	// QsciScintilla::setMatchedBraceBackgroundColor#
    {86, 1429, 1874},	// QsciScintilla::setMatchedBraceForegroundColor#
    {86, 1431, 1875},	// QsciScintilla::setMatchedBraceIndicator$
    {86, 1433, 1968},	// QsciScintilla::setModified$
    {86, 1435, 1891},	// QsciScintilla::setOverwriteMode$
    {86, 1437, 1969},	// QsciScintilla::setPaper#
    {86, 1446, 1970},	// QsciScintilla::setReadOnly$
    {86, 1453, 1971},	// QsciScintilla::setSelection$$$$
    {86, 1455, 1972},	// QsciScintilla::setSelectionBackgroundColor#
    {86, 1457, 1973},	// QsciScintilla::setSelectionForegroundColor#
    {86, 1459, 1888},	// QsciScintilla::setSelectionToEol$
    {86, 1470, 1974},	// QsciScintilla::setTabIndents$
    {86, 1472, 1975},	// QsciScintilla::setTabWidth$
    {86, 1474, 1976},	// QsciScintilla::setText$
    {86, 1480, 1877},	// QsciScintilla::setUnmatchedBraceBackgroundColor#
    {86, 1482, 1878},	// QsciScintilla::setUnmatchedBraceForegroundColor#
    {86, 1484, 1879},	// QsciScintilla::setUnmatchedBraceIndicator$
    {86, 1486, 1977},	// QsciScintilla::setUtf8$
    {86, 1498, 1892},	// QsciScintilla::setWhitespaceBackgroundColor#
    {86, 1500, 1893},	// QsciScintilla::setWhitespaceForegroundColor#
    {86, 1502, 1894},	// QsciScintilla::setWhitespaceSize$
    {86, 1504, 1978},	// QsciScintilla::setWhitespaceVisibility$
    {86, 1506, 1895},	// QsciScintilla::setWrapIndentMode$
    {86, 1508, 1979},	// QsciScintilla::setWrapMode$
    {86, 1510, 2030},	// QsciScintilla::setWrapVisualFlags$
    {86, 1511, 2031},	// QsciScintilla::setWrapVisualFlags$$
    {86, 1512, 1881},	// QsciScintilla::setWrapVisualFlags$$$
    {86, 1515, 1896},	// QsciScintilla::showUserList$?
    {86, 1518, 1897},	// QsciScintilla::standardCommands
    {86, 1523, 2036},	// QsciScintilla::staticMetaObject
    {86, 1531, 1898},	// QsciScintilla::tabIndents
    {86, 1532, 1899},	// QsciScintilla::tabWidth
    {86, 1534, 1900},	// QsciScintilla::text
    {86, 1535, 1901},	// QsciScintilla::text$
    {86, 1539, 1996},	// QsciScintilla::textChanged
    {86, 1541, 1902},	// QsciScintilla::textHeight$
    {86, 1547, 2001},	// QsciScintilla::tr$
    {86, 1548, 1737},	// QsciScintilla::tr$$
    {86, 1549, 1739},	// QsciScintilla::tr$$$
    {86, 1551, 2002},	// QsciScintilla::trUtf8$
    {86, 1552, 1738},	// QsciScintilla::trUtf8$$
    {86, 1553, 1740},	// QsciScintilla::trUtf8$$$
    {86, 1554, 1980},	// QsciScintilla::undo
    {86, 1556, 1981},	// QsciScintilla::unindent$
    {86, 1560, 1997},	// QsciScintilla::userListActivated$$
    {86, 1570, 1903},	// QsciScintilla::whitespaceSize
    {86, 1571, 1904},	// QsciScintilla::whitespaceVisibility
    {86, 1574, 1905},	// QsciScintilla::wordAtLineIndex$$
    {86, 1576, 1906},	// QsciScintilla::wordAtPoint#
    {86, 1577, 1907},	// QsciScintilla::wordCharacters
    {86, 1578, 1909},	// QsciScintilla::wrapIndentMode
    {86, 1579, 1908},	// QsciScintilla::wrapMode
    {86, 1581, 1910},	// QsciScintilla::write#
    {86, 1588, 1983},	// QsciScintilla::zoomIn
    {86, 1589, 1982},	// QsciScintilla::zoomIn$
    {86, 1590, 1985},	// QsciScintilla::zoomOut
    {86, 1591, 1984},	// QsciScintilla::zoomOut$
    {86, 1593, 1986},	// QsciScintilla::zoomTo$
    {86, 1631, 2140},	// QsciScintilla::~QsciScintilla
    {87, 455, 2165},	// QsciScintillaBase::QSCN_SELCHANGED$
    {87, 537, 2220},	// QsciScintillaBase::QsciScintillaBase
    {87, 538, 2148},	// QsciScintillaBase::QsciScintillaBase#
    {87, 571, 2169},	// QsciScintillaBase::SCEN_CHANGE
    {87, 572, 2166},	// QsciScintillaBase::SCN_AUTOCCANCELLED
    {87, 573, 2167},	// QsciScintillaBase::SCN_AUTOCCHARDELETED
    {87, 575, 2168},	// QsciScintillaBase::SCN_AUTOCSELECTION$$
    {87, 577, 2170},	// QsciScintillaBase::SCN_CALLTIPCLICK$
    {87, 579, 2171},	// QsciScintillaBase::SCN_CHARADDED$
    {87, 581, 2172},	// QsciScintillaBase::SCN_DOUBLECLICK$$$
    {87, 583, 2173},	// QsciScintillaBase::SCN_DWELLEND$$$
    {87, 585, 2174},	// QsciScintillaBase::SCN_DWELLSTART$$$
    {87, 586, 2175},	// QsciScintillaBase::SCN_FOCUSIN
    {87, 587, 2176},	// QsciScintillaBase::SCN_FOCUSOUT
    {87, 589, 2177},	// QsciScintillaBase::SCN_HOTSPOTCLICK$$
    {87, 591, 2178},	// QsciScintillaBase::SCN_HOTSPOTDOUBLECLICK$$
    {87, 593, 2179},	// QsciScintillaBase::SCN_HOTSPOTRELEASECLICK$$
    {87, 595, 2180},	// QsciScintillaBase::SCN_INDICATORCLICK$$
    {87, 597, 2181},	// QsciScintillaBase::SCN_INDICATORRELEASE$$
    {87, 599, 2182},	// QsciScintillaBase::SCN_MACRORECORD$$$
    {87, 601, 2183},	// QsciScintillaBase::SCN_MARGINCLICK$$$
    {87, 603, 2184},	// QsciScintillaBase::SCN_MODIFIED$$$$$$$$$$
    {87, 604, 2185},	// QsciScintillaBase::SCN_MODIFYATTEMPTRO
    {87, 606, 2186},	// QsciScintillaBase::SCN_NEEDSHOWN$$
    {87, 607, 2187},	// QsciScintillaBase::SCN_PAINTED
    {87, 608, 2188},	// QsciScintillaBase::SCN_SAVEPOINTLEFT
    {87, 609, 2189},	// QsciScintillaBase::SCN_SAVEPOINTREACHED
    {87, 611, 2190},	// QsciScintillaBase::SCN_STYLENEEDED$
    {87, 613, 2191},	// QsciScintillaBase::SCN_UPDATEUI$
    {87, 615, 2192},	// QsciScintillaBase::SCN_USERLISTSELECTION$$
    {87, 616, 2193},	// QsciScintillaBase::SCN_ZOOM
    {87, 618, -25},	// QsciScintillaBase::SC_ORDER_CUSTOM
    {87, 619, -80},	// QsciScintillaBase::SC_ORDER_PERFORMSORT
    {87, 620, -135},	// QsciScintillaBase::SC_ORDER_PRESORTED
    {87, 646, 2221},	// QsciScintillaBase::SendScintilla$
    {87, 647, 2159},	// QsciScintillaBase::SendScintilla$#
    {87, 648, -190},	// QsciScintillaBase::SendScintilla$$
    {87, 649, -195},	// QsciScintillaBase::SendScintilla$$#
    {87, 650, 2160},	// QsciScintillaBase::SendScintilla$$##$$
    {87, 651, -199},	// QsciScintillaBase::SendScintilla$$$
    {87, 652, 2157},	// QsciScintillaBase::SendScintilla$$$$
    {87, 654, 2163},	// QsciScintillaBase::SendScintillaPtrResult$
    {87, 839, 2217},	// QsciScintillaBase::bytesAsText$
    {87, 847, 2194},	// QsciScintillaBase::canInsertFromMimeData#
    {87, 874, 2164},	// QsciScintillaBase::commandKey$$
    {87, 878, 2197},	// QsciScintillaBase::contextMenuEvent#
    {87, 909, 2198},	// QsciScintillaBase::dragEnterEvent#
    {87, 911, 2199},	// QsciScintillaBase::dragLeaveEvent#
    {87, 913, 2200},	// QsciScintillaBase::dragMoveEvent#
    {87, 915, 2201},	// QsciScintillaBase::dropEvent#
    {87, 958, 2202},	// QsciScintillaBase::focusInEvent#
    {87, 960, 2204},	// QsciScintillaBase::focusNextPrevChild$
    {87, 962, 2203},	// QsciScintillaBase::focusOutEvent#
    {87, 989, 2195},	// QsciScintillaBase::fromMimeData#$
    {87, 1024, 2206},	// QsciScintillaBase::inputMethodEvent#
    {87, 1026, 2207},	// QsciScintillaBase::inputMethodQuery$
    {87, 1045, 2205},	// QsciScintillaBase::keyPressEvent#
    {87, 1105, 2141},	// QsciScintillaBase::metaObject
    {87, 1112, 2208},	// QsciScintillaBase::mouseDoubleClickEvent#
    {87, 1114, 2209},	// QsciScintillaBase::mouseMoveEvent#
    {87, 1116, 2210},	// QsciScintillaBase::mousePressEvent#
    {87, 1118, 2211},	// QsciScintillaBase::mouseReleaseEvent#
    {87, 1126, 2212},	// QsciScintillaBase::paintEvent#
    {87, 1134, 2149},	// QsciScintillaBase::pool
    {87, 1147, 2147},	// QsciScintillaBase::qt_metacall$$?
    {87, 1149, 2142},	// QsciScintillaBase::qt_metacast$
    {87, 1181, 2213},	// QsciScintillaBase::resizeEvent#
    {87, 1187, 2214},	// QsciScintillaBase::scrollContentsBy$$
    {87, 1451, 2215},	// QsciScintillaBase::setScrollBars
    {87, 1523, 2223},	// QsciScintillaBase::staticMetaObject
    {87, 1537, 2216},	// QsciScintillaBase::textAsBytes$
    {87, 1544, 2196},	// QsciScintillaBase::toMimeData#$
    {87, 1547, 2218},	// QsciScintillaBase::tr$
    {87, 1548, 2143},	// QsciScintillaBase::tr$$
    {87, 1549, 2145},	// QsciScintillaBase::tr$$$
    {87, 1551, 2219},	// QsciScintillaBase::trUtf8$
    {87, 1552, 2144},	// QsciScintillaBase::trUtf8$$
    {87, 1553, 2146},	// QsciScintillaBase::trUtf8$$$
    {87, 1632, 2386},	// QsciScintillaBase::~QsciScintillaBase
    {88, 356, 2415},	// QsciStyle::LowerCase
    {88, 383, 2413},	// QsciStyle::OriginalCase
    {88, 539, 2411},	// QsciStyle::QsciStyle
    {88, 540, 2410},	// QsciStyle::QsciStyle#
    {88, 541, 2387},	// QsciStyle::QsciStyle$
    {88, 542, 2412},	// QsciStyle::QsciStyle$$###
    {88, 543, 2388},	// QsciStyle::QsciStyle$$###$
    {88, 733, 2414},	// QsciStyle::UpperCase
    {88, 807, 2389},	// QsciStyle::apply#
    {88, 854, 2406},	// QsciStyle::changeable
    {88, 868, 2394},	// QsciStyle::color
    {88, 900, 2392},	// QsciStyle::description
    {88, 927, 2400},	// QsciStyle::eolFill
    {88, 981, 2398},	// QsciStyle::font
    {88, 1003, 2408},	// QsciStyle::hotspot
    {88, 1128, 2396},	// QsciStyle::paper
    {88, 1162, 2409},	// QsciStyle::refresh
    {88, 1251, 2405},	// QsciStyle::setChangeable$
    {88, 1253, 2393},	// QsciStyle::setColor#
    {88, 1266, 2391},	// QsciStyle::setDescription$
    {88, 1284, 2399},	// QsciStyle::setEolFill$
    {88, 1328, 2397},	// QsciStyle::setFont#
    {88, 1345, 2407},	// QsciStyle::setHotspot$
    {88, 1437, 2395},	// QsciStyle::setPaper#
    {88, 1476, 2401},	// QsciStyle::setTextCase$
    {88, 1496, 2403},	// QsciStyle::setVisible$
    {88, 1525, 2390},	// QsciStyle::style
    {88, 1538, 2402},	// QsciStyle::textCase
    {88, 1568, 2404},	// QsciStyle::visible
    {88, 1633, 2416},	// QsciStyle::~QsciStyle
    {89, 545, 2422},	// QsciStyledText::QsciStyledText#
    {89, 546, 2418},	// QsciStyledText::QsciStyledText$#
    {89, 547, 2417},	// QsciStyledText::QsciStyledText$$
    {89, 807, 2419},	// QsciStyledText::apply#
    {89, 1525, 2421},	// QsciStyledText::style
    {89, 1534, 2420},	// QsciStyledText::text
    {89, 1634, 2423},	// QsciStyledText::~QsciStyledText
};

}

extern "C" {

SMOKE_IMPORT void init_qtcore_Smoke();
SMOKE_IMPORT void init_qtgui_Smoke();

static bool initialized = false;
Smoke *qsci_Smoke = 0;

// Create the Smoke instance encapsulating all the above.
void init_qsci_Smoke() {
    init_qtcore_Smoke();
    init_qtgui_Smoke();
    if (initialized) return;
    qsci_Smoke = new Smoke(
        "qsci",
        __smokeqsci::classes, 89,
        __smokeqsci::methods, 2424,
        __smokeqsci::methodMaps, 2209,
        __smokeqsci::methodNames, 1634,
        __smokeqsci::types, 223,
        __smokeqsci::inheritanceList,
        __smokeqsci::argumentList,
        __smokeqsci::ambiguousMethodList,
        __smokeqsci::cast );
    initialized = true;
}

void delete_qsci_Smoke() { delete qsci_Smoke; }

}
